/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/* Notification class */
var notificationCount;
var NotificationClass = function () {
 
    var playerName,
        receiveEmailNotifications;
    /** get Notification data **/
    this.getNotificationData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getNotificationParameters("NotificationServiceProvider", "GetNotifications", ["3d984487-a757-4737-aa17-64c89e17c9e1"]);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnNotificationSuccess, this.OnNotificationError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getNotificationData " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getNotificationParameters = function (ServiceProvider, ServiceMethod, parametersArray) {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                notifySession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = ServiceProvider;
            data.ServiceMethod = ServiceMethod;
            data.Language = constants.englishLanguage;
            data.parametersArray =  parametersArray;
            notifySession.PlayerId = sessionData.playerId;
            notifySession.UserId = sessionData.userId;
            notifySession.FirstName = sessionData.firstName;
            notifySession.LastName = sessionData.lastName;
            notifySession.Roles = sessionData.roles;
            notifySession.UserName = applicationDataObj.getUsername();
            notifySession.EmailId = sessionData.emailId;
            notifySession.Address1 = sessionData.address1;
            notifySession.City = sessionData.city;
            notifySession.Country = sessionData.country;
            notifySession.TOKEN  = applicationDataObj.getToken();
            if ((applicationDataObj.getUserType() !== "Player")) {
                notifySession.PlayerId = "";
                if (sessionData.ManagementAgency) {
                    notifySession.ManagementAgency = sessionData.ManagementAgency;
                }
                if (sessionData.registeredDate) {
                    notifySession.JoinedDate = sessionData.registeredDate;
                }
                if (constants.onBehalfPlayerId) {
                    notifySession.OnBehalfPlayerId = constants.onBehalfPlayerId;
                }
            }
            data.SessionData = notifySession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getNotificationParameters " + err);
        }
    };
    
    /** binding Notification body data **/
    this.bindNotification = function (notifydata) {
        try {
            settingsLabel = notifydata.SettingsLabel;
            searchText = notifydata.SearchText;
            if (isApp) {
                if (cordova.platformId === 'ios') {
                    $(".imagesearchclose").addClass("searchcloseimg");
                }
            }  
            $('#myprofileInner').removeClass('myprofile-innercontnr');
            $(".pro-setting-div").empty();
            $(".accordnotify").empty();
            $(".pro-contact-btn").empty();
            $("#alert-word").empty();
            $(".para-modal").empty();
            $(".popup-cncl").empty();
            $(".pro-setting-div").append('<a href="javascript:void(0)" class="pro-notification-MarkAll" onclick="ReadAllNotifications()">Mark All as Read</a><a href="#/NotificationSettings"><span class="pro-notification-setting-img"></span></a><a href="#/NotificationSettings" class="pro-notification-setting-link">' + settingsLabel + '</a>');
            $(".searchtxt").attr("placeholder", searchText);
            notifications = notifydata.notifications;
            notify = notifications.length;
            submit = notifydata.Submit;
            markasUnreadText = notifydata.MarkasUnreadText;
            alertDescription = notifydata.AlertDescription;
            alertText = notifydata.AlertText;
            cancelText = notifydata.CancelText;
            count  = 0;
            
            
            notificationCount = count;
            for (i = 0; i < notify; i++) {
                var shortDesString = $('<div/>').html(notifications[i].ShortDiscription).text();
                var longDesString = $('<div/>').html(notifications[i].LongDiscription).text();
                longDiscription = notifications[i].LongDiscription === null ? "" : longDesString;
                shortDiscription = notifications[i].ShortDiscription === null ? "" : shortDesString;
                timeDuration = notifications[i].TimeDuration;
                ids = notifications[i].ID;
                isReadMsg = notifications[i].IsRead;
                $(".accordnotify").append('<div class="panel panel-default panel-div" id="div' + (i + 1) + '" data-type="accordion-section"><div class="msg-panel  accordian-innerdiv" id="accorddiv' + ids + '"><div class="panel-heading pro-panel-head" data-toggle="collapse" data-parent="#accordion" href="#accorcollapse' + (i + 1) + '" id="panel' + (i + 1) + '" onclick="changeStyle(' + (i + 1) + ')"><h4 class="panel-title" id="pantitle' + (i + 1) + '"><span class ="readspan" id="read' + (i + 1) + '" hidden>' + isReadMsg + '</span><a class="accordion-toggle pro-notification-accordian-text" id="accor' + (i + 1) + '" data-type="accordion-section-title">' + shortDiscription + '<br /></a><span class="subtitle-accordian">' + longDiscription.replace(/<\/?[^>]+(>|$)/g, "") + '</span><span class="col-xs-4 col-sm-4 pro-notification-span-time" id="Time' + (i + 1) + '">' + timeDuration + '</span></h4></div><span data-toggle="modal" data-target="#myModal" id="' + ids + '"  class="pro-notification-trash-img"><span class="delspan" id="del' + (i + 1) + '" hidden>' + isReadMsg + '</span></span></div><div id="accorcollapse' + (i + 1) + '" class="panel-collapse collapse"><div class="panel-body pro-notification-accordian-body" id="pro-notification-accordian-body' + (i + 1) + '">' + longDiscription + '<div></div><div id="button' + ids + '"><button class="pro-notification-mark-btn" id="markbtn' + (i + 1) + '" onclick="markasunread(' + (i + 1) + ')">' + markasUnreadText + 
                                          '</button><button class="pro-notification-mark-btn-style" id="markbtn' + (i + 1) + '" onclick="closeMessage(' + (i + 1) + ')">Close Message</button></div></div></div></div>');
                if ($("#pro-notification-accordian-body" + (i + 1)).find('a')) {
                    newTab = $("#pro-notification-accordian-body" + (i + 1)).find('a').attr('href');
                    $("#pro-notification-accordian-body" + (i + 1)).find('a').attr("href", newTab);
                    $("#pro-notification-accordian-body" + (i + 1)).find('a').attr("id", "newpage" + (i + 1));
                    $("#pro-notification-accordian-body" + (i + 1)).find('a').attr("value", newTab);
                    $("#pro-notification-accordian-body" + (i + 1)).find('a').attr("class", "opennewtab");
                    //$("#pro-notification-accordian-body" + (i + 1)).find('a').attr('href', '#');
                }

                if ($("#read" + (i + 1)).text() === "true") {
                    $("#accor" + (i + 1)).css("color", "#777777 !important");
                    $("#Time" + (i + 1)).css("color", "#777777 !important");
                } else {
                    notificationCount = notificationCount + 1;
                    $("#accor" + (i + 1)).css("color", "#00adf9 !important");
                    $("#Time" + (i + 1)).css("color", "#00adf9 !important");
                }
            }
            
            if(!$(".pro-notification-accordian-body").eq(0).find("table").hasClass("notification-settings-table")){
                 $(".pro-notification-accordian-body").eq(0).find("table").addClass("notification-settings-table");
            }


            $(".panel-div").click(function () {
                newTabId = $(this).find(".opennewtab").attr('id');
                newPageTab = $(this).find(".opennewtab").attr('value');
                $("#" + newTabId).on('click',function () {
                    window.open(newPageTab, '_system');
                });
            });
            $(".msg-panel").click(function(){
        		//parentDiv=$(this).parent().parent().parent().parent().html();
        		parentDiv = $(this).attr("id");//$(this).find(".accordian-innerdiv");
        		currentNotifyId = $(this).attr("id");//$(parentDiv).attr('id');
        		readNotifyId=currentNotifyId.slice(9);
        		 var saveNotifyObj = new NotificationClass();
                 saveNotifyObj.saveMsg(readNotifyId);
        	});
            if(constants.onBehalfPlayerId === "") {
                $(".notificationnum").text(notificationCount);
                var obj = applicationDataObj.getNavigationObj();
                obj.Notifications = notificationCount;
                applicationDataObj.setNavigationObj(obj);
                $(".notification-count").text(notificationCount);
            }
            $("#alert-word").append(alertText);
            $(".para-modal").append(alertDescription);
            $(".popup-cncl").append(cancelText);
            $(".pro-contact-btn").append(submit);
            $(".pro-contact-btn").click(function () {
                contactplayerRelations();
            });

            $(".panel-title").click(function () {
                var panelId = $(this).attr('id'),
                    num = panelId.replace( /^\D+/g, '');
                    isreadText = $("#" + panelId).find("#read" + num).html();
                if (notificationCount === 0 && isreadText === "true") {
                    $(".no-notify").hide();
                } else if (notificationCount !== 0 && isreadText === "false") {
                    notificationCount = notificationCount - 1;
                    var obj = applicationDataObj.getNavigationObj();
                    obj.Notifications = notificationCount;
                    applicationDataObj.setNavigationObj(obj);
                    $(".notification-count").text(notificationCount);
                    $(".notificationnum").text(notificationCount);
                    if (notificationCount === 0) {
                        $(".no-notify").hide();
                        $(".notification-count").hide();
                    }
                }	
                $("#" + panelId).find("#read" + num).text("true");
                $("#del" + num).text("true");			
                endLoading();
            });

            $(".pro-notification-accordian-text").click(function () {
                parentDiv = $(this).parent().parent().parent().parent().html();
                currentNotifyId = $(parentDiv).attr('id');
                readNotifyId = currentNotifyId.slice(9);
                var saveNotifyObj = new NotificationClass();
                saveNotifyObj.saveMsg(readNotifyId);
            });
            var delText;
            var delIcon;
            $(".pro-notification-trash-img").click(function () {
                delText = $(this).find('span').html();
              
                delIcon = this.id;
              
                endLoading();
                if (cordova.platformId === 'ios') {
                    $('#removescrolldiv').removeClass('iosscrolldiv');
                }
                
            });
            
              $(".popup-save").click(function () {
                  if (cordova.platformId === 'ios') {
                      $('#removescrolldiv').addClass('iosscrolldiv');
                  }
                  
                    if (notificationCount === 0) {
                        $(".no-notify").hide();
                        $(".notification-count").hide();
                    } else if (notificationCount !== 0 && delText === "true") {
                        $(".notificationnum").text(notificationCount);
                    } else if (notificationCount !== 0 && delText === "false") {
                        notificationCount = notificationCount - 1;
                        var obj = applicationDataObj.getNavigationObj();
                        obj.Notifications = notificationCount;
                        applicationDataObj.setNavigationObj(obj);
                        $(".notification-count").text(notificationCount);
                        $(".notificationnum").text(notificationCount);
                    }
                  
                    icon = delIcon;
                    var deleteMsgObj = new NotificationClass();
                    deleteMsgObj.deleteReadMsg(icon);
                });
            
            $(".popup-cncl").click(function () {
                if (cordova.platformId === 'ios') {
                      $('#removescrolldiv').addClass('iosscrolldiv');
                }
            });
            

            $(".pro-notification-mark-btn").click(function(){
                var markId = $(this).attr('id');
                var markParent = $("#"+markId).parent().parent().parent();
                var firstParent = markParent.parent();
                var panelId1 = firstParent.find('h4').attr('id');
                var num1 = panelId1.replace( /^\D+/g, '');
                notificationCount = notificationCount + 1;
                var obj = applicationDataObj.getNavigationObj();
                obj.Notifications = notificationCount;
                applicationDataObj.setNavigationObj(obj);
                $(".notification-count").text(notificationCount);
                if ($(".notification-count").hasClass('hide')) {
                    $(".notification-count").removeClass('hide');
                }
                $(".no-notify").show();
                $(".notification-count").show();
                $(".notificationnum").text(notificationCount);
                var isUnreadText = $("#" + panelId1).find("#read"+num1).text("false");
                $("#del"+num1).text("false");	
                closerDiv = $(this).closest("div");
                openedNotifyId = $(closerDiv).attr('id');
                unreadNotifyId = openedNotifyId.slice(6);
                var unreadNotifyObj = new NotificationClass();
                unreadNotifyObj.unReadMsg(unreadNotifyId);
                endLoading();
            });
            
            $("#myModal").on("shown.bs.modal", function () {
               $("#MyApp").css("overflow", "hidden");
               if (deviceOS === 'ios' && isApp) {
                  $("#iosscroll").removeClass("scrollcontent");
               }
            });
            $("#myModal").on("hidden.bs.modal", function () {
               $("#MyApp").removeAttr("style");
               if (deviceOS === 'ios' && isApp) {
                  $("#iosscroll").addClass("scrollcontent");
               }
            });

        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindNotification " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnNotificationSuccess = function (data) {
        try {
            var notificationClassObj = new NotificationClass();
            notificationClassObj.bindNotification(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNotificationSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnNotificationError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNotificationError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNotificationError " + err);
        }
    };
    
    /** get save notification data **/
    this.saveMsg = function (readNotifyId) {
        try {
            var apiservicecallsObj = new Apiservicecalls();
            var url = constants.ajaxUrl;
            saveArray=[];
            saveArray.push(readNotifyId);
            saveArray.push(true);
            saveArray.push(true);
            saveArray.push("3d984487-a757-4737-aa17-64c89e17c9e1");
            parametersArray=saveArray;
            constants.liveScoreLoading = true;
            var inputData = this.getNotificationParameters("NotificationServiceProvider","SaveReadStatusOfNotification",parametersArray);
            apiservicecallsObj.postData(url, inputData, this.OnSaveSuccess, this.OnSaveError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : saveMsg " + err);
        }
    }; 
    
    
     /*Ajax - Success Call back*/
    this.OnSaveSuccess = function (data) {
        try {
            if(data)
            {
            	constants.liveScoreLoading = false;
                endLoading();
            }
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnSaveSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnSaveError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnSaveError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnSaveError " + err);
        }
    };
    
    /** get Unread notification data **/
    this.unReadMsg = function (unreadNotifyId) {
        try {
            var apiservicecallsObj = new Apiservicecalls();
            var url = constants.ajaxUrl;
            unReadArray=[];
            unReadArray.push(unreadNotifyId);
            unReadArray.push(false);
            unReadArray.push(true);
            unReadArray.push("3d984487-a757-4737-aa17-64c89e17c9e1");
            parametersArray=unReadArray;
            var inputData = this.getNotificationParameters("NotificationServiceProvider","SaveReadStatusOfNotification",parametersArray);
            apiservicecallsObj.postData(url, inputData, this.OnUnreadSuccess, this.OnSaveError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : unReadMsg " + err);
        }
    }; 
    
    
     /*Ajax - Success Call back*/
    this.OnUnreadSuccess = function (data) {
        try {
            if(data)
            {
                endLoading();
            }
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnUnreadSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnUnreadError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnUnreadError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnUnreadError " + err);
        }
    };
    
    /** get Delete notification data **/
    this.deleteReadMsg = function (icon) {
        try {
            var apiservicecallsObj = new Apiservicecalls();
            var url = constants.ajaxUrl;
            deleteArray=[];
            deleteArray.push(icon);
            deleteArray.push("0");
            deleteArray.push("0");
            deleteArray.push("3d984487-a757-4737-aa17-64c89e17c9e1");
            parametersArray=deleteArray;
            var inputData = this.getNotificationParameters("NotificationServiceProvider","DeleteNotitication",parametersArray);
            apiservicecallsObj.postData(url, inputData, this.OnDeleteSuccess, this.OnDeleteError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : deleteReadMsg " + err);
        }
    }; 
    
    
     /*Ajax - Success Call back*/
    this.OnDeleteSuccess = function (data) {
        try {
            if(data)
            {
                var selectedMsg = $("#"+icon).parent().parent();
                selectedMsg.empty();	
                endLoading();
            }
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDeleteSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnDeleteError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDeleteError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDeleteError " + err);
        }
    };
    /*$(".pro-notification-trash-img").click(function(){
		var delIcon = this.id;
		$(".popup-save").click(function(){
			icon=delIcon;
			deleteReadMsg(icon);
		});
	});*/

	/*$(".msg-panel").click(function(){
		//parentDiv=$(this).parent().parent().parent().parent().html();
		parentDiv = $(this).attr("id");//$(this).find(".accordian-innerdiv");
		currentNotifyId = $(this).attr("id");//$(parentDiv).attr('id');
		readNotifyId=currentNotifyId.slice(9);
		saveMsg(readNotifyId);
	});*/

	/*$(".pro-notification-mark-btn").click(function(){
		closerDiv=$(this).closest("div");
		openedNotifyId= $(closerDiv).attr('id');
		unreadNotifyId=openedNotifyId.slice(6);
		unReadMsg(unreadNotifyId);
	});*/
};

/* Notification */

var notifyPlayernameObj=new NotificationClass();

var notificationReady = function (params) {
    try {
        if(isApp){
            window.ga.trackView('Notification');
        }
        var notificationObj = new NotificationClass();
        startLoading();
        notifyPlayernameObj.playerName = params.playerName;
		notifyPlayernameObj.receiveEmailNotifications = params.receiveEmailNotifications;
		if(params && params.onBehalfPlayerId){
			constants.onBehalfPlayerId = params.onBehalfPlayerId;
			$(".headercontent").hide();
			$(".mngplyhdr-plyrnm").text("");
		    $(".mngplyhdr-plyrnm").text(notifyPlayernameObj.playerName);
		    $(".manageplyr-header").removeClass("hide");
		    $(".manageplyr-header").addClass("show");
		    $(".mngingplyr-img").attr('src', constants.headShotImage);
		}
        else{
			constants.onBehalfPlayerId =  "";
		}
        setTimeout(function () {
            headerMain();
			subHeaderCarousel();
            var myProfileNotifyObj= new MyProfileNotifyClass();
			myProfileNotifyObj.myProfileNotify();
            notificationObj.getNotificationData();
            if (deviceOS === 'ios' && isApp) {
                $('#iosscroll').addClass("scrollcontent");
             }
        }, 500);
        
    }
    catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : notificationReady " + err);
    }
};

var getReadAllNotificationsParameters = function(sessionData) {
    try {
        var loginData =  {},
            userSession = {};
        loginData.Userid = applicationDataObj.getUserId();
        loginData.ServiceProvider = "NotificationServiceProvider";
        loginData.ServiceMethod = "ReadAllNotifications";
        loginData.Language = "en";
        loginData.parametersArray = ["3d984487-a757-4737-aa17-64c89e17c9e1"];
        userSession.PlayerId = sessionData.playerId;
        userSession.UserId = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.Roles = sessionData.roles;
        userSession.TOKEN  = applicationDataObj.getToken();
        userSession.EmailId = sessionData.emailId;
		userSession.City = sessionData.city;
		userSession.Country = sessionData.country;
		userSession.Address1 = sessionData.address1;
        loginData.SessionData = userSession;
        loginData = JSON.stringify(loginData);
        return loginData;
    }  catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error: getReadAllNotificationsParameters Method " + err);
    }
};

var ReadAllNotifications = function () {
    $('.pro-notification-MarkAll').css('color','#00adf9');
     try {
            var apiservicecallsObj = new Apiservicecalls();
			var url =  constants.ajaxUrl;
			var sessionData = applicationDataObj.getSessionResponse();
			var inputData = getReadAllNotificationsParameters(sessionData);
			apiservicecallsObj.postData(url, inputData, this.OnReadAllNotificationsSuccess,  this.OnReadAllNotificationsError);
          
        } catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error: ReadAllNotifications Method " + err);
		}
};

var OnReadAllNotificationsSuccess = function (response) {
    console.log(response);
    notificationCount = 0;
    var obj = applicationDataObj.getNavigationObj();
    obj.Notifications = notificationCount;
    applicationDataObj.setNavigationObj(obj);
    $(".notification-count").text(notificationCount);
    $(".notificationnum").text(notificationCount);
    $(".no-notify").hide();
    $(".notification-count").hide();
    for (text = 0; text < notify; text++) {
        changeStyle(text+1);
    }
    $(".panel-title .readspan").text("true");
    $(".pro-notification-trash-img .delspan").text("true");
    endLoading();
};

var OnReadAllNotificationsError = function (error) {
    console.log(error);
    endLoading();
};