/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed, 
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants*/

var AccountDataClass = function () {
	/**
	 * Populate contact Fields
	 */
	this.populateFields = function (data) {
		try {
			if (data.ContactDetails) {
				if (data.ContactDetails.Description) {
					$("#contact .myprflcntct-paragrph").text(data.ContactDetails.Description);
				}
				$("#mycntct-cntry").empty();
				$("#mycntct-cntry").append('<option value = "">Country</option>');
				if (data.CountryNames) {
					$.each(data.CountryNames,  function (key,  value) {
						$("#mycntct-cntry").append('<option value = "' + key + '">' + value + '</option>');
					});
				}
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : populateFields " + err);
		}
	};
	/**
	 * Bind contact details
	 */
	this.bindContactDetails = function (data) {
		try {
			data.MailingStreet ? $("#mailadrs-street1").val(data.MailingStreet) : $("#mailadrs-street1").val();
			data.MailingStreet2 ? $("#mailadrs-street2").val(data.MailingStreet2) : $("#mailadrs-street2").val();
			data.MailingCity ? $("#mycntct-city").val(data.MailingCity) : $("#mycntct-city").val("");
			data.MailingState ? $("#state-province").val(data.MailingState) : $("#state-province").val("");
			data.MailingZip ? $("#zip").val(data.MailingZip) : $("#zip").val("");
			data.PhoneNumberCode ? $("#phn-code").val(data.PhoneNumberCode) : $("#phn-code").val("");
			data.PhoneNumberWorkCode ? $("#work-code").val(data.PhoneNumberWorkCode) : $("#work-code").val("");
			data.PhoneNumberMobileCode ? $("#mob-code").val(data.PhoneNumberMobileCode) : $("#mob-code").val("");
			data.PhoneNumberFaxCode ? $("#fax-code").val(data.PhoneNumberFaxCode) : $("#fax-code").val("");
			data.PhoneNumber ? $("#home-phn").val(data.PhoneNumber) : $("#home-phn").val("");
			data.PhoneNumberWork ? $("#work-phn").val(data.PhoneNumberWork) : $("#work-phn").val("");
			data.PhoneNumberMobile ? $("#mob-phn").val(data.PhoneNumberMobile) : $("#mob-phn").val("");
			data.PhoneNumberFax ? $("#fax-phn").val(data.PhoneNumberFax) : $("#fax-phn").val("");
			data.EmailAddressPrimary ? $("#email-prmryemail").val(data.EmailAddressPrimary) : $("#email-prmryemail").val("");
			data.EmailAddressSecondary ? $("#pscndry-email").val(data.EmailAddressSecondary) : $("#pscndry-email").val("");
			data.EmailAddressAgent ? $("#agent-email").val(data.EmailAddressAgent) : $("#agent-email").val("");
			if (data.MailingCountry) {
				$("#mycntct-cntry").val(data.MailingCountry);
			} else {
				$("#mycntct-cntry").val("");
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindContactDetails " + err);
		}
	};
};