/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants,AccountSocialClass,AccountSocialDataClass,apiservicecalls,endLoading,logout,applicationDataObj,accountSocialClassObj*/

var initialSocialData,
    initialProviders = [],
    afterSaveSocialData,
    selectedProviders = [],
    initialData;
String.prototype.format = function () {
	var args = arguments;
	return this.replace(/\{(\d+)\}/g, function () {
		return args[arguments[1]];
	});
};

/**
 * Bind CheckBox Values
 */
var bindCheckBoxValues = function () {
	try {
		//TODO - for remove
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : bindCheckBoxValues " + err);
	}
};
/**
 * Function for adding social media from popove
 */
var addSocialMedia = function () {
	try {
		var selectedSocialArray = [],
		    accountSocialClassObj = new AccountSocialClass(),
            selectedSocialObj = {},
            selectedText,
            socialProviderId,
            alreadyExist,
            accountSocialDataClassObj;
		$(".innermain").each(function (i, obj) {
			var selectedSocialMedia = $(obj).find("input:checkbox").prop("checked");
			if (selectedSocialMedia) {
				selectedText = $(obj).find(".main-value").text();
				socialProviderId = $(obj).find(".main-value").attr("data-SocialProviderId");
				alreadyExist = accountSocialClassObj.checkIfAlreadyAdded(selectedText);
				if (!alreadyExist) {
					selectedSocialObj.ProviderName = selectedText;
					selectedSocialObj.SocialProviderId = socialProviderId;
					selectedSocialArray.push(selectedSocialObj);
				}
				if (jQuery.inArray(selectedText, selectedProviders) === -1) {
					selectedProviders.push(selectedText);
				}

			}
		});
		if (selectedSocialArray && selectedSocialArray.length && selectedSocialArray.length !== 0) {
			accountSocialDataClassObj = new AccountSocialDataClass();
			accountSocialDataClassObj.appendAddedSocialMediaData(selectedSocialArray);
		}
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : addSocialMedia " + err);
	}
};
/**
 * Function for add new button click event
 */
var addNewBtnClick = function () {
	try {
		
		$(".social-chekbox").removeAttr("checked");
		$(".innermain").each(function (i, obj) {
			var selectedText = $(obj).find(".main-value").text();
			if (jQuery.inArray(selectedText, selectedProviders) !== -1) {
				$(obj).find("input:checkbox").prop("checked", true);
			} else {
				$(obj).find("input:checkbox").prop("checked", false);
			}
		});
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : addNewBtnClick " + err);
	}
};
/**
 * Function for cancelling the edits
 */
var cancelEdits = function () {
	setTimeout(function () {
		$(".cnclsocialbutton1").removeClass("submit");
	}, 200);
	try {
		var accountSocialDataClassObj = new AccountSocialDataClass();
		$(".cnclsocialbutton1").addClass("submit");
        if (!$("#social-save-msg").hasClass("show")) {
            $("#addingsocia_content").empty();
            $(".inner-panel").empty();
            selectedProviders = [];
        }
		accountSocialDataClassObj.bindSocialDataUI(initialData);
		$("#social-save-msg").removeClass("show");
		$("#social-save-msg").addClass("hide");
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : cancelEdits " + err);
	}
};


/**
 * Function for saving the social media
 */
var saveSocialMediaData = function () {
	try {
		var accountSocialClassObj = new AccountSocialClass(),
            saveDetailArray = [],
            string = "",
            providerName,
            providerValue,
            webTextValue,
            webAppendedString,
            parameterString,
            parameterArrayString,
            inputData,
            apiservicecallsObj,
            url;
		$(".socialbutton1").addClass("mycntct-save");
		$(".main-outer").each(function (i, obj) {
			providerName = $(obj).find(".main-data").text();
			providerValue = $(obj).find(".value-data").val();
			string += providerName + '=' + providerValue + '&';
		});
		webTextValue = $("#webtext").val();
		webAppendedString = string + "Web_Site=" + webTextValue;
		parameterString = webAppendedString.replace(/ /g, "_");
		saveDetailArray.push(parameterString);
		if (webAppendedString !== "") {
			parameterArrayString = "C609E86B-06F9-4C58-AA18-FDE348FBA278";
			saveDetailArray.push(parameterArrayString);
			inputData = accountSocialClassObj.createRequestForSocialSave(saveDetailArray);
            apiservicecallsObj = new apiservicecalls();
            url =  constants.ajaxUrl;
			apiservicecallsObj.postData(url, inputData, accountSocialClassObj.onSocialSaveSuccess, accountSocialClassObj.onSocialSaveError);
		}
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : saveSocialMediaData " + err);
	}
	setTimeout(function () {
		$(".socialbutton1").removeClass("mycntct-save");
	}, 1300);
};

/**
 * AccountSocialClass
 */
var AccountSocialClass = function () {
	/**
	 * Social save success
	 */
	this.onSocialSaveSuccess = function (data) {
		try {
			endLoading();
			if (data) {
                var accountSocialDataClassObj = new AccountSocialDataClass();
                initialData = data;
                accountSocialDataClassObj.bindSocialDataUI(data);
				$("#social-save-msg").removeClass("hide");
				$("#social-save-msg").addClass("show");
			}
            
            if (data.ProvidersForAplayer.length === 9) {
                $("#socialnewbutton").addClass("addbutton-disabled");
				$("#socialnewbutton").attr("disabled", true);
            }
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : onSocialSaveSuccess " + err);
		}
	};
	/**
	 * Social Save error
	 */
	this.onSocialSaveError = function (jqXHR, exception) {
		try {
			endLoading();
			loggerObj.logToServer(constants.logSeverityError, "Error : onSocialSaveError " + exception);
			if (jqXHR.status && jqXHR.status === 401 &&
					jqXHR.statusText === "Unauthorized") {
				logout();
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : checkIfAlreadyAdded " + err);
		}
	};
	/**
	 * Function for creating save request for social media tab
	 */
	this.createRequestForSocialSave = function (parameterArray) {
		try {
			var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {},
                inputData;
			data.Userid = sessionData.userId;
			data.ServiceProvider = "MyProfileServiceProvider";
			data.ServiceMethod = "PostSocialDetails";
			data.Language = constants.englishLanguage;
			data.parametersArray =  parameterArray;
			userSession.PlayerId = sessionData.playerId;
			userSession.UserId = sessionData.userId;
			userSession.UserName = applicationDataObj.getUsername();
			userSession.FirstName = sessionData.firstName;
			userSession.LastName = sessionData.lastName;
			userSession.Roles = sessionData.roles;
			userSession.EmailId = sessionData.emailId;
			userSession.Address1 = sessionData.address1;
			userSession.City = sessionData.city;
			userSession.Country = sessionData.country;
			userSession.TOKEN  = applicationDataObj.getToken();
			data.SessionData = userSession;
			inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : createRequestForSocialSave " + err);
		}
	};
	/**
	 * Function for getting social media icon
	 */
	this.getSocialMediaIcon = function (socialProviderId) {
		var socilaMediaIcon = "";
		try {
			switch (socialProviderId) {
			case "FB":
				socilaMediaIcon = "fa fa-facebook fbicon";
				break;
			case "IG":
				socilaMediaIcon = "fa fa-instagram intsaicon";
				break;
			case "TW":
				socilaMediaIcon = "fa fa-twitter twiticon";
				break;
			case "ChPrf":
				socilaMediaIcon = "";
				break;
			case "G+":
				socilaMediaIcon = "fa fa-google-plus intsaicon";
				break;
			case "Kai":
				socilaMediaIcon = "";
				break;
			case "Sina":
				socilaMediaIcon = "fa fa-weibo intsaicon";
				break;
			case "YT":
				socilaMediaIcon = "fa fa-youtube intsaicon";
				break;
			case "Vix":
				socilaMediaIcon = "fa vixlet-icon fbicon";
				break;

			default:
				socilaMediaIcon = "";
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getSocialMediaIcon " + err);
		}
		return socilaMediaIcon;
	};

	/**
	 * Function to get social tab datas
	 */
	this.getSocialTabDatas = function () {
		try {
			var apiservicecallsObj = new apiservicecalls(),
                url = constants.ajaxUrl,
                inputData = this.getSocialInputRequestDetais();
			apiservicecallsObj.postData(url, inputData, this.OnSocialSuccess, this.OnSocialError);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getSocialTabDatas " + err);
		}
	};
	/**
	 * Social Success
	 */
	this.OnSocialSuccess = function (response) {
		try {
			endLoading();
			if (response) {
				var accountSocialDataClassObj = new AccountSocialDataClass();
				initialData = response;
				initialSocialData = response;
				accountSocialDataClassObj.bindSocialDataUI(response);
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : OnSocialSuccess " + err);
		}
	};
	/**
	 * Social Error
	 */
	this.OnSocialError = function (jqXHR, error) {
		try {
			endLoading();
			loggerObj.logToServer(constants.logSeverityError, "Error : OnSocialError " + error);
			if (jqXHR.status && jqXHR.status === 401 &&
					jqXHR.statusText === "Unauthorized") {
				logout();
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : OnSocialError " + err);
		}
	};
	/**
	 * Function for creating request for getting social tab data
	 */
	this.getSocialInputRequestDetais = function () {
		try {
			var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {},
                inputData;
			data.Userid = sessionData.userId;
			data.ServiceProvider = "MyProfileServiceProvider";
			data.ServiceMethod = "GetSocialMediaData";
			data.Language = constants.englishLanguage;
			data.parametersArray =  ["C609E86B-06F9-4C58-AA18-FDE348FBA278"];
			userSession.PlayerId = sessionData.playerId;
			userSession.UserId = sessionData.userId;
			userSession.UserName = applicationDataObj.getUsername();
			userSession.FirstName = sessionData.firstName;
			userSession.LastName = sessionData.lastName;
			userSession.Roles = sessionData.roles;
			userSession.EmailId = sessionData.emailId;
			userSession.Address1 = sessionData.address1;
			userSession.City = sessionData.city;
			userSession.Country = sessionData.country;
			userSession.TOKEN  = applicationDataObj.getToken();
			data.SessionData = userSession;
			inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getSocialInputRequestDetais " + err);
		}
	};
	/**
	 * Function to check if social media already added
	 */
	this.checkIfAlreadyAdded = function (checkProviderName) {
		var alreadyThere = false;
		try {
			$(".main-outer").each(function (i, obj) {
				var providerName = $(obj).find(".main-data").text();
				if (checkProviderName === providerName) {
					alreadyThere = true;
				}
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : checkIfAlreadyAdded " + err);
		}
		return alreadyThere;
	};
};
/**
 * AccountSocialDataClass
 */
var AccountSocialDataClass = function () {
	/**
	 * Templates
	 */
    var socialMediaTemplate,
        innerPanelTemplate,
        innerNoIconTemplate;
	socialMediaTemplate = '<div class="main-outer col-xs-12 col-sm-12 col-md-12 col-lg-12 textbox-area1 mycntct-street1                           social-common-div">' +
	                       '<div class="col-sm-12 col-md-12 col-lg-12 col-xs-12 paddinglftryt0">' +
	                       '<div class="col-sm-2 col-md-2 col-xs-2 col-lg-2 martop paddinglftryt0 padding-left-5">' +
	                       '<span class="socialfb"><a href="#" class="{3}"></a></span>' +
	                       '</div><div class="col-sm-10 col-md-10 col-xs-10 col-lg-10 paddinglftryt0">' +
	                       '<div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 social-label paddinglftryt0 main-data">{0}</div>' +
	                       '<div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 textbox1 paddinglftryt0">' +
	                       '<input type="text" class="textbox-input1 social-input value-data"  id="fbtext" placeholder="{2}" value = {1}>' +
	                       '</div></div></div></div><div class="clearfix"></div>';
	innerPanelTemplate = '<div class="innermain col-xs-6 col-sm-6 col-md-6 col-lg-6 marTop paddinglftryt0">' +
	                       '<div class="col-xs-2 col-ms-2 col-md-2 col-lg-2 socialcheckbox marTop"><input type="checkbox" id="youtubecheck" class="social-chekbox"></div>' +
	                       '<div class="col-xs-2 col-md-2 col-md-2 col-lg-2 socialfb"><a href="#" class="{1}"></a></div>' +
	                       '<div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 marTopbox social-margin-left main-value" data-SocialProviderId = {2}>{0}</div>' +
	                       '</div><div class="clearfix"></div>';
	innerNoIconTemplate = '<div class="innermain col-xs-6 col-sm-6  col-md-6 col-lg-6 marTop paddinglftryt0">' +
	                       '<div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 socialcheckbox marTop"><input type="checkbox" id="tumblrcheck" class="social-chekbox"></div>' +
	                       '<div class="youtubeplceholdtab col-xs-2 col-sm-2 col-md-2 col-lg-2"></div>' +
	                       '<div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 marTopbox main-value" data-SocialProviderId = {1}>{0}</div>' +
	                       '</div><div class="clearfix"></div>';
	/**
	 * Function to bind the social tab UI
	 */
	this.bindSocialDataUI = function (response) {
		try {
			var accountSocialClassObj = new AccountSocialClass();
			if (response.ProvidersForAplayer && response.ProvidersForAplayer.length && response.ProvidersForAplayer !== 0) {
				$("#addingsocia_content").empty();
				$.each(response.ProvidersForAplayer, function (index, value) {
					//{2} placeholder
					//{3} social media class SocialProviderId
					if (value.SocialProviderId && value.SocialProviderId !== "Web") {
						var socialMediaIcon = accountSocialClassObj.getSocialMediaIcon(value.SocialProviderId),
                            socialDiv = socialMediaTemplate.format(value.ProviderName, value.SocialLink, "", socialMediaIcon);
						$("#addingsocia_content").append(socialDiv);
					} else {
						$("#webtext").val(value.SocialLink);
					}
					initialProviders.push(value.ProviderName);
				});
			}
			//bindSocialPoupButtons(response);
			if (response.RemainingProviders && response.RemainingProviders.length && response.RemainingProviders.length !== 0) {
				$("#myModalSocial .inner-panel").empty();
				$.each(response.RemainingProviders, function (index, value) {
					//var divId = "div-" +index;
					var innerDiv = "",
                        socialMediaIcon = accountSocialClassObj.getSocialMediaIcon(value.SocialProviderId);
					if (socialMediaIcon) {
						innerDiv = innerPanelTemplate.format(value.ProviderName, socialMediaIcon, value.SocialProviderId);
					} else {
						innerDiv = innerNoIconTemplate.format(value.ProviderName, value.SocialProviderId);
					}
					$("#myModalSocial .inner-panel").append(innerDiv);
				});
				$("#socialnewbutton").removeClass("addbutton-disabled");
				$("#socialnewbutton").attr("disabled", false);
			} else {
				$("#socialnewbutton").addClass("addbutton-disabled");
				$("#socialnewbutton").attr("disabled", true);
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindSocialDataUI " + err);
		}
	};
	/**
	 * Function  for appending the added social media
	 */
	this.appendAddedSocialMediaData = function (selectedSocialArray) {
		try {
			var accountSocialClassObj = new AccountSocialClass();
			$.each(selectedSocialArray, function (index, value) {
				var socialMediaIcon = accountSocialClassObj.getSocialMediaIcon(value.SocialProviderId),
                    socialDiv = socialMediaTemplate.format(value.ProviderName, "", "", socialMediaIcon);
				$("#addingsocia_content").append(socialDiv);
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : appendAddedSocialMediaData " + err);
		}

	};
	/**
	 * bindSocialPoupButtons
	 */
	this.bindSocialPoupButtons = function (response) {
		$("#myModalSocial .inner-panel").empty();
		var allDetails = [];
		try {
			if (response.RemainingProviders && response.RemainingProviders.length && response.RemainingProviders.length !== 0) {
				$.each(response.RemainingProviders, function (index, value) {
					if (jQuery.inArray(value, allDetails) === -1) {
						allDetails.push(value);
					}
				});
			}
			if (response.ProvidersForAplayer && response.ProvidersForAplayer.length && response.ProvidersForAplayer.length !== 0) {
				$.each(response.ProvidersForAplayer, function (index, value) {
					if (jQuery.inArray(value, allDetails) === -1) {
						allDetails.push(value);
					}
				});
			}
			if (allDetails && allDetails.length && allDetails.length !== 0) {
				$.each(allDetails, function (index, value) {
					//var divId = "div-" +index;
					var innerDiv = "",
                        socialMediaIcon = accountSocialClassObj.getSocialMediaIcon(value.SocialProviderId);
					if (socialMediaIcon) {
						innerDiv = innerPanelTemplate.format(value.ProviderName, socialMediaIcon, value.SocialProviderId);
					} else {
						innerDiv = innerNoIconTemplate.format(value.ProviderName, value.SocialProviderId);
					}
					$("#myModalSocial .inner-panel").append(innerDiv);
				});
			}
			bindCheckBoxValues();

		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindSocialPoupButtons " + err);
		}
	};
};