/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants,Apiservicecalls,applicationDataObj,endLoading,logout,startLoading,headerMain,subHeaderBenefitsHide,isApp,navigationArrowMenu*/

var agentBenefitsClass = function () {
    /** get health data **/
    this.getBenefitsData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getBenefitsRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.onAgentsSuccess, this.onAgentsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getHealthData" + err);
        }
    };

    /** Binding Health body data**/
   
    this.bindAgentsResponse = function (response) {
        try {
            
            $("#agent-benefits-content").append(response.Content);
            if (response.Query !== null) {
                var scriptQuery = '<script language="JavaScript">';
                scriptQuery = scriptQuery + response.Query;
                scriptQuery = scriptQuery + '</script>';
                $("#agent-benefits-content").append(scriptQuery);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindAgentsResponse" + err);
        }
    };

    /** Creating request parameters**/
    this.getBenefitsRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(), data = {}, userSession = {};
            data.userId = sessionData.userId;
            data.ServiceProvider = "BenefitsServiceProvider";
            data.ServiceMethod = "GetHealth";
            data.Language = constants.Language;
            data.ParametersArray = ["7ce5c7d5-8a8f-4588-890a-7ade4ca048cb"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getBenefitsRequestParameters" + err);
        }
    };
    /*Ajax - Success Call back*/
    this.onAgentsSuccess = function (data) {
        try {
            var agentClassObj = new agentBenefitsClass();
            agentClassObj.bindAgentsResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onAgentsSuccess" + err);
        }
    };
    this.onAgentsError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : onAgentsError" + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onAgentsError" + err);
        }
    };
};

var agentBenefits = function () {
    try {
        if (isApp) {
            window.ga.trackView('Benefits agents');
        }
        var agentClassObj = new agentBenefitsClass();
        startLoading();
        headerMain();
        subHeaderBenefitsHide();
        navigationArrowMenu();
        agentClassObj.getBenefitsData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : agentBenefits" + err);
    }
};
