/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants,Apiservicecalls,applicationDataObj,endLoading,logout,subHeaderCarousel,navigationArrowMenu,isApp,startLoading,headerMain*/

/**
 * Allbenefits Class
 */
var AllbenefitsClass = function () {
    var phoneNo = "",
        benefitsData = {},
        benefitsPhoneNo = "";
    /** get benefits data **/
    this.getBenefitsData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getAllBenefitsRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.onAllBenefitsSuccess, this.onAllBenefitsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getBenefitsData " + err);
        }
    };

    /**
  * Creating request parameters
  */
    this.getAllBenefitsRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "BenefitsServiceProvider";
            data.ServiceMethod = "GetBenefitsDetails";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["8EBF28E4-F79F-430A-8728-3248C2A30BDF"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getAllBenefitsRequestParameters " + err);
        }

    };

    /** bind table data **/
    this.bindTabledata = function (response) {
        var benefitslength,
            benefitTitle,
            detailsImage = "",
            benefitText,
            benefitsPhoneNo,
            imageId,
            i,
            src,
            benefitsEmailAddress,
            benefitAppendDetail;
        AllbenefitsClass.benefitsData = response;
        benefitslength = response.Benefits.length;
        for (i = 0; i < benefitslength; i = i + 1) {
            src = "";
            if (response.Benefits[i].BenefitImage !== null) {
                src = response.Benefits[i].BenefitImage.Src;
            } else {
                src = "";
            }
            benefitTitle = response.Benefits[i].BenefitTitle;
            benefitText = response.Benefits[i].BenefitText;
            if (response.Benefits[i].BenefitImage && response.Benefits[i].BenefitImage.Src) {
                detailsImage = response.Benefits[i].BenefitImage.Src;
            }
            if (response.Benefits[i].Contacts.length !== 0) {
                benefitsPhoneNo = response.Benefits[i].Contacts[0].ContactNumber;
                benefitsPhoneNo = benefitsPhoneNo.replace(/\s+/g, '');
            } else {
                benefitsPhoneNo = "";
            }
            
            if (response.Benefits[i].EmailAddress.length !== 0) {
                benefitsEmailAddress = response.Benefits[i].EmailAddress[0].EmailAddress;
            } else {
                benefitsEmailAddress = "";
            }
            imageId = "benefitsImage-" + i;
            benefitAppendDetail = '<div class="role-innercntnr3 commondivclass margin-top-15"><div class="allbenefits-imgcntnr"><img id = "' + imageId + '" class="col-sm-5 col-md-5 col-xs-5 pull-left mylndng-plyrimg benefitbox" alt="Benefit image"/></div><div class="benefits-inrcntnr1-div"><div class="font-bold padding0"><div class="benefits-plyr-postn">' + response.Benefits[i].BenefitTitle + '</div></div><div class="benefits-inrcntnr1-cntnt">' + response.Benefits[i].SummaryText + '<div class="benefitContent hide">' + response.Benefits[i].BenefitText + '</div></div></div><div class="clearfix"></div><div class="benefitInfo"><span class="phonedetails"><a data-title = "' + response.Benefits[i].BenefitTitle + '" data-src = "' + detailsImage + '" class="benefitanchor" onClick="benefitsDetailsReady(this)">DETAILS</a>';
            
            if (benefitsPhoneNo !== "") {
                benefitAppendDetail = benefitAppendDetail + '<a href="#" accesskey="C"><img id="phoneNoClick" src="images/phone.png" class="benefits-email contactcallDetails" alt="Call" onClick="benefitPhone(' + benefitsPhoneNo + '); "/></a></span>';
            } else {
                benefitAppendDetail = benefitAppendDetail + '</span>';
            }
            
            if (benefitsEmailAddress !== "") {
                benefitAppendDetail = benefitAppendDetail + '<span><a href="mailto:' + benefitsEmailAddress + '" accesskey="E" ><img id="emailclick" src="images/e-mail_no_fill.png" class="benefits-email contactemail margin-left-2" alt="Email"></a></span></div></div>';
            }
            $(".benefits-details-table").append(benefitAppendDetail);
            $(".appendModal").append('<div id="container-divModal' + i + '" class="modal fade modal-height2" role="dialog">'    + '<div id="myModalEdit"><div class="modal-dialog modal-dailog-width">' +
                '<div class="modal-content myprofile-modal-container"><div class="">' +
                '<figure><img src="images/close_black.svg" alt="cross" class="mplndg-popup-close" data-dismiss="modal">' +
                '</figure></div><div id="benefit-contact-details' + i + '"></div><div class="emptydiv">' +
                '</div><div class="clearfix"></div></div></div></div></div>');
            if (response.Benefits[i].BenefitImage !== null) {
                $("#" + imageId).attr('src', response.Benefits[i].BenefitImage.Src);
            }
        }
    };
    
    /** Send Email **/

    this.sendEmail = function (mailId) {
        if (mailId[0].EmailAddress !== null) {
            window.location.href = "mailto:" + mailId;
        }
    };
    /**
       * Ajax success call
      */
    this.onAllBenefitsSuccess = function (data) {
        try {
            var benefitsObj = new AllbenefitsClass();
            benefitsObj.bindAllBenefitsResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onAllBenefitsSuccess " + err);
        }

    };
    /*Ajax - Error Call back*/
    this.onAllBenefitsError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : onAllBenefitsError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onAllBenefitsError " + err);
        }
    };

    /**
	 * Bind all benefits body data
	 */
    this.bindAllBenefitsResponse = function (response) {
        try {
            var found = 0;
            $(".benefitxt").append(response.SectionHeading);
            if (response.FeaturedBenefit.BenefitImage && response.FeaturedBenefit.BenefitImage.Src) {
                $("#featured_benefits_image").attr('src', response.FeaturedBenefit.BenefitImage.Src);
            }
            $("#featured_benefits_details").append(response.FeaturedBenefit.BenefitText);
            $("#detailslink").click(function () {
                var benefitsObj = {},
                    srcMain = "";
                benefitsObj.title = response.SectionHeading;
                benefitsObj.text = response.FeaturedBenefit.BenefitText;
                if (response.FeaturedBenefit.BenefitImage && response.FeaturedBenefit.BenefitImage.Src) {
                    srcMain = response.FeaturedBenefit.BenefitImage.Src;
                } else {
                    srcMain = "";
                }
                benefitsObj.img = srcMain;
                applicationDataObj.setbenefitsDetailObj(benefitsObj);
                window.location.href = "#/Benefits-details";
            });

            $('#callPhone').click(function () {
                event.preventDefault();
                window.location.href = "tel:" + phoneNo;
            });

            $("#email-send-image").append('<img id="email-img"src="images/e-mail_no_fill.png" class="benefits-email contactemail margin-left-2" alt="Email">');
            if (response.FeaturedBenefit.Contacts.length !== 0) {
                phoneNo = response.FeaturedBenefit.Contacts[0].ContactNumber;
            }
            this.bindTabledata(response);
            $('#email-img').click(function () {
                event.preventDefault();
                if (response.FeaturedBenefit.EmailAddress !== null) {
                    window.location.href = "mailto:" + response.FeaturedBenefit.EmailAddress[0].EmailAddress;
                }
            });
          
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindAllBenefitsResponse " + err);
        }
    };
    
};

var benefitPhone = function (phoneNum) {
    window.location.href = "tel:" + phoneNum;
};


/* Benefits details Ready function */

var benefitsDetailsReady = function (event) {
        var benefitsObj = {};
        benefitsObj.title = $(event).attr("data-title");//title;
        benefitsObj.text = $(event).parent().parent().siblings().find('.benefitContent').html();//text;
        benefitsObj.img = $(event).attr("data-src"); //img;
        applicationDataObj.setbenefitsDetailObj("");
        applicationDataObj.setbenefitsDetailObj(benefitsObj);
        window.location.href = "#/Benefits-details";
    };

function subHeaderBenefitsHide() {
    try {
        var role = "",
            lowerConvertedRole;
        if (applicationDataObj.getSessionResponse() && applicationDataObj.getSessionResponse().roles &&
			     applicationDataObj.getSessionResponse().roles.length !== 0) {
            role = applicationDataObj.getSessionResponse().roles[0];
        }
        if (role) {
            lowerConvertedRole = role.toLowerCase();
            if (lowerConvertedRole.indexOf("atp coach/atp agent") === 0 || lowerConvertedRole.indexOf("atp agent") === 0 || lowerConvertedRole.indexOf("atp coach/atp agent") === 0 || lowerConvertedRole.indexOf("atp coach") === 0) {
                $(".playerbenefits").addClass("hide");
                $(".nonplayerbenefits").removeClass("hide");
                subHeaderCarousel();
                navigationArrowMenu();
            } else {
                if (applicationDataObj.getpensionTrue()) {
                    $(".playerbenefits").removeClass("hide");
                    $(".nonplayerbenefits").addClass("hide");
                    subHeaderCarousel();
                    navigationArrowMenu();
                } else {
                    if (lowerConvertedRole.indexOf("registered player") === 0) {
                        $(".registeredPlayer").addClass("show");
                        $("#leftarrow").hide();
                        $("#rightarrow").hide();
                    } else {
                        $(".playerbenefits").addClass("hide");
                        $(".nonplayerbenefits").removeClass("hide");
                        $("#leftarrow").hide();
                        $("#rightarrow").hide();
                    }
                  
                }
                
            }
        }

    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : subHeaderBenefitsHide " + err);
    }
}
/**
 * All benefits Ready Function
 */
var benefitsReady = function () {
    try {
        if (isApp) {
            window.ga.trackView('BenefitsPage');
        }
        var allbenefitsClassObj = new AllbenefitsClass();
        startLoading();
        headerMain();
        subHeaderBenefitsHide();
        allbenefitsClassObj.getBenefitsData();
        /*$('#search').focus(function () {
            $("#MyApp").scrollTop($(".role-innercntnr4").height() + $(".benefitxt").height() + $(".tab-bg").height());
        });*/
        /** search Benefits **/
        $('#search').bind('keyup', function (event) {
            var value,
                finder = "",
                title,
                benefitsObj;
            if (event.keyCode === 13 || event.charCode === 13) {
                $('#search').blur();
            } else if ($(".searchbenefit").val()) {
                $(".search-img").hide();
                $(".pro-close-img").show();
                value = $(".searchbenefit").val();
                if (value !== "") {
                    $(".role-innercntnr3").each(function () {
                        title = $(this).find(".benefits-plyr-postn").text();
                        if (title.toLowerCase().indexOf(value.toLowerCase()) >= 0) {
                            $(this).show();
                        } else {
                            $(this).hide();
                        }
                    });
                }
            } else {
                $(".search-img").show();
                $(".pro-close-img").hide();
                $(".benefits-details-table").show();
                $(".benefits-details-table div").empty();
                $(".benefits-details-table").html('');
                benefitsObj = new AllbenefitsClass();
                benefitsObj.bindTabledata(AllbenefitsClass.benefitsData);
            }
        });

        $('.pro-close-img').click(function () {
            $(".search-img").show();
            $('.pro-close-img').hide();
            $(".pro-Notification-username-field").val("");
            $(".benefits-details-table div").empty();
            $(".benefits-details-table").html('');
            var benefitsObj = new AllbenefitsClass();
            benefitsObj.bindTabledata(AllbenefitsClass.benefitsData);
        });
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : benefitsReady " + err);
    }
};