/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants,Apiservicecalls,applicationDataObj,startLoading,endLoading,logout,isApp,headerMain,subHeaderHide*/

/* Anti Doping class */
var AntiDopingClass = function () {
    
    /** get Anti Doping data **/
    this.getAntiDopingData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getDopingRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnDopingSuccess, this.OnDopingError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getAntiDopingData " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getDopingRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "BenefitsServiceProvider";
            data.ServiceMethod = "GetATPAdvantage";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["68FF1904-9082-4E0B-8099-0C256A9F4863"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.Country = sessionData.country;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getDopingRequestParameters " + err);
        }
    };
    
    /** binding Doipng body data **/
    this.bindDopingResponse = function (data) {
        startLoading();
        try {
            $("#rules-anti-dopping").append(data.Content);
            if (data.Query !== null) {
                var scriptQuery = '<script language="JavaScript">';
                scriptQuery = scriptQuery + data.Query;
                scriptQuery = scriptQuery + '</script>';
                $("#rules-anti-dopping").append(scriptQuery);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindDopingResponse " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnDopingSuccess = function (data) {
        try {
            var dopingClassObj = new AntiDopingClass();
            dopingClassObj.bindDopingResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDopingSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnDopingError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDopingError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDopingError " + err);
        }
    };
};

/* Anti Doping */

var antiDopingReady = function () {
    try {
        if (isApp) {
            window.ga.trackView('Rules Anti-Doping');
        }
        var antiDopingObj = new AntiDopingClass();
        startLoading();
        headerMain();
        subHeaderHide();
        antiDopingObj.getAntiDopingData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : antiDoping " + err);
    }
};


var navigationRulesAlumniArrowMenu = function () {
    var firstContactAct = $("#rightarrow").parent().children().children().children(".alumniitem").first().hasClass("active"),
        lastContactAct = $("#rightarrow").parent().children().children().children(".alumniitem").last().hasClass("active");
    if (firstContactAct !== true && lastContactAct !== true) {
        $("#leftarrow").show();
        $("#rightarrow").show();
    } else if (firstContactAct === true) {
        $("#leftarrow").hide();
        $("#rightarrow").show();
    } else if (lastContactAct === true) {
        $("#leftarrow").show();
        $("#rightarrow").hide();
    }
    $("#rightarrow").click(function () {
        firstContactAct = $("#rightarrow").parent().children().children().children(".alumniitem").first().hasClass("active");
        lastContactAct = $("#rightarrow").parent().children().children().children(".alumniitem").last().hasClass("active");
        if (firstContactAct === true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        }
    });

    $("#leftarrow").click(function () {
        firstContactAct = $("#leftarrow").parent().children().children().children(".alumniitem").first().hasClass("active");
        lastContactAct = $("#leftarrow").parent().children().children().children(".alumniitem").last().hasClass("active");
        if (lastContactAct === true) {
            $("#leftarrow").hide();
            $("#rightarrow").show();
        }
    });
};