/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants,Apiservicecalls,applicationDataObj,endLoading,logout,isApp,startLoading,subHeaderBenefitsHide,navigationArrowMenu,headerMain*/

var agentMembershipClass = function () {
    /** get health data **/
    this.getMembershipData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getMembershipRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.onAgentMembershipSuccess, this.onAgentMembershipError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getHealthData" + err);
        }
    };

    /** Binding Health body data**/
   
    this.bindAgentMembershipResponse = function (response) {
        try {
            
            $("#benefits-membership-content").append(response.Content);
            if (response.Query !== null) {
                var scriptQuery = '<script language="JavaScript">';
                scriptQuery = scriptQuery + response.Query;
                scriptQuery = scriptQuery + '</script>';
                $("#benefits-membership-content").append(scriptQuery);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindAgentsResponse" + err);
        }
    };

    /** Creating request parameters**/
    this.getMembershipRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(), data = {}, userSession = {};
            data.userId = sessionData.userId;
            data.ServiceProvider = "BenefitsServiceProvider";
            data.ServiceMethod = "GetHealth";
            data.Language = constants.Language;
            data.ParametersArray = ["9942eb94-9141-407e-a449-f44e82a54d70"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getBenefitsRequestParameters" + err);
        }
    };
    /*Ajax - Success Call back*/
    this.onAgentMembershipSuccess = function (data) {
        try {
            var agentMembershipObj = new agentMembershipClass();
            agentMembershipObj.bindAgentMembershipResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onAgentMembershipSuccess" + err);
        }
    };
    this.onAgentMembershipError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : onAgentMembershipError" + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onAgentMembershipError" + err);
        }
    };
};

var BenefitsMembership = function () {
    try {
        if (isApp) {
            window.ga.trackView('Benefits agents');
        }
        var agentMembershipObj = new agentMembershipClass();
        startLoading();
        headerMain();
        subHeaderBenefitsHide();
        navigationArrowMenu();
        agentMembershipObj.getMembershipData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : BenefitsMembership" + err);
    }
};
