/**
File Name       : constants.js
Description     : Common variables accross app
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/

// Dev env - Dev Testing (Desktop only, does not work on mobile device since it needs to use hosts file)
//var envUrl = "http://ed.dev.atppz.com";
//var apiUrl = "http://devapi.atppz.com";
//var envAdminURL = "https://portalx.atppz.com";

// X env - QA Testing
//var envUrl = "https://wwwx.atppz.com";
//var apiUrl = "https://svcx.atppz.com";
//var envAdminURL = "https://portalx.atppz.com";

// PROD env - Production
var envUrl = "https://www.atppz.com";
var apiUrl = "https://svc.atppz.com";
var envAdminURL = "https://portal.atppz.com";

var constants = {
    ajaxUrl: envUrl + "/atp-api/DataApi/PZDataProcessorCompressed",
    ajaxTokenUrl: envUrl + "/atp-api/DataApi/Token",
    maintenanceURL: envAdminURL + "/api/dataapi/getmaintenancepage",
    mobileAppVersionURL: apiUrl + "/api/MobileAppForcedUpdate",
    saveBiometricUrl: envUrl + "/api/Sitecore/Registration/SaveBiometricUserData",
    removeBiometricUrl: envUrl + "/api/Sitecore/Registration/RemoveBiometricUserData",
    loggerUrl: envUrl + "/atp-api/DataApi/HybridLogger",
    englishLanguage: "en",
    carousalUrl: envUrl,
    basePath: envUrl,
    hybridAppSessionUrl: envUrl + "/registration/hybridappsession",
    entryMainUrl: envUrl + "/entries/entry?HybridApp=1",
    hybridAppLogin: envUrl + "/api/Sitecore/Registration/HybridAppLogin",
    hybridAppSessionValue: envUrl + "/api/Sitecore/Registration/SetOnBehalfPlayerIdSessionValue",
    photoUploadUrl: envUrl + "/atp-api/DataApi/PZDataProcessorSaveHeadshot",
    activeScheduleTab: "",
    liveScoreLoading: false,
    preferredUsdAddress: '3',
    preferredUsdWire: '2',
    preferredEurAddress: '3',
    preferredEurWire: '2',
    onBehalfPlayerId: '',
    receiveEmailNotifications: "",
    headShotImage: "",
    logSeverityError: "Error",
    logSeverityInfo: "Info",
    logSeverityFatal: "Fatal",
    errorCode401: 401,
    unauthorizedError: "Unauthorized",
    managingPlayers: false,
    managingModule: "",
    searchDefaultItems: 0,
    IOS: "IOS",
    Android: "Android",
    appName: "ATP PlayerZone 2.0",
    androidAppVersion: "1.3.1",
    iosAppVersion: "1.3.1"
};

var mwebUrls = {
    entryMainUrl: envUrl + "/entries/entry?HybridApp=1",
    acceptanceList: envUrl + "/entries/acceptance-list?HybridApp=1",
    priliminaryList: envUrl + "/entries/preliminary-list?HybridApp=1",
    entryActivity: envUrl + "/entries/entry-activity?HybridApp=1",
    entryWithdrawal: envUrl + "/entries/withdrawal?HybridApp=1",
    findPartner: envUrl + "/entries/find-partner?HybridApp=1",
    protectedRanking: envUrl + "/entries/protected-ranking?HybridApp=1",
    tournamentsCalendar: envUrl + "/tournaments/calendar?HybridApp=1",
    tourDetailSheet: envUrl + "/tournaments/tour-detail-sheets?HybridApp=1",
    challengerDetailSheet:  envUrl + "/tournaments/ch-detail-sheets?HybridApp=1",
    hotel: envUrl + "/tournaments/hotel?HybridApp=1",
    visa: envUrl + "/tournaments/visas?HybridApp=1",
    tournamentForms: envUrl + "/tournaments/transportation?HybridApp=1",
    cutoffs: envUrl + "/tournaments/cut-offs?HybridApp=1",
    singleRankings: envUrl + "/rankings/singles?HybridApp=1",
    singlesRace: envUrl + "/rankings/race-to-london?HybridApp=1",
    doubleRankings: envUrl + "/rankings/doubles?HybridApp=1",
    rankingsTeam: envUrl + "/rankings/team?HybridApp=1",
    rankingsPrizeMoney: envUrl + "/rankings/prize-money?HybridApp=1",
    rankingsStatistics: envUrl + "/rankings/statistics?HybridApp=1",
    rankingsBreakDown: envUrl + "/rankings/singles-breakdown?playerId=MC10&HybridApp=1",
    rankingSinglesBD: envUrl + "/rankings/singles-race-breakdown?playerId=MC10&HybridApp=1",
    rankingsDoubleBd: envUrl + "/rankings/doubles-breakdown?playerId=MC10&HybridApp=1",
    rankingsTeamBd: envUrl + "/rankings/team-breakdown?playerId=MC10&HybridApp=1",
    manageEntryUrl: envUrl + "/manage-player/entries/entry?HybridApp=1",
    videoUrl: envUrl + "/videos/videos?HybridApp=1",
    tennistvUrl: envUrl + "/videos/tennis-tv?HybridApp=1",
    playerzoneUrl: envUrl
};

var appMsgs = {
    noNetworkError: "Please check the Internet Connection",
    timeoutError: "Unexpected error occurred. Please wait and try again shortly.",
    serviceUnavailable: "Service unavailable"
};