/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants*/

/* FAQ class */
var active = true;
var FaqClass = function () {
    
    /** get FAQ data **/
    this.getFAQData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getFAQRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnFAQSuccess, this.OnFAQError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getFAQData " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getFAQRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "FAQServiceProvider";
            data.ServiceMethod = "GetFAQ";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["79f852f7-e11b-474d-ac77-626ba24c2d68"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getFAQRequestParameters " + err);
        }
    };
    
    /** binding FAQ body data **/
    this.bindFAQDetails = function (data) {
        try {
            $("#contactFAQ-openclose").append(data.OpenAll);
            var questionAnswer = data.QuestionAnswer,
                queslen = questionAnswer.length,
                i;
            /*Opening and closing of collapsible*/
            $('#contactFAQ-openclose').click(function () {
                if (active) {
                    active = false;
                    $(".newsflash-accordion a").addClass("newsflash-menu");
                    $(".newsflash-accordion a").removeClass("collapsed");
                    $('.contact-faq-accord .newsflashpanel-collapse').removeClass("collapsed");
                    $('.contact-faq-accord .newsflashpanel-collapse').addClass("in");
                    $('.newsflash-accordion').find("span").removeClass('news-flash-plus').addClass('news-flash-minus');
                    $(this).text(data.CloseAll);
                    $(".newsflashpanel-collapse").removeAttr("style");
                } else {
                    active = true;
                    $('.contact-faq-accord .panel-collapse').collapse('hide');
                    $(".newsflash-accordion a").addClass("collapsed");
                    $('.contact-faq-accord .newsflashpanel-collapse').removeClass("in");
                    $('.contact-faq-accord .newsflashpanel-collapse').addClass("collapsed");
                    $('.newsflash-accordion').find("span").removeClass('news-flash-minus').addClass('news-flash-plus');
                    $(this).text(data.OpenAll);
                }
            });
            for (i = 0; i < queslen; i = i + 1) {
                $("#newsflash-accordcontent").append('<div class="panel panel-default">' +
                          '<div class="newsflash-accordion panel-heading">' +
                          '<a accesskey="C" data-toggle="collapse" role="button"' +
                          'data-target="#collapsenewsflash' + i + '" aria-expanded="true" aria-controls="collapsenewsflash' + i + '"' +
                          'class="collapsed newsflash-accrdian-title" id="question-title' + i + '"><div class="row"><div class="col-xs-11">' + questionAnswer[i].Question + '</div>' +
                          '<span class="col-xs-1 pull-right news-flash-plus"></span></div></a></div>' +
                          '<div id="collapsenewsflash' + i + '" class="newsflashpanel-collapse collapse" role="tabpanel"' +
                          'aria-labelledby="headingOne">' +
                          '<div class="panel-body bg-colorgrey"><div class="newsflas-panelbody-content">' +
                          '<p id="question-answer' + i + '">' + questionAnswer[i].Answer + '</p></div></div></div></div>');
            }
            $('.contact-faq-accord').on('hide.bs.collapse', toggleIconContact);
            $('.contact-faq-accord').on('show.bs.collapse', toggleIconContact);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindFAQDetails " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnFAQSuccess = function (data) {
        try {
            var faqClassObj = new FaqClass();
            faqClassObj.bindFAQDetails(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFAQSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnFAQError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFAQError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFAQError " + err);
        }
    };
    
};

/* FAQ */

var frequentlyAskedQuestion = function () {
    try {
        if (isApp) {
            window.ga.trackView('Contacts FAQ');
        }
        var faqObj = new FaqClass();
        startLoading();
        headerMain();
        subHeaderContactHide();
        subHeader();
        subHeaderEllipsis();
        faqObj.getFAQData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : frequentlyAskedQuestion " + err);
    }
};


/* toggle icon */
function toggleIcon(e) {
    if (e.type === 'show') {
        $(e.target)
            .prev(".panel-heading")
            .find(".newsflash-accrdian-title");
    }
    if (e.type === 'hide') {
        $(e.target)
            .prev(".panel-heading")
            .find(".newsflash-accrdian-title");
    }
}
$('.contact-faq-accord').on('hide.bs.collapse', toggleIcon);
$('.contact-faq-accord').on('show.bs.collapse', toggleIcon);



var navigationContactOtherArrowMenu = function () {
    var firstContactAct = $("#rightarrow").parent().children().children().children(".otheritem").first().hasClass("active"),
        lastContactAct = $("#rightarrow").parent().children().children().children(".otheritem").last().hasClass("active");
    if (firstContactAct === true) {
        $("#leftarrow").hide();
        $("#rightarrow").hide();
    }
};


function toggleIconContact(e) {
    var x = $(".newsflash-accordion").length,
        i = 0,
        y = $(".newsflash-accordion").length,
        j = 0;
    if ($(e.target).prev('.newsflash-accordion').find("span").hasClass("news-flash-plus") || $(e.target).prev('.newsflash-accordion').find("span").hasClass("news-flash-minus")) {

        if (e.type === 'show') {
            $(e.target).prev('.newsflash-accordion').find("span").removeClass('news-flash-plus').addClass('news-flash-minus');
            
            $(".newsflashpanel-collapse").each(function () {
                if ($(this).eq(0).parent().children().eq(0).children("a").find("div.row").children().eq(1).hasClass("news-flash-minus")) {
                    i = i + 1;
                }
            });
            
            if (i === x) {
                $("#contactFAQ-openclose").text('CLOSE ALL');
            } else if (j === y) {
                $("#contactFAQ-openclose").text('OPEN ALL');
            }
    	
        }
        if (e.type === 'hide') {
            $(e.target).prev('.newsflash-accordion').find("span").removeClass('news-flash-minus').addClass('news-flash-plus');
            
            $(".newsflashpanel-collapse").each(function () {
    	
                if ($(this).eq(0).parent().children().eq(0).children("a").find("div.row").children().eq(1).hasClass("news-flash-plus")) {
                    j = j + 1;
                }
            });
            
            if (j === y) {
                $("#contactFAQ-openclose").text('OPEN ALL');
            } else if (i === x) {
                $("#contactFAQ-openclose").text('CLOSE ALL');
            }
        }
    }
}
