/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants*/

/* Player Relation class */

var PlayerRelationClass = function () {
    /** get Anti corruption data **/
    this.getPlayerRelationData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getPlayerRelationsParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnPlayerRelationsSuccess, this.OnPlayerRelationsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getPlayerRelationData " + err);
        }
    };
    
    /** binding player Relation body data **/
    this.bindPlayerRelationsResponse = function (response) {
        try {
            var i,
                phNum;
            PlayersRelationsLength = response.PlayerRelations.length;
            for (i = 0; i < PlayersRelationsLength; i = i + 1) {
                $(".contact-details").append('<div class="role-innercntnr3 commondivclass" id="commondivid' + i + '"><div class="pull-left contact-medical-plyrimg" id="playerrelateimage' + i + '"></div></div>');
                if (response.PlayerRelations[i].HeadshotImage !== null && response.PlayerRelations[i].HeadshotImage !== "") {
                    $("#playerrelateimage" + i).append('<img src="' + response.PlayerRelations[i].HeadshotImage.Src + '" alt="image"/>');
                } else {
                    $("#playerrelateimage" + i).append('<img src="images/Photo_Grey.png"/>');

                }
                phNum = $(response.PlayerRelations[i].PhoneNumber).text();
                phNum =  phNum.split("-").join("");
                $("#commondivid" + i).append('<div class="mylndng-inrcntnr1-div1"><div class="mylndng-inrcntnr1-cntnt1">' +
                                             '<div class="col-xs-12 paddinglftryt0 paddtopten"><span class="roleplayername2 pull-left paddtopfive">' + response.PlayerRelations[i].Name +
                                             '</span><div class="clearfix"><span class="contact_profile4 pull-left margin-top-iphone6-18 padding-left-1 paddtopfive">' + response.PlayerRelations[i].Position +
                                             '</span></div><div class="col-xs-12 paddinglftryt0 margin-top-iphone6-18 paddingtop10"><span class="phonedetails"><a href="#" accesskey="C">' +
                                             '<img src="images/phone.png" class="benefits-email contactcallDetails call-playerrelation" alt="Call" onclick="event.preventDefault();contactClick(' + phNum + ');">' +
                                             '</a></span><span><a href="mailto:' + response.PlayerRelations[i].EmailAddress + '" accesskey="E"><img src="images/e-mail_no_fill.png" class="benefits-email contactemail margin-left-2 email-playerrelation" alt="Email">' +
                                             '</a></span></div></div></div></div><div class="col-xs-12 contact_profile4 contact-hr-div bordercontact"><ul class="padding-left-0 paddzero">' + response.PlayerRelations[i].Description + '</ul></div>');
            }
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindPlayerRelationsResponse " + err);
        }
    };
    
    
    /** Creating request Parameters **/
    this.getPlayerRelationsParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "PlayerRelationsServiceProvider";
            data.ServiceMethod = "GetPlayerRelations";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["7B394A78-0E90-420A-9BCE-27024BC5E5A3"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getPlayerRelationsParameters " + err);
        }
    };
    
    /*Ajax - Success Call back*/
    this.OnPlayerRelationsSuccess = function (data) {
        try {
            var playerRelationClassObj = new PlayerRelationClass();
            playerRelationClassObj.bindPlayerRelationsResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnPlayerRelationsSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnPlayerRelationsError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnPlayerRelationsError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnPlayerRelationsError " + err);
        }
    };
};

/* Player Relation */
var playerrelations = function () {
    try {
        if (isApp) {
            window.ga.trackView('Contact PlayerRelations');
        }
        var playerRelationObj = new PlayerRelationClass();
        startLoading();
        headerMain();
        subHeaderContactHide();
        subHeaderPlayer();
        subHeaderEllipsis();
        playerRelationObj.getPlayerRelationData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : playerrelations " + err);
    }
};


/** Contact button click function **/

function contactClick(contactNumber) {
    window.location.href = "tel:" + contactNumber;
}

function subHeaderEllipsis() {
    if (isApp) {
        if (cordova.platformId === 'ios') {
            $(".ellipse").removeClass("paddinglftryt0");
        }
    }
}



function subHeaderPlayer() {
    $("#leftarrow").hide();
    $('#alignCarousal').bind('slid.bs.carousel', function (e) {
        if ($('.carousel-inner .playeritem:first').hasClass('active')) {
            $('#leftarrow').hide();
            $('#rightarrow').show();
        }
        if ($('.carousel-inner .playeritem:last').hasClass('active')) {
            $('#rightarrow').hide();
            $('#leftarrow').show();
        }
        
    });
    $('#myCarousel').on('slid', function (e) {
        if ($('.carousel-inner .playeritem:first').hasClass('active')) {
            $('.left .carousel-control').hide();
            $('.right .carousel-control').show();
        }
        if ($('.carousel-inner .playeritem:last').hasClass('active')) {
            $('.right .carousel-control').hide();
            $('.left .carousel-control').show();
        }
    });
}


