/**
  * This software is the confidential and proprietary information of
  * ATP and may not be used, reproduced, modified, distributed,
  * publicly displayed or otherwise disclosed without the express written
  * consent of ATP. 
  */
 
 /* Directories class */
 var globalData,
     globalDataAlumni,
     globalDataCoach,
     globalDataAgent,
     directoryRole = "",
     onScroll = "-1",
     searchitem = "",
     issearch = false,
     startrow = 0,
     directoryItem = "32110032-06BE-4309-B8F7-E3B124470F72",
     alumniCount = 0,
     coachCount = 0,
     agentCount = 0,
     alumniTotalCount = 0,
     coachTotalCount = 0,
     agentTotalCount = 0,
     clickedField;
 
 var DirectoriesClass = function () {
     /** get Directories data **/
     this.getdirectoriesData = function () {
         try {
             directoryRoleAlumni = "alumni";
             directoryRoleCoach = "coach";
             directoryRoleAgent = "agent";
             onScroll = "1";
             searchitem = "";
             issearch = false;
             startrow = 0;
             var apiservicecallsObj = new Apiservicecalls(),

                 inputDataAlumni = this.getDirectoriesRequestParameter(directoryRoleAlumni, onScroll, searchitem, issearch, startrow, directoryItem),
                 inputDataCoach = this.getDirectoriesRequestParameter(directoryRoleCoach, onScroll, searchitem, issearch, startrow, directoryItem),
                 inputDataAgent = this.getDirectoriesRequestParameter(directoryRoleAgent, onScroll, searchitem, issearch, startrow, directoryItem);
             apiservicecallsObj.postData(constants.ajaxUrl, inputDataAlumni, this.OnGetDirectoriesAlumniSuccess, this.OnGetDirectoriesAlumniError);
             apiservicecallsObj.postData(constants.ajaxUrl, inputDataCoach, this.OnGetDirectoriesCoachSuccess, this.OnGetDirectoriesCoachError);
             apiservicecallsObj.postData(constants.ajaxUrl, inputDataAgent, this.OnGetDirectoriesAgentSuccess, this.OnGetDirectoriesAgentError);
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getdirectoriesData " + err);
         }
     };
     
     this.OnGetDirectoriesAlumniSuccess = function (data) {
         try {
             globalDataAlumni = data;
             var directoryClassObj = new DirectoriesClass(),
                 alumniArrLength = 0;
             if (data.Alumni !== null) {
                 alumniArrLength = data.Alumni.length;
             }
             
             if (!(alumniArrLength == 0)) {
                 alumniTotalCount = data.AlumniCount;
             }
             
             if (alumniArrLength > 0 ) {
                 directoryClassObj.bindDirectoriesResponseAlumni(data,'');
                 alumniCount = alumniArrLength;
             } 
             endLoading();
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesAlumniSuccess " + err);
         }
     };
     
     this.OnGetDirectoriesAlumniError = function (jqXHR, error) {
         try {
             endLoading();
             var errorMessage = jqXHR.statusText;
             if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                 errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
             }
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesAlumniError " + errorMessage);
             if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                     jqXHR.statusText === constants.unauthorizedError) {
                 logout();
             }
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesAlumniError " + err);
         }
     };
     
     this.OnGetDirectoriesCoachSuccess = function (data) {
         try {
             globalDataCoach = data;
             var directoryClassObj = new DirectoriesClass(),
                 coachArrlength = 0;

             
             if (data.Coach !== null) {
                 coachArrlength = data.Coach.length;
             }
            
             if (!(coachArrlength == 0)) {
                 coachTotalCount = data.CoachCount;
             }
            
             if (coachArrlength > 0 ) {
                 directoryClassObj.bindDirectoriesResponseCoach(data,'');
                 coachCount = coachArrlength;
             }  
            
             endLoading();
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesCoachSuccess " + err);
         }
     };
     
     this.OnGetDirectoriesCoachError = function (jqXHR, error) {
         try {
             endLoading();
             var errorMessage = jqXHR.statusText;
             if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                 errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
             }
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesCoachError " + errorMessage);
             if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                     jqXHR.statusText === constants.unauthorizedError) {
                 logout();
             }
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesCoachError " + err);
         }
     };
     
     this.OnGetDirectoriesAgentSuccess = function (data) {
         try {
             globalDataAgent = data;
             var directoryClassObj = new DirectoriesClass(),
                 agentArrLength = 0;
            
             if (data.Agent !== null) {
                 agentArrLength = data.Agent.length;
             }
            
             if (!(agentArrLength == 0)) {
                 agentTotalCount = data.AgentCount;
             } 
               
             if (agentArrLength > 0 ) {
                 directoryClassObj.bindDirectoriesResponseAgent(data,'');
                 agentCount = agentArrLength;
             }
             endLoading();
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesAgentSuccess " + err);
         }
     };
     
     this.OnGetDirectoriesAgentError = function (jqXHR, error) {
         try {
             endLoading();
             var errorMessage = jqXHR.statusText;
             if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                 errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
             }
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesAgentError " + errorMessage);
             if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                     jqXHR.statusText === constants.unauthorizedError) {
                 logout();
             }
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesAgentError " + err);
         }
     };
     
     this.getdirectoriesDataAlumni = function () {
         try {
             directoryRole = "alumni",
             onScroll = "1",
             searchitem = "",
             issearch = false,
             startrow = alumniCount;
             var apiservicecallsObj = new Apiservicecalls(),
                 inputData = this.getDirectoriesRequestParametersAlumni(directoryRole, onScroll, searchitem, issearch, startrow, directoryItem);
             apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnDirectoriesAlumniSuccess, this.OnDirectoriesAlumniError);
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getdirectoriesData " + err);
         }
     };
     
     this.getdirectoriesSearch = function (directoryRole, onScroll, searchitem, issearch, startrow) {
         try {
             var apiservicecallsObj = new Apiservicecalls(),
                 inputData = this.getDirectoriesRequestParametersAlumni(directoryRole, onScroll, searchitem, issearch, startrow, directoryItem);
             apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnGetDirectoriesSuccess, this.OnGetDirectoriesError);
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getdirectoriesData " + err);
         }
     };
     
     this.getdirectoriesDataCoach = function () {
         try {
             directoryRole = "coach",
             onScroll = "1",
             searchitem = "",
             issearch = false,
             startrow = coachCount;
             var apiservicecallsObj = new Apiservicecalls(),
                 inputData = this.getDirectoriesRequestParametersCoach(directoryRole, onScroll, searchitem, issearch, startrow, directoryItem);
             apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnDirectoriesCoachSuccess, this.OnDirectoriesCoachError);
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getdirectoriesData " + err);
         }
     };
     
     this.getdirectoriesDataAgent = function () {
         try {
             directoryRole = "agent",
             onScroll = "1",
             searchitem = "",
             issearch = false,
             startrow = agentCount;
             var apiservicecallsObj = new Apiservicecalls(),
                 inputData = this.getDirectoriesRequestParametersAgent(directoryRole, onScroll, searchitem, issearch, startrow, directoryItem);
             apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnDirectoriesAgentSuccess, this.OnDirectoriesAgentError);
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getdirectoriesData " + err);
         }
     };
 
      /** Creating Directories Request Parameters **/
     this.getDirectoriesRequestParameter = function (directoryRole, onScroll, searchitem, issearch, startrow, directoryItem) {
         try {
             var sessionData = applicationDataObj.getSessionResponse(),
                 data = {},
                 userSession = {},
                 parametersArray = [];
             parametersArray.push(directoryRole);
             parametersArray.push(onScroll);
             parametersArray.push(searchitem);
             parametersArray.push(issearch);
             parametersArray.push(startrow);
             parametersArray.push(directoryItem);
             data.Userid = sessionData.userId;
             data.ServiceProvider = "DirectoriesServiceProvider";
             data.ServiceMethod = "GetDirectoriesSearch";
             data.Language = constants.englishLanguage;
             data.parametersArray = parametersArray;
             userSession.PlayerId = sessionData.playerId;
             userSession.Userid = sessionData.userId;
             userSession.FirstName = sessionData.firstName;
             userSession.LastName = sessionData.lastName;
             userSession.TOKEN = applicationDataObj.getToken();
             data.SessionData = userSession;
             data = JSON.stringify(data);
             return data;
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getDirectoriesRequestParameters " + err);
         }
     };
     
         /** Creating request Parameters **/
     this.getDirectoriesRequestParametersCoach = function (directoryRole, onScroll, searchitem, issearch, startrow, directoryItem) {
         try {
             var sessionData = applicationDataObj.getSessionResponse(),
                 data = {},
                 userSession = {};
             data.Userid = sessionData.userId;
             data.ServiceProvider = "DirectoriesServiceProvider";
             data.ServiceMethod = "GetDirectoriesSearch";
             data.Language = constants.englishLanguage;
             data.parametersArray = [directoryRole, onScroll, searchitem, issearch, startrow, directoryItem];
             userSession.PlayerId = sessionData.playerId;
             userSession.Userid = sessionData.userId;
             userSession.FirstName = sessionData.firstName;
             userSession.LastName = sessionData.lastName;
             userSession.TOKEN = applicationDataObj.getToken();
             data.SessionData = userSession;
             data = JSON.stringify(data);
             return data;
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getDirectoriesRequestParameters " + err);
         }
     };
     
     /** Creating request Parameters **/
     this.getDirectoriesRequestParametersAlumni = function (directoryRole, onScroll, searchitem, issearch, startrow, directoryItem) {
         try {
             var sessionData = applicationDataObj.getSessionResponse(),
                 data = {},
                 userSession = {};
             data.Userid = sessionData.userId;
             data.ServiceProvider = "DirectoriesServiceProvider";
             data.ServiceMethod = "GetDirectoriesSearch";
             data.Language = constants.englishLanguage;
             data.parametersArray = [directoryRole, onScroll, searchitem, issearch, startrow, directoryItem];
             userSession.PlayerId = sessionData.playerId;
             userSession.Userid = sessionData.userId;
             userSession.FirstName = sessionData.firstName;
             userSession.LastName = sessionData.lastName;
             userSession.TOKEN = applicationDataObj.getToken();
             data.SessionData = userSession;
             data = JSON.stringify(data);
             return data;
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getDirectoriesRequestParameters " + err);
         }
     };
     
      /** Creating request Parameters **/
     this.getDirectoriesRequestParametersAgent = function (directoryRole, onScroll, searchitem, issearch, startrow, directoryItem) {
         try {
             var sessionData = applicationDataObj.getSessionResponse(),
                 data = {},
                 userSession = {};
             data.Userid = sessionData.userId;
             data.ServiceProvider = "DirectoriesServiceProvider";
             data.ServiceMethod = "GetDirectoriesSearch";
             data.Language = constants.englishLanguage;
             data.parametersArray = [directoryRole, onScroll, searchitem, issearch, startrow, directoryItem];
             userSession.PlayerId = sessionData.playerId;
             userSession.Userid = sessionData.userId;
             userSession.FirstName = sessionData.firstName;
             userSession.LastName = sessionData.lastName;
             userSession.TOKEN = applicationDataObj.getToken();
             data.SessionData = userSession;
             data = JSON.stringify(data);
             return data;
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : getDirectoriesRequestParameters " + err);
         }
     };
     
     this.bindDirectoriesResponseCoach = function (data,userType) {
         if(data !== undefined) {
             $('#CoachDesc').html(data.CoachDescription);
             for (k = 0; k < data.Coach.length; k++) {
                 if(userType == 'coach' || userType == ''){
                     var coachDirHTML = '';
                     coachDirHTML = coachDirHTML + '<div class="role-innercntnr3 role-innercntnr2 commondivclass ">';
                     coachDirHTML = coachDirHTML + '<div class="row margin-15 margind-15 player-details">';
                     coachDirHTML = coachDirHTML + '<div class="col-md-12 col-sm-12 col-xs-12 ">';
                     coachDirHTML = coachDirHTML + '<div class="pull-left plyrimg_profile">';
                     if (data.Coach[k].HeadshotImage.indexOf("Photo_Grey.png") !== -1 || data.Coach[k].HeadshotImage === null) {
                         coachDirHTML = coachDirHTML + '<img class="img_team_player" src="images/Photo_Grey.png" alt="player-image" id="coachheadshot' + (k) + '"/>';
                     } else {
                         coachDirHTML = coachDirHTML + '<img class="img_team_player" src="' + data.Coach[k].HeadshotImage + '" alt="player-image" id="coachheadshot' + (k) + '"/>'
                     }
                     coachDirHTML = coachDirHTML + '</div>';
                     coachDirHTML = coachDirHTML + '<div class="pull-left directories-details padding-left-2">';
                     coachDirHTML = coachDirHTML + '<div class="playername">' + data.Coach[k].FirstName + " " + data.Coach[k].LastName + '</div>';
                     coachDirHTML = coachDirHTML + '<div class="country-code">';
                     if(data.Coach[k].NatlId !==null) {
                         coachDirHTML = coachDirHTML + '<span class="countrycode" id="coachcodecountry' + i + '">' + data.Coach[k].NatlId + '</span>';
                         coachDirHTML = coachDirHTML + '<span id="countrycoach' + i +'">  |  </span>';
                     } else {
                         coachDirHTML = coachDirHTML + '<span></span>';
                     }

                     if(data.Coach[k].CurrentMainEmployer !== null) {
                          coachDirHTML = coachDirHTML + '<span id="currentcoachemp' + i + '">' + data.Coach[k].CurrentMainEmployer + '</span>';
                     } else {
                         coachDirHTML = coachDirHTML + '<span id="currentacoachemp' + i + '"></span>';
                     }
                     coachDirHTML = coachDirHTML + '</div>';
                     coachDirHTML = coachDirHTML + '<div class="country-code" id="industryoccupy' + i + '">';
                     if(data.Coach[k].IndustryOccupation !== null) {
                         coachDirHTML = coachDirHTML + '<span>' + data.Coach[k].IndustryOccupation + '</span>';
                     } else {
                         coachDirHTML = coachDirHTML + '<span></span>';
                     }
                     coachDirHTML = coachDirHTML + '</div>';
                     coachDirHTML = coachDirHTML + '</div>';
                     coachDirHTML = coachDirHTML + '<div class="pull-right directories-details padding-left-2 emailimg">';
                     coachDirHTML = coachDirHTML + '<div>';
                     coachDirHTML = coachDirHTML + '<a accesskey="E" id="coachemail' + i + '" href="mailto:' +data.Coach[k].EmailAddressPrimary + '">';
                     coachDirHTML = coachDirHTML + '<img src="images/email.svg" class="dir-email" alt="email-image">';
                     coachDirHTML = coachDirHTML + '</a>';
                     coachDirHTML = coachDirHTML + '</div>';
                     coachDirHTML = coachDirHTML + '</div>'; 
                     coachDirHTML = coachDirHTML + '<div class="player-information p-t-70">';
                     if (data.Coach[k].PlayerName1 !== null ) {
                         coachDirHTML = coachDirHTML + '<span class="coach-playername1 paddinglft5" id="player1' + i + '">' + data.Coach[k].PlayerName1 + '</span>';
                     }
                     if (data.Coach[k].PlayerName2 !== null ) {
                         coachDirHTML = coachDirHTML + '<span class="coach-playername" id="playerseparate1' + i + '"> | </span>';
                         coachDirHTML = coachDirHTML + '<span class="coach-playername2 paddinglftryt5" id="player2' + i + '">' + data.Coach[k].PlayerName2 + '</span>';
                     }
                     if (data.Coach[k].PlayerName3 !== null ) {
                         coachDirHTML = coachDirHTML + '<span class="coach-playername" id="playerseparate2' + i + '"> | ' +'</span>';
                         coachDirHTML = coachDirHTML + '<span class="coach-playername3 paddingryt5" id="player3' + i + '">' + data.Coach[k].PlayerName3 + '</span>';
                     }
                     coachDirHTML = coachDirHTML + '</div>';
                     coachDirHTML = coachDirHTML + '</div>';
                     coachDirHTML = coachDirHTML + '<div class="clearfix"></div>';
                     coachDirHTML = coachDirHTML + '</div>';
                     $("#coachdirectory").append(coachDirHTML);

               }
             }

         }
         
         setTimeout(function () {
             endLoading();
         },500);
     };
     
     this.bindDirectoriesResponseAgent = function (data,userType) {
         
         if(data !== undefined) {
             $('#AgentDesc').html(data.AgentDescription);
             if(data.Agent.length > 0) {
                 for (i = 0; i < data.Agent.length; i++) {
                     if(userType == 'agent' || userType == ''){
                         var agentDirHTML = '';
                         agentDirHTML = agentDirHTML + '<div class="role-innercntnr3 role-innercntnr2 commondivclass ">';
                         agentDirHTML = agentDirHTML + '<div class="row margin-15 margind-15 player-details">';
                         agentDirHTML = agentDirHTML + '<div class="col-md-12 col-sm-12 col-xs-12 ">';
                         agentDirHTML = agentDirHTML + '<div class="pull-left plyrimg_profile">';
                         if (data.Agent[i].HeadshotImage.indexOf("Photo_Grey.png") !== -1 || data.Agent[i].HeadshotImage === null) {
                             agentDirHTML = agentDirHTML + '<img class="img_team_player" src="images/Photo_Grey.png" alt="player-image" id="agentheadshot' + (i) + '"/>';
                         } else {
                             agentDirHTML = agentDirHTML + '<img class="img_team_player" src="' + data.Agent[i].HeadshotImage + '" alt="player-image" id="agentheadshot' + (i) + '"/>'
                         }
                         agentDirHTML = agentDirHTML + '</div>';
                         agentDirHTML = agentDirHTML + '<div class="pull-left directories-details padding-left-2">';
                         agentDirHTML = agentDirHTML + '<div class="playername">' + data.Agent[i].FirstName + " " + data.Agent[i].LastName + '</div>';
                         agentDirHTML = agentDirHTML + '<div class="country-code">';
                         if(data.Agent[i].NatlId !==null) {
                             agentDirHTML = agentDirHTML + '<span class="countrycode" id="agentcodecountry' + i + '">' + data.Agent[i].NatlId + '</span>';
                             agentDirHTML = agentDirHTML + '<span id="countryagent' + i +'">  |  </span>';
                         } else {
                             agentDirHTML = agentDirHTML + '<span></span>';
                         }


                         if(data.Agent[i].CurrentMainEmployer !== null) {
                              agentDirHTML = agentDirHTML + '<span id="currentagentemp' + i + '">' + data.Agent[i].CurrentMainEmployer + '</span>';
                         } else {
                             agentDirHTML = agentDirHTML + '<span id="currentagentemp' + i + '"></span>';
                         }
                         agentDirHTML = agentDirHTML + '</div>';
                         agentDirHTML = agentDirHTML + '<div class="country-code" id="industryoccupy' + i + '">';
                         if(data.Agent[i].IndustryOccupation !== null) {
                             agentDirHTML = agentDirHTML + '<span>' + data.Agent[i].IndustryOccupation + '</span>';
                         } else {
                             agentDirHTML = agentDirHTML + '<span></span>';
                         }
                         agentDirHTML = agentDirHTML + '</div>';
                         agentDirHTML = agentDirHTML + '</div>';
                         agentDirHTML = agentDirHTML + '</div>';
                         agentDirHTML = agentDirHTML + '<div class="pull-right directories-details padding-left-2 emailimg">';
                         agentDirHTML = agentDirHTML + '<div>';
                         agentDirHTML = agentDirHTML + '<a accesskey="E" id="agentemail' + i + '" href="mailto:' +data.Agent[i].EmailAddressPrimary + '">';
                         agentDirHTML = agentDirHTML + '<img src="images/email.svg" class="dir-email" alt="email-image">';
                         agentDirHTML = agentDirHTML + '</a>';
                         agentDirHTML = agentDirHTML + '</div>';
                         agentDirHTML = agentDirHTML + '<div class="player-information p-t-70">';
                         if (data.Agent[i].PlayerName1 !== null ){
                             agentDirHTML = agentDirHTML + '<span class="agent-playername1 paddinglft5" id="player1' + i + '">' + data.Agent[i].PlayerName1 + '</span>';
                         }
                         if (data.Agent[i].PlayerName2 !== null ){
                             agentDirHTML = agentDirHTML + '<span class="agent-playername" id="playerseparate1' + i + '"> | </span>';
                             agentDirHTML = agentDirHTML + '<span class="agent-playername2 paddinglftryt5" id="player2' + i + '">' + data.Agent[i].PlayerName2 + '</span>';
                         }
                         if (data.Agent[i].PlayerName3 !== null ) {
                             agentDirHTML = agentDirHTML + '<span class="agent-playername" id="playerseparate2' + i + '"> | ' +'</span>';
                             agentDirHTML = agentDirHTML + '<span class="agent-playername3 paddingryt5" id="player3' + i + '">' + data.Agent[i].PlayerName3 + '</span>';
                         }
                         agentDirHTML = agentDirHTML + '</div>'; 
                         agentDirHTML = agentDirHTML + '</div>';
                         agentDirHTML = agentDirHTML + '<div class="clearfix"></div>';
                         agentDirHTML = agentDirHTML + '</div>';
                         $("#agentdirectory").append(agentDirHTML);
                       }
                 }
             } else {
                 $("#agentdirectory").append('<p style="text-align: center;font-weight: bold;">No records found</p>');
             }
         }
         
         
         setTimeout(function () {
             endLoading();
         },500);
     };
 
     /** binding Directories body data **/
     this.bindDirectoriesResponseAlumni = function (data,userType) {
         try {
             $('#AlumniDesc').html(data.AlumniDescription);
             for (j = 0; j < data.Alumni.length; j++) {
                 if(userType == 'alumni' || userType == '') {
                     var alumniDirHTML = '';
                     alumniDirHTML = alumniDirHTML + '<div class="role-innercntnr3 role-innercntnr2 commondivclass ">';
                     alumniDirHTML = alumniDirHTML + '<div class="row margin-15 margind-15 player-details">';
                     alumniDirHTML = alumniDirHTML + '<div class="col-md-12 col-sm-12 col-xs-12 ">';
                     alumniDirHTML = alumniDirHTML + '<div class="pull-left plyrimg_profile">';
                     if(data.Alumni[j].HeadshotImage !== null) {
                         if (data.Alumni[j].HeadshotImage.indexOf("Photo_Grey.png") !== -1 || data.Alumni[j].HeadshotImage === null) {
                             alumniDirHTML = alumniDirHTML + '<img class="img_team_player" src="images/Photo_Grey.png" alt="player-image" id="alumniheadshot' + (j) + '"/>';
                         } else {
                             alumniDirHTML = alumniDirHTML + '<img class="img_team_player" src="' + data.Alumni[j].HeadshotImage + '" alt="player-image" id="alumniheadshot' + (j) + '"/>'
                         }
                         
                     } else {
                         alumniDirHTML = alumniDirHTML + '<img class="img_team_player" src="images/Photo_Grey.png" alt="player-image" id="alumniheadshot' + (j) + '"/>';
                     }
                     alumniDirHTML = alumniDirHTML + '</div>';
                     alumniDirHTML = alumniDirHTML + '<div class="pull-left directories-details padding-left-2">';
                     alumniDirHTML = alumniDirHTML + '<div class="playername"> ' + data.Alumni[j].FirstName + " " + data.Alumni[j].LastName + '</div>';
                     alumniDirHTML = alumniDirHTML + '<div class="country-code">';
                     if(data.Alumni[j].NatlId !==null) {
                         alumniDirHTML = alumniDirHTML + '<span id="codecountry' + j + '">' + data.Alumni[j].NatlId + '</span>';
                         alumniDirHTML = alumniDirHTML + '<span id="countryalumni' + j +'">  |  </span>';
                     } else {
                         alumniDirHTML = alumniDirHTML + '<span></span>';
                     }
                     
                     if(data.Alumni[j].CurrentMainEmployer !== null) {
                          alumniDirHTML = alumniDirHTML + '<span id="currentalumniemp' + j + '">' + data.Alumni[j].CurrentMainEmployer + '</span>';
                     } else {
                         alumniDirHTML = alumniDirHTML + '<span id="currentalumniemp' + j + '"></span>';
                     }
                        
                     alumniDirHTML = alumniDirHTML + '</div>';
                     alumniDirHTML = alumniDirHTML + '<div class="country-code" id="industryoccupy' + j + '">';
                     if(data.Alumni[j].IndustryOccupation !== null) {
                         alumniDirHTML = alumniDirHTML + '<span>' + data.Alumni[j].IndustryOccupation + '</span>';
                     } else {
                         alumniDirHTML = alumniDirHTML + '<span></span>';
                     }
                     alumniDirHTML = alumniDirHTML + '</div>';
                     alumniDirHTML = alumniDirHTML + '</div>';
                     alumniDirHTML = alumniDirHTML + '</div>';
                     alumniDirHTML = alumniDirHTML + '<div class="pull-right directories-details padding-left-2 emailimg">';
                     alumniDirHTML = alumniDirHTML + '<div>';
                     alumniDirHTML = alumniDirHTML + '<a accesskey="E" id="alumniemail' + j + '" href="mailto:' +data.Alumni[j].EmailAddressPrimary + '">';
                     alumniDirHTML = alumniDirHTML + '<img src="images/email.svg" class="dir-email" alt="email-image">';
                     alumniDirHTML = alumniDirHTML + '</a>';
                     alumniDirHTML = alumniDirHTML + '</div>';
                     alumniDirHTML = alumniDirHTML + '</div>';
                     alumniDirHTML = alumniDirHTML + '<div class="clearfix"></div>';
                     alumniDirHTML = alumniDirHTML + '</div>';
                     $("#alumnidirectory").append(alumniDirHTML);
               }
             }
         
             setTimeout(function () {
                 endLoading();
             },500);
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : bindDirectoriesResponseAlumni " + err);
         }
      
     };
       /*Ajax - Success Call back*/
     this.OnGetDirectoriesSuccess = function (data) {
         try {
             globalData = data;
             var directoryClassObj = new DirectoriesClass(),
                 alumniArrLength = 0,
                 coachArrlength = 0,
                 agentArrLength = 0;
             if (data.Alumni !== null) {
                 alumniArrLength = data.Alumni.length;
             }
             if (data.Coach !== null) {
                 coachArrlength = data.Coach.length;
             }
             if (data.Agent !== null) {
                 agentArrLength = data.Agent.length;
             }
             
             if (!(alumniArrLength == 0)) {
                 alumniTotalCount = data.AlumniCount;
             }
             if (!(coachArrlength == 0)) {
                 coachTotalCount = data.CoachCount;
             }
             if (!(agentArrLength == 0)) {
                 agentTotalCount = data.AgentCount;
             } 
             if (alumniArrLength > 0 ) {
                 directoryClassObj.bindDirectoriesResponseAlumni(data,'');
                 alumniCount = alumniArrLength;
             } 
 
             if (coachArrlength > 0 ) {
                 directoryClassObj.bindDirectoriesResponseCoach(data,'');
                 coachCount = coachArrlength;
             }  
             if (agentArrLength > 0 ) {
                 directoryClassObj.bindDirectoriesResponseAgent(data,'');
                 agentCount = agentArrLength;
             }
             endLoading();
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesSuccess " + err);
         }
     };
     
     this.OnGetDirectoriesError = function (jqXHR, error) {
         try {
             endLoading();
             var errorMessage = jqXHR.statusText;
             if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                 errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
             }
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAlumniError " + errorMessage);
             if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                     jqXHR.statusText === constants.unauthorizedError) {
                 logout();
             }
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnGetDirectoriesError " + err);
         }
     };
     
     this.OnDirectoriesAlumniSuccess = function (data) {
         try {

             //globalData.Alumni.push.apply(globalData.Alumni, data.Alumni)
             var directoryClassObj = new DirectoriesClass();
             directoryClassObj.bindDirectoriesResponseAlumni(data,'');
             alumniCount = alumniCount + data.Alumni.length;
             endLoading();
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAlumniSuccess " + err);
         }
     };
 
     /*Ajax - Error Call back*/
     this.OnDirectoriesAlumniError = function (jqXHR, error) {
         try {
             endLoading();
             var errorMessage = jqXHR.statusText;
             if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                 errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
             }
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAlumniError " + errorMessage);
             if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                     jqXHR.statusText === constants.unauthorizedError) {
                 logout();
             }
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAlumniError " + err);
         }
     };
     
     this.OnDirectoriesCoachSuccess = function (data) {
         try {

             //globalData.Coach.push.apply(globalData.Coach, data.Coach)
             var directoryClassObj = new DirectoriesClass();
             directoryClassObj.bindDirectoriesResponseCoach(data,'');
             coachCount = coachCount + data.Coach.length;
             endLoading();
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesCoachSuccess " + err);
         }
     };
     
     this.OnDirectoriesAlumniError = function (jqXHR, error) {
         try {
             endLoading();
             var errorMessage = jqXHR.statusText;
             if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                 errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
             }
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAlumniError " + errorMessage);
             if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                     jqXHR.statusText === constants.unauthorizedError) {
                 logout();
             }
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAlumniError " + err);
         }
     };
     
     this.OnDirectoriesAgentSuccess = function (data) {
         try {

             //globalData.Agent.push.apply(globalData.Agent,data.Agent)
             var directoryClassObj = new DirectoriesClass();
             directoryClassObj.bindDirectoriesResponseAgent(data,'');
             agentCount = agentCount + data.Agent.length;
             endLoading();
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAgentSuccess " + err);
         }
     };
     
     this.OnDirectoriesAgentError = function (jqXHR, error) {
         try {
             endLoading();
             var errorMessage = jqXHR.statusText;
             if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                 errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
             }
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAgentError " + errorMessage);
             if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                     jqXHR.statusText === constants.unauthorizedError) {
                 logout();
             }
         } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "Error : OnDirectoriesAgentError " + err);
         }
     };
 };
 
 /* Directories */
 var directories = function () {
     try {
         if(isApp){
             window.ga.trackView('Contact Directories');
         }
         var directoriesObj = new DirectoriesClass();
         
         startLoading();
         headerMain();
         subHeaderContactHide();
         subHeader();
         subHeaderEllipsis();
         directoriesObj.getdirectoriesData();
         if (deviceOS === "ios") {
             $('.directoryDiv').scroll(function(e) {
                 if($('div#iosscroll').find('li.alumni-tab').hasClass('active')) {
                     if($('.directoryDiv').scrollTop()==($('.myproflcontct-container').outerHeight(true)-$('.directoryDiv').height())) {
                         if (alumniCount < alumniTotalCount) {
                             startLoading();
                             directoriesObj.getdirectoriesDataAlumni();   
                         }
                     }
                     e.preventDefault();
                 }
 
                 if($('div#iosscroll').find('li.coach-tab').hasClass('active')) {
                     if($('.directoryDiv').scrollTop()==($('.myproflcontct-container').outerHeight(true)-$('.directoryDiv').height())) {
                         if (coachCount < coachTotalCount) {
                             startLoading();
                             directoriesObj.getdirectoriesDataCoach();
                         }
                     }
                     e.preventDefault();
                 }
 
                 if($('div#iosscroll').find('li.agent-tab').hasClass('active')) {
                     if($('.directoryDiv').scrollTop()==($('.myproflcontct-container').outerHeight(true)-$('.directoryDiv').height())) {
                         if (agentCount < agentTotalCount) {
                             startLoading();
                             directoriesObj.getdirectoriesDataAgent();
                         }
                     }
                     e.preventDefault();
                 }
             });
         }
         if (deviceOS === "android") {
             $('#MyApp').scroll(function(e) {
                 if($('div#iosscroll').find('li.alumni-tab').hasClass('active')) {
                     if($('#MyApp').scrollTop()==($('.myproflcontct-container').height()-$('#MyApp').height() + $('.headercontent').height())) {
                         if (alumniCount < alumniTotalCount) {
                             startLoading();
                             directoriesObj.getdirectoriesDataAlumni();   
                         }
                     }
                     e.preventDefault();
                 }
 
                 if($('div#iosscroll').find('li.coach-tab').hasClass('active')) {
                     if($('#MyApp').scrollTop()==($('.myproflcontct-container').height()-$('#MyApp').height() + $('.headercontent').height())) {
                         if (coachCount < coachTotalCount) {
                             startLoading();
                             directoriesObj.getdirectoriesDataCoach();
                         }
                     }
                     e.preventDefault();
                 }
 
                 if($('div#iosscroll').find('li.agent-tab').hasClass('active')) {
                     if($('#MyApp').scrollTop()==($('.myproflcontct-container').height()-$('#MyApp').height() + $('.headercontent').height())) {
                         if (agentCount < agentTotalCount) {
                             startLoading();
                             directoriesObj.getdirectoriesDataAgent();
                         }
                     }
                     e.preventDefault();
                 }
             });
         }
 
         $('.myDirectoriesContainer li').click(function () {
             var directoryClassObj = new DirectoriesClass();
             clickedField = $(this).find('a').text();
             if($(".alumni-tab").hasClass('active')) {
                 if(clickedField === "Coach" || clickedField === "Agent") {
                     $("#aluminisearch").val("");
                     $('#alumnidirectory').html("");
                     directoryClassObj.bindDirectoriesResponseAlumni(globalDataAlumni,'');
                 }
             } else if($(".coach-tab").hasClass('active')) {
                 if(clickedField === "Alumni" || clickedField === "Agent") {
                     $("#coachsearch").val("");
                     $('#coachdirectory').html("");
                     
                     directoryClassObj.bindDirectoriesResponseCoach(globalDataCoach,'');
                 }
             } else if($(".agent-tab").hasClass('active')) {
                 if(clickedField === "Alumni" || clickedField === "Coach") {
                     $("#agentsearch").val("");
                     $('#agentdirectory').html("");
                     directoryClassObj.bindDirectoriesResponseAgent(globalDataAgent,'');
                 }
             }
            $('.alumni-search-directory').css("display", "block");
            $('.alumni-close-directory').css("display", "none");
            $('.coach-search-directory').css("display", "block");
            $('.coach-close-directory').css("display", "none");
            $('.agent-search-directory').css("display", "block");
            $('.agent-close-directory').css("display", "none");
         });
         
                                  
         var typingTimer;
         var typingInterval = 1000; //1000 milliseconds Idle time
         $("#aluminisearch").keyup(function (event) {
            if ($("#aluminisearch").val().length === 0) {
                $('.alumni-search-directory').css("display", "block");
                $('.alumni-close-directory').css("display", "none");
            }
         });
         
         $("#coachsearch").keyup(function (event) {
            if ($("#coachsearch").val().length === 0) {
                $('.alumni-search-directory').css("display", "block");
                $('.alumni-close-directory').css("display", "none");
            }
         });
         
         $("#agentsearch").keyup(function (event) {
            if ($("#agentsearch").val().length === 0) {
                $('.alumni-search-directory').css("display", "block");
                $('.alumni-close-directory').css("display", "none");
            }
         });
         
         $('.alumni-srch-btn').click(function (event) {
             event.preventDefault();
             if ($("#aluminisearch").val().length > 0) {
                 clearTimeout(typingTimer);
                 typingTimer = setTimeout(function(){
                     var alumniSearchText = $("#aluminisearch").val();
                     directoryRole = "alumni";
                     onScroll = "-1";
                     searchitem = alumniSearchText;
                     issearch = true;
                     startrow = 0;
                     $('#alumnidirectory').html("");
                     directoriesObj.getdirectoriesSearch(directoryRole, onScroll, searchitem, issearch, startrow);
                     clearTimeout(typingTimer);
                     $('.alumni-search-directory').css("display", "none");
                     $('.alumni-close-directory').css("display", "block");
                 }, typingInterval);
             } else {
                 $('.alumni-search-directory').css("display", "block");
                 $('.alumni-close-directory').css("display", "none");
             }
         });
         
         $('.alumni-search-directory').click(function (event) {
             event.preventDefault();
             if ($("#aluminisearch").val().length > 0) {
                 clearTimeout(typingTimer);
                 typingTimer = setTimeout(function(){
                     var alumniSearchText = $("#aluminisearch").val();
                     directoryRole = "alumni";
                     onScroll = "-1";
                     searchitem = alumniSearchText;
                     issearch = true;
                     startrow = 0;
                     $('#alumnidirectory').html("");
                     directoriesObj.getdirectoriesSearch(directoryRole, onScroll, searchitem, issearch, startrow);
                     clearTimeout(typingTimer);
                     $('.alumni-search-directory').css("display", "none");
                     $('.alumni-close-directory').css("display", "block");
                 }, typingInterval);
             } else {
                 $('.alumni-search-directory').css("display", "block");
                 $('.alumni-close-directory').css("display", "none");
             }
         });
         
         $('.coach-srch-btn').click(function (event) {
            event.preventDefault();
             if ($("#coachsearch").val().length > 0) {
                 clearTimeout(typingTimer);
                 typingTimer = setTimeout(function(){
                     $('.coach-search-directory').css("display", "none");
                     $('.coach-close-directory').css("display", "block");
                     var coachSearchText = $("#coachsearch").val();
                     directoryRole = "coach";
                     onScroll = "-1";
                     searchitem = coachSearchText;
                     issearch = true;
                     startrow = 0;
                     $('#coachdirectory').html("");
                     directoriesObj.getdirectoriesSearch(directoryRole, onScroll, searchitem, issearch, startrow);
                     clearTimeout(typingTimer);
                 }, typingInterval);
             } else {
                 $('.coach-search-directory').css("display", "block");
                 $('.coach-close-directory').css("display", "none");
             }
         });
         
           $('.coach-search-directory').click(function (event) {
            event.preventDefault();
             if ($("#coachsearch").val().length > 0) {
                 clearTimeout(typingTimer);
                 typingTimer = setTimeout(function(){
                     $('.coach-search-directory').css("display", "none");
                     $('.coach-close-directory').css("display", "block");
                     var coachSearchText = $("#coachsearch").val();
                     directoryRole = "coach";
                     onScroll = "-1";
                     searchitem = coachSearchText;
                     issearch = true;
                     startrow = 0;
                     $('#coachdirectory').html("");
                     directoriesObj.getdirectoriesSearch(directoryRole, onScroll, searchitem, issearch, startrow);
                     clearTimeout(typingTimer);
                 }, typingInterval);
             } else {
                 $('.coach-search-directory').css("display", "block");
                 $('.coach-close-directory').css("display", "none");
             }
         });
         
         $('.agent-srch-btn').click(function (event) {
            event.preventDefault();
             if ($("#agentsearch").val().length > 0) {
                 clearTimeout(typingTimer);
                 typingTimer = setTimeout(function(){
                     $('.agent-search-directory').css("display", "none");
                     $('.agent-close-directory').css("display", "block");
                     var agentSearchText = $("#agentsearch").val();
                     directoryRole = "agent";
                     onScroll = "-1";
                     searchitem = agentSearchText;
                     issearch = true;
                     startrow = 0;
                     $('#agentdirectory').html("");
                     directoriesObj.getdirectoriesSearch(directoryRole, onScroll, searchitem, issearch, startrow);
                     clearTimeout(typingTimer);
                 }, typingInterval);
             } else {
                 $('.agent-search-directory').css("display", "block");
                 $('.agent-close-directory').css("display", "none");
             }
         });
         
         $('.agent-search-directory').click(function (event) {
            event.preventDefault();
             if ($("#agentsearch").val().length > 0) {
                 clearTimeout(typingTimer);
                 typingTimer = setTimeout(function(){
                     $('.agent-search-directory').css("display", "none");
                     $('.agent-close-directory').css("display", "block");
                     var agentSearchText = $("#agentsearch").val();
                     directoryRole = "agent";
                     onScroll = "-1";
                     searchitem = agentSearchText;
                     issearch = true;
                     startrow = 0;
                     $('#agentdirectory').html("");
                     directoriesObj.getdirectoriesSearch(directoryRole, onScroll, searchitem, issearch, startrow);
                     clearTimeout(typingTimer);
                 }, typingInterval);
             } else {
                 $('.agent-search-directory').css("display", "block");
                 $('.agent-close-directory').css("display", "none");
             }
         });
         
         /*$("#coachsearch").keyup(function (event) {
             event.preventDefault();
             if ($("#coachsearch").val().length > 0) {
                 clearTimeout(typingTimer);
                 typingTimer = setTimeout(function(){
                     $('.coach-search-directory').css("display", "none");
                     $('.coach-close-directory').css("display", "block");
                     var coachSearchText = $("#coachsearch").val();
                     directoryRole = "coach";
                     onScroll = "-1";
                     searchitem = coachSearchText;
                     issearch = true;
                     startrow = 0;
                     $('#coachdirectory').html("");
                     directoriesObj.getdirectoriesSearch(directoryRole, onScroll, searchitem, issearch, startrow);
                     clearTimeout(typingTimer);
                 }, typingInterval);
             } else {
                 $('.coach-search-directory').css("display", "block");
                 $('.coach-close-directory').css("display", "none");
             }
         });*/
         /*
         $("#agentsearch").keyup(function (event) {
             event.preventDefault();
             if ($("#agentsearch").val().length > 0) {
                 clearTimeout(typingTimer);
                 typingTimer = setTimeout(function(){
                     $('.agent-search-directory').css("display", "none");
                     $('.agent-close-directory').css("display", "block");
                     var agentSearchText = $("#agentsearch").val();
                     directoryRole = "agent";
                     onScroll = "-1";
                     searchitem = agentSearchText;
                     issearch = true;
                     startrow = 0;
                     $('#agentdirectory').html("");
                     directoriesObj.getdirectoriesSearch(directoryRole, onScroll, searchitem, issearch, startrow);
                     clearTimeout(typingTimer);
                 }, typingInterval);
             } else {
                 $('.agent-search-directory').css("display", "block");
                 $('.agent-close-directory').css("display", "none");
             }
         });*/
         
         $('.close-directory').click(function () {
             startLoading();
             var directoryClassObj = new DirectoriesClass();
             if($('div#iosscroll').find('li.alumni-tab').hasClass('active')) {
                 $('#aluminisearch').val("");
                 $('#alumnidirectory').html("");
                 directoryClassObj.bindDirectoriesResponseAlumni(globalDataAlumni,'');
                 $('.alumni-search-directory').css("display", "block");
                 $('.alumni-close-directory').css("display", "none");
             }
             
             if($('div#iosscroll').find('li.coach-tab').hasClass('active')) {
                 $('#coachsearch').val("");
                 $('#coachdirectory').html("");
                 directoryClassObj.bindDirectoriesResponseCoach(globalDataCoach,'');
                 $('.coach-search-directory').css("display", "block");
                 $('.coach-close-directory').css("display", "none");
             }
             
             if($('div#iosscroll').find('li.agent-tab').hasClass('active')) {
                 $('#agentsearch').val("");
                 $('#agentdirectory').html("");
                 directoryClassObj.bindDirectoriesResponseAgent(globalDataAgent,'');
                 $('.agent-search-directory').css("display", "block");
                 $('.agent-close-directory').css("display", "none");
             }
 
             alumniTotalCount = globalData.AlumniCount;
             coachTotalCount = globalData.CoachCount;
             agentTotalCount = globalData.AgentCount;
         });
 
     } catch (err) {
         loggerObj.logToServer(constants.logSeverityError, "Error : antiCorruption " + err);
     }
 };
 
 function subHeaderContactHide() {
     try {
         var role = "";
         if (applicationDataObj.getSessionResponse() && applicationDataObj.getSessionResponse().roles && applicationDataObj.getSessionResponse().roles.length !== 0) {
             role = applicationDataObj.getSessionResponse().roles[0];
             $(".player-status").text(role);
         }
         if (role) {
             var lowerConvertedRole = role.toLowerCase();
             if (lowerConvertedRole.indexOf("atp agent") === 0) {
                 $(".agent").removeClass("hide");
                 $(".player").addClass("hide");
                 $(".other").addClass("hide");
                 $(".register").addClass("hide");
                 $('.carousel-inner .playeritem:first').removeClass('active');
                 $('.carousel-inner .playeritem:last').removeClass('active');
                 navigationContactAgentArrowMenu();
             } else if (lowerConvertedRole.indexOf("other") === 0) {
                 $(".agent").addClass("hide");
                 $(".player").addClass("hide");
                 $(".other").removeClass("hide");
                 $(".register").addClass("hide");
                 $('.carousel-inner .playeritem:first').removeClass('active');
                 $('.carousel-inner .playeritem:last').removeClass('active');
                 $('.carousel-inner .agentitem:first').removeClass('active');
                 $('.carousel-inner .agentitem:last').removeClass('active');
                 navigationContactOtherArrowMenu();
             } else if (lowerConvertedRole.indexOf("registered player") === 0) {
                 $(".agent").addClass("hide");
                 $(".player").addClass("hide");
                 $(".other").addClass("hide");
                 $(".register").removeClass("hide");
                 $('.carousel-inner .playeritem:first').removeClass('active');
                 $('.carousel-inner .playeritem:last').removeClass('active');
                 $('.carousel-inner .agentitem:first').removeClass('active');
                 $('.carousel-inner .agentitem:last').removeClass('active');
                 navigationRegisterArrowMenu();
             } else if (lowerConvertedRole.indexOf("alumni/atp coach/atp agent") !== -1) {
               $(".agent").addClass("hide");
                 $(".player").removeClass("hide");
                 $(".other").addClass("hide");
                 $(".register").addClass("hide");
                 $('.carousel-inner .agentitem:first').removeClass('active');
                 $('.carousel-inner .agentitem:last').removeClass('active');
                 navigationContactsArrowMenu(); 
             } else {
                 $(".agent").addClass("hide");
                 $(".player").removeClass("hide");
                 $(".other").addClass("hide");
                 $(".register").addClass("hide");
                 $('.carousel-inner .agentitem:first').removeClass('active');
                 $('.carousel-inner .agentitem:last').removeClass('active');
                 navigationContactsArrowMenu();
             }
         }
     } catch (err) {
         loggerObj.logToServer(constants.logSeverityError, "Error : subHeaderContactHide " + err);
     }
 }
 
 var navigationContactsArrowMenu = function () {
     firstContactAct = $("#rightarrow").parent().children().children().children(".playeritem").first().hasClass("active");
     lastContactAct = $("#rightarrow").parent().children().children().children(".playeritem").last().hasClass("active");
     if (firstContactAct !== true && lastContactAct !== true) {
         $("#leftarrow").show();
         $("#rightarrow").show();
     } else if (firstContactAct === true) {
         $("#leftarrow").hide();
         $("#rightarrow").show();
     } else if (lastContactAct === true) {
         $("#leftarrow").show();
         $("#rightarrow").hide();
     }
 
     $("#rightarrow").click(function () {
         firstContactAct = $("#rightarrow").parent().children().children().children(".playeritem").first().hasClass("active");
         lastContactAct = $("#rightarrow").parent().children().children().children(".playeritem").last().hasClass("active");
         if (firstContactAct !== true) {
             $("#leftarrow").show();
             $("#rightarrow").show();
         } else if (firstContactAct === true) {
             $("#leftarrow").show();
             $("#rightarrow").show();
         } else if (lastContactAct !== true) {
             $("#leftarrow").show();
             $("#rightarrow").hide();
         }
         if ($('.carousel-inner .playeritem:last').hasClass('active')) {
             $('#rightarrow').hide();
             $('#leftarrow').show();
         }
     });
 
     $("#leftarrow").click(function () {
         firstContactAct = $("#leftarrow").parent().children().children().children(".playeritem").first().hasClass("active");
         lastContactAct = $("#leftarrow").parent().children().children().children(".playeritem").last().hasClass("active");
         if (lastContactAct === true) {
             $("#leftarrow").show();
             $("#rightarrow").show();
         } else if (firstContactAct !== true && lastContactAct !== true) {
             $("#leftarrow").show();
             $("#rightarrow").show();
         }
     });
 };
 
 function subHeader() {
     $('#alignCarousal').bind('slid.bs.carousel', function (e) {
         if ($('.carousel-inner .playeritem:first').hasClass('active')) {
             $('#leftarrow').hide();
             $('#rightarrow').show();
         }
         if ($('.carousel-inner .playeritem:last').hasClass('active')) {
             $('#rightarrow').hide();
             $('#leftarrow').show();
         }
     });
     $('#myCarousel').on('slid', function (e) {
         if ($('.carousel-inner .playeritem:first').hasClass('active')) {
             $('.left .carousel-control').hide();
             $('.right .carousel-control').show();
         }
         if ($('.carousel-inner .playeritem:last').hasClass('active')) {
             $('.right .carousel-control').hide();
             $('.left .carousel-control').show();
         }
     });
 }