/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

var inAppBrowserRef;

/* Draws class */

var DrawsClass = function () {
    
    /** get Draws data **/
    this.getDrawsData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getDrawsRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnDrawSuccess, this.OnDrawError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getDrawsData " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getDrawsRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "HomeServiceProvider";
            data.ServiceMethod = "GetDraws";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["80B709F2-CEE7-4F20-8249-7F365151F573"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.Roles = sessionData.roles;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getDrawsRequestParameters " + err);
        }
    };
    
    /** binding Draws body data **/
    this.bindDrawsResponse = function (data) {
        try {
            $(".tournaments").append(data.TournamentColumnHeading);
            $(".drawscolumn").append(data.DrawsColumnHeading);
            eventDate = data.Events.length;
            events = data.Events;
            for (i = 0; i < eventDate; i++) {
                tabTitle = events[i].TabTitle;
                tabEvents = events[i].TabEvents;
                tabEventsVal = tabEvents.length;
                tabId = tabTitle.split(" ").join("");
                if (i === 0) {
                    $(".entry-singles-tab").append('<a data-toggle="tab" class="fontsize18" href="#' + tabId + '">' + tabTitle + '</a>');
                    $(".tabsparticular").append('<div  class="tab-pane fade tab1"></div>');
                    $(".tab1").attr('id', tabId);
                    $(".tab1").append('<table class="table tab-brd table-hover table-draws bgcolor-white"><thead><tr class="hidden-md hidden-lg bg-draw bgTable-color"><th class="bold th-color tournaments col-xs-6 col-sm-6 col-md-6">' + data.TournamentColumnHeading + '</th><th class="bold th-color drawscolumn col-xs-6 col-sm-6 col-md-6">' + data.DrawsColumnHeading + '</th></tr></thead><tbody class="tabrow"></tbody></table>');
                    for (iloop = 0; iloop < tabEventsVal; iloop++) {
                    	 doubleUrlId = "double"+i+iloop;
                        $(".tabrow").append('<tr><td class=" td-wdth1"><a data-url = "' + tabEvents[iloop].EventPath + '" onclick = "navigateEntryUrl(this);">' + tabEvents[iloop].EventName + '</a></td><td class=""><span class="td-wdth"><a data-url = "' + tabEvents[iloop].SinglesUrl + '" onclick = "showPdf(this);">S</a></span><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].DoublesUrl + '" onclick = "showPdf(this);">D</a></span><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].QualifyingSinglesUrl + '" onclick = "showPdf(this);">QS</a></span><span id = "'+doubleUrlId+'" "class="doubleurl"><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].QualifyingDoublesUrl + '" onclick = "showPdf(this);">QD</a></span></span></td></tr>');
                        if (tabEvents[iloop].QualifyingDoublesUrl !== null) {
                            $("#"+doubleUrlId).show();
                        } else {
                        	 $("#"+doubleUrlId).hide();
                        }
                    }

                } else if (i === 1) {
                    $(".middle").append('<a data-toggle="tab" class="fontsize18" href="#' + tabId + '">' + tabTitle + '</a>');
                    $(".tabsparticular").append('<div class="tab-pane fade tab2"></div>');
                    $(".tab2").attr('id', tabId);
                    $(".tab2").append('<table class="table tab-brd table-hover table-draws bgcolor-white"><thead><tr class="hidden-md hidden-lg bg-draw bgTable-color"><th class="bold th-color tournaments col-xs-6 col-sm-6 col-md-6">' + data.TournamentColumnHeading + '</th><th class="bold th-color drawscolumn col-xs-6 col-sm-6 col-md-6">' + data.DrawsColumnHeading + '</th></tr></thead><tbody class="tabrow1"></tbody></table>');
                    for (iloop = 0; iloop < tabEventsVal; iloop++) {
                    	doubleUrlId = "double"+i+iloop;
                        $(".tabrow1").append('<tr><td class=" td-wdth1"><a data-url = "' + tabEvents[iloop].EventPath + '" onclick = "navigateEntryUrl(this);">' + tabEvents[iloop].EventName + '</a></td><td class=""><span class="td-wdth"><a data-url = "' + tabEvents[iloop].SinglesUrl + '" onclick = "showPdf(this);">S</a></span><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].DoublesUrl + '" onclick = "showPdf(this);">D</a></span><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].QualifyingSinglesUrl + '" onclick = "showPdf(this);">QS</a></span><span id = "'+doubleUrlId+'" class="doubleurl"><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].QualifyingDoublesUrl + '" onclick = "showPdf(this);">QD</a></span></span></td></tr>');
                        if (tabEvents[iloop].QualifyingDoublesUrl !== null) {
                        	 $("#"+doubleUrlId).show();
                        } else {
                        	 $("#"+doubleUrlId).hide();
                        }
                    }
                } else {
                    $(".last").append('<a data-toggle="tab" class="fontsize18" href="#' + tabId + '">' + tabTitle + '</a>');
                    $(".tabsparticular").append(' <div class="tab-pane fade in active tab3"></div>');
                    $(".tab3").attr('id', tabId);
                    $(".tab3").append('<table class="table tab-brd table-hover table-draws bgcolor-white"><thead><tr class="hidden-md hidden-lg bg-draw bgTable-color"><th class="bold th-color tournaments col-xs-6 col-sm-6 col-md-6">' + data.TournamentColumnHeading + '</th><th class="bold th-color drawscolumn col-xs-6 col-sm-6 col-md-6">' + data.DrawsColumnHeading + '</th></tr></thead><tbody class="tabrow2"></tbody></table>');
                    for (iloop = 0; iloop < tabEventsVal; iloop++) {
                    	doubleUrlId = "double"+i+iloop;
                        $(".tabrow2").append('<tr><td class=" td-wdth1"><a data-url = "' + tabEvents[iloop].EventPath + '" onclick = "navigateEntryUrl(this);">' + tabEvents[iloop].EventName + '</a></td><td class=""><span class="td-wdth"><a data-url = "' + tabEvents[iloop].SinglesUrl + '" onclick = "showPdf(this);">S</a></span><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].DoublesUrl + '" onclick = "showPdf(this);">D</a></span><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].QualifyingSinglesUrl + '" onclick = "showPdf(this);">QS</a></span><span id = "'+doubleUrlId+'" class="doubleurl"><span class="td-wdth td-width5 separaterline">|</span><span class="td-wdth"><a data-url = "' + tabEvents[iloop].QualifyingDoublesUrl + '" onclick = "showPdf(this);">QD</a></span></span></td></tr>');
                        if (tabEvents[iloop].QualifyingDoublesUrl !== null) {
                        	$("#"+doubleUrlId).show();
                        } else {
                        	$("#"+doubleUrlId).hide();
                        }
                    }
                }
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindDrawsResponse " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnDrawSuccess = function (data) {
        try {
            var drawsClassObj = new DrawsClass();
            drawsClassObj.bindDrawsResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDrawSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnDrawError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDrawError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnDrawError " + err);
        }
    };
};

/* Draws */

var draws = function () {
    try {
        if(isApp){
            window.ga.trackView('Draws Page');
        }
        var drawsObj = new DrawsClass();
        startLoading();
        /*if(deviceOS == 'ios' && isApp){
    		$('#iosscroll').addClass("scrollcontent");
        }*/
        headerMain();
        drawsObj.getDrawsData();
        firstdrawact = $("#rightarrow").parent().children().children(".item").first().hasClass("active");
        lastdrawact = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
        if (firstdrawact !== true || lastdrawact !== true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        }

        $("#rightarrow").click(function () {
            firstdraw = $("#rightarrow").parent().children().children(".item").first().hasClass("active");
            lastdraw = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
            if (firstdraw === true || lastdraw === true) {
                $("#leftarrow").show();
                $("#rightarrow").hide();
            }
        });

        $("#leftarrow").click(function () {
            firstactdraw = $("#leftarrow").parent().children().children(".item").first().hasClass("active");
            lastactdraw = $("#leftarrow").parent().children().children(".item").last().hasClass("active");
            if (firstactdraw === true || lastactdraw === true) {
                $("#rightarrow").show();
                $("#leftarrow").hide();
            }
        });  
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : draws " + err);
    }
};


var showPdf = function (event) {
	try {
		var url = $(event).attr("data-url");
		if (url && url !== "null" && url !== "undefined") {/*
            if (device) {
                if (device.platform && device.platform.toLowerCase() === "android") {
                    url = "https://docs.google.com/viewer?url=" + encodeURIComponent(url);
                }
            }
            openBrowser(url);
		 */
			window.open(url,"_system");
		}
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : showPdf " + err);
	}
};

function openBrowser(url) {
	try {
		if(url){
			window.open(url,"_system");
		}
		/*var target = '_blank',
            options = 'location=no,closebuttoncaption=back,toolbar=yes,hardwareback=yes,toolbarposition=top',
            ref = cordova.InAppBrowser.open(url, target, options);
		ref.addEventListener('loadstart', loadstartCallback);
		ref.addEventListener('loadstop', loadstopCallback);
		ref.addEventListener('loadloaderror', loaderrorCallback);
		ref.addEventListener('exit', exitCallback);*/
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : openBrowser " + err);
	}
}

function loadstartCallback(event) {
    console.log('Loading started: '  + event.url);
}
function loadstopCallback(event) {
    console.log('Loading finished: ' + event.url);
}
function loaderrorCallback(error) {
    console.log('Loading error: ' + error.message);
}

function exitCallback() {
    if (device.platform.toLowerCase() === "ios") {
        document.body.style.webkitTransform = 'translate3d(0, 20px, 0)';
    }
}