/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/*jslint browser: true*/
/*global $, jQuery,loggerObj,constants*/

/* Feedback class */
var emailAddress;
var FeedbackClass = function () {
    
    /** get Feedback data **/
    this.getfeedbackData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getFeedbackRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnFeedbackSuccess, this.OnFeedbackError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getfeedbackData " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getFeedbackRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "FeedbackServiceprovider";
            data.ServiceMethod = "GetFeedback";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["6CE857C2-3384-4E9B-AE07-4F3A6B7C114A"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getFeedbackRequestParameters " + err);
        }
    };
    
    /** binding Feedback body data **/
    this.bindFeedback = function (data) {
        try {
            emailAddress = data.EmailAddress;
            $("#feedbackheading").append(data.SectionHeading);
            $("#registration-name").append(data.FullNameLabel);
            $("#label-optional").append(data.OptionalLabel);
            $("#registration-comments").append(data.CommentsHeadingLabel);
            $("#contact-feedback-button").append(data.SubmitButtonLabel);
            $("#contact-feedback-button").removeClass("otherbio-cancel");
            $("#contact-feedback-button").addClass("otherbio-cancelactive");
            setTimeout(function () {
                $("#contact-feedback-button").removeClass("otherbio-cancelactive");
                $("#contact-feedback-button").addClass("otherbio-cancel");
            }, 1000);
            $("#contact-feedback-button").click(function () {
                var apiservicecallsObj = new Apiservicecalls(),
                    inputData = sendEmailParameters();
                apiservicecallsObj.postData(constants.ajaxUrl, inputData, OnEmailSuccess, OnEmailError);
            });
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindFeedback " + err);
        }
    };
    
    var OnEmailSuccess = function () {
        $("#EmailSuccessText").append("Comments sent successfully.");
        $(".textbox-input1").val("");
        $(".contacts-textarea-field").val("");
        endLoading();
    };
    
    var OnEmailError = function () {
        $("#EmailSuccessText").append("Email not Sent");
        $(".textbox-input1").val("");
        $(".contacts-textarea-field").val("");
        endLoading();
    };
    
    /*Ajax - Success Call back*/
    this.OnFeedbackSuccess = function (data) {
        try {
            var feedbackClassObj = new FeedbackClass();
            feedbackClassObj.bindFeedback(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFeedbackSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnFeedbackError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFeedbackError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFeedbackError " + err);
        }
    };
};

/* Feedback */

var feedback = function () {
    try {
        if (isApp) {
            window.ga.trackView('Contacts Feedback');
        }
        var feedbackObj = new FeedbackClass();
        startLoading();
        headerMain();
        subHeaderContactHide();
        subHeader();
        subHeaderEllipsis();
        feedbackObj.getfeedbackData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : feedback " + err);
    }
};

var navigationContactAgentArrowMenu = function () {
    var firstContactAct = $("#rightarrow").parent().children().children().children(".agentitem").first().hasClass("active"),
        lastContactAct = $("#rightarrow").parent().children().children().children(".agentitem").last().hasClass("active");
    if (firstContactAct !== true && lastContactAct !== true) {
        $("#leftarrow").show();
        $("#rightarrow").show();
    } else if (firstContactAct === true) {
        $("#leftarrow").hide();
        $("#rightarrow").show();
    } else if (lastContactAct === true) {
        $("#leftarrow").show();
        $("#rightarrow").hide();
    }
    $("#rightarrow").click(function () {
        firstContactAct = $("#rightarrow").parent().children().children().children(".agentitem").first().hasClass("active");
        lastContactAct = $("#rightarrow").parent().children().children().children(".agentitem").last().hasClass("active");
        if (firstContactAct !== true && lastContactAct !== true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        } else if (firstContactAct === true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        } else if (lastContactAct === true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        }
    });

    $("#leftarrow").click(function () {
        firstContactAct = $("#leftarrow").parent().children().children().children(".agentitem").first().hasClass("active");
        lastContactAct = $("#leftarrow").parent().children().children().children(".agentitem").last().hasClass("active");
        if (lastContactAct === true) {
            $("#leftarrow").hide();
            $("#rightarrow").show();
        } else if (firstContactAct !== true && lastContactAct !== true) {
            $("#leftarrow").hide();
            $("#rightarrow").show();
        }
    });
};

var navigationRegisterArrowMenu = function () {
    var firstContactAct = $("#rightarrow").parent().children().children().children(".registeritem").first().hasClass("active"),
        lastContactAct = $("#rightarrow").parent().children().children().children(".registeritem").last().hasClass("active");
    if (firstContactAct !== true && lastContactAct !== true) {
        $("#leftarrow").show();
        $("#rightarrow").show();
    } else if (firstContactAct === true) {
        $("#leftarrow").hide();
        $("#rightarrow").show();
    } else if (lastContactAct === true) {
        $("#leftarrow").show();
        $("#rightarrow").hide();
    }
    $("#rightarrow").click(function () {
        firstContactAct = $("#rightarrow").parent().children().children().children(".registeritem").first().hasClass("active");
        lastContactAct = $("#rightarrow").parent().children().children().children(".registeritem").last().hasClass("active");
        if (firstContactAct === true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        } else if (lastContactAct === true) {
            $("#leftarrow").hide();
            $("#rightarrow").show();
        }
    });

    $("#leftarrow").click(function () {
        firstContactAct = $("#leftarrow").parent().children().children().children(".registeritem").first().hasClass("active");
        lastContactAct = $("#leftarrow").parent().children().children().children(".registeritem").last().hasClass("active");
        if (lastContactAct === true) {
            $("#leftarrow").hide();
            $("#rightarrow").show();
        } else if (firstContactAct === true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        }
    });
};

/** Creating request Parameters **/
var sendEmailParameters = function () {
    try {
        var sessionData = applicationDataObj.getSessionResponse();
        var fullName = sessionData.firstName + " " + sessionData.lastName;
        var emailAddress2 = sessionData.emailId;
        var feedbackName = $(".textbox-input1").val() + " " + "(Full Name: " + fullName + ", Email Address: " + emailAddress2 +")",
            feedbackComments = $(".contacts-textarea-field").val(),
            data = {},
            userSession = {};
        data.Userid = sessionData.userId;
        data.ServiceProvider = "FeedbackServiceprovider";
        data.ServiceMethod = "SendEmail";
        data.Language = constants.englishLanguage;
        data.parametersArray = [feedbackName, emailAddress, feedbackComments, "6CE857C2-3384-4E9B-AE07-4F3A6B7C114A"];
        userSession.PlayerId = sessionData.playerId;
        userSession.Userid = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.TOKEN  = applicationDataObj.getToken();
        data.SessionData = userSession;
        data = JSON.stringify(data);
        return data;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : getFeedbackRequestParameters " + err);
    }
};