/**
Clas Name       : headerMain
Description     : header functionality
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/

//On Navigation success API call
var OnHeaderNavigationSuccess = function (navigationObj) {
    try {
        if(window.localStorage.getItem("HamburgerMenu")) {
            window.localStorage.removeItem("HamburgerMenu");
        }
        var parseNavObj = {};
        parseNavObj.navObj = navigationObj;
        parseNavObj.creationTime = new Date();
        parseNavObj.navTTL = 45;
        window.localStorage.setItem("HamburgerMenu", JSON.stringify(parseNavObj));
        var bindNavigationDataObj = new bindNavigationDataClass();
        applicationDataObj.setNavigationObj(navigationObj);
        window.localStorage.setItem("LoginID",navigationObj.PlayerName);
        bindNavigationDataObj.bindNavigationData(applicationDataObj.getNavigationObj());
   } catch (err) {
       loggerObj.logToServer(constants.logSeverityError, "Error : OnNavSuccess " + err);
   }
};

//error function for navigation API call
var OnHeaderNavigationError = function (jqXHR, error) {
	try {
		endLoading();
        if(window.localStorage.getItem("HamburgerMenu")) {
            var HamburgerResponse = window.localStorage.getItem("HamburgerMenu");
            var ParsedResponse = JSON.parse(HamburgerResponse);
            var bindNavigationDataObj = new bindNavigationDataClass();
            applicationDataObj.setNavigationObj(ParsedResponse.navObj);
            setTimeout(function () {
                bindNavigationDataObj.bindNavigationData(applicationDataObj.getNavigationObj());
            }, 100);
            window.localStorage.removeItem("HamburgerMenu");
            var parseNavObj = {};
            parseNavObj.navObj = ParsedResponse.navObj;
            parseNavObj.creationTime = new Date();
            parseNavObj.navTTL = 10;
            window.localStorage.setItem("HamburgerMenu", JSON.stringify(parseNavObj));
        } else {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : OnNavError " + jqXHR.statusText;
                logout();
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnNavError " + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnNavError Unexpected Error with status Code 0";
            } else {
                timoutErrorStatus = true;
                errMsg = "Error : OnNavError Unexpected Error";
            }
            logout();
        }
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : OnNavError " + err);
	}
};

//fetching data from cache JSON
var getCachedNavMenu = function () {
    var bindHamburgerObj = new bindHamburgerClass();
    var bindNavigationDataObj = new bindNavigationDataClass();
    var HamburgerResponse = window.localStorage.getItem("HamburgerMenu"),
    ParsedResponse = JSON.parse(HamburgerResponse),
    ParsedTime = new Date(ParsedResponse.creationTime);
    var currentTime = new Date();
    var TimeDifference= moment.duration(moment(new Date(currentTime)).diff(moment(ParsedTime)));
    // check if TTL is expired or not
    if(TimeDifference.asMinutes() < ParsedResponse.navTTL) {
        // if not expired
        var bindNavigationDataObj = new bindNavigationDataClass();
		applicationDataObj.setNavigationObj(ParsedResponse.navObj);
        setTimeout(function () {
            bindNavigationDataObj.bindNavigationData(applicationDataObj.getNavigationObj());
        }, 100);
    } else {
        //TTL expired
        var apiservicecallsObj = new apiservicecalls(),
            url = constants.ajaxUrl,
            sessionData = applicationDataObj.getSessionResponse(),
            inputData = getRequestParametersGetProfilePicture(sessionData);
        apiservicecallsObj.postData(url, inputData, OnHeaderNavigationSuccess,OnHeaderNavigationError);
    }
};

//header main function
var headerMain = function () {
    var bindNavigationDataObj = new bindNavigationDataClass();
    $("#MyApp").removeClass("overflow-important");
    $('body').removeClass('modal-open');
    $('.modal-backdrop').remove();
    $('.headercontent').load("templates/navbar_menu.template");
    var sessionResponsePlayerName = applicationDataObj.getSessionResponse().firstName +" " + applicationDataObj.getSessionResponse().lastName;
    // check if in cache data JSON is there or not
    if(window.localStorage.getItem("HamburgerMenu")) {
        // if cache data is there
        if(sessionResponsePlayerName === window.localStorage.getItem("LoginID")) {
            getCachedNavMenu();
        } else {
             //if cache data not there
               if (!applicationDataObj.getNavigationObj()) {
                    var apiservicecallsObj = new apiservicecalls(),
                        url = constants.ajaxUrl,
                        sessionData = applicationDataObj.getSessionResponse(),
                        inputData = getRequestParametersGetProfilePicture(sessionData);
                    apiservicecallsObj.postData(url, inputData, OnHeaderNavigationSuccess,OnHeaderNavigationError);
                    //OnNavSuccess
                } else {
                    setTimeout(function () {
                        bindNavigationDataObj.bindNavigationData(applicationDataObj.getNavigationObj());
                    }, 100);
                }
        }
    } else {
        //if cache data not there
       if (!applicationDataObj.getNavigationObj()) {
            var apiservicecallsObj = new apiservicecalls(),
                url = constants.ajaxUrl,
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = getRequestParametersGetProfilePicture(sessionData);
            apiservicecallsObj.postData(url, inputData, OnHeaderNavigationSuccess,OnHeaderNavigationError);
            //OnNavSuccess
        } else {
            setTimeout(function () {
                bindNavigationDataObj.bindNavigationData(applicationDataObj.getNavigationObj());
            }, 100);
        }
    }

    setTimeout(function () {
        if (deviceOS === "android") {
            FingerprintAuth.isAvailable(isTouchIDAvailableSuccess, isTouchIDAvailableError);
        }
        if (deviceOS === "ios" && deviceVersion >= 8) {
            window.plugins.touchid.isAvailable(TouchIDAvailableSuccessIOS, TouchIDAvailableErrorIOS);
		}
        if (deviceOS === "web") {
            $('#navbarsettings').hide();
        }
        
        $("#loginFormfingersetting input").keyup(function (event) {
            if (event.keyCode === 13 || event.charCode === 13) {
                validateextraspaceSettings(true);
                var textboxes = $("#loginFormfingersetting input"),
                    currentBoxNumber = textboxes.index(this),
                    nextBox;
                if (textboxes[currentBoxNumber + 1]) {
                    nextBox = textboxes[currentBoxNumber + 1];
                    $(nextBox).focus();
                    $(nextBox).select();
                    $(nextBox).val().trim();
                    event.preventDefault();
                    return false;
                } else {
                    $("input").blur();
                    $("#fingerprint_signin").click();
                }
            }
        });
        
        $("#loginFormfacesetting input").keyup(function (event) {
            if (event.keyCode === 13 || event.charCode === 13) {
                validateextraspaceSettings(true);
                var textboxes = $("#loginFormfacesetting input"),
                    currentBoxNumber = textboxes.index(this),
                    nextBox;
                if (textboxes[currentBoxNumber + 1]) {
                    nextBox = textboxes[currentBoxNumber + 1];
                    $(nextBox).focus();
                    $(nextBox).select();
                    $(nextBox).val().trim();
                    event.preventDefault();
                    return false;
                } else {
                    $("input").blur();
                    $("#face_signin").click();
                }
            }
        });
    }, 500); 

    setTimeout(function () {
        bindNavigationDataObj.bindHomeClicks();
    }, 1000);
    
    if (applicationDataObj.getUserType() === "Player") {
    	checkPlayerinProfileBankOrEntry();
    }
};

var isTouchIDAvailableSuccess = function (result) {
    if (window.localStorage.getItem('Username') === null || userlogin === undefined || userlogin === "") {
        $('#navbarsettings').show();
    } else {
        if (window.localStorage.getItem('Username').toLowerCase().trim() === userlogin.toLowerCase().trim()) {
            $('#navbarsettings').show();
        } else {
            $('#navbarsettings').hide();
        }
    }
};

var isTouchIDAvailableError = function () {
     $('#navbarsettings').css("display", "none");
};

var TouchIDAvailableSuccessIOS = function () {
    if (window.localStorage.getItem('Username') === null || userlogin === undefined || userlogin === "") {
        $('#navbarsettings').show();
    } else {
        if (window.localStorage.getItem('Username').toLowerCase().trim() === userlogin.toLowerCase().trim()) {
            $('#navbarsettings').show();
        } else {
            $('#navbarsettings').hide();
        }
    }
};

var TouchIDAvailableErrorIOS = function () {
    $('#navbarsettings').css("display", "none");
    if (touchiderrormsg === undefined) {
        $('#navbarsettings').show();
    } else {
        if (touchiderrormsg.code === -7) {
            $('#navbarsettings').show();
        } else if (touchiderrormsg.code === -6) {
            $('.setting-modal').hide();
        }
    }
};

var bindNavigationDataClass = function () {
    
    var hamburgerMeunObj = new hamburgerMeunClass();
    //binding navigation Data
    this.bindNavigationData = function (response) {
       try {
           if (response && response.ProfilePictureSrc) {
                var imageUrl = response.ProfilePictureSrc;
                if (response.ProfilePictureSrc.indexOf("data:image") >= 0) {
                    imageUrl = response.ProfilePictureSrc;
                }
                applicationDataObj.setProfilePic(imageUrl);
            }
            hamburgerMeunObj.bindHamburgerMenu(response);
            if (applicationDataObj.getSessionResponse() && applicationDataObj.getSessionResponse().roles &&
                    applicationDataObj.getSessionResponse().roles.length !== 0) {
                otherRole = applicationDataObj.getSessionResponse().roles[0];
            }
            if (otherRole) {
                var lowerConvertedRole = otherRole.toLowerCase();
                if (lowerConvertedRole.indexOf("other") !== -1) {
                    $("#videoNavbar").addClass("hide");
                    $("#benefitsNavbar").addClass("hide");
                }
            }
            hamburgerMeunObj.settingHeaderReady();
            hamburgerMeunObj.getSubHeaderMenusReady();
            $('.img-user-icon').removeClass("display-none");
            $('.img-user-icon').attr('src', applicationDataObj.getProfilePic().indexOf("Photo_Grey.png") >= 0 ? "images/Photo_Grey.png" : applicationDataObj.getProfilePic());
            if (response && response.Notifications) {
                $(".notification-count").text(response.Notifications);
                $(".notification-counts").text(response.Notifications);
                $(".notification-count").removeClass("hide");
            } else {
                $(".notification-count").addClass("hide");
                $(".no-notify").hide();
            }
            setTimeout(function () {
                if (!applicationDataObj.getNavigationObj()) {
                    endLoading();
                }
            }, 1000);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindNavigationData " + err); 
        }
    };
    
    //bind home click events
    this.bindHomeClicks = function () {
        var otherProfileClassObj = new otherProfileClass();
        $('.header-navbar-home').on('click', function (e) {
            if (location.hash === "#/Home") {
            	if ((applicationDataObj.getUserType() === "Player")) {
            		$('.header-nav-container').hide();
            		$('.homepage-entry-deadlines').css("border-bottom", "3px solid #01acfa");
            		$('.homepage-withdrwl-deadlines').css("border-bottom", "none");
            		$('.homepage-preliminary-deadlines').css("border-bottom", "none");
            		$(".homepage-preliminary-deadlines").removeClass("font-bold");
            		$(".homepage-withdrwl-deadlines").removeClass("font-bold");
            		loadMain();
            	} else {
                    var otherHomeClassObj = new OtherHomeClass();
                    otherHomeClassObj.loadOtherRolesHomePage();
                }
                e.preventDefault();
            }
        });

        $('.img-logo').on('click', function (e) {
            if (location.hash === "#/Home") {
            	if ((applicationDataObj.getUserType() === "Player")) {
            		$('.homepage-entry-deadlines').css("border-bottom", "3px solid #01acfa");
            		$('.homepage-withdrwl-deadlines').css("border-bottom", "none");
            		$('.homepage-preliminary-deadlines').css("border-bottom", "none");
            		$(".homepage-preliminary-deadlines").removeClass("font-bold");
            		$(".homepage-withdrwl-deadlines").removeClass("font-bold");
            		loadMain();
            	} else {
                    var otherHomeClassObj = new OtherHomeClass();
                    otherHomeClassObj.loadOtherRolesHomePage();
                }
                e.preventDefault();
            }
        });
        $("#profile-header-li").on('click', function (e) {
            if (location.hash === "#/MyLanding") {
                startLoading();
                setTimeout(function () {
                    var userType = applicationDataObj.getUserType();
                    if (userType === "Player") {
                        var myProfLandingClass = new MyProfLandingClass();
                        myProfLandingClass.bindProfile();
                        endLoading();
                    } else {
                        $("#other-role-profile").removeClass('hide');
                        $("#other-role-profile").addClass('show');
                        $("#playerprofileDiv").addClass('hide');
                        $("#playerprofileDiv").removeClass('show');
                        otherProfileClassObj.getOtherProfileDetails();
                        endLoading();
                    }
                    $(".user-icon").removeClass("open");
                }, 500);
            }
        });
       
    };
};

//remove fingerprint functionality
var removefingerPrint = function () {
    endLoading();
    var removefingerPrintObj = new removefingerPrintClass();
    try {
        $('#removefingerprint').modal('hide');
        var loginData =  {};
        loginData.Userid = applicationDataObj.getUserId();
        loginData.deviceid = deviceuuid;
        loginData = JSON.stringify(loginData);
        var apiservicecallsObj = new apiservicecalls();
        var url = constants.removeBiometricUrl;
        apiservicecallsObj.postData(url, loginData, removefingerPrintObj.OnremovefingerSuccess, removefingerPrintObj.OnremovefingerError);
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : removefingerPrint " + err);
    }
};

//clicking on settings tab
var settingCollapse = function () {
    try {
        if (deviceOS === "android") {
            FingerprintAuth.isAvailable(touchidAndSuccess,touchidAndError);
        }
        if (deviceOS === "ios") {
            window.plugins.touchid.isAvailable(touchidIosSuccess,touchidIosError);
        }
    } catch (err) {
         loggerObj.logToServer(constants.logSeverityError, "Error : settingCollapse " + err);
    }
};

function touchidAndSuccess(result) {
    if (window.localStorage.getItem("GUID") === null) {
        $('#settingsPanel').html('<a id="add-fingerprint">Enable Touch ID</a>');
    } else {
        if (touchidresult.hasEnrolledFingerprints === true) {
            $('#settingsPanel').html('<a id="existingfingerprint">Disable Touch ID</a>');
        } else {
            $('#settingsPanel').html('<a id="add-fingerprint">Enable Touch ID</a>');
        }
    }
    
    $('#add-fingerprint').click(function () {
        clickCloseNavBar();
        $('.settingText').html('Settings > Lock screen and<div> security > Fingerprints</div>');
        if (result.hasEnrolledFingerprints) {
            $('#finger-username2').val("");
            $('#finger-password2').val("");
            $('#invalid_user_fingerprint').text("");
            $('.usernamevalidation-finger').hide();
            $(".usernamevalidation-finger-invalid").hide();
            $('.passwordvalidation-finger').hide();
            $('#fingerPrintModalSettings').modal('show');
        } else {
            $('#fingerPrintSettingModal').modal('show');
        }
    });

    $('#existingfingerprint').click(function () {
        $('#removefingerprintmodal').modal('show');
    });
}
  
function touchidAndError(error) {
    loggerObj.logToServer(constants.logSeverityError, "Error : isTouchIDAvailableError " + error);
}

function touchidIosSuccess() {
    if (window.localStorage.getItem("GUID") === null) {
        if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
            $('#settingsPanel').html('<a id="add-fingerprint">Enable Face ID</a>');
        } else {
            $('#settingsPanel').html('<a id="add-fingerprint">Enable Touch ID</a>');
        }
    } else {
        if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
             $('#settingsPanel').html('<a id="existingfingerprint">Disable Face ID</a>');
        } else {
            $('#settingsPanel').html('<a id="existingfingerprint">Disable Touch ID</a>');
        }
        
    }

    $('#add-fingerprint').click(function () {
        clickCloseNavBar();
        $('.settingText').html('Settings > Touch ID & Passcode</div>');
            $('#finger-username2').val("");
            $('#finger-password2').val("");
            $('#face-username2').val("");
            $('#face-password2').val("");
            $('#invalid_user_fingerprint').text("");
            $('#invalid_user_face').text("");
            $('.usernamevalidation-finger').hide();
            $(".usernamevalidation-finger-invalid").hide();
            $('.passwordvalidation-finger').hide();
            
            if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
                $('#faceIDModalSettings').modal('show');
            } else {
                $('#fingerPrintModalSettings').modal('show');
            }
            
    });

    $('#existingfingerprint').click(function () {
        if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
            $('#removeFaceIDmodal').modal('show');
        } else {
            $('#removefingerprintmodal').modal('show');
        }
        
    });
}

function touchidIosError(msg) {
     if (msg.code === -7) {
         if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
              $('#settingsPanel').html('<a id="add-fingerprint">Enable Face ID</a>');
         } else {
             $('#settingsPanel').html('<a id="add-fingerprint">Enable Touch ID</a>');
         }
        
    }
    
    $('#add-fingerprint').click(function () {
        clickCloseNavBar();
        if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
            $('.settingText').html('Settings > Face ID & Passcode</div>');
            $('#FaceIDSettingModal').modal('show');
        } else {
            $('.settingText').html('Settings > Touch ID & Passcode</div>');
            $('#fingerPrintSettingModal').modal('show');
        }
        
    });
}

var removefingerPrintClass = function () {
    
    //on remove fingerprint success
    this.OnremovefingerSuccess = function (value) {
        endLoading();
        try {
            window.localStorage.clear();
            $('.modal-backdrop').remove();
            logout();

        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnremovefingerSuccess " + err);
            }
    };

    //on remove fingerprint error
    this.OnremovefingerError = function (jqXHR) {
        endLoading();
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : OnremovefingerError " + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnremovefingerError " + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnremovefingerError Unexpected Error";
            } else {
                errMsg = "Error : OnNavError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            logout();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnremovefingerError " + err);
        }
    };
};

var hamburgerMeunClass = function () {
    
    var bindHamburgerObj = new bindHamburgerClass();
    //bind hamburger menu
    this.bindHamburgerMenu = function (response) {
        try {
            if (response && response.Navigation && response.Navigation.length && response.Navigation.length !== 0) {
                $('#panel01').empty();
                if(response.Id === "44b0ea2f-70ed-41a1-9c8e-d3e037f091ec") {
                    $('#panel01').append('  <div class="header-navbar-accordion header-navbar-home homenavbar"><a href="#/Home" onclick="clickCloseNavBar()" data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse0" aria-expanded="true" aria-controls="collapse0" class="collapseContent collapsed header-navmenus">'+response.MenuText.toUpperCase()+'</a></div><div id="collapse0" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr"></div></div>');
                }
        
                $("#panel03").empty();
                $("#panel04").empty();
                $("#panel05").empty();
                $("#panel06").empty();
                $("#panel07").empty();
                $("#panel08").empty();
                $("#panel09").empty();
                $("#panel10").empty();
                $("#panel11").empty();
                $.each(response.Navigation, function( index, value ) {
                    if (value && value.Id === "6135d2b1-02ee-456f-bb54-8df2144ab00f") {
                        //for MyProfile 
                        $("#panel03").append('<div class=" header-navbar-accordion headernavbar1  header-navmenu-container"><a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse2" aria-expanded="true" aria-controls="collapse2" class="collapseContent collapsed header-navmenus">'+value.MenuText.toUpperCase() +'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse2" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel03"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel03(value);
                    }
                    if (value && value.Id === "f786d905-9e33-4e53-b692-ee770d1a58e9") {
                        //for entries
                        $("#panel04").append('<div class=" header-navbar-accordion headernavbar2  header-navmenu-container"> <a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse3" aria-expanded="true" aria-controls="collapse3" class="collapseContent collapsed header-navmenus">'+value.MenuText.toUpperCase()+'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse3" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel04"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel04(value);
                    }
                    if (value && value.Id === "724230a9-26ae-4fbb-80e8-853b9c96d041") {
                        //for TOURNAMENTS
                        $("#panel05").append(' <div class=" header-navbar-accordion headernavbar3 header-navmenu-container"><a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse4" aria-expanded="true" aria-controls="collapse4" class="collapseContent collapsed header-navmenus ">'+value.MenuText.toUpperCase()+'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse4" class="panel-collapse collapse apps-custom-collapse" role="b" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel05"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel05(value);
                    }
                    if (value && value.Id === "9460ee6c-852d-4d1f-b699-48355d23018f") {
                        //for Rules
                        $("#panel06").append('<div class=" header-navbar-accordion headernavbar4 header-navmenu-container mobtab_collapse"><a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse5" aria-expanded="true" aria-controls="collapse5" class="collapseContent collapsed header-navmenus">'+value.MenuText.toUpperCase()+'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse5" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel06"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel06(value);
                    }
                    if (value && value.Id === "555c167e-5e32-4bf2-babb-3264ea19a070") {
                        //for Rankings
                        $("#panel07").append('<div class=" header-navbar-accordion headernavbar5 header-navmenu-container"><a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse6" aria-expanded="true" aria-controls="collapse6" class="collapseContent collapsed header-navmenus">'+value.MenuText.toUpperCase()+'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse6" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel07"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel07(value);
                    }
                    if (value && value.Id === "e744f0eb-ea66-4793-b6f0-093947e77992") {
                         //for Benefits
                        $("#panel08").append(' <div class=" header-navbar-accordion headernavbar6 header-navmenu-container"><a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse7" aria-expanded="true" aria-controls="collapse7" class="collapseContent collapsed header-navmenus">'+value.MenuText.toUpperCase()+'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse7" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel08"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel08(value);
                    }
                    if (value && value.Id === "d6bd8202-9059-467e-9fe8-48c902fee2fd") {
                        //for news
                         $("#panel09").append('<div class=" header-navbar-accordion headernavbar7 header-navmenu-container"><a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse8" aria-expanded="true" aria-controls="collapse8" class="collapseContent collapsed header-navmenus">'+value.MenuText.toUpperCase()+'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse8" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel09"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel09(value);
                    }
                    if (value && value.Id === "770d0b9c-0e84-490a-9204-bcd893714655") {
                         //for contacts
                         $("#panel10").append(' <div class=" header-navbar-accordion headernavbar8 header-navmenu-container"><a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse9" aria-expanded="true" aria-controls="collapse9" class="collapseContent collapsed header-navmenus">'+value.MenuText.toUpperCase()+'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse9" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel10"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel10(value);
                    }
                    
                    if (value && value.Id === "03beb574-76f0-43d3-a4de-7a2da6f072ff") {
                       //videos
                         $("#panel11").append(' <div class=" header-navbar-accordion headernavbar9 header-navmenu-container"><a data-toggle="collapse" data-parent="#accord-content" role="button" data-target="#collapse10" aria-expanded="true" aria-controls="collapse10" class="collapseContent collapsed header-navmenus">'+value.MenuText.toUpperCase()+'<span class="pull-right plus_mobile" src="images/plus_rounded.svg"></span></a></div><div id="collapse10" class="panel-collapse collapse apps-custom-collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body panel-body-content header-navbar-rulecntnr" id="insidePanel11"></div></div>');
                        bindHamburgerObj.bindHamburgerDetailsPanel11(value);
                    }
                });
            } else {
                logout();
            }
            if (response.ProfileMenu && response.ProfileMenu.Navigation && response.ProfileMenu.Navigation.length &&                       response.ProfileMenu.Navigation.length !== 0) {
                $('#dropdownNavigation').empty();
                $('#dropdownNavigationimage').empty();
                $.each(response.ProfileMenu.Navigation, function(index, value) {
                    if (value && value.Id === "f521b226-9c33-44fc-aeaa-62d5485f2ff6") {
                        $('#dropdownNavigation').append('<li class ="profile-li"><a href="#/MyLanding" id = "profile-header-li" class="avatar-menu-text">'+value.MenuText +'</a></li>');
                        
                        $('#dropdownNavigationimage').append('<li class ="profile-li"><a href="#/MyLanding" id = "profile-header-li" class="avatar-menu-text">'+value.MenuText +'</a></li>');
                    }
                    if (value && value.Id === "7c30dada-3149-4feb-b029-a1a18ac76739") {
                        $('#dropdownNavigation').append('<li class = "notify-li"><a href="#/Notification" id = "notification-header-li" class="avatar-menu-text headtab">'+value.MenuText+'</a></li>');
                        
                        $('#dropdownNavigationimage').append('<li class = "notify-li"><a href="#/Notification" id = "notification-header-li" class="avatar-menu-text headtab">'+value.MenuText+'</a></li>');
                        
                    }
                    if (value && value.Id === "79922194-326e-4c3b-a085-58376fec2160") {
                        $('#dropdownNavigation').append('<li class = "contact-li"><a onclick="contactplayerRelations();" href="javascript:void(0)" id = "contact-header-li" class="avatar-menutext">'+value.MenuText+'</a></li>');
                        
                        $('#dropdownNavigationimage').append('<li class = "contact-li"><a onclick="contactplayerRelations();" href="javascript:void(0)" id = "contact-header-li" class="avatar-menutext">'+value.MenuText+'</a></li>');

                    }
                    if (value && value.Id === "76c5e739-924d-4825-8ced-82033257c5bc") {
                        $('#dropdownNavigation').append('<div class="border-bottom"></div><li onclick="logout();" class ="logout-li"><a id = "logout-header-li" class="avatar-menu-text headtab">' +value.MenuText+'</a></li>');
                        
                        $('#dropdownNavigationimage').append('<div class="border-bottom"></div><li onclick="logout();" class ="logout-li"><a id = "logout-header-li" class="avatar-menu-text headtab">' +value.MenuText+'</a></li>');
                    }
                });    
            } else {
                logout();
            }
            bindHamburgerObj.showDetailsofOtherUSers();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerMenu " + err);
        }
    };
    
    //settings header functionality
    this.settingHeaderReady = function () {
        try {
            ua = navigator.userAgent.toLowerCase();
            isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");
            if($(window).width() >= 360 && $(window).width() < 410 && isAndroid){
                $("#hamburgourmenu").css("cssText", "height:35px !important;");
            }
            if (deviceOS === "android") {
                $('#scroll').removeClass('scrollcontent');
            }
            if (deviceOS === "web") {
                $('#scroll').removeClass('scrollcontent');
            }
            setTimeout(function () {
                
                function toggleHamburgur(e){
                    $('#removescrolldiv').removeClass('iosscrolldiv');
                    $('#landingscroll').removeClass('iosscrolldiv');
                    $('.myproflcontct-container').removeClass('iosscrolldiv');
                    $('.top-header').removeClass('iosscrolldiv');
                    if(e.type === 'shown') {
                        e.preventDefault();
	                    $('.scrollcontent').css('position', 'fixed');
                        $(".header-navbar-home").blur();
                        $(".hamburger-pointer").addClass("pointer-class");
                        $("#mWebIframeHolder").removeClass("demo-iframe-holder");
                        $("#mWebIframeHolder").removeClass("scroll-wrapper");
                        $("#MyApp").addClass("overflow-important");
                        $(".homepage-bottom-container .scrolltouch").addClass("overflow-important");
                        $('#navbar-hamburger').addClass('hidden');
                        $('#navbar-close').removeClass('hidden');
                        $('.header-nav-container').show();
                        $('.header-navbar-close').addClass('headerheight');
                    }
                     if(e.type === 'hide'){
                        e.preventDefault();
                         $('.scrollcontent').css('position', 'fixed');
                        $(".header-navbar-home").blur();
                        $(".hamburger-pointer").addClass("pointer-class");
                        $("#mWebIframeHolder").removeClass("demo-iframe-holder");
                        $("#mWebIframeHolder").removeClass("scroll-wrapper");
                        $("#MyApp").addClass("overflow-important");
                        $(".homepage-bottom-container .scrolltouch").addClass("overflow-important");
                        $('#navbar-hamburger').removeClass('hidden');
                        $('#navbar-close').addClass('hidden');
                        $('.header-nav-container').show();
                        $('.header-navbar .panel-collapse').removeClass('in');
                        $('.header-navbar-accordion a').addClass("collapsed");
                        $('.header-navbar-accordion a').find('span').removeClass('minus_mobile').addClass('plus_mobile');
                        if (cordova.platformId === 'android') {
                            $("#mWebIframe").contents().find("html").css("width","100%");
                            $("#mWebIframe").contents().find("html").css("height","100%");
                            $("#mWebIframe").contents().find("html").css("overflow","auto");
                            $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling","touch");
                        }
                             
                        if (cordova.platformId === 'ios') {
                            if($("#mWebIframe").contents().find('.trnmnt-home-cntnr').text().length > 0) {
                                $("#mWebIframe").contents().find("html").css("width","100%");
                                $("#mWebIframe").contents().find("html").css("height","100%");
                                $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling","touch");
                            } else {
                                $("#mWebIframe").contents().find("html").css("width","100%");
                                $("#mWebIframe").contents().find("html").css("height","100%");
                                $("#mWebIframe").contents().find("html").css("overflow-y","scroll");
                                $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling","touch");
                            }
                        }
                         
                         
                    }
                    if($('#bs-example-navbar-collapse-1').hasClass("in")){ 
                         $("#mWebIframe").contents().find("html").removeAttr("style");
                         if (deviceOS === "android") {
                             $("#mWebIframe").attr("scrolling","no");
                         }
                     }
                }
                $('#bs-example-navbar-collapse-1').on('shown.bs.collapse', toggleHamburgur);
                $('#bs-example-navbar-collapse-1').on('hide.bs.collapse', toggleHamburgur);

                function toggleIcon(e) {
                    var contOffset,
                        rulOffset;
                    if ($(e.target).prev('.header-navbar-accordion').find("span").hasClass("plus_mobile") || $(e.target).prev('.header-navbar-accordion').find("span").hasClass("minus_mobile")) {
                        if (e.type === 'show') {
                            $(e.target).prev('.header-navbar-accordion').find("span").removeClass('plus_mobile').addClass('minus_mobile');
                        }
                        if (e.type === 'hide') {
                            $(e.target).prev('.header-navbar-accordion').find("span").removeClass('minus_mobile').addClass('plus_mobile');
                        }
                        if (e.type === 'shown') {
                            if (e.target.id === 'collapse9' || e.target.id === 'collapse6') {
                                contOffset = $('.headernavbar8').offset();
                                rulOffset = $('.headernavbar4').offset();
                                $('#accord-content').scrollTop(contOffset.top - rulOffset.top);
                            }
                            if (e.target.id === 'collapse10') {
                                contOffset = $('.headernavbar9').offset();
                                rulOffset = $('.headernavbar1').offset();
                                $('#accord-content').scrollTop(contOffset.top - rulOffset.top);
                            }
                            if (e.target.id === 'collapse8' || e.target.id === 'collapse7') {
                                contOffset = $('.headernavbar8').offset();
                                rulOffset = $('.headernavbar3').offset();
                                $('#accord-content').scrollTop(contOffset.top - rulOffset.top);
                            }
                        }
                    }
                }
                $('.header-navbar .panel-group').on('hide.bs.collapse', toggleIcon);
                $('.header-navbar .panel-group').on('show.bs.collapse', toggleIcon);
                $('.header-navbar .panel-group').on('shown.bs.collapse', toggleIcon);
            }, 1000);
        } catch (err) {
             loggerObj.logToServer(constants.logSeverityError,"Error : settingHeaderReady " + err);
        }
    };
    
    //sub header menu functionality
    this.getSubHeaderMenusReady = function() {
        try {
            $(".navbar-rulemenus").click(function() {
                var navigateToPage = $(this).find("a").attr("href").toLowerCase();
                mobileWebMenuItemNavigation(navigateToPage);
            });
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : getSubHeaderMenusReady " + err);
        }
    };
};


var bindHamburgerClass = function () {
    
     //binding hamburger menu details for MYPROFILE
    this.bindHamburgerDetailsPanel03 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    if (value.Id === "50903fd2-b119-4a36-9333-daca9a70cbe1") {
                        $('#insidePanel03').append('<div class="navbar-rulemenus profile"><a href="#/MyLanding">'+value.MenuText +'</a></div>');
                        $(".myProfileId").text(value.MenuText);
                    }
                    if (value.Id === "a7b1e208-81d2-40d6-b31a-bb69b920994b") {
                        $('#insidePanel03').append('<div class="navbar-rulemenus notificn"><a href="#/Notification">'+value.MenuText+'</a></div>');
                        $(".notificationId").text(value.MenuText);
                    }
                    if (value.Id === "cea8afb4-87a3-4284-a237-df2b69b24d17") {
                        $('#insidePanel03').append('<div class="navbar-rulemenus myacnt"><a href="#/MyAccount">'+value.MenuText+'</a></div>');
                        $(".myAccoundId").text(value.MenuText);
                    }
                    if (value.Id === "f47e999a-bf5e-41e8-aa9d-1f4666dc27a1") {
                        $('#insidePanel03').append('<div class="navbar-rulemenus prize-money"><a href="#/MyPrizeMoney">'+value.MenuText+'</a></div>');
                        $(".myPrizeMoneyId").text(value.MenuText);
                    }
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel03 " + err);
        }
    };
    
    //binding hamburger menu details for ENTRIES
    this.bindHamburgerDetailsPanel04 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    var lPath = value.NavPath;
                    if(lPath != null) {
                        var param = lPath.substring(lPath.lastIndexOf("/") + 1);
                        $('#insidePanel04').append('<div class="navbar-rulemenus entry"><a href="#/Entries/'+  param+'">'+value.MenuText+'</a></div>');
                    }
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel04 " + err);
        }
    };
    
    //binding hamburger menu details for TOURNAMENT
    this.bindHamburgerDetailsPanel05 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    var lPath = value.NavPath;
                    if(lPath != null) {
                       var param = lPath.substring(lPath.lastIndexOf("/") + 1);
                        $('#insidePanel05').append('<div class="navbar-rulemenus calendar"><a href="#/Tournaments/'+  param+'">'+value.MenuText+'</a></div>'); 
                    }
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel05 " + err);
        }
    };
    
     //binding hamburger menu details for TOURNAMENT
    this.bindHamburgerDetailsPanel06 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    if (value.Id === "2af53b7e-8ff7-42c7-987d-18b46eefa982") {
                        $('#insidePanel06').append('<div class="navbar-rulemenus rules-rulebook"><a href="#/RuleBook">'+value.MenuText+'</a></div>');
                        $(".rulebookId").text(value.MenuText);
                    }
                    if (value.Id === "577e9a7b-040b-404e-87d4-801a33ae24c4") {
                        $('#insidePanel06').append(' <div class="navbar-rulemenus rules-anticorruption"><a href="#/AntiCorruption">'+value.MenuText+'</a></div>');
                        $(".anticorruptionId").text(value.MenuText);
                    }
                    if (value.Id === "682b7dc2-f0aa-4885-bbdc-d08505f4c8a7") {
                        $('#insidePanel06').append('<div class="navbar-rulemenus rules-antidoping"><a href="#/Rules-AntiDoping">'+value.MenuText+'</a></div>');
                        $(".antidopingId").text(value.MenuText);
                    }
                    if (value.Id === "6ff1acfc-5e36-462c-bba4-1a8131509dc9") {
                        $('#insidePanel06').append('<div class="navbar-rulemenus rules-forms"><a href="#/Forms">'+value.MenuText+'</a></div>');
                        $(".formsId").text(value.MenuText);
                    }
                    if (value.Id === "8f6c6f1a-2f52-4f72-978f-6f1a73a3b428") {
                        $('#insidePanel06').append('<div class="navbar-rulemenus rules-tipp"><a data-url=""  onclick="showTIPPScreen();clickCloseNavBar();">'+value.MenuText+'</a></div>');
                        $(".tippId").text(value.MenuText);
                    }  
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel06 " + err);
        }
    };
    
    //binding hamburger menu details for RAnking
    this.bindHamburgerDetailsPanel07 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    var lPath = value.NavPath;
                    if(lPath != null) {
                        var param = lPath.substring(lPath.lastIndexOf("/") + 1);
                        $('#insidePanel07').append('<div class="navbar-rulemenus rank-singles"><a href="#/Rankings/'+  param+'">'+value.MenuText+'</a></div>');
                    }
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel07 " + err);
        }
    };
    
    //binding hamburger menu details for Benefits
     this.bindHamburgerDetailsPanel08 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    if (value.Id === "8ebf28e4-f79f-430a-8728-3248c2a30bdf") {
                        $('#insidePanel08').append('  <div class="navbar-rulemenus allbenefits"><a href="#/Benefits" accesskey="A">'+value.MenuText+'</a></div>');
                        $(".allBenefitsId").text(value.MenuText);
                    }
                    if (value.Id === "02c1359e-d474-4806-8309-a008e62c71db") {
                        $('#insidePanel08').append(' <div class="navbar-rulemenus atpadvantage"><a href="#/Benefits-ATP-Advantage" accesskey="A">'+value.MenuText+'</a></div>');
                        $(".developmentId").text(value.MenuText);
                    }
                    if (value.Id === "c7774333-6731-44a4-9035-aee6817abeff") {
                        $('#insidePanel08').append('<div class="navbar-rulemenus pension"><a href="#/Benefits-Pension" accesskey="P">'+value.MenuText+'</a></div>');
                        applicationDataObj.setpensionTrue(true);
                        $(".PensionId").text(value.MenuText);
                    }
                    if (value.Id === "e9e78092-1e1f-4627-93e4-1186de24f5b7") {
                        $('#insidePanel08').append(' <div class="navbar-rulemenus health"><a href="#/Benefits-Health" accesskey="H">'+value.MenuText+'</a></div>');
                        $(".healthId").text(value.MenuText);
                    }
                    if (value.Id === "b3219ee4-3a5c-4254-b91e-3078df92313f") {
                        $('#insidePanel08').append(' <div class="navbar-rulemenus social-media-abuse"><a href="#/social-media-abuse" accesskey="H">'+value.MenuText+'</a></div>');
                        $(".socialMediaId").text(value.MenuText);
                    }
                    if (value.Id === "7ce5c7d5-8a8f-4588-890a-7ade4ca048cb") {
                        $('#insidePanel08').append(' <div class="navbar-rulemenus benefits-agents"><a href="#/benefits-agents" accesskey="H">'+value.MenuText+'</a></div>');
                        $(".benefitsAgentId").text(value.MenuText);
                    }
                    
                    if (value.Id === "9942eb94-9141-407e-a449-f44e82a54d70") {
                        $('#insidePanel08').append(' <div class="navbar-rulemenus benefits-membership"><a href="#/benefits-memebership" accesskey="H">'+value.MenuText+'</a></div>');
                        $(".benefitsMembershipId").text(value.MenuText);
                    }
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel08 " + err);
        }
    };
    
    //binding hamburger menu details for News
      this.bindHamburgerDetailsPanel09 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    if (value.Id === "e787374b-08de-43e5-80cc-727aa6f30f79") {
                        $('#insidePanel09').append(' <div class="navbar-rulemenus playersweekly"><a href="#/News_PlayersWeekly">'+value.MenuText+'</a></div>');
                        $(".playersWeeklyId").text(value.MenuText);
                    }
                    if (value.Id === "468abf2b-05b3-4331-a66e-6f44d6e8dfbd") {
                        $('#insidePanel09').append(' <div class="navbar-rulemenus newsarchive"><a href="#/News_NewsArchive">'+value.MenuText+'</a></div>');
                        $(".newsArchiveId").text(value.MenuText);
                    }
                    if (value.Id === "5219244d-691e-4139-9673-d96aa66f7185") {
                        $('#insidePanel09').append('<div class="navbar-rulemenus newsflash"><a href="#/News_Newsflash">'+value.MenuText+'</a></div>');
                        $(".newsFlashId").text(value.MenuText);
                    }
                    if (value.Id === "247a39b5-3d5c-4833-9c6e-d057a1b3ad5e") {
                        $('#insidePanel09').append(' <div class="navbar-rulemenus newsletters"><a href="#/News_Newsletters">'+value.MenuText+'</a></div>');
                        $(".newsletterId").text(value.MenuText);
                    }
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel09 " + err);
        }
    };
    
      //binding hamburger menu details for Conatcts
      this.bindHamburgerDetailsPanel10 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    if (value.Id === "83cd2a86-0f73-41c4-bd77-b59f9a94b429") {
                        $('#insidePanel10').append('<div class="navbar-rulemenus playerrelations"><a href="#/Contact-Player-Relations">'+value.MenuText+'</a></div>');
                        $(".playerRelationId").text(value.MenuText);
                    }
                    if (value.Id === "44e226c8-cd87-4162-babd-7644216a6c7c") {
                        $('#insidePanel10').append('<div class="navbar-rulemenus medicalservices"><a href="#/Contact-MedicalServices">'+value.MenuText+'</a></div>');
                        $(".medicalServicesId").text(value.MenuText);
                    }
                    if (value.Id === "570076da-cecf-43ea-bbd0-d81f6e162b67") {
                        $('#insidePanel10').append('<div class="navbar-rulemenus councilboard"><a href="#/Contact-CouncilBoard">'+value.MenuText+'</a></div>');
                        $(".councilBoardId").text(value.MenuText);
                    }
                    if (value.Id === "32110032-06be-4309-b8f7-e3b124470f72") {
                        $('#insidePanel10').append(' <div class="navbar-rulemenus directories"><a href="#/Contact-Directories">'+value.MenuText+'</a></div>');
                        $(".directoriesId").text(value.MenuText);
                    }
                    if (value.Id === "992a58de-f21e-43c7-8e54-f99b234998c8") {
                        $('#insidePanel10').append('<div class="navbar-rulemenus feedback"><a href="#/Contact-Feedback">'+value.MenuText+'</a></div>');
                        $(".feedBackId").text(value.MenuText);
                    }
                    if (value.Id === "79f852f7-e11b-474d-ac77-626ba24c2d68") {
                        $('#insidePanel10').append('<div class="navbar-rulemenus faq"><a href="#/Contact-FAQ">'+value.MenuText+'</a></div>');
                        $(".faqId").text(value.MenuText);
                    }
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel10 " + err);
        }
    };
    
    //binding hamburger menu details for Videos
     this.bindHamburgerDetailsPanel11 = function(entryResponse) {
        try {
            
            if(entryResponse && entryResponse.Navigation && entryResponse.Navigation.length &&
               entryResponse.Navigation.length !== 0) {
                
                $.each(entryResponse.Navigation, function( index, value ) {
                    var lPath = value.NavPath;
                    var param = lPath.substring(lPath.lastIndexOf("/") + 1);
                    $('#insidePanel11').append('<div class="navbar-rulemenus videolist"><a href="#/Videos/'+  param+'">'+value.MenuText+'</a></div>');
                });
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : bindHamburgerDetailsPanel11 " + err);
        }
    };
    
    //details of other users
    this.showDetailsofOtherUSers = function() {
        try{
            if ((applicationDataObj.getUserType()!=="Player")) {
                $(".entry-header").addClass("hide");
                if (applicationDataObj.getSessionResponse()&& applicationDataObj.getSessionResponse().roles && 
                        applicationDataObj.getSessionResponse().roles.length !== 0) {
                    var role = applicationDataObj.getSessionResponse().roles[0];
                    if (role) {
                        var lowerConvertedRole = role.toLowerCase(); 
                        if (!(lowerConvertedRole.indexOf("alumni") !== -1 || lowerConvertedRole.indexOf("staff") !== -1)) {
                            if (!($(".prize-money").hasClass("hide"))) {
                                $(".prize-money").addClass("hide");
                            }
                            if (!($(".notificn").hasClass("hide"))) {
                                $(".notificn").addClass("hide");
                            }
                            if (!($('.notify-li').hasClass("hide"))) {
                                $('.notify-li').addClass("hide");
                            }
                             
                        }
                        if (lowerConvertedRole === "alumni" ) {
                            if (!($(".notificn").hasClass("hide"))) {
                                $(".notificn").addClass("hide");
                            }
                            if (!($('.notify-li').hasClass("hide"))) {
                                $('.notify-li').addClass("hide");
                            }
                            
                        } else {
                            if (!($(".notificn").hasClass("hide"))) {
                                $(".notificn").addClass("hide");
                            }
                            if (!($('.notify-li').hasClass("hide"))) {
                                $('.notify-li').addClass("hide");
                            }
                        }
                    }
                }
            }
        } catch(err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : showDetailsofOtherUSers " + err);
        }
    };
};

//logout from app
var logout = function () {
    $("#login-username-field").val("");
    $("#login-password").val("");
    $("#invalid_user").text("");
    applicationDataObj = new ApplicationData();
    passwordFlag = true;
    constants.onBehalfPlayerId = '';
    constants.searchDefaultItems = 0;
    constants.managingModule = "";
    constants.headShotImage = "";
    constants.managingPlayers = false;
    constants.liveScoreLoading = false;
    savedImageUri = "";
    clearTimeout(popupTimer);
    clearTimeout(tokenTimer);
    popupTimerFlag = false;
    if (warningCon) {
        con.close();
        clearTimeout(popupTimer);
    }
    window.location.href = "#/";
};

//GetProfilePicture parameters
var getRequestParametersGetProfilePicture = function (sessionData) {
    try {
        var data = {};
        data.UserId = applicationDataObj.getUserId();
        data.ServiceProvider = "NavigationServiceProvider";
        data.ServiceMethod = "GetNavigation";
        data.Language = constants.englishLanguage;
        data.parametersArray = ["44B0EA2F-70ED-41A1-9C8E-D3E037F091EC"];
        var userSession = {};
        userSession.PlayerId = sessionData.playerId;
        userSession.UserId = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.UserName = applicationDataObj.getUsername();
        userSession.Roles = sessionData.roles;
        userSession.EmailId = sessionData.emailId;
        userSession.Address1 = sessionData.address1;
        userSession.City = sessionData.city;
        userSession.Country = sessionData.country;
        userSession.TOKEN = applicationDataObj.getToken();
        data.SessionData = userSession;
        data = JSON.stringify(data);
        return data;
    } catch (err) {
       loggerObj.logToServer(constants.logSeverityError,"Error : getRequestParametersGetProfilePicture " + err); 
    }
};

//clicking the close nav bar
var clickCloseNavBar = function () {
    try {
        $('#removescrolldiv').addClass('iosscrolldiv');
        $('.top-header').addClass('iosscrolldiv');
        $('.myproflcontct-container').addClass('iosscrolldiv');
        $('#landingscroll').addClass('iosscrolldiv');
        $('.scrollcontent').css('position', 'absolute');
        $(".header-navbar-home").focus();
        $(".hamburger-pointer").removeClass("pointer-class");
        $("#mWebIframeHolder").addClass("demo-iframe-holder");
        $("#mWebIframeHolder").addClass("scroll-wrapper");
        $("#MyApp").removeClass("overflow-important");
        $(".homepage-bottom-container .scrolltouch").removeClass("overflow-important");
        $('.header-nav-container').hide();
        $('.home-enter-btn').attr("disabled", false);
        $('.membership-anchor-font').attr("disabled", false);
        $('.add-team-btn').attr("disabled", false);
        $('.atp_humberger_height').removeClass("collapse");
        if (cordova.platformId === 'android') {
            $("#mWebIframe").contents().find("html").css("width","100%");
            $("#mWebIframe").contents().find("html").css("height","100%");
            $("#mWebIframe").contents().find("html").css("overflow","auto");
            $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling","touch");
        }
                             
        if (cordova.platformId === 'ios') {
            if($("#mWebIframe").contents().find('.trnmnt-home-cntnr').text().length > 0) {
                $("#mWebIframe").contents().find("html").css("width","100%");
                $("#mWebIframe").contents().find("html").css("height","100%");
                $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling","touch");
            } else {
                $("#mWebIframe").contents().find("html").css("width","100%");
                $("#mWebIframe").contents().find("html").css("height","100%");
                $("#mWebIframe").contents().find("html").css("overflow-y","scroll");
                $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling","touch");
            }
        }
        $("#bs-example-navbar-collapse-1").removeAttr("style");
        if (deviceOS === "android") {
          $("#mWebIframe").removeAttr("scrolling");
        }
        if ($('.header-navbar .panel-collapse').hasClass('in')) {
            $('.header-navbar .panel-collapse').removeClass('in'); 
            $('.header-navbar-accordion a').addClass("collapsed");
            $('.header-navbar-accordion a').find('span').removeClass('minus_mobile').addClass('plus_mobile');
        }
    } catch (err) {
         loggerObj.logToServer(constants.logSeverityError,"Error : clickCloseNavBar " + err);
    }
};  

// determines whether the page hash matches the current list of mobile web pages
var isMobileWebPageHash = function (pageHash){
    if(~pageHash.toLowerCase().indexOf("#/tournaments") 
        || ~pageHash.toLowerCase().indexOf("#/entries") 
        || ~pageHash.toLowerCase().indexOf("#/rankings")
        || ~pageHash.toLowerCase().indexOf("#/videos")){
        return true;
    }
    return false;
};

// used to handle navigation for mobile web pages
var mobileWebMenuItemNavigation = function (navigateToPage) {
    try {
        var currentLocation = location.hash.toLowerCase();
        if(navigateToPage) {
            // handles navigation for mobile web page when the current page is the same as the one requested
            // which resolves a scenario when navigating within the iframe and wanting to route back to the original page
            if (currentLocation === navigateToPage && isMobileWebPageHash(currentLocation)) {
                $( '#mWebIframe' ).attr( 'src', function ( i, val ) { return val; });
                clickCloseNavBar();
                startLoading();
            } else {
                window.location.href = navigateToPage;
            }
        }
    } catch (err) {
         loggerObj.logToServer(constants.logSeverityError,"Error : mobileWebMenuItemNavigation " + err);
    }
};  

//navigate functionality
var navigate = function(type) {
	try {
		$(".open").removeClass("open");
		if(type === "notify") {
			window.location.href = "#/Notification";
		}
		if(type === "landing") {
			window.location.href = "#/MyLanding";
		}

	} catch(err) {
		loggerObj.logToServer(constants.logSeverityError,"Error : navigate " + err);
	}
};

//validate extra space
var validateextraspaceinsettings = function() {
    try {
        var noErrorexists = true;
        $('.usernamevalidation').hide();
        $('.passwordvalidation').hide();
        $('.invalid_username').hide();
        $(".usernamevalidation-finger-invalid").hide();
        var usernameValue = document.getElementById('finger-username2').value;
        if (usernameValue) {
            if (startsOrEndsWithWhitespace($('#finger-username2').val())) {
                $('.usernamevalidation-finger').hide();
                $(".usernamevalidation-finger-invalid").show();
                return false;
            }
        } else {
            $('.usernamevalidation-finger').show();
            $(".usernamevalidation-finger-invalid").hide();
            return false;
        }
    } catch(err) {
         loggerObj.logToServer(constants.logSeverityError,"Error : validateextraspaceinsettings " + err);
    }
};

//validate extra space
var validateextraspaceinsettingsface = function() {
    try {
        var noErrorexists = true;
        $('.usernamevalidation').hide();
        $('.passwordvalidation').hide();
        $('.invalid_username').hide();
        $(".usernamevalidation-finger-invalid").hide();
        var usernameValue = document.getElementById('face-username2').value;
        if (usernameValue) {
            if (startsOrEndsWithWhitespace($('#face-username2').val())) {
                $('.usernamevalidation-finger').hide();
                $(".usernamevalidation-finger-invalid").show();
                return false;
            }
        } else {
            $('.usernamevalidation-finger').show();
            $(".usernamevalidation-finger-invalid").hide();
            return false;
        }
    } catch(err) {
         loggerObj.logToServer(constants.logSeverityError,"Error : validateextraspaceinsettings " + err);
    }
};

var getReqParamTippEnvelope = function (sessionData) {
    try {
        var data = {},
            parametersArray = [],
            userSession = {};
        data.UserId = applicationDataObj.getUserId();
        data.ServiceProvider = "RulesServiceProvider";
        data.ServiceMethod = "EncryptPlayerTippEnvelopeForHybridApp";
        data.Language = constants.englishLanguage;
        parametersArray.push(applicationDataObj.getSessionResponse().playerId);
        parametersArray.push("02647EED-207A-4FA0-B0F9-A34517F837F1");
        data.parametersArray = parametersArray;
        userSession.PlayerId = sessionData.playerId;
        userSession.UserId = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.UserName = applicationDataObj.getUsername();
        userSession.Roles = sessionData.roles;
        userSession.EmailId = sessionData.emailId;
        userSession.Address1 = sessionData.address1;
        userSession.City = sessionData.city;
        userSession.Country = sessionData.country;
        userSession.TOKEN = applicationDataObj.getToken();
        data.SessionData = userSession;
        data = JSON.stringify(data);
        return data;
    } catch (err) {
       loggerObj.logToServer(constants.logSeverityError,"Error : getReqParamTippEnvelope " + err); 
    }
};

var showTIPPScreen = function() {
    try {
            var apiservicecallsObj = new apiservicecalls(),
                url = constants.ajaxUrl,
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = getReqParamTippEnvelope(sessionData);
            apiservicecallsObj.postData(url, inputData, OnshowTIPPScreenSuccess, OnshowTIPPScreenError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : showTIPPScreen " + err);
        }
};

var OnshowTIPPScreenSuccess = function (response) {
    endLoading();
    if(response){
       // var tippLoginUrl = constants.tippUrl + response;
        window.open(response,"_system");
    }
};

var OnshowTIPPScreenError = function (jqXHR) {
    try {
            endLoading();
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                logout();
            } else if (jqXHR.status === 500) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNews1Error " + err);
        }
};