/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

var HealthClass = function () {
    /** get health data **/
    this.getHealthData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getHealthRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.onHealthSuccess, this.onHealthError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getHealthData " + err);
        }
    };

    /** Binding Health body data**/
   
    this.bindBenefitsHealthResponse = function (response) {
        try {
            
            $("#benefits-health-content").append(response.Content);
            if(response.Query !== null) {
                var scriptQuery = '<script language="JavaScript">';
                scriptQuery = scriptQuery + response.Query;
                scriptQuery = scriptQuery + '</script>';
                $("#benefits-health-content").append(scriptQuery);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindBenefitsHealthResponse " + err);
        }
    };

    /** Creating request parameters**/
    this.getHealthRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(), data = {}, userSession = {};
            data.userId = sessionData.userId;
            data.ServiceProvider = "BenefitsServiceProvider";
            data.ServiceMethod = "GetHealth";
            data.Language = constants.Language;
            data.ParametersArray = ["E9E78092-1E1F-4627-93E4-1186DE24F5B7"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getHealthRequestParameters " + err);
        }
    };
    /*Ajax - Success Call back*/
    this.onHealthSuccess = function (data) {
        try {
            var healthClassObj = new HealthClass();
            healthClassObj.bindBenefitsHealthResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnHealthSuccess " + err);
        }
    };
    this.onHealthError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnHealthError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnHealthError " + err);
        }
    };
};

var navigationArrowMenuAgent = function () {
    var firstdirectoryact, lastdirectoryact;
    firstdirectoryact = $("#rightarrow").parent().children().children(".playeritem").first().next().hasClass("active");
    lastdirectoryact = $("#rightarrow").parent().children().children(".playeritem").last().hasClass("active");
    if (firstdirectoryact !== true || lastdirectoryact !== true) {
        $("#leftarrow").hide();
        $("#rightarrow").show();
    }

    $("#rightarrow").click(function () {
        firstdirectoryact = $("#rightarrow").parent().children().children(".playeritem").first().hasClass("active");
        lastdirectoryact = $("#rightarrow").parent().children().children(".playeritem").last().hasClass("active");
        if (firstdirectoryact === true || lastdirectoryact === true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        }
    });

    $("#leftarrow").click(function () {
        firstdirectoryact = $("#leftarrow").parent().children().children(".playeritem").first().hasClass("active");
        lastdirectoryact = $("#leftarrow").parent().children().children(".playeritem").last().hasClass("active");
        if (firstdirectoryact === true || lastdirectoryact === true) {
            $("#rightarrow").show();
            $("#leftarrow").hide();
        }
    });
};

var navigationArrowMenu = function () {
    var firstdirectoryact, lastdirectoryact;
    firstdirectoryact = $("#rightarrow").parent().children().children(".item").first().hasClass("active");
    lastdirectoryact = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
    if (firstdirectoryact !== true || lastdirectoryact !== true) {
        $("#leftarrow").show();
        $("#rightarrow").hide();
    }

    $("#rightarrow").click(function () {
        firstdirectoryact = $("#rightarrow").parent().children().children(".item").first().hasClass("active");
        lastdirectoryact = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
        if (firstdirectoryact === true || lastdirectoryact === true) {
            $("#leftarrow").show();
            $("#rightarrow").hide();
        }
    });

    $("#leftarrow").click(function () {
        firstdirectoryact = $("#leftarrow").parent().children().children(".item").first().hasClass("active");
        lastdirectoryact = $("#leftarrow").parent().children().children(".item").last().hasClass("active");
        if (firstdirectoryact === true || lastdirectoryact === true) {
            $("#rightarrow").show();
            $("#leftarrow").hide();
        }
    });
};

var navigationContactArrowMenu = function () {
    var firstContactAct,
        lastContactAct;
    firstContactAct = $("#rightarrow").parent().children().children().children(".item").first().hasClass("active");
    lastContactAct = $("#rightarrow").parent().children().children().children(".item").last().hasClass("active");
    if (firstContactAct !== true && lastContactAct !== true) {
        $("#leftarrow").show();
        $("#rightarrow").show();
    } else if (firstContactAct === true) {
        $("#leftarrow").hide();
        $("#rightarrow").show();
    } else if (lastContactAct === true) {
        $("#leftarrow").show();
        $("#rightarrow").hide();
    }
    $("#rightarrow").click(function () {
        firstContactAct = $("#rightarrow").parent().children().children(".item").first().hasClass("active");
        lastContactAct = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
        if (firstContactAct !== true && lastContactAct !== true) {
            $("#leftarrow").show();
            $("#rightarrow").show();
        }
    });

    $("#leftarrow").click(function () {
        firstContactAct = $("#leftarrow").parent().children().children(".item").first().hasClass("active");
        lastContactAct = $("#leftarrow").parent().children().children(".item").last().hasClass("active");
        if (firstContactAct !== true && lastContactAct !== true) {
            $("#leftarrow").show();
            $("#rightarrow").show();
        }
    });
};
/** Health **/

var health = function () {
    try {
        if(isApp){
            window.ga.trackView('Benefits Health');
        }
        var healthClassObj = new HealthClass();
        var role = "",lowerConvertedRole;
        role = applicationDataObj.getSessionResponse().roles[0];
        lowerConvertedRole = role.toLowerCase();
        startLoading();
        headerMain();
        subHeaderBenefitsHide();
        if (lowerConvertedRole.indexOf("atp coach/atp agent") === 0 || lowerConvertedRole.indexOf("atp agent") === 0) {
               navigationArrowMenuAgent();
        } else {
            navigationArrowMenu();
        }
        
        healthClassObj.getHealthData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : health " + err);
    }
};
