/**
Clas Name       : HomeClass
Description     : Data binding for Home Modules
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/

//Globals
var totalMinutes;


//Method called when #/Home route happens
var homeMain = function () {
    try {
        if(isApp){
            window.ga.trackView('HomePage');
        }
        if (deviceOS == 'ios' && isApp) {
            $('#iosscroll').addClass("scrollcontent");
        }
        var carousalClass = new CarousalClass(),
            getThisWeekClass = new GetThisWeekClass(),
            homeClass = new HomeClass(),
            touchIdAndroid = new TouchIdAndroidClass(),
            touchIdiOS = new TouchIdiOSClass();
        startLoading();
        headerMain();
        $('.homepage-eventlist-container').hide();
        $('.home-prelim1-container').hide();
        $('.homepage-eventwithdrwl-container').hide();
        $('.headlines-banner-container').hide();
        carousalClass.carousalData();
        getThisWeekClass.thisweek();
        //var scrollable = document.getElementById("scroll");
       // new ScrollFix(scrollable);
        if ((applicationDataObj.getUserType() === "Player")) {
            $(".player-home-div").removeClass("hide");
            loadMain(true);
        } else {
            var otherHomeClassObj = new OtherHomeClass();
            otherHomeClassObj.loadOtherRolesHomePage();
        }
        $(".homepage-entry-deadlines").click(function () {
            $(".homepage-eventlist-container").html('');
            loadMain();
        });
        $(".homepage-withdrwl-deadlines").click(function () {
            $(".homepage-eventwithdrwl-container").html('');
            loadWithDraw();
        });
        $(".homepage-preliminary-deadlines").click(function () {
            loadPrelimsList();
        });

        $("#prelimsPlayerList caption").click(function (e) {
            if(!this.nextElementSibling.hidden)
            {
                this.firstElementChild.nextElementSibling.src = "images/arrow-down.svg";
                this.nextElementSibling.hidden = true;
                this.nextElementSibling.nextElementSibling.hidden = true;
            } else {
                this.firstElementChild.nextElementSibling.src = "images/arrow-up.svg";
                this.nextElementSibling.hidden = false;
                this.nextElementSibling.nextElementSibling.hidden = false;
            }
        });

        $("#itfPrelimsPlayerList caption").click(function (e) {
            if(!this.nextElementSibling.hidden)
            {
                this.firstElementChild.nextElementSibling.src = "images/arrow-down.svg";
                this.nextElementSibling.hidden = true;
                this.nextElementSibling.nextElementSibling.hidden = true;
            } else {
                this.firstElementChild.nextElementSibling.src = "images/arrow-up.svg";
                this.nextElementSibling.hidden = false;
                this.nextElementSibling.nextElementSibling.hidden = false;
            }
        });

        //for the first time login login with touch id not setup popup will be shown
        setTimeout(function () {
            if (window.localStorage.getItem("flagResult") === null) {
                window.localStorage.setItem("flagResult", 0);
                if (deviceOS === "android") {
                    FingerprintAuth.isAvailable(touchIdAndroid.firstTimeAndroidSucess,
                    touchIdAndroid.firstTimeAndroidError);
                }

                if (deviceOS === "ios" && deviceVersion >= 8) {
                    window.plugins.touchid.isAvailable(touchIdiOS.firstTimeIOSSucess,
                    touchIdiOS.firstTimeIOSError);
                }
            }
        }, 2000);

    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "In homeMain : " + err);
    }
};

//Called to get String value to display time remaining in Premlims tab
var showTimer = function (hours) {
    var timer,
        isTimeZero,
        hrs,
        mins;
    isTimeZero = window.setInterval(function () {
        if (totalMinutes > 0) {
            if (hours) {
                hrs = totalMinutes / 60;
                mins = totalMinutes % 60;
                totalMinutes = totalMinutes - 1;
                timer = parseInt(hrs) + " Hrs " + mins + " Mins until entry deadline";
            } else {
                mins = totalMinutes;
                totalMinutes = totalMinutes - 1;
                timer = mins + " Mins until entry deadline";
            }
            $('#timercont').html(timer);
        } else {
            window.clearInterval(isTimeZero);
        }
    }, 60000);
};

var HomeClass = function () {
    this.initilaizeHomeControls = function () {
        try {
            $(".homepage-eventcalender-innercontent a").click(function (e) {
                var eventUrl = $(e.target).attr("data-url"),
                    urlPath,
                    encodedString;
                if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
                    //urlPath = constants.basePath + eventUrl;
                    encodedString = btoa(eventUrl);
                    window.location.href = "#/LoadWebsite/?urlToLoad=" + encodedString;
                }
            });
            $('.homepage-eventwithdrwl-container').hide();
            $('.homepage-entry-deadlines').css("border-bottom", "3px solid #01acfa");
            $('.homepage-entry-deadlines').addClass("font-bold");
            $('.homepage-eventwithdrwl-container').hide();
            $('.home-prelim1-container').hide();

            $(".home-dropdown.dropdown-menu li").click(function (e) {
                //sets button text
                $("#dropdownMenu1").text($($(this).find("a")).text());
                $(".up-down-arrow").html(' <span class="caret"></span><img src="images/arrows_up_down.svg" class=" homepage-dropdown">');
                //removes isSelected class
                $(".dropdown li a").removeClass("isSelected");
                //add isSlected Class to clicked element
                $($(this).find('a')).addClass("isSelected");
                e.preventDefault();
            });

            $('#bs-example-navbar-collapse-1')
                .on('shown.bs.collapse', function () {
                    $('#navbar-hamburger').addClass('hidden');
                    $('#navbar-close').removeClass('hidden');
                    $('.header-nav-container').show();
                    $('.header-navbar-close').addClass('headerheight');
                })
                .on('hidden.bs.collapse', function () {
                    $('#navbar-hamburger').removeClass('hidden');
                    $('#navbar-close').addClass('hidden');
                    $('.header-nav-container').show();
                });

            $('.header-navbar-accordion a').click(function () {
                $(this).find('span').toggleClass('plus_mobile minus_mobile');

            });
            $(window).load(function () {
                $('.selectedmenu').css('text-decoration', 'underline');
            });
            $(".profilepage_selection").click(function () {
                $('.profilepage_selection').css('text-decoration', 'underline');
                $('.notification_selection').css('text-decoration', 'none');
                $(".team_selection").css('text-decoration', 'none');
                $(".myaccount_selection").css('text-decoration', 'none');
                $(".money_selection").css('text-decoration', 'none');
            });
            $(".notification_selection").click(function () {
                $('.profilepage_selection').css('text-decoration', 'none');
                $('.notification_selection').css('text-decoration', 'underline');
                $(".team_selection").css('text-decoration', 'none');
                $(".myaccount_selection").css('text-decoration', 'none');
                $(".money_selection").css('text-decoration', 'none');
            });
            $(".team_selection").click(function () {
                $('.profilepage_selection').css('text-decoration', 'none');
                $('.notification_selection').css('text-decoration', 'none');
                $(".team_selection").css('text-decoration', 'underline');
                $(".myaccount_selection").css('text-decoration', 'none');
                $(".money_selection").css('text-decoration', 'none');
            });
            $(".myaccount_selection").click(function () {
                $('.profilepage_selection').css('text-decoration', 'none');
                $('.notification_selection').css('text-decoration', 'none');
                $(".team_selection").css('text-decoration', 'none');
                $(".myaccount_selection").css('text-decoration', 'underline');
                $(".money_selection").css('text-decoration', 'none');
            });
            $(".money_selection").click(function () {
                $('.profilepage_selection').css('text-decoration', 'none');
                $('.notification_selection').css('text-decoration', 'none');
                $(".team_selection").css('text-decoration', 'none');
                $(".myaccount_selection").css('text-decoration', 'none');
                $(".money_selection").css('text-decoration', 'underline');
            });

            $(".homepage-entry-deadlines").mouseenter(function () {
                $('.homepage-entry-deadlines').css("border-bottom", "3px solid #01acfa");
                $(".homepage-preliminary-deadlines").css("border-bottom", "none");
                $(".homepage-withdrwl-deadlines").css("border-bottom", "none");
            });
            $(".homepage-withdrwl-deadlines").mouseenter(function () {
                $('.homepage-withdrwl-deadlines').css("border-bottom", "3px solid #01acfa");
                $(".homepage-entry-deadlines").css("border-bottom", "none");
                $(".homepage-preliminary-deadlines").css("border-bottom", "none");
            });

            $(".homepage-preliminary-deadlines").mouseenter(function () {
                $(".homepage-preliminary-deadlines").css("border-bottom", "3px solid #01acfa");
                $('.homepage-withdrwl-deadlines').css("border-bottom", "none");
                $(".homepage-entry-deadlines").css("border-bottom", "none");
            });

            $(".homepage-entry-deadlines").click(function () {
                $('.homepage-entry-deadlines').css("border-bottom", "3px solid #01acfa");
                $(".homepage-preliminary-deadlines").css("border-bottom", "none");
                $(".homepage-withdrwl-deadlines").css("border-bottom", "none");
                $('.homepage-entry-deadlines').addClass("font-bold");
                $(".homepage-preliminary-deadlines").removeClass("font-bold");
                $(".homepage-withdrwl-deadlines").removeClass("font-bold");
                $('.homepage-eventlist-container').show();
                $('.home-prelim1-container').hide();
                $('.homepage-eventwithdrwl-container').hide();
                $('.headlines-banner-container').show();
                $('.homepage-bottom-container').css("background-color", "#e1e1e1");
            });

            $(".homepage-withdrwl-deadlines").click(function () {
                $('.homepage-withdrwl-deadlines').css("border-bottom", "3px solid #01acfa");
                $(".homepage-entry-deadlines").css("border-bottom", "none");
                $(".homepage-preliminary-deadlines").css("border-bottom", "none");
                $('.homepage-bottom-container').css("background-color", "#e1e1e1");
                $('.homepage-withdrwl-deadlines').addClass("font-bold");
                $(".homepage-preliminary-deadlines").removeClass("font-bold");
                $(".homepage-entry-deadlines").removeClass("font-bold");
            });

            $(".homepage-preliminary-deadlines").click(function () {
                $(".homepage-preliminary-deadlines").css("border-bottom", "3px solid #01acfa");
                $('.homepage-withdrwl-deadlines').css("border-bottom", "none");
                $(".homepage-entry-deadlines").css("border-bottom", "none");
                $('.homepage-bottom-container').css("background-color", "#e1e1e1");
                $('.homepage-withdrwl-deadlines').removeClass("font-bold");
                $(".homepage-preliminary-deadlines").addClass("font-bold");
                $(".homepage-entry-deadlines").removeClass("font-bold");
            });
            setTimeout(function () {
                endLoading();
            }, 1000);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : initilaizeHomeControls " + err);
        }
    };

    this.getTimerToShow = function () {
        try {
            var text = $(".homepage-dateevent-calender").find('.timercont').html(),
                stipedTime = text.replace('until entry deadline', ''),
                totalMins,
                totalhrs,
                totalms;
            if (stipedTime.indexOf('Hrs') > 0 && stipedTime.indexOf('Mins') > 0) {
                stipedTime = stipedTime.split(" ");
                totalhrs = stipedTime[0];
                totalms = stipedTime[2];
                totalMins = (parseInt(totalhrs) * 60) + parseInt(totalms);
                totalMinutes = totalMins;
                showTimer(true);
            } else if (stipedTime.indexOf('Mins') > 0 && stipedTime.indexOf('Hrs') === -1) {
                stipedTime = stipedTime.split(" ");
                totalms = stipedTime[0];
                totalMins = parseInt(totalms);
                totalMinutes = totalMins;
                showTimer(false);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getTimerToShow " + err);
        }
    };

    //Method to bind entry data
    this.getEntry = function (data) {
        try {
            var len = data.length;
            if (len === 0) {
                $(".homepage-eventlist-container").append("There are no tournaments to enter at the moment");
            }
            for (i = 0; i < len; i++) {
                var lan = data[i].Events,
                    strdate,
                    timeText,
                    stipedTime,
                    totalMins;
                if (data[i].EventDeadLineDate !== null) {
                    strdate = moment(data[i].EventDeadLineDate).format("DD MMM");
                } else {
                    strdate = data[i].EventDeadLineDate;
                }
                timeText = data[i].EntryDeadlineClock;
                stipedTime = timeText.replace('until entry deadline', '');

                $(".homepage-eventlist-container").append('<div class="homepage-dateevent-calender" id="calander-cont"> <div class="row"><div class="col-sm-2 col-xs-2 monthspec paddingright0">' + strdate + '</div> <div class="col-sm-10 col-xs-10 dayspec timercont" id="timercont">' + data[i].EntryDeadlineClock + ' </div></div> <ul class="homepage-eventcalender-innercontainer" id="div' + i + '" ></ul><div class="homepage-enter"><input class="home-enter-btn" onclick = "navigateEntryFromEnter(this);" type="button" data-type = "entry" data-url = "' + data[i].EntryButtonUrl + '"id="b' + i + '" value="ENTER" ></div><div class="clearfix"></div></div>');
                if ((data[i].EntryDeadlineClock.indexOf("00 Hrs 00 Mins") !== -1) || (data[i].EntryDeadlineClock.indexOf("Entry Deadline has passed") !== -1)) {
                    $('#b' + i).prop('disabled', true).addClass('disabledbutton');
                } else {
                    $('#b' + i).click(function () {
                        window.location.href = '#';
                    });
                }
                for (j = 0; j < lan.length; j++) {
                    $("#div" + i).append('<li class="homepage-eventcalender-innercontent"><a  data-url = ' + lan[j].EventUrl + '>' + lan[j].EventName.toUpperCase() + '</a></li>');
                }
            }
            this.initilaizeHomeControls();
            this.getTimerToShow();
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getEntry " + err);
        }
    };

    //initializeHomeWithdrawalControls
    this.initializeHomeWithdrawalControls = function () {
        $(".homepage-eventwithdrwl-container a").click(function (e) {
            var eventUrl = $(e.target).attr("data-url"),
                urlPath,
                encodedString;
            if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
                //urlPath = constants.basePath + eventUrl;
                encodedString = btoa(eventUrl);
                window.location.href = "#/LoadWebsite/?urlToLoad=" + encodedString;
            }
        });
    };

    this.getWithdrawal = function (data) {
        try {
            var len = data.length;
            if (len === 0) {
                $(".homepage-eventwithdrwl-container").append("You have not entered any events so there are no available tournaments to withdraw from");
            }
            for (i = 0; i < len; i++) {
                var lan = data[i].Events,
                    strdate,
                    textToDisplay = data[i].WithdrawalDeadlineClock;
                if (data[i].EventDeadLineDate !== null) {
                    strdate = moment(data[i].EventDeadLineDate).format("DD MMM");
                } else {
                    strdate = data[i].EventDeadLineDate;
                }

                if (textToDisplay.indexOf("00 Hrs 00 Mins") !== -1) {
                    textToDisplay = "0 Minutes";
                }
                $(".homepage-eventwithdrwl-container").append('<div class="homepage-dateevent-calender" id="divmain' + i + '"> <div class="row"> <div class="col-sm-2 col-xs-2 monthspec paddingright0">' + strdate + '</div> <div class="col-sm-10 col-xs-10 dayspec">' + textToDisplay + ' </div></div> <ul class="homepage-eventcalender-innercontainer" id="divs' + i + '" ></ul><div class="homepage-withdrawal"><input class="home-withdrawal-btn" onclick = "navigateEntryFromEnter(this);" type="button"  data-type = "withdraw" data-url = "' + data[i].WithdrawButtonUrl + '" id="bs' + i + '" value="WITHDRAW" ></div><div class="clearfix"></div></div>');
                if ((data[i].WithdrawalDeadlineClock.indexOf("00 Hrs 00 Mins") !== -1) || (data[i].WithdrawalDeadlineClock.indexOf("Withdrawal Deadline has passed") !== -1)) {
                    $('#bs' + i).prop('disabled', true).addClass('disabledbutton');
                } else {
                    $('#bs' + i).click(function () {
                        window.location.href = '#';
                    });
                }
                if (lan.length !== 0) {
                    for (j = 0; j < lan.length; j++) {
                        $("#divs" + i).append('<li class="homepage-eventcalender-innercontent"><a data-url = ' + lan[j].EventUrl + '>' + lan[j].EventName.toUpperCase() + '</a></li>');
                    }
                } else {
                    $("#divmain" + i).hide();
                }
            }
            this.initializeHomeWithdrawalControls();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getWithdrawal " + err);
        }
    };
};

var getWithdrawParameters = function (sessionData, parametersArray) {
    try {
        var data = {},
            userSession = {};
        data.Userid = sessionData.userId;
        data.ServiceProvider = "HomeServiceProvider";
        data.ServiceMethod = "GetWithdrawals";
        data.Language = constants.englishLanguage;
        userSession.PlayerId = sessionData.playerId + "a";
        userSession.Userid = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.TOKEN = applicationDataObj.getToken();
        userSession.Roles = sessionData.roles;
        data.parametersArray = parametersArray;
        data.SessionData = userSession;
        data = JSON.stringify(data);
        return data;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : getWithdrawParameters " + err);
    }
};

var loadWithDraw = function () {
    try {
        $('.homepage-withdrwl-deadlines').css("border-bottom", "3px solid #01acfa");
        $(".homepage-entry-deadlines").css("border-bottom", "none");
        $(".homepage-preliminary-deadlines").css("border-bottom", "none");
        $('.homepage-bottom-container').css("background-color", "#e1e1e1");
        $('.homepage-withdrwl-deadlines').addClass("font-bold");
        $(".homepage-preliminary-deadlines").removeClass("font-bold");
        $(".homepage-entry-deadlines").removeClass("font-bold");
        startLoading();
        var apiservicecallsObj = new Apiservicecalls(),
            data = {},
            sessionData = applicationDataObj.getSessionResponse(),
            parameter1 = [],
            inputData;
        parameter1.push(sessionData.playerId);
        parameter1.push("1B904834-B964-4EE6-A1A3-2F37AD962E37");
        parametersArray = parameter1;
        inputData = getWithdrawParameters(sessionData, parametersArray);
        apiservicecallsObj.postData(constants.ajaxUrl, inputData, OnWithdrawSuccess, OnWithdrawError);
        $('.homepage-eventwithdrwl-container').show();
        $('.homepage-eventlist-container').hide();
        $('.home-prelim1-container').hide();
        $('.headlines-banner-container').show();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : loadWithDraw " + err);
    }
};


var getEntryParameters = function (sessionData, parametersArray) {
    try {
        var data = {},
            userSession = {};
        data.Userid = sessionData.userId;
        data.ServiceProvider = "HomeServiceProvider";
        data.ServiceMethod = "GetEntries";
        data.Language = constants.englishLanguage;
        userSession.PlayerId = sessionData.playerId;
        userSession.Userid = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.TOKEN = applicationDataObj.getToken();
        userSession.Roles = sessionData.roles;
        data.parametersArray = parametersArray;
        data.SessionData = userSession;
        data = JSON.stringify(data);
        return data;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : getEntryParameters " + err);
    }
};

var loadMain = function (value) {
    startLoading();
    $('.homepage-entry-deadlines').css("border-bottom", "3px solid #01acfa");
    $(".homepage-preliminary-deadlines").css("border-bottom", "none");
    $(".homepage-withdrwl-deadlines").css("border-bottom", "none");
    $('.homepage-entry-deadlines').addClass("font-bold");
    $(".homepage-preliminary-deadlines").removeClass("font-bold");
    $(".homepage-withdrwl-deadlines").removeClass("font-bold");
    $('.homepage-bottom-container').css("background-color", "#e1e1e1");
    if (value) {
        loadEntryHome();
    } else {
        loadEntryHome();
    }
};

var OnEntrySuccess = function (data) {
    try {
        if (data) {
            var homeClass = new HomeClass();
            $(".homepage-eventlist-container").empty();
            homeClass.getEntry(data);
            $(".homepage-eventlist-container").css("display", "block");
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : OnEntrySuccess " + err);
    }
};

var OnEntryError = function (jqXHR, error) {
    try {
        endLoading();
        loggerObj.logToServer(constants.logSeverityError, "Error : OnEntryError " + jqXHR.statusText);
        if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
            logout();
        }
        if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
            timoutErrorStatus = true;
            logout();
        }
        if (jqXHR.status === 0) {
            timoutErrorStatus = true;
            logout();
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : OnEntryError " + err);
    }
};

var loadEntryHome = function () {
    try {
        var apiservicecallsObj = new Apiservicecalls(),
            data = {},
            sessionData = applicationDataObj.getSessionResponse(),
            parameter = [],
            inputData;
        parameter.push("1B904834-B964-4EE6-A1A3-2F37AD962E37");
        parametersArray = parameter;
        inputData = getEntryParameters(sessionData, parametersArray);
        apiservicecallsObj.postData(constants.ajaxUrl, inputData, OnEntrySuccess, OnEntryError);
        $('.homepage-eventlist-container').show();
        $('.home-prelim1-container').hide();
        $('.homepage-eventwithdrwl-container').hide();
        $('.headlines-banner-container').show();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : loadEntryHome " + err);
    }
};

var OnWithdrawSuccess = function (data) {
    try {
        if (data) {
            var homeClass = new HomeClass();
            homeClass.getWithdrawal(data);
            endLoading();
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : OnWithdrawSuccess " + err);
    }
};

var OnWithdrawError = function (jqXHR, error) {
    try {
        endLoading();
        if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
            console.log("timeout");
        } else if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
            logout();
        } else {
            logout();
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : OnWithdrawError " + err);
    }
};

var getRequestParametersPrelimsEvents = function (sessionData) {
    try {
        var data = {},
            userSession = {};
        data.Userid = sessionData.userId;
        data.ServiceProvider = "HomeServiceProvider";
        data.ServiceMethod = "GetPrelimListEvents";
        data.Language = constants.englishLanguage;
        data.parametersArray = ["80FF8E20-BEA9-4966-88F0-61CED8953725"];
        userSession.PlayerId = sessionData.playerId;
        userSession.UserId = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.TOKEN = applicationDataObj.getToken();
        data.SessionData = userSession;
        data = JSON.stringify(data);
        return data;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : getRequestParametersPrelimsEvents " + err);
    }
};

var getRequestParametersPrelimsByEvents = function (sessionData, eventYear, eventId) {
    try {
        var data = {},
            userSession = {};
        data.Userid = sessionData.userId;
        data.ServiceProvider = "HomeServiceProvider";
        data.ServiceMethod = "GetPrelimListByEvent";
        data.Language = constants.englishLanguage;
        data.parametersArray = ['Singles', eventYear, eventId, "80FF8E20-BEA9-4966-88F0-61CED8953725"];
        userSession.PlayerId = sessionData.playerId;
        userSession.UserId = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.Roles = sessionData.roles;
        userSession.EmailId = sessionData.emailId;
        userSession.Address1 = sessionData.address1;
        userSession.City = sessionData.city;
        userSession.Country = sessionData.country;
        userSession.UserName = applicationDataObj.getUsername();
        userSession.TOKEN = applicationDataObj.getToken();
        data.SessionData = userSession;
        data = JSON.stringify(data);
        return data;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : getRequestParametersPrelimsByEvents " + err);
    }
};

//prelimlist click event
$(".homepage-preliminary-deadlines").click(function () {
    loadPrelimsList();
});

//initializePrelimListControls
var initializePrelimListControls = function () {
    try {
        $('#selection').on('change', function (e) {
            $('.homepage-withdrwl-deadlines').css("border-bottom", "none");
            $(".homepage-entry-deadlines").css("border-bottom", "none");
            $(".homepage-preliminary-deadlines").css("border-bottom", "3px solid #01acfa");
            var eventYear = $(this).children(":selected").attr("data-year");
            var eventId = $(this).children(":selected").attr("data-EventId");
            bindPrelimlistBody(eventYear, eventId);
        });
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : initializePrelimListControls " + err);
    }
};

//loadPrelimsList
var loadPrelimsList = function () {
    try {
        $('.homepage-withdrwl-deadlines').css("border-bottom", "none");
        $(".homepage-entry-deadlines").css("border-bottom", "none");
        $(".homepage-preliminary-deadlines").css("border-bottom", "3px solid #01acfa");
        $(".maincontain").removeClass("scrolltouch");
        $('.homepage-eventlist-container').hide();
        $('.home-prelim1-container').show();
        $('.homepage-eventwithdrwl-container').hide();
        startLoading();
        var apiservicecallsObj = new Apiservicecalls(),
            sessionData = applicationDataObj.getSessionResponse(),
            inputData = getRequestParametersPrelimsEvents(sessionData);
        apiservicecallsObj.postData(constants.ajaxUrl, inputData, OnPrelimsListSuccess, OnPrelimsListError);
        initializePrelimListControls();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : loadPrelimsList " + err);
    }
};

var OnPrelimsListSuccess = function (response) {
    try {
        var myClass,
            eventYear,
            eventId;
        if (response !== null && response !== undefined && response.Events.length && response.Events.length !== 0) {
            $("#selection").empty();
            for (var index = 0; index < response.Events.length; index++) {
                myClass = "option" + index;
                $("#selection").append('<option data-EventId=' + response.Events[index].EventId + ' class=' + myClass + ' value="" data-year=' + response.Events[index].EventYear + '>' + response.Events[index].EventDisplayName +
                '</option>');
            }
            $("#selection").append('<option class= "option1" value="allWeek" data-EventId = "all"> All Weeks </option>');
            $('.option0').attr('selected', true);
            eventYear = $('.option0').attr("data-year");
            eventId = $('.option0').attr("data-EventId");
            bindPrelimlistBody(eventYear, eventId);
        } else {
            myClass = "option0";
            $("#selection").append('<option class=' + myClass + ' value=""> Select' + '</option>');
            $("#selection").append('<option class= option1 value="allWeek" data-EventId = "all"> All Weeks' + '</option>');
            $('.option0').attr('selected', true);
            $(".home-prelim-midcntnr").hide();
            $("#prelimsPlayerList").hide();
            $("#itfPrelimsPlayerList").hide();
            eventYear = $('.option0').attr("data-year");
            eventId = $('.option0').attr("data-EventId");
            bindPrelimlistBody(eventYear, eventId);
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : OnSuccess1 " + err);
    }
};

var OnPrelimsListError = function (jqXHR, error) {
    try {
        endLoading();
        if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
            logout();
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : OnError1 " + err);
    }
};

//bindPrelimlistBody
var bindPrelimlistBody = function (eventYear, eventId) {
    try {
        if (eventId === "all") {
            endLoading();
            window.location.href = "#/Entries/PriliminaryList";
        } else {
            /*initializing apicall object*/
            var apiservicecallsObj = new Apiservicecalls(),
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = getRequestParametersPrelimsByEvents(sessionData, eventYear, eventId);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, OnPrelimsByEventsSuccess, OnPrelimsByEventsError);
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : bindPrelimlistBody " + err);
    }
};

var OnPrelimsByEventsSuccess = function (response) {
    try {
        if (response !== null && response !== undefined) {
            document.getElementById("prelimsPlayerList-arrow").src = "images/arrow-up.svg";
            document.getElementById("prelimsHead").hidden = false;
            document.getElementById("prelimsBody").hidden = false;
            document.getElementById("itfPrelimsPlayerList-arrow").src = "images/arrow-up.svg";
            document.getElementById("itfPrelimsHead").hidden = false;
            document.getElementById("itfPrelimsBody").hidden = false;
            
            var trStrDate,
                trEndDline;  
            if (response.EventDate !== null) {
                trStrDate = moment(response.EventDate).format("DD MMM");
            } else {
                trStrDate = response.EventDate;
            }

            if (response.EntryDeadline !== null) {
                trEndDline = moment(response.EntryDeadline).format("DD MMM");
            } else {
                trEndDline = response.EntryDeadline;
            }
            
            $(".startDiv").empty().append('<div>' +
                '<span class="prelim-label" id="startDate">' + response.TournamentDateLabel + ' </span>' +
                '<span class="prelim-label-value">' + trStrDate + '</span>' +
                '</div>' +
                '<div class=" prelim-label-value">' +
                '<span class="prelim-label" id="endDate">' + response.EntryDeadlineLabel + ' </span>' +
                '<span class="prelim-label-value">' + trEndDline + '</span>' +
                '</div>' +
                '<div class="clearfix"></div>');
            $(".EntryDeadlineDiv").empty().append('<div>' +
                '<span class="prelim-surface-label" id="surfacePlay">' + response.Surface + ' </span>' +
                '<span class="prelim-label-value">' + response.EventSurface + '</span>' +
                '</div>' +
                '<div class=" prelim-label-value">' +
                '<span class="prelim-label" id="prize">' + response.PrizeMoneyLabel + ' </span>' +
                '<span class="prelim-label-value">' + (response.EventTotalPrize == null ? ' -- ' : response.EventCurrencySymbol + response.EventTotalPrize) + '</span>' +
                '</div>' +
                '<div class="clearfix"></div>');

            // initialize cutoff variables and change below based on the data 
            var cutoffAppend;
            var cutoffHeader = response.PrevEventYear + ' ' + response.CutOffs;
            var cutoffMds = response.NewEventLabel;
            var cutoffQs = '';

            if (response.PrevQSglAcceptCutoffRank === null && response.PrevQSglDrawCutoffRank === null) {
                cutoffHeader = response.PrevEventYear + ' ' + response.CutOffs;
                cutoffMds = response.MDSLabel + ' ' + response.PrevSglAcceptCutoffRank + '/' + response.PrevSglDrawCutoffRank;
                cutoffQs = response.QSLabel + ' ' + response.NewEventLabel;
            } else {
                cutoffMds = response.MDSLabel + ' ' + response.PrevSglAcceptCutoffRank + '/' + response.PrevSglDrawCutoffRank;

                if(response.PrevQSglAcceptCutoffRank !== null && response.PrevQSglDrawCutoffRank !== null) {
                    cutoffQs = response.QSLabel + ' ' + response.PrevQSglAcceptCutoffRank + '/' + response.PrevQSglDrawCutoffRank;
                }
                
                if(response.PrevQSglAcceptCutoffRank === null && response.PrevQSglDrawCutoffRank !== null) {
                    cutoffQs = response.QSLabel + ' ' + response.PrevQSglDrawCutoffRank;
                }
                
                if(response.PrevQSglAcceptCutoffRank !== null && response.PrevQSglDrawCutoffRank === null) {
                    cutoffQs = response.QSLabel + ' ' + response.PrevQSglAcceptCutoffRank;
                }
                
                if(response.PrevQSglAcceptCutoffRank === null && response.PrevQSglDrawCutoffRank === null) {
                    cutoffQs = response.QSLabel + ' ' + '--';
                }
            }

            if(response.DrawBreakdownSinglesView.IsPastComparable) {
                if(!response.DrawBreakdownSinglesView.IsTour){
                    cutoffMds = response.IncompatibleDrawSizeLabel;
                    cutoffQs = '';
                }   
            } else {
                cutoffMds = response.NewEventLabel;
                cutoffQs = '';
            }

            cutoffAppend = '<div>';
            cutoffAppend = cutoffAppend +'<span class="prelim-label">' + cutoffHeader + ' </span>';
            cutoffAppend = cutoffAppend + '</div>';
            cutoffAppend = cutoffAppend + '<div class=" prelim-label-value">';
            cutoffAppend = cutoffAppend + '<span class=" prelim-label-value"> ' + cutoffMds + '</span>';
            cutoffAppend = cutoffAppend + '<span class="prelim-label-value-text-spacing prelim-label-value"> ' + cutoffQs + '</span>';
            cutoffAppend = cutoffAppend +'</div>';
            $(".cutOffDiv").empty().append(cutoffAppend);

            if (response.DrawSize && response.EventDrawSize) {
                $(".drawDiv").empty().append('<div><span class="prelim-label">' + 
                    response.DrawSize + 
                    ' </span></div>' +
                    '<div class=" prelim-label-value">' +
                    '<span class=" prelim-label-value"> ' + 
                    response.EventDrawSize + 
                    '</span></div>');
            }

            $("#prelimsBody").empty();
            for (var index = 0; index < response.PreliminaryList.length; index++) {
                var prelimsListRow = "";
                prelimsListRow = '<tr>';
                prelimsListRow = prelimsListRow + '<td>' + (index + 1) + '</td>';
                prelimsListRow = prelimsListRow + '<td><img src=' + response.PreliminaryList[index].CountryFlag.Src + ' class="home-flag" />';
                prelimsListRow = prelimsListRow + '<a >';
                prelimsListRow = prelimsListRow + '<span data-url="' + envUrl + '/rankings/singles-breakdown?playerId=' + response.PreliminaryList[index].PlayerId + '"> ' + response.PreliminaryList[index].PlayerFirstName + ' ' + response.PreliminaryList[index].PlayerLastName + '</span>';
                prelimsListRow = prelimsListRow + '</a>';
                prelimsListRow = prelimsListRow + '  (' + (response.PreliminaryList[index].Choice) + ') </td>';
                if (response.PreliminaryList[index].UseProtectedRanking) {
                    prelimsListRow = prelimsListRow + '<td>' + response.PreliminaryList[index].ProtectedRanking + '(PR) </td>';
                } else {
                    prelimsListRow = prelimsListRow + '<td>' + response.PreliminaryList[index].AtpRanking + '</td>';
                }
                prelimsListRow = prelimsListRow + '</tr>';
                $("#prelimsBody").append(prelimsListRow);
            }

            $("#prelimsHead").empty();
            var prelimsHead = "";
            prelimsHead = '<tr>';
            prelimsHead = prelimsHead + '<th>' + response.POSLabel + '</th>';
            prelimsHead = prelimsHead + '<th>' + response.PlayerLabel + '<span class="prelims-player-span">  ' 
                + response.ChoiceLabel + '</span></th>';
            prelimsHead = prelimsHead + '<th>' + response.RankLabel + '</th>';
            prelimsHead = prelimsHead + '</tr>';
            $("#prelimsHead").append(prelimsHead);
            
            $("#prelimsBody a").click(function (e) {
                var eventUrl = $(e.target).attr("data-url"),
                    urlPath,
                    encodedString;
                if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
                    encodedString = btoa(eventUrl);
                    window.location.href = "#/LoadWebsite/?urlToLoad=" + encodedString;
                }
            });

            if(response.DrawBreakdownSinglesView.HasItfInfo) {
                $("#itfPrelimsPlayerList").show();
                $("#itfPrelimsBody").empty();

                $(".mainDiv").empty().append('<div><span class="prelim-label">' + 
                    response.MdBreakdownLabel + 
                    '</span></div>' +
                    '<div class="breakdownLeftDiv prelim-label-value">' +
                    response.ATPITFDALabel + ' ' + response.DrawBreakdownSinglesView.NumOfDirect + ' / ' + response.DrawBreakdownSinglesView.NumOfItfDirectAccept +
                    '</div>' +
                    '<div><span class="prelim-label-value">' + 
                    response.WildCardsLabel + ' ' + response.DrawBreakdownSinglesView.NumOfWC +
                    '</span></div>' +
                    '<div class="breakdownLeftDiv prelim-label-value">' +
                    response.QualifiersLabel + ' ' + response.DrawBreakdownSinglesView.NumOfQualy +
                    '</div>' +
                    '<div><span class="prelim-label-value">' + 
                    response.SpecialExemptsLabel + ' ' + response.DrawBreakdownSinglesView.NumOfSE +
                    '</span></div>');

                $(".qualyDiv").empty().append('<div><span class="prelim-label">' + 
                    response.QBreakdownLabel + 
                    '</span></div>' +
                    '<div class="breakdownLeftDiv prelim-label-value">' +
                    response.ITFDALabel + ' ' + response.DrawBreakdownSinglesView.NumOfItfQual +
                    '</div>' +
                    '<div><span class="prelim-label-value">' + 
                    response.WildCardsLabel + ' ' + response.DrawBreakdownSinglesView.NumOfQualWC +
                    '</span></div>');

                for (var index = 0; index < response.PreliminaryListItf.length; index++) {
                    var itfPrelimsListRow = "";
                    itfPrelimsListRow = '<tr>';
                    itfPrelimsListRow = itfPrelimsListRow + '<td>' + (index + 1) + '</td>';
                    itfPrelimsListRow = itfPrelimsListRow + '<td><img src=' + response.PreliminaryListItf[index].CountryFlag.Src + ' class="home-flag" />';
                    itfPrelimsListRow = itfPrelimsListRow + '<a >';
                    itfPrelimsListRow = itfPrelimsListRow + '<span data-url="' + envUrl + '/rankings/singles-breakdown?playerId=' + response.PreliminaryListItf[index].PlayerId + '"> ' + response.PreliminaryListItf[index].PlayerFirstName + ' ' + response.PreliminaryListItf[index].PlayerLastName + '</span>';
                    itfPrelimsListRow = itfPrelimsListRow + '</a>';
                    itfPrelimsListRow = itfPrelimsListRow + '  (' + (response.PreliminaryListItf[index].Choice) + ') </td>';
                    if (response.PreliminaryListItf[index].UseProtectedRanking) {
                        itfPrelimsListRow = itfPrelimsListRow + '<td>' + response.PreliminaryListItf[index].ProtectedRanking + '(PR) </td>';
                    } else {
                        itfPrelimsListRow = itfPrelimsListRow + '<td>' + response.PreliminaryListItf[index].ItfRanking + '</td>';
                    }
                    itfPrelimsListRow = itfPrelimsListRow + '</tr>';
                    $("#itfPrelimsBody").append(itfPrelimsListRow);
                }
                
                $("#itfPrelimsHead").empty();
                prelimsHead = '<tr>';
                prelimsHead = prelimsHead + '<th>' + response.POSLabel + '</th>';
                prelimsHead = prelimsHead + '<th>' + response.PlayerLabel + '<span class="itf-prelims-player-span">  ' 
                    + response.ChoiceLabel + '</span></th>';
                prelimsHead = prelimsHead + '<th>' + response.RankLabel + '</th>';
                prelimsHead = prelimsHead + '</tr>';
                $("#itfPrelimsHead").append(prelimsHead);

                $("#itfPrelimsBody a").click(function (e) {
                    var eventUrl = $(e.target).attr("data-url"),
                        urlPath,
                        encodedString;
                    if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
                        encodedString = btoa(eventUrl);
                        window.location.href = "#/LoadWebsite/?urlToLoad=" + encodedString;
                    }
                });
            } else {
                $("#itfPrelimsPlayerList").hide();
                if (response.DrawBreakdownSinglesView.ShowMdBreakdown){
                    $(".mainDiv").empty().append('<div><span class="prelim-label">' + 
                        response.MdBreakdownLabel + 
                        '</span></div>' +
                        '<div class="breakdownLeftDiv prelim-label-value">' +
                        response.ATPDALabel + ' ' + response.DrawBreakdownSinglesView.NumOfDirect +
                        '</div>' +
                        '<div><span class="prelim-label-value">' + 
                        response.WildCardsLabel + ' ' + response.DrawBreakdownSinglesView.NumOfWC +
                        '</span></div>' +
                        '<div class="breakdownLeftDiv prelim-label-value">' +
                        response.QualifiersLabel + ' ' + response.DrawBreakdownSinglesView.NumOfQualy +
                        '</div>' +
                        '<div><span class="prelim-label-value">' + 
                        response.SpecialExemptsLabel + ' ' + response.DrawBreakdownSinglesView.NumOfSE +
                        '</span></div>');
                } else {
                    $("#mainDrawBreakdown").hide();
                }
    
                if (response.DrawBreakdownSinglesView.ShowQBreakdown){
                    $(".qualyDiv").empty().append('<div><span class="prelim-label">' + 
                        response.QBreakdownLabel + 
                        '</span></div>' +
                        '<div class="breakdownLeftDiv prelim-label-value">' +
                        response.ATPDALabel + ' ' + response.DrawBreakdownSinglesView.NumOfATPQualSpots +
                        '</div>' +
                        '<div><span class="prelim-label-value">' + 
                        response.WildCardsLabel + ' ' + response.DrawBreakdownSinglesView.NumOfQualWC +
                        '</span></div>');
                } else {
                    $("#qualyDrawBreakdown").hide();
                }
            }
        } //if ends here
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : OnPrelimsByEventsSuccess " + err);
    }
    endLoading();
};

var OnPrelimsByEventsError = function (jqXHR, error) {
    try {
        endLoading();
        if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
            logout();
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : OnPrelimsByEventsError " + err);
    }
};

//navigateEntryUrl
var navigateEntryUrl = function (event) {
    try {
        var eventUrl = $(event).attr("data-url");
        if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
            var eventType = $(event).attr("data-type"),
                //urlPath = constants.basePath + eventUrl,
                encodedString = btoa(eventUrl);
            window.location.href = "#/LoadWebsite/?urlToLoad=" + encodedString;
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : navigateEntryUrl " + err);
    }
};


//navigateEntryUrl
var navigateEntryFromEnter = function (event) {
    try {
        var eventUrl = $(event).attr("data-url");
        if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
            var eventType = $(event).attr("data-type"),
                urlPath = constants.basePath + eventUrl,
                encodedString = btoa(urlPath);
            window.location.href = "#/LoadWebsite/?urlToLoad=" + encodedString;
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : navigateEntryUrl " + err);
    }
};

//collapsiblelines
var collapsiblelines = function () {
    $('.home-enter-btn').attr("disabled", true);
    $('.membership-anchor-font').attr("disabled", true);
    $('.add-team-btn').attr("disabled", true);
};