var resizeableImage = function(image_target) {
  // Some variable and settings
  var $container,
      orig_src = new Image(),
      event_state = {},
      constrain = false,
      min_width = 60, // Change as required
      min_height = 60,
      max_width = 800, // Change as required
      max_height = 900,
      resize_canvas = document.createElement('canvas');
      image_target = $(image_target).get(0);

  init = function(){

    // When resizing, we will always use this copy of the original as the base
    if(image_target){
      orig_src.src=image_target.src;
    }
      
    if($(image_target).parent().hasClass("resize-container")){
        $('.resize-handle').remove();
        $(image_target).unwrap();
    }     
    // Wrap the image with the container and add resize handles
    $(image_target).wrap('<div class="resize-container"></div>')
    .before('<span class="resize-handle resize-handle-nw"></span>')
    .before('<span class="resize-handle resize-handle-ne"></span>')
    .after('<span class="resize-handle resize-handle-se"></span>')
    .after('<span class="resize-handle resize-handle-sw"></span>');

    // Assign the container to a variable
    $container =  $(image_target).parent('.resize-container');

    // Add events
    $container.on('mousedown touchstart', '.resize-handle', startResize);
    $container.on('mousedown touchstart', 'img', startMoving);
    //$('').on('click', crop);
  };

  startResize = function(e){
    e.preventDefault();
    e.stopPropagation();
    saveEventState(e);
    $(document).on('mousemove touchmove', resizing);
    $(document).on('mouseup touchend', endResize);
  };

  endResize = function(e){
    e.preventDefault();
    $(document).off('mouseup touchend', endResize);
    $(document).off('mousemove touchmove', resizing);
    var compLeft = $('.component').offset().left;
    var compTop = $('.component').offset().top;
    var compRight = $('.component').offset().left + $('.component').outerWidth();
    var compBottom = $('.component').offset().top + $('.component').outerHeight();
      
    var imgLeft = $('.resize-image').offset().left;
    var imgTop = $('.resize-image').offset().top;
    var imgRight = $('.resize-image').offset().left + $('.resize-image').width();
    var imgBottom = $('.resize-image').offset().top + $('.resize-image').height();
      
     if(imgLeft < compLeft && imgRight < compLeft) {
        $('.resize-container').offset($('.component').offset());
        init();
    }
    
    if(imgLeft > compRight && imgRight > compRight) {
        $('.resize-container').offset($('.component').offset());
        init();
    }
    
    if(imgTop < compTop && imgBottom < compTop) {
        $('.resize-container').offset($('.component').offset());
        init();
    }
    
    if(imgTop > compBottom && imgBottom > compBottom) {
        $('.resize-container').offset($('.component').offset());
        init();
    }
     return true; 
  };

  saveEventState = function(e){
    // Save the initial event details and container state
    event_state.container_width = $container.width();
    event_state.container_height = $container.height();
    event_state.container_left = $container.offset().left; 
    event_state.container_top = $container.offset().top;
    event_state.mouse_x = (e.clientX || e.pageX || e.originalEvent.touches[0].clientX) + $(window).scrollLeft(); 
    event_state.mouse_y = (e.clientY || e.pageY || e.originalEvent.touches[0].clientY) + $(window).scrollTop();
  
  // This is a fix for mobile safari
  // For some reason it does not allow a direct copy of the touches property
  if(typeof e.originalEvent.touches !== 'undefined'){
    event_state.touches = [];
    $.each(e.originalEvent.touches, function(i, ob){
      event_state.touches[i] = {};
      event_state.touches[i].clientX = 0+ob.clientX;
      event_state.touches[i].clientY = 0+ob.clientY;
    });
  }
    event_state.evnt = e;
  };

  resizing = function(e){
    var mouse={},width,height,left,top,offset=$container.offset();
    mouse.x = (e.clientX || e.pageX || e.originalEvent.touches[0].clientX) + $(window).scrollLeft(); 
    mouse.y = (e.clientY || e.pageY || e.originalEvent.touches[0].clientY) + $(window).scrollTop();
    
    // Position image differently depending on the corner dragged and constraints
    if( $(event_state.evnt.target).hasClass('resize-handle-se') ){
      width = mouse.x - event_state.container_left;
      height = mouse.y  - event_state.container_top;
      left = event_state.container_left;
      top = event_state.container_top;
    } else if($(event_state.evnt.target).hasClass('resize-handle-sw') ){
      width = event_state.container_width - (mouse.x - event_state.container_left);
      height = mouse.y  - event_state.container_top;
      left = mouse.x;
      top = event_state.container_top;
    } else if($(event_state.evnt.target).hasClass('resize-handle-nw') ){
      width = event_state.container_width - (mouse.x - event_state.container_left);
      height = event_state.container_height - (mouse.y - event_state.container_top);
      left = mouse.x;
      top = mouse.y;
      if(constrain || e.shiftKey){
        top = mouse.y - ((width / orig_src.width * orig_src.height) - height);
      }
    } else if($(event_state.evnt.target).hasClass('resize-handle-ne') ){
      width = mouse.x - event_state.container_left;
      height = event_state.container_height - (mouse.y - event_state.container_top);
      left = event_state.container_left;
      top = mouse.y;
      if(constrain || e.shiftKey){
        top = mouse.y - ((width / orig_src.width * orig_src.height) - height);
      }
    }
  
    // Optionally maintain aspect ratio
    if(constrain || e.shiftKey){
      height = width / orig_src.width * orig_src.height;
    }

    if(width > min_width && height > min_height && width < max_width && height < max_height){
      // To improve performance you might limit how often resizeImage() is called
      resizeImage(width, height);  
      // Without this Firefox will not re-calculate the the image dimensions until drag end
      $container.offset({'left': left, 'top': top});
    }
  };

  resizeImage = function(width, height){
    resize_canvas.width = width;
    resize_canvas.height = height;
    resize_canvas.getContext('2d').drawImage(orig_src, 0, 0, width, height);   
    $(image_target).attr('src', resize_canvas.toDataURL("image/jpeg"));  
  };

  startMoving = function(e){
    e.preventDefault();
    e.stopPropagation();
    saveEventState(e);
    $(document).on('mousemove touchmove', moving);
    $(document).on('mouseup touchend', endMoving);
  };

  endMoving = function(e){
    e.preventDefault();
    $(document).off('mouseup touchend', endMoving);
    $(document).off('mousemove touchmove', moving);
       var compLeft = $('.component').offset().left;
    var compTop = $('.component').offset().top;
    var compRight = $('.component').offset().left + $('.component').outerWidth();
    var compBottom = $('.component').offset().top + $('.component').outerHeight();
      
    var imgLeft = $('.resize-image').offset().left;
    var imgTop = $('.resize-image').offset().top;
    var imgRight = $('.resize-image').offset().left + $('.resize-image').width();
    var imgBottom = $('.resize-image').offset().top + $('.resize-image').height();
      
    if(imgLeft < compLeft && imgRight < compLeft) {
        $('.resize-container').offset($('.component').offset());
        init();
    }
    
    if(imgLeft > compRight && imgRight > compRight) {
        $('.resize-container').offset($('.component').offset());
        init();
    }
    
    if(imgTop < compTop && imgBottom < compTop) {
        $('.resize-container').offset($('.component').offset());
        init();
    }
    
    if(imgTop > compBottom && imgBottom > compBottom) {
        $('.resize-container').offset($('.component').offset());
        init();
    }
    return true;  
  };

  moving = function(e){
    var  mouse={}, touches;
    e.preventDefault();
    e.stopPropagation();
    
    touches = e.originalEvent.touches;
    
    mouse.x = (e.clientX || e.pageX || touches[0].clientX) + $(window).scrollLeft(); 
    mouse.y = (e.clientY || e.pageY || touches[0].clientY) + $(window).scrollTop();
    $container.offset({
      'left': mouse.x - ( event_state.mouse_x - event_state.container_left ),
      'top': mouse.y - ( event_state.mouse_y - event_state.container_top ) 
    });
      
    // Watch for pinch zoom gesture while moving
    if(event_state.touches && event_state.touches.length > 1 && touches.length > 1){
      var width = event_state.container_width, height = event_state.container_height;
      var a = event_state.touches[0].clientX - event_state.touches[1].clientX;
      a = a * a; 
      var b = event_state.touches[0].clientY - event_state.touches[1].clientY;
      b = b * b; 
      var dist1 = Math.sqrt( a + b );
      
      a = e.originalEvent.touches[0].clientX - touches[1].clientX;
      a = a * a; 
      b = e.originalEvent.touches[0].clientY - touches[1].clientY;
      b = b * b; 
      var dist2 = Math.sqrt( a + b );

      var ratio = dist2 /dist1;

      width = width * ratio;
      height = height * ratio;
      // To improve performance you might limit how often resizeImage() is called
      resizeImage(width, height);
    }
  };

  crop = function(){
    //Find the part of the image that is inside the crop box
    if($('.resize-image').width() < 300 || $('.resize-image').height() < 300){
      $.alert({
        title: '',
        content: 'Image must be placed within the entire cropping area. Drag and zoom to resize.',
      });
      return false;
    }
      
      var overlayRight = $('.overlay').offset().left + $('.overlay').outerWidth();
      var overlayBottom = $('.overlay').offset().top + $('.overlay').outerHeight();
      var imgRight = $('.resize-image').offset().left + $('.resize-image').width();
      var imgBottom = $('.resize-image').offset().top + $('.resize-image').height();

     if(($('.overlay').offset().top < $('.resize-image').offset().top ) || ($('.overlay').offset().left < $('.resize-image').offset().left) || (imgRight < overlayRight) || (imgBottom < overlayBottom)){
      $.alert({
        title: '',
        content: 'Image must be placed within the entire cropping area. Drag and zoom to resize.',
      }); 
      return false;
    }
  
  
    var crop_canvas,
        left = $('.overlay').offset().left - $container.offset().left,
        top =  $('.overlay').offset().top - $container.offset().top,
        width = $('.overlay').width(),
        height = $('.overlay').height();
    
    crop_canvas = document.createElement('canvas');
    crop_canvas.width = width;
    crop_canvas.height = height;
    
    crop_canvas.getContext('2d').drawImage(image_target, left, top, width, height, 0, 0, width, height);
    //window.open(crop_canvas.toDataURL("image/png"));
    var galleryImage = document.getElementById('photoImage');
    galleryImage.style.display = 'block';
    $('.photo-image').css('background-image','none');
    galleryImage.src = crop_canvas.toDataURL("image/jpeg");
    $('#photoCropModal').modal("hide");
    savePhotoUpload();
  };

  init();
};