/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed, 
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

var LiveScoresClass = function () {
	/**
	 * Initializing templates of livescores
	 */
	this.mainOuterTemplate = '<div id = {2} class="main tab-btm top-btm"><div class="main-detail border-bottom-no "> ' +
	    '<div id = {3} class="main-cont-sec colortop"><div class="padtop1">' +
	    '<span class="images"><img src="{0}" alt="image" class="valign livescore-img" /></span>' +
	    '<span class="bold-text"><a  id="textcol" class="tournament" onclick=navigateUrl(this); data-url="{4}">{1}</a></span>' +
	    '</div></div>' +
	    '</div></div>';
	this.courtRoundTemplate = '<div class="row"><div class="col-sm-6 col-md-4"><div id={3} class="thumbnail tumb">' +
	    '<div class="round-two">{0} - {1}</div><div class="time">{2}</div>' +
	    '<table class="table table-mob"><tbody></tbody></table>' +
	    '</div></div></div>';
	this.bindTeamTable = '<tr class="{12}"><td class="main-td col-xs-10 livescore-padding">' +
	    '<div class="livescore-table-info seed seed-ls-margin text-center">{0}</div><div id ={8} class="livescore-main-cont2 live-score-name-outer">' +
	    '<div style = "padding-right:5px;" class="icon-flag"><img src="{1}" alt="image" class="valign margintop-5 home-flag" /></div>' +
	    '<div style = "padding-left:5px; vertical-align: middle; margin-top : -5px;" class="table-text live-score-player-name">{2}</div>' +
	    '<div class="livescore-ball-div ball-margin hide"><img src="images/ball.svg" class="valign livescore-ball-img" /></div></div></td>' +
	    '<td class="col-xs-2 col-sm-2 num td-width-small addwidth game-score">{4}</td><td class="col-xs-2 col-sm-2 num1 addwidth set1-score">{5}<sup>{9}</sup></td>' +
	    '<td class="col-xs-2 col-sm-2 num3 set2-score addwidth">{6}<sup>{10}</sup></td>'+
        '<td class="col-xs-2 col-sm-2 num3 addwidth set3-score">{7}<sup>{11}</sup></td>'+
        '<td class="col-xs-2 col-sm-2 hidden-xs hidden-sm"></td><td class="col-xs-2 col-sm-2 hidden-xs hidden-sm"></td>' +
	    '</tr>';
    this.bindTeamTableMoreThanThree = '<tr class="{12}"><td class="main-td col-xs-10 livescore-padding">' +
	    '<div class="livescore-table-info seed seed-ls-margin text-center">{0}</div><div id ={8} class="livescore-main-cont2 live-score-name-outer">' +
	    '<div style = "padding-right:5px;" class="icon-flag"><img src="{1}" alt="image" class="valign margintop-5 home-flag" /></div>' +
	    '<div style = "padding-left:5px; vertical-align: middle; margin-top : -5px;" class="table-text live-score-player-name">{2}</div>' +
	    '<div class="livescore-ball-div ball-margin hide"><img src="images/ball.svg" class="valign livescore-ball-img" /></div></div></td>' +
	    '<td class="col-xs-2 col-sm-2 num td-width-small addwidth game-score">{4}</td><td class="col-xs-2 col-sm-2 num1 addwidth set1-score">{5}<sup>{9}</sup></td>' +
	    '<td class="col-xs-2 col-sm-2 num3 set2-score addwidth">{6}<sup>{10}</sup></td>'+
        '<td class="col-xs-2 col-sm-2 num3 addwidth set3-score">{7}<sup>{11}</sup></td>'+
        '<td class="col-xs-2 col-sm-2 num3 addwidth set4-score">{13}<sup>{15}</sup></td>'+
        '<td class="col-xs-2 col-sm-2 num3 addwidth set5-score">{14}<sup>{16}</sup></td>'+
        '<td class="col-xs-2 col-sm-2 hidden-xs hidden-sm"></td><td class="col-xs-2 col-sm-2 hidden-xs hidden-sm"></td>' +
	    '</tr>';
	this.patnerDetails = '<div style = "padding-top:5px" class="livescore-main-cont2 live-score-name-outer" id={0}><div style = "padding-right:5px;" class="icon-flag">' +
	    '<img src="{1}" alt="image" class="valign  home-flag"></div>' +
	    '<div style = "padding-left:5px;" class="table-text live-score-player-name">{2}</div></div></div>';

	
	/**
	 * Function to bind court and round names
	 */
	this.bindCourtRoundNames = function (matchesArray, rowId, contentId, type) {
		try {
			var liveScoreObjData = new LiveScoresClass();
			$.each(matchesArray,  function (index,  value) {
				var thumbId = "thumb" + type + index;
				var courtRoundDetails = liveScoreObjData.courtRoundTemplate.format(value.Round, value.CourtName, value.MatchTime, thumbId);
				$("#" + contentId).append(courtRoundDetails);
				liveScoreObjData.bindTableData(value, index, contentId, type);
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindCourtRoundNames " +  err);
		}
	};
	/**
	 * Funtion to bind table data
	 */
	this.bindTableData = function (matches, rowId, contentId, type) {
		try {
			var lastServe = "";
			if (matches.LastServer) {
				lastServe = matches.LastServer;
			} else {
				lastServe = "";
			}
			if (matches.Team1) {
				this.bindTeamDetails(matches.Team1, rowId, contentId, "1", lastServe, type);
			}
			if (matches.Team2) {
				this.bindTeamDetails(matches.Team2, rowId, contentId, "2", lastServe, type);
			}
			this.bindProperBallImages();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindTableData " +  err);
		}
	};
	/**
	 * function to bind team details
	 */
	this.bindTeamDetails = function (team, index, contentId, teamNumber, lastServe, type) {
		try {
			var rowClass = "";
			var seed = team.SeedEntry;
			var playerFlag = team.PlayerCountryFlagPath;
			var playerName = team.PlayerFirstName +  " " + team.PlayerLastName;
			var ballIcon = "";
			if (team.BallClass) {
				ballIcon = team.BallClass;
				ballIcon = "../../images/ball.svg";
			}
			ballIcon = "../../images/ball.svg";
			var gameScore = team.GameScore;
			if (gameScore === null) {gameScore = ""; }
			var firstSetScore = this.getSetScores(team.Sets, 1);
			var secondSetScore = this.getSetScores(team.Sets, 2);
			var thirdSetScore = this.getSetScores(team.Sets, 3);
            if(team.Sets.length == 6 || team.Sets.length == 5) {
                var fourthSetScore = this.getSetScores(team.Sets, 4);
                var fifthSetScore = this.getSetScores(team.Sets, 5);
                var fourthTieBreakScore = this.getTieBreakScore(team.Sets, 4);
                var fifthTieBreakScore = this.getTieBreakScore(team.Sets, 5);
            }
			var firstTieBreakScore = this.getTieBreakScore(team.Sets, 1);
			var secondTieBreakScore = this.getTieBreakScore(team.Sets, 2);
			var thirdTieBreakScore = this.getTieBreakScore(team.Sets, 3);
			var thumbId = "thumb" + type + index;
			var divId = "thumbdiv" + type + teamNumber;
			if (teamNumber === "2") {rowClass = "border-line1"; }
            if(team.Sets.length == 6 || team.Sets.length == 5) {
                var teamDetailsMoreThanThree = this.bindTeamTableMoreThanThree.format(seed, playerFlag, playerName, ballIcon, gameScore, firstSetScore, secondSetScore, thirdSetScore, divId, firstTieBreakScore, secondTieBreakScore, thirdTieBreakScore, rowClass,fourthSetScore,fifthSetScore,fourthTieBreakScore,fifthTieBreakScore);
            } else {
                var teamDetails = this.bindTeamTable.format(seed, playerFlag, playerName, ballIcon, gameScore, firstSetScore, secondSetScore, thirdSetScore, divId, firstTieBreakScore, secondTieBreakScore, thirdTieBreakScore, rowClass);
            }
			
            if(team.Sets.length === 6 || team.Sets.length == 5) {
                $("#" + contentId).find("#" + thumbId).find('tbody').append(teamDetailsMoreThanThree);
            } else {
                $("#" + contentId).find("#" + thumbId).find('tbody').append(teamDetails);
            }
			var partnerFlagPath = team.PartnerCountryFlagPath;
			var partnerName = team.PartnerFirstName +  " " +  team.PartnerLastName;
			if (partnerFlagPath !== null && partnerFlagPath !== "") {
				partnerFlagPath = partnerFlagPath;
				var partnerNameData = this.patnerDetails.format("1", partnerFlagPath, partnerName);
				$("#" + contentId).find("#" + thumbId).find("#" + divId).parent().append(partnerNameData);
				$("#" + contentId).find("#" + thumbId).find(".seed").addClass("seed-ls");
				$("#" + contentId).find("#" + thumbId).find(".seed").removeClass("seed-ls-margin");
				$("#" + contentId).find("#" + thumbId).find(".livescore-ball-div").addClass("seed-ls");
			}
			if (teamNumber === "1") {
				if (lastServe === "0" || lastServe === "2" || lastServe === 0 || lastServe === 2) {
					$("#" + contentId).find("#" + thumbId).find('#' + divId + ' .livescore-ball-div').addClass('show');
					$("#" + contentId).find("#" + thumbId).find('#' + divId + ' .livescore-ball-div').removeClass('hide');
				}
			}
			if (teamNumber === "2") {
				if (lastServe === "1" || lastServe === "3" || lastServe === 1 || lastServe === 3) {
					$("#" + contentId).find("#" + thumbId).find('#' + divId + ' .livescore-ball-div').addClass('show');
					$("#" + contentId).find("#" + thumbId).find('#' + divId + ' .livescore-ball-div').removeClass('hide');
				}
			}
			var latestGameScore = team.IsLatestScore;
			if (latestGameScore) {
				$("#" + contentId).find("#" + thumbId).find("#" + divId).parent().siblings(".game-score").addClass("latest-score");
			}
            if(team.GameScore === "0") {
                $("#" + contentId).find("#" + thumbId).find("#" + divId).parent().siblings(".game-score").removeClass("latest-score");
            }
            if (team.Sets) {
                $.each(team.Sets,  function (index,  value) {
                    var setLatestScore = value.IsLatestScore;
                    if (setLatestScore) {
                        if (value.SetNumber === 1) {
                            $("#" + contentId).find("#" + thumbId).find("#" + divId).parent().siblings(".set1-score").addClass("latest-score");
                        }
                        if (value.SetNumber === 2) {
                            $("#" + contentId).find("#" + thumbId).find("#" + divId).parent().siblings(".set2-score").addClass("latest-score");
                        }
                        if (value.SetNumber === 3) {
                            $("#" + contentId).find("#" + thumbId).find("#" + divId).parent().siblings(".set3-score").addClass("latest-score");
                        }
                        if (value.SetNumber === 4) {
                            $("#" + contentId).find("#" + thumbId).find("#" + divId).parent().siblings(".set4-score").addClass("latest-score");
                        }
                        if (value.SetNumber === 5) {
                            $("#" + contentId).find("#" + thumbId).find("#" + divId).parent().siblings(".set5-score").addClass("latest-score");
                        }
                    }
                });
            }

		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindTeamDetails " +  err);
		}
	};
	/**
	 * Get set scores
	 */
	this.getSetScores = function (set, setNumber) {
		try {
			var setScore = "";
			$.each(set,  function (index, value) {
				if (setNumber === value.SetNumber) {
					if (value.SetScore) {
						setScore = value.SetScore;
					}
				}
			});
			return setScore;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getSetScores " +  err);
		}
	};
	/**
	 * Get Tie breaker Scores
	 */
	this.getTieBreakScore = function (set, setNumber) {
		try {
			var tieBreakScore = "";
			$.each(set,  function (index, value) {
				if (setNumber === value.SetNumber) {
					if (value.TieBreakScore) {
						tieBreakScore = value.TieBreakScore;
					}
				}
			});
			return tieBreakScore;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getTieBreakScore " +  err);
		}
	};
	/**
	 * Setting input request
	 */
	this.getLiveScoreRequestParameters = function (sessionData) {
		try {
			var data = {};
			data.Userid = sessionData.userId;
			data.ServiceProvider = "LiveScoresServiceProvider";
			data.ServiceMethod = "GetLiveScores";
			data.Language = constants.englishLanguage;
			data.parametersArray =  ["0960D7D2-539F-46F1-B74B-52290DB30DCD"];
			var userSession = {};
			userSession.PlayerId = sessionData.playerId;
			userSession.Userid = sessionData.userId;
			userSession.FirstName = sessionData.firstName;
			userSession.LastName = sessionData.lastName;
			userSession.Roles = sessionData.roles;
			userSession.TOKEN  = applicationDataObj.getToken();
			data.SessionData = userSession;
			var inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getLiveScoreRequestParameters " +  err);
		}
	};
	
	/**
	 * Binding Proper ball images
	 */
	this.bindProperBallImages = function () {
		try {
			setTimeout(function () {
				//$(".livescore-ball-img").attr("src", "");
				$(".livescore-ball-img").attr("src", "images/ball.svg");
			}, 1000);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindProperBallImages " +  err);
		}
	};
	/**
	 * Get live scores data
	 */
	this.getLiveScoresData = function () {
		try {
			var apiservicecallsObj = new Apiservicecalls();
			var url =  constants.ajaxUrl;
			var sessionData = applicationDataObj.getSessionResponse();
			var inputData = this.getLiveScoreRequestParameters(sessionData);
			apiservicecallsObj.postData(url, inputData, this.onLiveScoreSuccess,  this.onLiveScoreError);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getLiveScoresData " +  err);
		}
	};
	/**
	 * Success handling of Live Scores Ajax
	 */
	this.onLiveScoreSuccess = function (data) {
		try {
			var liveScoreObjData = new LiveScoresDataClass();
			liveScoreObjData.bindLiveScoresDataFromService(data);
			endLoading();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : onLiveScoreSuccess " +  err);
		}
	};
	/**
	 * Error handling of Live Scores Ajax
	 */
	this.onLiveScoreError = function (jqXHR,  exception) {
		try {
			endLoading();
			var errMsg = "";
			if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized" ) {
				errMsg = "Error : onLiveScoreError " + jqXHR.statusText;
			} else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
				timoutErrorStatus = true;
				errMsg = "Error : onLiveScoreError " + jqXHR.statusText;
			} else if (jqXHR.status === 0) {
				timoutErrorStatus = true;
				errMsg = "Error : onLiveScoreError Unexpected Error with status Code 0";
			} else {
				timoutErrorStatus = true;
				errMsg = "Error : onLiveScoreError Unexpected Error";
			}
			loggerObj.logToServer(constants.logSeverityError, errMsg);
			logout();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : onLiveScoreError " +  err);
		}
	};
	/**
	 * Initializing Controls
	 */
	this.initializeControls = function () {
		try {
			$("#rightarrow").click(function () {
				firstlive = $("#rightarrow").parent().children().children(".item").first().hasClass("active");
				lastlive = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
				if (firstlive === true || lastlive  === true) {
					$("#leftarrow").show();
				}
			});

			$("#leftarrow").click(function () {
				firstliveact = $("#leftarrow").parent().children().children(".item").first().hasClass("active");
				lastliveact = $("#leftarrow").parent().children().children(".item").last().hasClass("active");
				if (firstliveact === true || lastliveact  === true) {
					$("#rightarrow").show();
				}
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : initializeControls " +  err);
		}
	};
};
/**
 * Ready function of Live Scores 
 */
var liveScoresReady = function () {
	try {
        if(isApp){
            window.ga.trackView('LiveScores');
        }
          if(deviceOS === 'ios' && isApp){
           $('#iosscroll').addClass("scrollcontent");
          }
		var liveScoreObj = new LiveScoresClass();
		startLoading();
		//setTimeout(function () {
			headerMain();
			subHeaderCarousel();
			liveScoreObj.getLiveScoresData();
			liveScoreObj.initializeControls();
		//}, 500);
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : liveScoresReady " +  err);
	}
};

/**
 * Navigate to mweb url
 */
var navigateUrl = function (event) {
    try {
        var eventUrl = $(event).attr("data-url");
        if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
            var eventType = $(event).attr("data-type"),
                //urlPath = constants.basePath + eventUrl,
                encodedString = btoa(eventUrl);
            window.location.href = "#/LoadWebsite/?urlToLoad=" + encodedString;
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : navigateUrl " +  err);
    }
};