/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed, 
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

var LiveScoresDataClass = function () {
	/**
	 * Binding livescores data from service
	 */
	this.bindLiveScoresDataFromService = function (data) {
		try {
			if (data && data.ChallengerTournaments && data.ChallengerTournaments.Tournaments && data.ChallengerTournaments.Tournaments !== 0) {
				$("#challengertab").empty();
				this.bindTournamentImageName(data.ChallengerTournaments.Tournaments, "challengertab", "challenger");
			}
			if (data && data.TourTournaments && data.TourTournaments.Tournaments && data.TourTournaments.Tournaments !== 0) {
				$("#tourtab").empty();
				this.bindTournamentImageName(data.TourTournaments.Tournaments, "tourtab", "tour");
			}
			endLoading();
			this.callWorkerThread();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindLiveScoresDataFromService " + err);
		}
	};
	/**
	 * function for binding tournament name and image
	 */
	this.bindTournamentImageName = function (tournamentsArray, id, type) {
		try {
			var liveScoreObjData = new LiveScoresClass();
			$.each(tournamentsArray,  function (index,  value) {
				var contentId = "content" + type + index;
				var imagePath = value.TournamentBadgePath;
				var tournamentLink;
				if (value.TournamentLink) {
					tournamentLink = value.TournamentLink;
				}
				if (value && value.Matches && value.Matches.length && value.Matches.length !== 0) {
					var tournamentName = liveScoreObjData.mainOuterTemplate.format(imagePath, value.TournamentName, index, contentId, tournamentLink);
					$("#" + id).append(tournamentName);
					liveScoreObjData.bindCourtRoundNames(value.Matches, index, contentId, type);
				}
			});
            if($('#tourtab').html() === ""){
                $('#tourtab').html("No matches currently on Court");
            }
            if($('#challengertab').html() === ""){
                $('#challengertab').html("No matches currently on Court");
            }
            
			$(".table-text.colortxt").css("cssText",  "padding-left: 2px !important;");
			$('.addwidth').css("cssText",  "min-width: 28px !important;");
			$(".main-td").css("cssText",  "width: 200px !important;");
			$(".tournament").click(function () {
				var eventUrl = $(this).attr("data-url");
				if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
					window.location.href  = "#/LoadWebsite/?urlToLoad=" + eventUrl;
				}
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindTournamentImageName " + err);
		}
	};
	/**
	 * Polling Live Data
	 */
	this.callWorkerThread = function () {
		try {
			var liveScoreObj = new LiveScoresClass();
			setTimeout(function () {
				var currentLocation = window.location.hash;
				if (currentLocation === "#/Livescores") {
					constants.liveScoreLoading = true;
					liveScoreObj.getLiveScoresData();
				} else {
					constants.liveScoreLoading = false;
				}
			}, 20000);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : callWorkerThread " + err);
		}
	};
};
