/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed, 
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/**
 * Logger Class
 */
var loggerClass = function () {
	/**
	 * Creating logger request
	 */
	this.createLoggerRequest = function (logSeverity, logMessage) {
		try {
			var logParams = this.getLogParams(),
			    deviceId = this.getDeviceId(),
			    data = {};
			data.severity = logSeverity;
			var errorMessage = "APPNAME : " + logParams.appName + ", APPVERSION : " + logParams.appVersion +
								", TIMESTAMP : "  + logParams.timeStamp +  ", DEVICEID : " + logParams.deviceId +
								", USERNAME : " + logParams.userName + ", OS : " + logParams.osDetail +  ", MESSAGE : " + logMessage;
		/*	var errorMessage = logParams.appName + " , " + logParams.appVersion +
			    " , "  + logParams.timeStamp +  ", " + logParams.deviceId +
			    " , " + logParams.userName + " , " + logParams.osDetail +  " , " + logMessage;*/
			data.msg = errorMessage;
		    sessions = {};
			sessions.TOKEN = applicationDataObj.getToken();
			data.SessionData = sessions;
			var inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			console.log(err);
		}
	};
	/**
	 * Function to get device id
	 */
	this.getDeviceId = function () {
		var isApp =  document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1,
		    deviceId = "";
		if (isApp) {
			deviceId = device.uuid;
		} else {
			deviceId = "Web";
		}
		return deviceId;
	};
	this.getTimeStamp = function () {
		var date = new Date(),
		    month = date.getMonth()  +  1,
		    day = date.getDate(),
		    hour = date.getHours(),
		    min = date.getMinutes(),
		    sec = date.getSeconds();
		month = (month < 10 ? "0" : "")  +  month;
		day = (day < 10 ? "0" : "")  +  day;
		hour = (hour < 10 ? "0" : "")  +  hour;
		min = (min < 10 ? "0" : "")  +  min;
		sec = (sec < 10 ? "0" : "")  +  sec;
		var strDate = date.getFullYear()  +  "-"  +  month  +  "-"  +  day  +  "_"  +   hour  +  ":"  +  min  +  ":"  +  sec;
		return strDate;
	};
	this.getOSDetails = function () {
		var isApp =  document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1,
		    osDetail = "";
		if (isApp) {
			if (navigator.userAgent.match(/iPhone/i)) {
				osDetail = constants.IOS;
	        } else {
	        	osDetail = constants.Android;
	        }
		} else {
			osDetail = "web";
		}
		return osDetail;
	};
	this.getLogParams = function () {
		var logParams = {};
		logParams.deviceId = this.getDeviceId();
		logParams.timeStamp = this.getTimeStamp();
		logParams.appName = constants.appName;
		logParams.appVersion = constants.appVersion;
		logParams.osDetail = this.getOSDetails();
		logParams.userName = applicationDataObj.getUsername();
		return logParams;
	};
	/**
	 * Logging error to server
	 */
	this.logToServer = function (severity, message) {
		try {
            console.log("Message on Logger : "+message);
			var loggerUrl = constants.loggerUrl,
			    inputData = this.createLoggerRequest(severity, message);
            if(typeof applicationDataObj.getToken() !== "undefined") {
                this.logData(loggerUrl, inputData, this.onLoggerSuccess, this.onLoggerError);
            }   
			
		} catch (err) {
			console.log(err);
		}
	};
	/**
	 * Handling logger success
	 */
	this.onLoggerSuccess = function () {
		console.log("Logger Success");
	};
	/**
	 * Handling logger error
	 */
	this.onLoggerError = function (jqXHR, exception) {
		console.log(jqXHR);
		console.log(exception);
		if (jqXHR.status && jqXHR.status === 401 &&
				jqXHR.statusText === "Unauthorized") {
			logout();
		}
	};
	/**
	 * Logger Ajax Call
	 */
	this.logData = function (url, inputData, OnSuccess, onError) {
		try {
			var bearerToken = applicationDataObj.getToken();
			$.ajax({
				type: "POST",
				url: url,
				data: inputData,
				contentType: "application/json",
				processData: false,
				headers: {
					"Content-Type": "application/json",
					"Authorization" : "Bearer " + bearerToken
				},
				timeout: 60000,
				success: OnSuccess,
				error: onError,
				async: true

			});
		} catch (err) {
			console.log(err);
		}

	};
};