/**
Clas Name       : loginMain
Description     : login service
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/

//login main ready function
var userlogin;
var EmailBody;
var EmailSubject;
var tokenResponseAPI;
var loginMethod = "C"; // C for Username and password method & F for Fingerprint & FS for Settings Menu FingerPrint
var loginFingerPrintdata = {};
var loginMain = function () {
    //Google Analytics
   /* if(isApp){
        window.ga.trackView('Login');
    }*/

    clearTimeout(popupTimer);
    clearTimeout(tokenTimer);
    $('#fingerprint-available').hide();
    $('#faceId').hide();
    var fingerprintImageObj = new fingerprintImageClass();
    userlogin = "";
    $('.btn-link').focus(function () {
        $('#forget-password-link').blur();
        $('.loginTouchId').blur();
    });
    $('.validationclass').hide();
    $("#show-username-label").hide();
    $("#loginForm input").keyup(function (event) {
        if (event.keyCode === 13 || event.charCode === 13) {
            validateextraspace(false);
            var textboxes = $("#loginForm input"),
                currentBoxNumber = textboxes.index(this),
                nextBox;
            if (textboxes[currentBoxNumber + 1]) {
                nextBox = textboxes[currentBoxNumber + 1];
                $(nextBox).focus();
                $(nextBox).select();
                $(nextBox).val().trim();
                event.preventDefault();
                return false;
            } else {
                $("input").blur();
                $("#login").click();
            }
        }
    });
    $("#loginFormfinger input").keyup(function (event) {
    if (event.keyCode === 13 || event.charCode === 13) {
        validateextraspace(true);
        var textboxes = $("#loginFormfinger input"),
            currentBoxNumber = textboxes.index(this),
            nextBox;
        if (textboxes[currentBoxNumber + 1]) {
            nextBox = textboxes[currentBoxNumber + 1];
            $(nextBox).focus();
            $(nextBox).select();
            $(nextBox).val().trim();
            event.preventDefault();
            return false;
        } else {
            $("input").blur();
            $("#fingerprint_signin").click();
        }
    }
    });
    
    $("#loginFormFace input").keyup(function (event) {
        if (event.keyCode === 13 || event.charCode === 13) {
            validateextraspace(true);
            var textboxes = $("#loginFormFace input"),
                currentBoxNumber = textboxes.index(this),
                nextBox;
            if (textboxes[currentBoxNumber + 1]) {
                nextBox = textboxes[currentBoxNumber + 1];
                $(nextBox).focus();
                $(nextBox).select();
                $(nextBox).val().trim();
                event.preventDefault();
                return false;
            } else {
                $("input").blur();
                $("#face_signin").click();
            }
        }
    });

    if (deviceOS === "android") {
        FingerprintAuth.isAvailable(fingerprintImageObj.androidSuccess, fingerprintImageObj.androidError);
    }
    if (deviceOS === "ios" && deviceVersion >= 8) {
        window.plugins.touchid.isAvailable(fingerprintImageObj.iosSuccess, fingerprintImageObj.iosError);
    }

    //fingerprint image click event
    $('.setting-modal').on('click' , function () {
        if (deviceOS === "android") {
            var touchIdAndroid = new TouchIdAndroidClass();
            FingerprintAuth.isAvailable(touchIdAndroid.androidTouchIDAvailableSuccess,
                touchIdAndroid.androidisTouchIDAvailableError);
        }
        if (deviceOS === "ios" && deviceVersion >= 8) {
            startLoading();
            var touchIdiOS = new TouchIdiOSClass();
            window.plugins.touchid.isAvailable(touchIdiOS.iOSTouchIDAvailableSuccess,
                touchIdiOS.iOSTouchIDAvailableError);
        }
    });

    if (timoutErrorStatus) {
        $("#invalid_user").html(appMsgs.timeoutError);
        timoutErrorStatus = false;
    }

    if (isApp){
        if (window.localStorage.getItem("LoginUserName")) {
            $('#login-username-field').val(window.localStorage.getItem("LoginUserName"));
        }
    }    
};

//open app in appstore
var openAppInStore = function () {
    try {
        //the user has opened the app in the appstore to update, so if there is a new version
        //the prompt will now show again
        window.localStorage.setItem("OptionalUpdatePrompt", "NotShown");

        if (deviceOS === "android") {
            window.location.href = 'market://details?id=com.atptour.playerzone';
        } else if (deviceOS === "ios") {
            window.location.href = 'itms-apps://itunes.apple.com/app/id1461247931';
        } else {
            window.location.href = 'https://www.atppz.com';
        }
     } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "openAppInStore method" + err);
    }
};

//exit the app (only allowed in Android)
var exitApp = function () {
    try {
        if (navigator.app) {
            navigator.app.exitApp();
        } else if (navigator.device) {
            navigator.device.exitApp();
        } else {
            window.close();
        }
     } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "closeApp method" + err);
    }
};

//close the reset popup
var closereset = function () {
    $('.login-logo-container').css('padding-top', '100px');
    $('.passwordvalidation-finger').hide();
    $('.usernamevalidation-finger').hide();
    $('.invalid_username-finger').hide();
    $("#username_validate").val("");
    $("#show-username-label").hide();
    $(".usernamevalidation-finger-invalid").hide();
    $(".usernamevalidation").hide();
    $(".passwordvalidation").hide();
    $(".invalid_username").hide();
};

//close the update prompt popup
var closeUpdatePrompt = function () {
    window.localStorage.setItem("OptionalUpdatePrompt", "Shown");
    closereset();
};

//validate fingerprint from login page
var validatefingerPrint = function () {
    $("#fingerprint_signin").css('background-color', '#ffffff');
    $("#fingerprint_signin").css('border', '2px solid #00adf9');
    $("#fingerprint_signin").css('border-radius', '4px');
    $("#fingerprint_signin").css('color', 'color: #00adf9;');

    var errorflag = false;
    if ($('#finger-username').val() === "") {
        $('.usernamevalidation-finger').show();
        $(".usernamevalidation-finger-invalid").hide();
        errorflag = true;
    }
    if (startsOrEndsWithWhitespace($('#finger-username').val())) {
        $('.usernamevalidation-finger').hide();
        $(".usernamevalidation-finger-invalid").show();
        errorflag = true;
    }
    if ($('#finger-password').val() === "") {
        $('.passwordvalidation-finger').show();
        errorflag = true;
    }
    if (errorflag === false) {
        var user = $('#finger-username').val(),
            password = $('#finger-password').val(),
            fingerdata = {};
        fingerdata.UserName = user;
        fingerdata.Password = password;
        try {
            authenticateUserFinger(fingerdata);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "validatefingerPrint method" + err);
        }
    }
    
    //authenticate fingerprint from login page
    function authenticateUserFinger(data) {
        try {
            if (getOnlineStatus()) {
                loginFingerPrintdata = data;
                loginMethod = "F";
                maintCheckLogin();
            } else {
                $("#invalid_user_fingerprint").html(appMsgs.noNetworkError);
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "authenticate_user_finger method" + err);
        }
    }
};

//validate faceid from login page
var validatefaceID = function() {
    $("#face_signin").css('background-color', '#ffffff');
    $("#face_signin").css('border', '2px solid #00adf9');
    $("#face_signin").css('border-radius', '4px');
    $("#face_signin").css('color', 'color: #00adf9;');

    var errorflag = false;
    if ($('#finger-username-face').val() === "") {
        $('.usernamevalidation-face').show();
        $(".usernamevalidation-face-invalid").hide();
        errorflag = true;
    }
    if (startsOrEndsWithWhitespace($('#finger-username-face').val())) {
        $('.usernamevalidation-face').hide();
        $(".usernamevalidation-face-invalid").show();
        errorflag = true;
    }
    if ($('#finger-password-face').val() === "") {
        $('.passwordvalidation-face').show();
        errorflag = true;
    }
    if (errorflag === false) {
        var user = $('#finger-username-face').val(),
            password = $('#finger-password-face').val(),
            fingerdata = {};
        fingerdata.UserName = user;
        fingerdata.Password = password;
        try {
            authenticateUserFace(fingerdata);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "validatefingerPrint method" + err);
        }
    }
    
    //authenticate fingerprint from login page
    function authenticateUserFace(data) {
        try {
            if (getOnlineStatus()) {
                loginFingerPrintdata = data;
                loginMethod = "F";
                maintCheckLogin();
            } else {
                $("#invalid_user_faceId").html(appMsgs.noNetworkError);
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "authenticate_user_finger method" + err);
        }
    }
}

//validate fingerprint from settings tab
var validatefingerPrintsecond = function () {
    $("#fingerprint_signin").css('background-color', '#ffffff');
    $("#fingerprint_signin").css('border', '2px solid #00adf9');
    $("#fingerprint_signin").css('border-radius', '4px');
    $("#fingerprint_signin").css('color', 'color: #00adf9;');

    var errorflag = false;
    if ($('#finger-username2').val() === "") {
        $('.usernamevalidation-finger').show();
        $(".usernamevalidation-finger-invalid").hide();
        errorflag = true;
    }
    if (startsOrEndsWithWhitespace($('#finger-username2').val())) {
        $('.usernamevalidation-finger').hide();
        $(".usernamevalidation-finger-invalid").show();
        errorflag = true;
    }
    if ($('#finger-password2').val() === "") {
        $('.passwordvalidation-finger').show();
        errorflag = true;
    }
    if (errorflag === false) {
        username = $('#finger-username2').val();
        var password = $('#finger-password2').val();
       
        loginFingerPrintdata.UserName = username;
        loginFingerPrintdata.Password = password;
        try {
            loginMethod = "FS";
            maintCheckLogin();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "authenticateUserFingerSettings call" + err);
        }
        
    }
    
    //authenticate user from setting menu tab
    function authenticateUserFingerSettings(data) {
        try {
            if (getOnlineStatus()) {
                var apiservicecallsObj = new apiservicecalls();
                var tokenUrl =  constants.ajaxTokenUrl;
                data = JSON.stringify(data);
                apiservicecallsObj.postData(tokenUrl, data, autheticateFingerOtherSuccess, autheticateFingerOtherError);
            } else {
                if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
                    $("#invalid_user_face").html(appMsgs.noNetworkError);
                } else {
                    $("#invalid_user_fingerprint").html(appMsgs.noNetworkError);
                }
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "authenticateUserFingerSettings method" + err);
        }
    }
    
    //authenticated user success
    function autheticateFingerOtherSuccess(tokenResponse) {
        try {
            tokenresponse = tokenResponse;
            if (applicationDataObj.getUsername().toLowerCase().trim() === username.toLowerCase().trim()) {
                authenticateTokenFromSettings(tokenresponse);
            } else {
                $("#sign-in-modal").modal('hide');
                $("#sign-in-modal-face").modal('hide');
                clickCloseNavBar();
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "autheticateFingerOtherSuccess method" + err);
        }
    }
    
    //authentcation error
    function autheticateFingerOtherError(jqXHR, error) {
        endLoading();
        try {
            var errorMessage = "Service unavailable";
            if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                errorMessage = appMsgs.timeoutError;
            } else {
                errorMessage = jqXHR.responseJSON.Message;
            }
            if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
                $("#invalid_user_face").html(errorMessage);
            } else {
                $("#invalid_user_fingerprint").html(errorMessage);
            }
            
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "autheticateFingerOtherError method" + err);
        }
    }
    
    //if token response from authentication settings menu tab
    function authenticateTokenFromSettings(tokenResponse) {
        try {
            var touchIdAndroid = new TouchIdAndroidClass();
            var touchIdiOS = new TouchIdiOSClass();
            if (tokenResponse) {
                applicationDataObj.setTokenResponse(tokenResponse);
                if (tokenResponse.Session) {
                    applicationDataObj.setSessionResponse(tokenResponse.Session);
                    applicationDataObj.setUserId(tokenResponse.Session.userId);
                }
                if (tokenResponse.Token) {
                    applicationDataObj.setToken(tokenResponse.Token.access_token);
                    applicationDataObj.setRefreshToken(tokenResponse.Token.refresh_token);
                    applicationDataObj.setRemainingTimeAfterWarning(tokenResponse.remainingTimeAfterWarning*60*1000);
                    applicationDataObj.setSessionExpiredMessage(tokenResponse.session_expired_message);
                    applicationDataObj.setSessionWarningMessage(tokenResponse.session_warning_message);
                    applicationDataObj.setExpires(tokenResponse.Token[".expires"]);
                    timeOutTimerValue = tokenResponse.Token.expires_in * 1000;
                    startTokenTimer();
                    if (device.platform.toLowerCase() === "android") {
                        FingerprintAuth.isAvailable(touchIdAndroid.isAvailableSuccessSettings,      touchIdAndroid.isAvailableErrorSettings);
                    }
                    if (device.platform.toLowerCase() === "ios") {
                        window.plugins.touchid.isAvailable(touchIdiOS.isAvailableSuccessSettings,
                            touchIdiOS.isAvailableErrorSettings);
                    }
                }
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "authenticateTokenFromSettings method" + err);
        }
    }
};

//validate faceid from settings tab
var validatefacePrintsecond = function () {
    $("#face_signin").css('background-color', '#ffffff');
    $("#face_signin").css('border', '2px solid #00adf9');
    $("#face_signin").css('border-radius', '4px');
    $("#face_signin").css('color', 'color: #00adf9;');

    var errorflag = false;
    if ($('#face-username2').val() === "") {
        $('.usernamevalidation-finger').show();
        $(".usernamevalidation-finger-invalid").hide();
        errorflag = true;
    }
    if (startsOrEndsWithWhitespace($('#face-username2').val())) {
        $('.usernamevalidation-finger').hide();
        $(".usernamevalidation-finger-invalid").show();
        errorflag = true;
    }
    if ($('#face-password2').val() === "") {
        $('.passwordvalidation-finger').show();
        errorflag = true;
    }
    if (errorflag === false) {
        username = $('#face-username2').val();
        var password = $('#face-password2').val();
       
        loginFingerPrintdata.UserName = username;
        loginFingerPrintdata.Password = password;
        try {
            loginMethod = "FS";
            maintCheckLogin();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "authenticateUserFingerSettings call" + err);
        }
        
    }
};

//validate login form
var validateLoginForm = function () {
    var noErrorexists = true;
    $('.login-logo-container').css('padding-top', '100px');
    $('.usernamevalidation').hide();
    $('.passwordvalidation').hide();
    $('.invalid_username').hide();
    $("#login").css('background-color', 'transparent');
    $("#login").css('border', '1px solid white');
    $("#login").css('border-radius', '4px');
    var usernameValue = document.getElementById("login-username-field").value;
    if (usernameValue === "") {
        $('.usernamevalidation').show();
        noErrorexists = false;
    }
    if (startsOrEndsWithWhitespace(usernameValue)) {
        $('.invalid_username').show();
        noErrorexists = false;
    }
    if ($('#login-password').val() === "") {
        $('.passwordvalidation').show();
        noErrorexists = false;
    }
    if (noErrorexists === true) {
        userlogin = $("#login-username-field").val();
        var pass = $("#login-password").val();
        var data = {};
        data.UserName = userlogin;
        data.Password = pass;
        try {
            authenticate_user(data);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "authenticate_user call" + err);
        }
    }
    
    //authenticate login form
    function authenticate_user(data) {
        try {
            $("#login").css('background-color', 'transparent');
            $("#login").css('border', '1px solid white');
            $("#login").css('border-radius', '4px');
            if (getOnlineStatus()) {
                $("#invalid_user").html("");
                startLoading();
                loginFingerPrintdata = data;
                loginMethod = "C";
                maintCheckLogin();
            } else {
                $("#invalid_user").html(appMsgs.noNetworkError);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "authenticate_user method" + err);
        }
    }
};

var startsOrEndsWithWhitespace = function (str) {
	return /^\s|\s$/.test(str);
};

var usernamevalidation = function () {
    $('.login-logo-container').css('padding-top', '100px');
    $("#invalid_user_fingerprint").html("");
    $("#invalid_user_faceId").html("");
    $("#invalid_user").html("");
    $('.usernamevalidation').hide();
    $('.usernamevalidation-finger').hide();
    $('.usernamevalidation-face').hide();
    $(".usernamevalidation-face-invalid").hide();
    $('.invalid_username').hide();
};

var passwordvalidation = function () {
    $('.login-logo-container').css('padding-top', '100px');
    $("#invalid_user_fingerprint").html("");
    $("#invalid_user_faceId").html("");
    $("#invalid_user").html("");
    $('.passwordvalidation').hide();
    $('.passwordvalidation-finger').hide();
    $('.passwordvalidation-face').hide();
};

//validate email form
var validateEmailForm = function () {
    var emailResultOBj = new emailResultClass();
    try {
        $("#show-username-label").hide();
        if ($('#username_validate').val() === "") {
            $("#show-username-label").show();
        } else {
            $('#resetModal').modal('hide');
            $("#show-username-label").hide();
            $('#reset-alert-modal').modal('show');
            var user_name = $('#username_validate').val();
            var data = {};
            data.Userid = "";
            data.ServiceProvider = "RegistrationServiceProvider";
            data.ServiceMethod = "ValidateForgotPassword";
            data.Language = "en";
            data.parametersArray = [{"username": user_name, "Subject":EmailSubject,"Body":EmailBody}];
            data.SessionData = {};
            var inputData = JSON.stringify(data),
                apiservicecallsObj = new apiservicecalls(),
                url = constants.ajaxUrl;
            apiservicecallsObj.postData(url, inputData, emailResultOBj.OnEmailSuccess, emailResultOBj.OnEmailError);
        }
     } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "validateEmailForm method" + err);
    }
};

//close the reset popup
var closereset = function () {
    $('.login-logo-container').css('padding-top', '100px');
    $('.passwordvalidation-finger').hide();
    $('.usernamevalidation-finger').hide();
    $('.invalid_username-finger').hide();
    $("#username_validate").val("");
    $("#show-username-label").hide();
    $(".usernamevalidation-finger-invalid").hide();
    $(".usernamevalidation").hide();
    $(".passwordvalidation").hide();
    $(".invalid_username").hide();
};

var emailResultClass = function () {

    //On Email success
    this.OnEmailSuccess = function (response) {
        endLoading();
        try {
            $("#username_validate").val("");
            if (response) {
                $('#email_validation').html('Success');
            } else {
                $('#email_validation').html('<h1 class="alert-heading">Username not found.</h1>' +
                    '<p class="para-modal">Please contact' + ' ' +
                    '<a href="mailto:asteinroeder@atpworldtour.com">asteinroeder@atpworldtour.com</a>' + ' ' +
                    'for assistance.</p>');
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "OnEmailSuccess" + err);
        }
    };

    //On Email error
    this.OnEmailError = function (jqXHR) {
        endLoading();
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : OnEmailError " + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnEmailError " + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnEmailError Unexpected Error";
            } else {
                errMsg = "Error : OnloginError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            logout();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "OnEmailError" + err);
        }
    };
};

//forget password Ajax service call
var clickForgotPassword = function () {
    try {
    	$(".usernamevalidation").hide();
        $(".passwordvalidation").hide();
        $(".invalid_username").hide();
        $('.login-logo-container').css('padding-top', '100px');
        $('#forget-password-link').css('text-decoration', 'none');
        $("#login-username-field").val("");
        $("#login-password").val("");
        $("#invalid_user").text("");
        if (getOnlineStatus()) {
            var data = {},
                apiservicecallsObj = new apiservicecalls();
            data.UserId = "";
            data.ServiceProvider = "RegistrationServiceProvider";
            data.ServiceMethod = "GetForgotPassword";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["120E7750-E5FF-4519-8AAA-17FEA73FF18E"];
            data.SessionData = {};
            data = JSON.stringify(data);
            apiservicecallsObj.postData(constants.ajaxUrl, data, OnLoginResetSuccess, OnLoginResetError);
            
            //OnReset success callback
            
        } else {
            $("#invalid_user").html(appMsgs.noNetworkError);
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "clickForgotPassword method" + err);
    }
};
var OnLoginResetSuccess = function (response) {
    endLoading();
    try {
        EmailBody = response.Body;
        EmailSubject = response.Subject;
        $("#reset-modal-para").empty();
        $("#Summary").empty();
        $("#reset-modal-title").empty();
        $("#send_mail").empty();
        $("#reset-modal-para").append(response.Description);
        $("#Summary").append(response.Summary);
        $("#reset-modal-title").append(response.Title);
        $("#send_mail").append(response.SendEmailButtonText);
        $('#resetModal').modal("show");
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "OnResetSuccess" + err);
    }
};

//OnReset error callback
var OnLoginResetError = function (jqXHR) {
    endLoading();
    try {
        $("#invalid_user").html(jqXHR.responseJSON.error);
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "OnResetError" + err);
    }
};

//validateextraspace function defined
var validateextraspace = function (fingerprint) {
    var noErrorexists = true;
    $('.login-logo-container').css('padding-top', '100px');
    $('.usernamevalidation').hide();
    $('.passwordvalidation').hide();
    $('.invalid_username').hide();
    $(".usernamevalidation-finger-invalid").hide();
    var usernameValue = document.getElementById("login-username-field").value;
    if (fingerprint) {
        usernameValue = document.getElementById("finger-username").value;
    }
    if (usernameValue) {
        if (startsOrEndsWithWhitespace(usernameValue)) {
            if (fingerprint) {
                $(".usernamevalidation-finger-invalid").show();
            } else {
                $('.invalid_username').show();
                $('.usernamevalidation').hide();
            }
            return false;
        }
    } else {
        if (fingerprint) {
            $(".usernamevalidation-finger-invalid").hide();
            $('.usernamevalidation-finger').show();
        } else {
            $('.invalid_username').hide();
            $('.usernamevalidation').show();
        }
    }
};

//validateextraspace function defined
var validateextraspaceface = function (fingerprint) {
    var noErrorexists = true;
    $('.login-logo-container').css('padding-top', '100px');
    $('.usernamevalidation').hide();
    $('.passwordvalidation').hide();
    $('.invalid_username').hide();
    $(".usernamevalidation-face-invalid").hide();
    var usernameValue = document.getElementById("login-username-field").value;
    if (fingerprint) {
        usernameValue = document.getElementById("finger-username-face").value;
    }
    if (usernameValue) {
        if (startsOrEndsWithWhitespace(usernameValue)) {
            if (fingerprint) {
                $(".usernamevalidation-face-invalid").show();
            } else {
                $('.invalid_username').show();
                $('.usernamevalidation').hide();
            }
            return false;
        }
    } else {
        if (fingerprint) {
            $(".usernamevalidation-face-invalid").hide();
            $('.usernamevalidation-face').show();
        } else {
            $('.invalid_username').hide();
            $('.usernamevalidation').show();
        }
    }
};

var validateextraspaceSettings = function (fingerprint) {
    var noErrorexists = true;
    $('.login-logo-container').css('padding-top', '100px');
    $('.usernamevalidation').hide();
    $('.passwordvalidation').hide();
    $('.invalid_username').hide();
    $(".usernamevalidation-finger-invalid").hide();
    if (fingerprint) {
        usernameValue = document.getElementById("finger-username2").value;
    }
    if (usernameValue) {
        if (startsOrEndsWithWhitespace(usernameValue)) {
            if (fingerprint) {
                $(".usernamevalidation-finger-invalid").show();
            } else {
                $('.invalid_username').show();
                $('.usernamevalidation').hide();
            }
            return false;
        }
    } else {
        if (fingerprint) {
            $(".usernamevalidation-finger-invalid").hide();
            $('.usernamevalidation-finger').show();
        } else {
            $('.invalid_username').hide();
            $('.usernamevalidation').show();
        }
    }
};

var fingerprintPluginSuccess = function(tokenResponse) {
    tokenResponseAPI = tokenResponse;
    loginMethod = "FSW";
    maintCheckLogin();    
};

var checkloginFromStartOfApp = function () {
    var loginServiceClass = new LoginServiceClass();
    applicationDataObj.setUsername(window.localStorage.getItem("Username").toLowerCase().trim());
    if (tokenResponseAPI) {
        applicationDataObj.setTokenResponse(tokenResponseAPI);
        if (tokenResponseAPI.Session) {
            applicationDataObj.setSessionResponse(tokenResponseAPI.Session);
            applicationDataObj.setUserId(tokenResponseAPI.Session.userId);
            if (tokenResponseAPI.Session.roles && tokenResponseAPI.Session.roles.length !== 0) {
                var userRole = applicationDataObj.getSessionResponse().roles[0];
                if (userRole.indexOf("Player") !== -1) {
                    applicationDataObj.setUserType("Player");
                } else {
                    applicationDataObj.setUserType("NonPlayer");
                }
            }
        }
        if (tokenResponseAPI.Token) {
            applicationDataObj.setToken(tokenResponseAPI.Token.access_token);
            applicationDataObj.setRefreshToken(tokenResponseAPI.Token.refresh_token);
            timeOutTimerValue = tokenResponseAPI.Token.expires_in * 1000;
            applicationDataObj.setRemainingTimeAfterWarning(tokenResponseAPI.remainingTimeAfterWarning*60*1000);
            applicationDataObj.setSessionExpiredMessage(tokenResponseAPI.session_expired_message);
            applicationDataObj.setSessionWarningMessage(tokenResponseAPI.session_warning_message);
            applicationDataObj.setExpires(tokenResponseAPI.Token[".expires"]);
            startTokenTimer();
            loginServiceClass.getLoginDetails();
        }
    }
};

var fingerprintPluginError = function(jqXHR) {
    endLoading();
    var errorMessage = "Service unavailable";
    if(jqXHR.statusText === "timeout" && jqXHR.status === 0){
        errorMessage = appMsgs.timeoutError;
    } else {
        errorMessage = jqXHR.responseJSON.Message;
    }
    window.location.href = "#/";
    $('#invalid_user').append(errorMessage);
    loggerObj.logToServer(constants.logSeverityError, "androidPluginError" + errorMessage);
};


