/**
Clas Name       : getLoginService
Description     : Token Services
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/


var LoginServiceClass = function () {
    var apiservicecallsObj = new Apiservicecalls();
    var tripwareObj = new TripwareClass();
    //get Login Details
    this.getLoginDetails = function () {
        try {
            var loginData =  {};
            loginData.Userid = applicationDataObj.getUserId();
            loginData.ServiceProvider = "RegistrationServiceProvider";
            loginData.ServiceMethod = "GetLoginDetails";
            loginData.Language = "en";
            loginData.parametersArray = ["120E7750-E5FF-4519-8AAA-17FEA73FF18E"];
            loginData.SessionData = {};
            loginData = JSON.stringify(loginData);
            apiservicecallsObj.postData(constants.ajaxUrl, loginData, this.OnLoginSuccess, this.OnLoginError);
        } catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error: getLoginDetails Method " + err);
		}
    };
    
 
    
    //Succes call of getLoginDetails
    this.OnLoginSuccess = function (loginResponse) {
        try {
            if(isApp) {
                window.localStorage.setItem("LoginUserName", applicationDataObj.getUsername());
            }
            applicationDataObj.setLoginResponse(loginResponse);
            tripwareObj.tripwareValidation();
            
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "OnLoginSuccess method" + err);
        }
    };
    
     //Error call of getLoginDetails
    this.OnLoginError = function (jqXHR) {
        endLoading();
        try {

            var errorMessage = "Service unavailable !!!";
            if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                errorMessage = appMsgs.timeoutError;
                $("#invalid_user").html(errorMessage);
            } else {
                $("#invalid_user").html(jqXHR.statusText);
            }
            $('.login-logo-container').css('padding-top', '40px');
            $("#login").css('background-color', 'transparent');
            $("#login").css('border', '1px solid white');
            $("#login").css('border-radius', '4px');
            loggerObj.logToServer(constants.logSeverityError, errorMessage);
            logout();

        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "OnLoginError method" + err);
        }
    };
};