var maintStatusCheckFlag = false;
var maintAlert; // Confirm Alert box for Maintenance message
var maintAlertFlag = false; //Flag to check Maintenance alert box, if True display & false if hidden
var getMaintenanceStatus = function () {
    try {
         maintStatusCheckFlag = false;
         if(window.localStorage.getItem("MaintenanceObj")) {
            var maintObj = window.localStorage.getItem("MaintenanceObj");
            var parseMaintObj = JSON.parse(maintObj);
            var timeDiffMaintTTL = moment.duration(moment(new Date()).diff(moment(parseMaintObj.creationTime)));
            // check if TTL is expired or not
            if(timeDiffMaintTTL.asMinutes() < parseMaintObj.maintTTL) {
                // if not expired
                maintenanceFlag = parseMaintObj.maintenanceResp.Status;
                maintenanceMessage = parseMaintObj.maintenanceResp.Message;
                maintStatusCheckFlag = true;
                return maintStatusCheckFlag;
            } else {
                //if TTL expired
                maintenanceCheck();
                return maintStatusCheckFlag;
            }
         } else {
            maintenanceCheck();
            return maintStatusCheckFlag;
         }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "getMaintenanceStatus method" + err);
    }
};

var maintenanceCheck = function () {
     try {
        $.ajax({
            type: "GET",
            url: constants.maintenanceURL,
            contentType: "application/json",
            processData: false,
            headers : { 
					"Content-Type": "application/json"
				},
            success: getMaintenanceSuccess,
            error: getMaintenanceError               
        }).done(function(){
           
      });
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "maintenanceCheck method" + err);
    }
};

var getMaintenanceSuccess = function (maintenanceResp) {
     try {
            console.log("maintenanceResp",maintenanceResp);
            maintenanceResp = JSON.parse(maintenanceResp);
            maintenanceFlag = maintenanceResp.Status;
            maintenanceMessage = maintenanceResp.Message;
            var maintenanceObj = {};
            maintenanceObj.maintenanceResp = maintenanceResp;
            maintenanceObj.maintTTL = 1;
            maintenanceObj.creationTime = new Date();
            window.localStorage.setItem("MaintenanceObj", JSON.stringify(maintenanceObj));
            maintStatusCheckFlag = true;
         } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getMaintenanceSuccess method" + err);
         }
};

var getMaintenanceError = function (jqXHR) {
    try {
        maintenanceFlag = false;
        if(window.localStorage.getItem("MaintenanceObj")) {
            window.localStorage.removeItem("MaintenanceObj");
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "getMaintenanceError method" + err + jqXHR.responseJSON.Message);
    } 
};

var maintCheckLogin = function () {
     try {
        $.ajax({
            type: "GET",
            url: constants.maintenanceURL,
            contentType: "application/json",
            processData: false,
            headers : { 
					"Content-Type": "application/json"
				},
            success: getMaintLoginSuccess,
            error: getMaintLoginError               
      });
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "maintenanceCheck method" + err);
    }
};

var getMaintLoginSuccess = function (maintenanceResp) {
     try {
            maintenanceFlag = maintenanceResp.Status;
            maintenanceMessage = maintenanceResp.Message;
            var maintenanceObj = {};
            maintenanceObj.maintenanceResp = maintenanceResp;
            maintenanceObj.maintTTL = 1;
            maintenanceObj.creationTime = new Date();
            window.localStorage.setItem("MaintenanceObj", JSON.stringify(maintenanceObj));
            maintStatusCheckFlag = true;
            if (maintenanceFlag) {
                endLoading();
                if (!maintAlertFlag) {
                    maintAlert = $.confirm({
                        title: 'Alert!',
                        content: '<div style="left: 62px !important;position: relative;">'+ maintenanceMessage+'</div>',
                        buttons: {
                            Ok : function () {
                                loggerObj.logToServer(constants.logSeverityError, "PlayerZone is Down for Maintenance");
                            }
                        },
                        onOpen: function () {
                            // after the modal is displayed.
                            maintAlertFlag = true;
                        },
                        onClose: function () {
                            // before the modal is hidden.
                            maintAlertFlag = false;
                        },
                    });
                }
            } else {
                var tokenServiceClass = new TokenServiceClass();
                if (loginMethod === "C") {
                    tokenServiceClass.createToken(loginFingerPrintdata); 
                } else if (loginMethod === "F") {
                    tokenServiceClass.createTokenfingerprint(loginFingerPrintdata);
                } else if (loginMethod === "FS") {
                    authenticateUserFingerSettings(loginFingerPrintdata);
                } else if (loginMethod === "FSW") {
                    checkloginFromStartOfApp();
                }
            }
         } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getMaintLoginSuccess method" + err);
         }
};

var getMaintLoginError = function (jqXHR) {
    try {
        maintenanceFlag = false;
        if(window.localStorage.getItem("MaintenanceObj")) {
            window.localStorage.removeItem("MaintenanceObj");
        }
        var tokenServiceClass = new TokenServiceClass();
        if (loginMethod === "C") {
            tokenServiceClass.createToken(loginFingerPrintdata); 
        } else if (loginMethod === "F") {
            tokenServiceClass.createTokenfingerprint(loginFingerPrintdata);
        } else if (loginMethod === "FS") {
            authenticateUserFingerSettings(loginFingerPrintdata);
        } else if (loginMethod === "FSW") {
            checkloginFromStartOfApp();
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "getMaintLoginError method" + err);
    } 
};