/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/* Medical Service class */

var MedicalServiceClass = function () {
 
    /** get Medical Service data **/
    this.getMedicalServiceData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getMedicalRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnMedicalServiceSuccess, this.OnMedicalServiceError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getMedicalServiceData " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getMedicalRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MedicalServicesProvider";
            data.ServiceMethod = "GetMedicalServices";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["44E226C8-CD87-4162-BABD-7644216A6C7C"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getMedicalRequestParameters " + err);
        }
    };
    
    /** binding Medical body data **/
    this.bindMedicalServices = function (data) {
        try {
            medicalSection = data.MedicalSectionHeading;
            $("#medicalservice1").append(medicalSection);
            medicalServiceTeam = data.MedicalTeam;
            medicalServicelen = medicalServiceTeam.length;
            if (medicalServicelen !== 0) {
                for (i = 0; i < medicalServicelen; i++) {
                    if (medicalServiceTeam[i].PhoneNumber !== "Not available") {
                               $("#Physiotherapists").append('<div class=""><div class="role-innercntnr3 commondivclass ">' +
                                             '<div class="pull-left contact-medical-plyrimg"><img src="  ' + medicalServiceTeam[i].HeadshotImage.Src + '" alt="player" id="medicalTeamImg' + i + '"></div>' +
                                             '<div class="mylndng-inrcntnr1-div1">' +
                                             '<div class="mylndng-inrcntnr1-cntnt1">' +
                                                 '<div class="col-xs-12 paddinglftryt0">' +
                                                    '<p class="roleplayername2 width100 pull-left margin-top-0">' + medicalServiceTeam[i].Name + '</p>' +
                                                     '<p class="contact_profile4 pull-left margin-top-0">' + medicalServiceTeam[i].Description + '</p>' +
                                                 '</div>' +
                                                 '<div class="clearfix"></div>' +
                                                 '<div class="col-xs-12 paddinglftryt0 margin-top-5">' +
                                                     '<span class="details"><a accesskey="D" class="med-detailstext contactDetails" href="#" data-toggle="modal" data-target="#container-div' + i + '">' +
                                                    medicalServiceTeam[i].Details + '</a></span>' +
                                                     '<span class="phonedetails"><a href="#" accesskey="C"><img src="images/phone.png" class="benefits-email contactcallDetails call-playerrelation margincall" alt="Call" onClick="medicalPhone(' + medicalServiceTeam[i].PhoneNumber + '); "/></a></span>' +
                                                     '<span><a href= "mailto:' + medicalServiceTeam[i].Email + '" accesskey="E"><img src="images/e-mail_no_fill.png" class="benefits-email contactemail margin-left-2 email-playerrelation margintop0" alt="Email"></a></span>' +
                                                 '</div>' +
                                             '</div>' +
                                         '</div>' +
                                         '</div>' +
                                     '</div>' +
                                     '<div class="clearfix"></div>');
                    } else {
                         $("#Physiotherapists").append('<div class=""><div class="role-innercntnr3 commondivclass ">' +
                                             '<div class="pull-left contact-medical-plyrimg"><img src="  ' + medicalServiceTeam[i].HeadshotImage.Src + '" alt="player" id="medicalTeamImg' + i + '"></div>' +
                                             '<div class="mylndng-inrcntnr1-div1">' +
                                             '<div class="mylndng-inrcntnr1-cntnt1">' +
                                                 '<div class="col-xs-12 paddinglftryt0">' +
                                                    '<p class="roleplayername2 width100 pull-left margin-top-0">' + medicalServiceTeam[i].Name + '</p>' +
                                                     '<p class="contact_profile4 pull-left margin-top-0">' + medicalServiceTeam[i].Description + '</p>' +
                                                 '</div>' +
                                                 '<div class="clearfix"></div>' +
                                                 '<div class="col-xs-12 paddinglftryt0 margin-top-5">' +
                                                     '<span class="details"><a accesskey="D" class="med-detailstext contactDetails" href="#" data-toggle="modal" data-target="#container-div' + i + '">' +
                                                    medicalServiceTeam[i].Details + '</a></span>' +
                                                     '<span><a class ="margin-left-18" href= "mailto:' + medicalServiceTeam[i].Email + '" accesskey="E"><img src="images/e-mail_no_fill.png" class="benefits-email contactemail margin-left-2 email-playerrelation margintop0" alt="Email"></a></span>' +
                                                 '</div>' +
                                             '</div>' +
                                         '</div>' +
                                         '</div>' +
                                     '</div>' +
                                     '<div class="clearfix"></div>');
                    }
             
                    if (medicalServiceTeam[i].HeadshotImage.Src === null) {
                        $("#medicalTeamImg" + i).attr("src", "images/Photo_Grey.png");
                    }
                    
                 
                    $(".appendModal").append('<div id="container-div' + i + '" class="modal fade modal-height" role="dialog">' +
                                                 '<div id="myModalEdit' + i + '">' +
                                                '<div class="modal-dialog modal-dailog-width">' +
                                                         '<div class="modal-content myprofile-modal-container">' +
                                                             '<div class=""><figure><img src="images/close_black.svg" alt="cross" class="mplndg-popup-close" data-dismiss="modal"/></figure></div>'+
                                                             '<p class="roleplayername3" id="medicalTeamName' + i + '"></p>' +
                                                            '<p class="contact_profile-5" id="medicalTeamDesc' + i + '"></p>' +
                                                            '<div class="clearfix"></div>' +
                                                        '</div>' +
                                                    '</div>' +
                                                '</div>' +
                                            '</div>');
                    $("#medicalTeamName" + i).append(medicalServiceTeam[i].Name);
                    $("#medicalTeamDesc" + i).append(medicalServiceTeam[i].Description);

                }

            }
            this.getOtherMedicalDetails();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindMedicalServices " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnMedicalServiceSuccess = function (data) {
        try {
            var medicalClassObj = new MedicalServiceClass();
            medicalClassObj.bindMedicalServices(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnMedicalServiceSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnMedicalServiceError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnMedicalServiceError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnMedicalServiceError " + err);
        }
    };
    
    /** get Other Medical Details data **/
    this.getOtherMedicalDetails = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getOtherMedicalRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnOtherMedicalServiceSuccess, this.OnOtherMedicalServiceError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getOtherMedicalDetails " + err);
        }
    }; 
    
    /** Creating request Parameters **/
    this.getOtherMedicalRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MedicalServicesProvider";
            data.ServiceMethod = "GetMedicalServices";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["EE5C4B73-E03C-412F-BDD6-6BD5D0ACF30D"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId; 
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();	
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getOtherMedicalRequestParameters " + err);
        }
    };
    
    /** binding Other Medical Details body data **/
    this.bindOtherMedicalServices = function (data) {
        try {
            $("#mission").append(data.BodyText.replace(/\\/g, ""));
            $("#vid5").attr("poster","");
            $("#vid5").attr("playsinline","");
            $("#newsflash-content").find('.panel').addClass("panel-default margin-top-0");
            var myVideo = videojs(vid5, { controls: true });
            $('style.vjs-styles-dimensions').remove();
            $('style.vjs-styles-defaults').remove();
            $("#MyApp").append("<style class='vjs-styles-defaults'>.video-js {width: 100%;height: 150px;}.vjs-fluid {  padding-top: 56.25%}</style>");     
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindOtherMedicalServices " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnOtherMedicalServiceSuccess = function (data) {
        try {
            var othermedicalClassObj = new MedicalServiceClass();
            othermedicalClassObj.bindOtherMedicalServices(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnOtherMedicalServiceSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnOtherMedicalServiceError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnOtherMedicalServiceError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnOtherMedicalServiceError " + err);
        }
    };
};

/* Medical Services */

var medicalServices = function () {
    try {
        if(isApp){
            window.ga.trackView('Contact Medical Services');
        }
        var medicalServiceObj = new MedicalServiceClass();
        startLoading();
        headerMain();
        subHeaderContactHide();
        subHeader();
        subHeaderEllipsis();
        medicalServiceObj.getMedicalServiceData();
    }
    catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : medicalServices " + err);
    }
};

/*Phone Number Display*/

var medicalPhone = function (phoneNum) {
    window.location.href="tel:"+phoneNum;
}; 










