/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP.
 */

/*jslint browser: true*/
/*global sample_data,$, jQuery,constants,applicationDataObj,loggerObj,endLoading,logout,apiservicecalls,AccountDataClass*/

/**
 * Ready function to get the url
 */
var getmWebUrl = function (mobileWebUrl) {
    startLoading();
    setTimeout(function () {
        headerMain();
        if (mobileWebUrl) {
            var loadMwebFunctionClassOj = new LoadMwebFunctionClass();
            loadMwebFunctionClassOj.loadMwebUrl(mobileWebUrl);
        }
    }, 300);
};
/**
 * To load pages from website
 */
var loadUrlFromWebsite = function (parameters) {
    var loadMwebFunctionClassOj = new LoadMwebFunctionClass();
    loadMwebFunctionClassOj.loadOtherMwebUrls(parameters);
};
var loadManageEntryUrl = function (parameters) {
    var url,
        queryString = "",
        decodedUrl;
    if (parameters.urlToLoad) {
        decodedUrl = atob(parameters.urlToLoad);
        url = decodedUrl;
    }
    if (url) {
        setTimeout(function () {
            headerMain();
            var loadMwebFunctionClassOj = new LoadMwebFunctionClass();
            loadMwebFunctionClassOj.loadManageEntryUrl(url);
        }, 500);
    }
};
/**
 * Class for the mweb page load functions
 */
var LoadMwebFunctionClass = function () {
    this.loadManageEntryUrl = function (manageEntryUrl) {
        try {
            $("#mWebIframe").attr("src", "");
            setTimeout(function () {
                var deviceWidth = $(window).width(),
                    deviceheight = $(window).height() - 30,
                    isIframeLoaded;
                $('#mWebIframe').attr('src', manageEntryUrl);
                $('#mWebIframe').load(function (event) {
                    isIframeLoaded = window.setInterval(function () {
                        if (document.getElementById('mWebIframe')) {
                            var iframe_state = document.getElementById('mWebIframe').contentDocument.readyState;
                            if (iframe_state === "complete") {
                                //window.clearInterval(isIframeLoaded);
                                $("#mWebIframe").removeClass("hidden");
                                $("#mWebIframeHolder").removeClass("hidden");
                                $("#mWebIframeHolder").addClass("ios-scroll");
                                $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                $("#mWebIframe").contents().find("body").css("-webkit-overflow-scrolling", "touch");
                                if (cordova.platformId === 'android') {
                                    $("#mWebIframe").contents().find("html").css("width", "100%");
                                    $("#mWebIframe").contents().find("html").css("height", "100%");
                                    $("#mWebIframe").contents().find("html").css("overflow", "auto");
                                    $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                }
                             
                                if (cordova.platformId === 'ios') {
                                    $("#mWebIframe").contents().find("html").css("width","100%");
                                    $("#mWebIframe").contents().find("html").css("height","100%");
                                    $("#mWebIframe").contents().find("html").css("overflow-y","scroll");
                                    $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling","touch");
                                    $("#mWebIframe").contents().find('.entry-fltngbtn').css("position", "relative");
                                    $("#mWebIframe").contents().find('.entry-instruction-div').css("margin-bottom", "0px");
                                    $("#mWebIframe").contents().find("div#receiptconfirm").addClass("hybridappmargin");
                                    $("#mWebIframe").contents().find("div#doublereceipt").addClass("hybridappmargin");
                                    $("#mWebIframe").contents().find("div#rankingbreakdown").addClass("hybridappmargin");
                                    if ($(window).width() >= 414) {
                                        $("#mWebIframe").contents().find("div.entryreceipt-subheader").css("cssText", "margin-top: 10px !important;");
                                    }
                                     /*if ($("#mWebIframe").contents().find('.trnmnt-home-cntnr').text().length > 0) {
                                        $("#mWebIframe").contents().find("html").css("width", "100%");
                                        $("#mWebIframe").contents().find("html").css("height", "100%");
                                        $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                    } else {
                                        if (mwebUrl.includes("Entries")) {
                                            $("#mWebIframe").contents().find("html").css("cssText", "width:" + deviceWidth + "px !important; height:" + deviceheight + "px !important;");
                                            $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                        } else {
                                            $(".demo-iframe-holder").css("bottom", "0px");
                                            $("#mWebIframe").contents().find("html").css("cssText", "width:" + deviceWidth + "px !important; height:" + deviceheight + "px !important;");
                                            $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                        }
                                    }*/
                                }
                                setTimeout(function () {
                                    endLoading();
                                }, 1000);
                            }
                        }
                    }, 100);
                });
            }, 500);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : LoadMwebFunctionClass " + err);
        }
    };
    
    
    /**
     * To Load the mweb pages in iFrame
     */
    this.loadMwebUrl = function (mwebUrl) {
        try {
            $("#mWebIframe").attr("src", "");
            startLoading();
            nextMwebUrl = mwebUrl;
            var iframeError = setTimeout(function () {
                $('#tryAgain').show();
                $('#mWebIframeHolder').hide();
                endLoading();
            }, 60000);
            var deviceWidth = $(window).width(),
                deviceheight = $(window).height() - 30,
                isIframeLoaded;
            //$("#mWebIframe").css("cssText", "width:" + deviceWidth + "px !important; height:" + deviceheight + "px !important;");
            setTimeout(function () {
                var userId = applicationDataObj.getUserId(),
                    token = applicationDataObj.getToken(),
                    refTok = applicationDataObj.getRefreshToken(),
                    appExpires = applicationDataObj.getExpires();
                $.ajax({
                    url: constants.hybridAppLogin,
                    data: { "userId": userId,  "token": token, "refreshToken": refTok, "expires": appExpires },
                    xhrFields: {
                        withCredentials: true
                    },
                    crossDomain: true,
                    type: "POST",
                    async: true,
                    timeout: 60000,
                    success: function (respdata) {
                       //$('.navbar-inverse').css("position","absolute");
                        $('#mWebIframe').attr('src', mwebUrl);
                        $('#mWebIframe').load(function (event) {
                            startLoading();
                            $("#mWebIframeHolder").addClass("ios-scroll");
                            $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                            $("#mWebIframe").contents().find("body").css("-webkit-overflow-scrolling", "touch");
                            if (cordova.platformId === 'android') {
                                $("#mWebIframe").contents().find("html").css("width", "100%");
                                $("#mWebIframe").contents().find("html").css("height", "100%");
                                $("#mWebIframe").contents().find("html").css("overflow", "auto");
                            }
                            if (cordova.platformId === 'ios') {
                                if ($("#mWebIframe").contents().find('.trnmnt-home-cntnr').text().length > 0) {
                                    $("#mWebIframe").contents().find("html").css("width", "100%");
                                    $("#mWebIframe").contents().find("html").css("height", "100%");
                                    $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                  
                                } else {
                                    if (mwebUrl.includes("Entries")) {
                                        $("#mWebIframe").contents().find("html").css("cssText", "width:" + deviceWidth + "px !important; height:" + deviceheight + "px !important;");
                                        $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                        $("#mWebIframe").contents().find("html").css("overflow-y", "scroll");
                                    } else {
                                        $("#mWebIframe").contents().find("html").css("overflow-y", "scroll");
                                        $("#mWebIframe").contents().find("html").css("cssText", "width:" + deviceWidth + "px !important; height:" + deviceheight + "px !important;");
                                        $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                    }
                                        
                                }
                                $("#mWebIframe").contents().find("div#receiptconfirm").addClass("hybridappmargin");
                                $("#mWebIframe").contents().find("div#doublereceipt").addClass("hybridappmargin");
                                $("#mWebIframe").contents().find("div#rankingbreakdown").addClass("hybridappmargin");
                                if ($(window).width() >= 414) {
                                    $("#mWebIframe").contents().find("div.entryreceipt-subheader").css("cssText", "margin-top: 10px !important;");
                                }
                            }
                            clearTimeout(iframeError);
                            isIframeLoaded = window.setInterval(function () {
                                if (document.getElementById('mWebIframe')) {
                                    var iframe_state = document.getElementById('mWebIframe').contentDocument.readyState;
                                    if (iframe_state === "complete") {
                                        $("#mWebIframe").contents().find('.entry-fltngbtn').css("position", "relative");
                                        $("#mWebIframe").contents().find('.entry-instruction-div').css("margin-bottom", "0px");
                                        var pdf_obj = $('#mWebIframe').contents();
                                        //$("#mWebIframe").contents().find("html").css("cssText", "width:" + deviceWidth + "px !important; height:" + deviceheight + "px !important;");
                                        $("#mWebIframe").removeClass("hidden");
                                        $("#mWebIframeHolder").removeClass("hidden");
                                    }
                                }
                            }, 100);
                            
                            $("#mWebIframe").contents().find('.dblwdrwl-trnmnt-plyrname').click(function () {
                                $("#mWebIframeHolder").removeClass("ios-scroll");
                                $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "");
                                $("#mWebIframe").contents().find("body").css("-webkit-overflow-scrolling", "");
                            });
                            
                            $("#mWebIframe").contents().find('.input-autogen-partner').click(function (e) {
                                this.selectionStart = this.selectionEnd = this.value.length;
                            });

                            $("#mWebIframe").contents().find('.ui-menu-item').click(function (e) {
                                $("#mWebIframe").contents().find('.entry-dropdown-li').hide();
                                $("#mWebIframe").contents().find('.input-autogen-partner').blur();
                            });
                            endLoading();
                        });
                    },
                    error: function (jqXHR,  exception) {
                        endLoading();
                        if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                            errMsg = "Error : loadMwebUrl "  + jqXHR.statusText;
                        } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                            timoutErrorStatus = true;
                            errMsg = "Error : loadMwebUrl "  + jqXHR.statusText;
                        } else if (jqXHR.status === 0) {
                            timoutErrorStatus = true;
                            errMsg = "Error : loadMwebUrl Unexpected Error with status Code 0";
                        } else {
                            timoutErrorStatus = true;
                            errMsg = "Error : loadMwebUrl Unexpected Error";
                        }
                        loggerObj.logToServer(constants.logSeverityError, errMsg);
                        logout();
                    }
                });
            }, 500);
           
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : loadMwebUrl " + err);
        }
        
        
    };
    
    
    /**
     * Set End loading
     */
    this.setEndLoading = function (deviceWidth, deviceheight) {
        var isIframeLoaded,
            iframe_state;
        $('#mWebIframe').load(function (event) {
            isIframeLoaded = window.setInterval(function () {
                if (document.getElementById('mWebIframe')) {
                    iframe_state = document.getElementById('mWebIframe').contentDocument.readyState;
                    if (iframe_state === "complete") {
                        window.clearInterval(isIframeLoaded);
                        $("#mWebIframe").removeClass("hidden");
                        $("#mWebIframeHolder").removeClass("hidden");
                        $("#mWebIframeHolder").addClass("ios-scroll");
                        $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                        $("#mWebIframe").contents().find("body").css("-webkit-overflow-scrolling", "touch");
                        if (cordova.platformId === 'android') {
                            $("#mWebIframe").contents().find("html").css("width", "100%");
                            $("#mWebIframe").contents().find("html").css("height", "100%");
                            $("#mWebIframe").contents().find("html").css("overflow", "auto");
                            $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                        }
                        if (cordova.platformId === 'ios') {
                            if ($("#mWebIframe").contents().find('.trnmnt-home-cntnr').text().length > 0) {
                                $("#mWebIframe").contents().find("html").css("width", "100%");
                                $("#mWebIframe").contents().find("html").css("height", "100%");
                                $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                            } else {
                                if (mwebUrl.includes("Entries")) {
                                    $("#mWebIframe").contents().find("html").css("cssText", "width:" + deviceWidth + "px !important; height:" + deviceheight + "px !important;");
                                    $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                } else {
                                    $(".demo-iframe-holder").css("bottom", "0px");
                                    $("#mWebIframe").contents().find("html").css("cssText", "width:" + deviceWidth + "px !important; height:" + deviceheight + "px !important;");
                                    $("#mWebIframe").contents().find("html").css("-webkit-overflow-scrolling", "touch");
                                }
                            }
                            $("#mWebIframe").contents().find("div#receiptconfirm").addClass("hybridappmargin");
                            $("#mWebIframe").contents().find("div#doublereceipt").addClass("hybridappmargin");
                            $("#mWebIframe").contents().find("div#rankingbreakdown").addClass("hybridappmargin");
                            if ($(window).width() >= 414) {
                                $("#mWebIframe").contents().find("div.entryreceipt-subheader").css("cssText", "margin-top: 10px !important;");
                            }
                        }
                        setTimeout(function () {
                            endLoading();
                        }, 1000);
                    }
                }
            }, 100);
        });
    };
    /**
     * Load the other urls - that comes with server response
     * eg : tournament home
     */
    this.loadOtherMwebUrls = function (parameters) {
        try {
            $("#MyApp").removeClass("overflow-important");
            var url,
                queryString = "",
                decodedUrl;
            if (parameters.urlToLoad) {
                decodedUrl = atob(parameters.urlToLoad);
                url = decodedUrl;
            }
            if (url) {
                if (url.indexOf("HybridApp=1") === -1) {
                    if (!(url.indexOf("?") >= 0 || url.indexOf("#") >= 0)) {
                        url = url  +  "?HybridApp=1";
                    } else {
                        url = url  +  "&HybridApp=1";
                    }
                }
                //HybridApp=1
                this.loadMwebUrl(url);
                setTimeout(function () {
                    headerMain();
                }, 1000);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : loadUrlFromWebsite " + err);
        }
        
    };
    
    
};
/**
 * Post Message Changes
 */
window.onmessage = function (e) {
    if (e.data.action === "url") {
        if (typeof e.data.manageEntry  !== "undefined") {
            if (e.data.manageEntry === "close") {
                window.location.href = "#/MyLanding";
                $("#MyApp").removeAttr("style");
            }
        }
        if (typeof e.data.pdfUrl  !== "undefined") {
            var pdfUrl = e.data.pdfUrl;
            if (pdfUrl) {
                window.open(pdfUrl, "_system");
            }
        }
    } else if (e.data.action === "header") {
        if (e.data.value === false) {
            $('.headercontent').hide();
            $('#mWebIframeHolder').removeClass('iframe-margin');
        } else if (e.data.value === true) {
            $('.headercontent').show();
            $('#mWebIframeHolder').addClass('iframe-margin');
        }
    } else if (e.data.action === "timeout") {
        if (typeof e.data.url !== "undefined") {
            nextMwebUrl = e.data.url;
        }
        $('#tryAgain').show();
        $('#mWebIframeHolder').hide();
    } else if (e.data.action === "ShowSpinner") {
        if (typeof e.data.spinner !== "undefined") {
            if (e.data.spinner) {
                startLoading();
            }
        }
    }
};

var networkError = function () {
    $('#tryAgain').show();
    $('#mWebIframeHolder').hide();
    endLoading();
};

/**
 * Try again method in case of no network/timeout
 */
var tryagain = function () {
    $("#tryAgain").css('background-color', 'transparent');
    $("#tryAgain").css('border', '1px solid white');
    $("#tryAgain").css('border-radius', '4px');
    if (getOnlineStatus()) {
        $('#tryAgain').hide();
        $('#mWebIframeHolder').show();
        var loadMwebFunctionClassOj = new LoadMwebFunctionClass();
        loadMwebFunctionClassOj.loadMwebUrl(nextMwebUrl);
    }
};