/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP.
 */

/*Player weekly class*/
var PlayersWeeklyClass = function () {
    /** playersWeekly **/
    this.playersWeekly = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = this.getNewsPlayerParameters(sessionData);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnNewsSuccess, this.OnNewsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : playersWeekly " + err);
        }
    };
    /** Ajax Success call **/
    this.OnNewsSuccess = function (data) {
        try {
            if (data) {
                var playersWeeklyClassObj = new PlayersWeeklyClass();
                playersWeeklyClassObj.bindNewsPlayer(data);
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNewsSuccess " + err);
        }
    };
    /**Ajax error call **/
    this.OnNewsError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNewsError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNewsError " + err);
        }
    };
    /** creating Request Parameters**/
    this.getNewsPlayerParameters = function (sessionData) {
        try {
            var data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "NewsServiceProvider";
            data.ServiceMethod = "GetPlayersWeekly";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["e787374b-08de-43e5-80cc-727aa6f30f79"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getNewsPlayerParameters " + err);
        }
    };
    /** binding data **/
    this.bindNewsPlayer = function (data) {
        try {
            var embedURL, newslength, i, strdate1;
            embedURL = data.AppBoxURL.Url;
            newslength = data.PlayersWeekly.length;
            $(".news-plyrwkly-tdaysstory").append('<img src="' + embedURL + '" alt="News-today">');
            for (i = 0; i < newslength; i = i + 1) {null
                if (data.PlayersWeekly[i].EditionDate !== null) {
                    strdate1 = moment(data.PlayersWeekly[i].EditionDate).format("MMMM DD, YYYY");
                }
                if(data.PlayersWeekly[i].PDFLink !== null) {
                    $(".backgroundcolor").append('<tr><th><a data-url = "' + data.PlayersWeekly[i].PDFLink.Url + '" onclick = "showPdf(this);" class="plyrwkly-pdflinktext" id="news' + i + '"><span><img class="news-plyrwkly-pdfimg" src="images/pdf-news.png" alt="pdf-image"></span><span class="plyrwkly-pdflinktext">' + strdate1 + '</span></a></th></tr>');
                }   
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindNewsPlayer " + err);
        }
    };
};
/**
 * Ready Function
 */
var playersWeeklyReady = function () {
    try {
        if (cordova.platformId === 'ios') {
            $('#newscontainer').addClass('news-container');
        }
        if (cordova.platformId === 'android') {
             $('#newscontainer').addClass('news-container-android');
        }
        if(isApp){
            window.ga.trackView('News Players Weekly');
        }
        var playersWeeklyClassObj = new PlayersWeeklyClass();
        startLoading();
        setTimeout(function () {
            headerMain();
            subHeaderCarousel();
            playersWeeklyClassObj.playersWeekly();
        }, 500);
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : playersWeeklyReady " + err);
    }
};

