/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,   reproduced,   modified,   distributed,  
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/**
 * News Article Class
 */
var NewsArticleClass =  function () {
	var newsId,
	    newsText;
	this.getHomeNewsData = function (params) {
		try {
			var apiservicecallsObj = new apiservicecalls();
			var url = constants.ajaxUrl;
			var inputData = this.getHomeNewsRequestParameters();
			newsId = params.newsId;
			newsText = params.newsText;
			apiservicecallsObj.postData(url,  inputData,  this.homeNewsSuccess,  this.homeNewsError);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError,  "Error : getHomeNewsData " +  err);
		}
	};
	/**
	 * getHomeNewsRequestParameters
	 */
	this.getHomeNewsRequestParameters = function () {
		try {
			var sessionData = applicationDataObj.getSessionResponse();
			var data = {},
                userSession = {},
                inputData;
			data.Userid = sessionData.userId;
			data.ServiceProvider = "HomeServiceProvider";
			data.ServiceMethod = "GetHeadlines";
			data.Language = constants.englishLanguage;
			data.parametersArray =  ["28A85A5A-BDA6-4709-8F0B-6AB4C320699D"];
			userSession.PlayerId = sessionData.playerId;
			userSession.Userid = sessionData.userId;
			userSession.FirstName = sessionData.firstName;
			userSession.LastName = sessionData.lastName;
			userSession.UserName = applicationDataObj.getUsername();
			userSession.Roles = sessionData.roles;
			userSession.TOKEN  = applicationDataObj.getToken();
			data.SessionData = userSession;
			inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError,  "Error : getHomeNewsRequestParameters " +  err);
		}
	};
	/**
	 * homeNewsSuccess
	 */
	this.homeNewsSuccess = function (response) {
		try {
			var latestNewsLinks = "";
			if (response && response.HeadlinesHeading) {
				$(".newsarticle-heading").text(response.HeadlinesHeading);
			}
			if (response && response.HeadlinesHeading) {
				//$(".newsarticle-date").text("I")
			}
			var id = response.Id;
			if (response && response.childItems && response.childItems.length !== 0) {
				$("#latestNews").empty();
				var lowerConvertedNewsId = newsId.toLowerCase();
				$.each(response.childItems,   function (index,   value) {
					latestNewsLinks += '<div class="newsarticle-all-headlines"><a class="newsArticleanchor" data-Id = "' + value.Id + '" data-title = "' + value.Title + '">' + value.Title + '</a></div>';
					var childArticleId = value.Id;
					if (childArticleId) {
						childArticleId = childArticleId.toLowerCase();
					}
					if (lowerConvertedNewsId === childArticleId) {
						$(".newsarticle-main-content").empty();
						$(".newsarticle-heading").text(value.Title);
						var date = $.datepicker.formatDate('M dd, yy', new Date(value.Date));
						$(".newsarticle-date").text(date);
						$(".newsarticle-main-content").append(value.Body);
						$(".newsarticle-main-content").removeClass("hide");
					}
				});
				$("#latestNews").append(latestNewsLinks);
				clickNewsLinks();
				endLoading();
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError,  "Error : homeNewsSuccess " +  err);
		}
	};
	/**
	 * homeNewsError
	 */
	this.homeNewsError = function (jqXHR, error) {
		endLoading();
		if(jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
			errMsg = "Error : homeNewsError " + jqXHR.statusText;
		} else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
			timoutErrorStatus = true;
			errMsg = "Error : homeNewsError " +jqXHR.statusText;
		} else if (jqXHR.status === 0) {
			timoutErrorStatus = true;
			errMsg = "Error : homeNewsError Unexpected Error with status Code 0";
		} else {
			timoutErrorStatus = true;
			errMsg = "Error : loadMwebUrl Unexpected Error";
		}
		loggerObj.logToServer(constants.logSeverityError, errMsg);
		logout();
	};
};
var clickNewsLinks = function () {
	try {
		$(".newsarticle-all-headlines").click(function () {
			var newsId = $(this).find("a").attr("data-id"),
			    newsText = $(this).find("a").attr("data-title"),
			    params = {},
			    newsClass = new NewsArticleClass();;
			if(newsId){
				params.newsId = newsId;
				params.newsText = newsText;
				newsClass.getHomeNewsData(params);
			}
		});
	} catch (err) {
		
	}
};
/**
 * newsArticleMain - Ready Function
 */
var newsArticleMain  = function (params) {
    if(isApp){
        window.ga.trackView('News Articles');
    }
	var newsClass = new NewsArticleClass();
	startLoading();
	setTimeout(function () {
		headerMain();
		newsClass.getHomeNewsData(params);
	}, 500);

};