/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/*News flash class*/
var NewsFlashClass = function () {
    /** news flash**/
    var active = true;
    this.newsFlash = function () {
        try {
            $(".news-archive-artclcntnr").slice(0, 3).show();
            $(".news-archive-loadmore").on('click', function (e) {
                e.preventDefault();
                $(".news-archive-artclcntnr:hidden").slice(0, 6).slideDown();
            });
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getNewsflashParameters();
            $('.panel-group').on('hide.bs.collapse', toggleIconNewsFlash);
            $('.panel-group').on('show.bs.collapse', toggleIconNewsFlash);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnNews2Success, this.OnNews2Error);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : newsFlash " + err);
        }
    };
    /**
	 * Ajax success call
	 */
    this.OnNews2Success = function (data) {
        try {
            if (data) {
                var newsFlashClassObj = new NewsFlashClass();
                newsFlashClassObj.bindNewsflash(data);
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNews2Success " + err);
        }
    };
    /**
	 * Ajax failure call
	 */
    this.OnNews2Error = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNews2Error " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNews2Error " + err);
        }
    };
    /** creating Request Parameters**/
    this.getNewsflashParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "NewsServiceProvider";
            data.ServiceMethod = "GetNewsFlash";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["5219244D-691E-4139-9673-D96AA66F7185", "8012CD50-EBC9-4153-B198-EA618E5E83D6"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getNewsflashParameters" + err);
        }
    };
    /** binding flash news body **/
    this.bindNewsflash = function (data) {
        try {
            
            function padDateTime(dt) {
                return dt < 10 ? "0"+dt : dt;
            }
            var t1 = data.newsFlashArticles;
            var t2 =[];
            var t3 =[];
            t1.forEach( function (arrayItem)
            {
               t2.push(arrayItem);
            });
            
            t2.forEach( function (arrayItem)
            {
                var x = arrayItem.PublishDate;
                var dateParsed = new Date(x);
                var dd = padDateTime(dateParsed.getDate());
                var mm = padDateTime(dateParsed.getMonth()+1);
                var yyyy = dateParsed.getFullYear();
                var hrs = padDateTime(dateParsed.getHours());
                var mins = padDateTime(dateParsed.getMinutes());
                var myDateTimeString = dd+"/"+mm+"/"+yyyy;
                arrayItem.PublishDate = myDateTimeString;
                t3.push(arrayItem);
            });
            
            function padDateTime(dt) {
                return dt < 10 ? "0"+dt : dt;
            }
          
            var sorted  = t3.sort( function(a,b){
                return b.PublishDate.split('/').reverse().join('') - a.PublishDate.split('/').reverse().join('');
            });
            var flash, defaultNum, i;
            flash = data.newsFlashArticles;
            defaultNum = data.newsFlashArticles.length;
            var subsortedlength = sorted.length-3;
            for (i = 0; i < subsortedlength; i = i + 1) {
                $("#newsflash-accordcontent").append('<div class="panel" id="flashContent' + i + '"><div class="newsflash-accordion">' +
                '<a data-toggle="collapse" accesskey="L1" role="button" href="#" data-target="#collapsenewsflash' + i + '"' +
                'aria-expanded="true" aria-controls="collapsenewsflash' + i + '"class="collapsed newsflash-accrdian-title" ' +
                'id="accrdn' + i + '">' + sorted[i].Title + '<span class="pull-right news-flash-plus"></span></a></div><div id="collapsenewsflash' + i + '"' +
                'class="newsflashpanel-collapse collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body  bg-colorgrey">' +
                '<div class="newsflas-panelbody-content" id="paracoll' + i + '">' + sorted[i].Body + '</div></div></div></div>');
                
                if (sorted[i].Body === "") {
                    $("#flashContent" +i).hide();
                }
            }
            $('#newsflash-openclose').click(function () {
                if (active) {
                    active = false;
                    for (i = defaultNum; i < flash.length; i = i + 1) {
                        $("#newsflash-accordcontent").append('<div class="panel" id="flashContent' + i + '"><div class="newsflash-accordion">' +
                        '<a data-toggle="collapse" accesskey="L1" role="button" href="#" data-target="#collapsenewsflash' + i + '"' +
                        'aria-expanded="true" aria-controls="collapsenewsflash' + i + '"class="collapsed newsflash-accrdian-title" ' +
                        'id="accrdn' + i + '">' + data.newsFlashArticles[i].Title + '<span class="pull-right news-flash-plus"></span></a></div><div id="collapsenewsflash' + i + '"' +
                        'class="newsflashpanel-collapse collapse" role="tabpanel" aria-labelledby="headingOne"><div class="panel-body  bg-colorgrey">' +
                        '<div class="newsflas-panelbody-content" id="paracoll' + i + '">' + data.newsFlashArticles[i].Body + '</div></div></div></div>');
                    }
                    $(".newsflash-accordion a").addClass("newsflash-menu");
                    $(".newsflash-accordion a").removeClass("collapsed");
                    $('.newsflashpanel-collapse').addClass("in");
                    $(".newsflashpanel-collapse").removeAttr("style");
                    $('.newsflash-accordion').find("span").removeClass('news-flash-plus').addClass('news-flash-minus');
                    $(this).text('CLOSE ALL');
                } else {
                    active = true;
                    $('.newsflashpanel-collapse').collapse('hide');
                    $(".newsflash-accordion a").addClass("collapsed");
                    $('.newsflash-accordion').find("span").removeClass('news-flash-minus').addClass('news-flash-plus');
                    $(this).text('OPEN ALL');
                        for (i = defaultNum; i < flash.length; i = i + 1) {
                        $("#flashContent" + i).remove();
                    }
                }
            });
            if(data.Query !== null) {
                var scriptQuery = '<script language="JavaScript">';
                scriptQuery = scriptQuery + data.Query;
                scriptQuery = scriptQuery + '</script>';
                $("#newsflash-accordcontent").append(scriptQuery);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindNewsflash " + err);
        }
    };
};

/**
 * Ready Function
 */
var newsFlashReady = function () {
    try {
        if(isApp){
            window.ga.trackView('News Flash');
        }
        var newsFlashClassObj = new NewsFlashClass();
        startLoading();
        setTimeout(function () {
            headerMain();
            subHeaderNewsHide();
            newsFlashClassObj.newsFlash();
            if (deviceOS === 'ios' && isApp) {
                $('#iosscroll').addClass("scrollcontent");
            }
        }, 500);
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : newsFlashReady " + err);
    }
};

function toggleIconNewsFlash(e) {
    var x= $(".newsflash-accordion").length;
    var i=0;
    var y= $(".newsflash-accordion").length;
    var j=0;
    
    if ($(e.target).prev('.newsflash-accordion').find("span").hasClass("news-flash-plus") || $(e.target).prev('.newsflash-accordion').find("span").hasClass("news-flash-minus")) {

        if (e.type === 'show') {
            $(e.target).prev('.newsflash-accordion').find("span").removeClass('news-flash-plus').addClass('news-flash-minus');

            $(".newsflashpanel-collapse").each(function () {
                if($(this).eq(0).parent().children().eq(0).children("a").find("span").hasClass("news-flash-minus")){
                    i++;
                }
            });
    
    	     if(i==x){
    		   $("#newsflash-openclose").text('CLOSE ALL');
    	     }
    	     else if(j==y){
    		   $("#newsflash-openclose").text('OPEN ALL');
             }
    	
        }
        if (e.type === 'hide') {
            $(e.target).prev('.newsflash-accordion').find("span").removeClass('news-flash-minus').addClass('news-flash-plus');
            $(".newsflashpanel-collapse").each(function () {
    	      if($(this).eq(0).parent().children().eq(0).children("a").find("span").hasClass("news-flash-plus")){
    	        j++;
    	       }
            });
    
    	    if(j==y){
    		   $("#newsflash-openclose").text('OPEN ALL');
    	    }
    	    else if(i==x){
    		   $("#newsflash-openclose").text('CLOSE ALL');
    		}
        }
    }
}
