/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

var NewsLetterClass = function () {
    /*function to call other news letter functions*/
    this.newsLetters = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getNewsletterParameters();
            $('.panel-group').on('hide.bs.collapse', toggleIconNewsFlash);
            $('.panel-group').on('show.bs.collapse', toggleIconNewsFlash);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnNews1Success, this.OnNews1Error);
            navigationArrowMenu();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : newsLetters " + err);
        }
    };
    /**
	 * Ajax success call
	 */
    this.OnNews1Success = function (data) {
        try {
            if (data) {
                var newsLetterClassSuccessObj = new NewsLetterClass();
                newsLetterClassSuccessObj.bindNewsletters(data);
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNews1Success " + err);
        }
    };
    /**
	 * Ajax failure call
	 */
    this.OnNews1Error = function (jqXHR, error) {
        try {
            endLoading();
            if (jqXHR.status && jqXHR.status === 401 &&
                    jqXHR.statusText === "Unauthorized") {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnNews1Error " + err);
        }
    };
    /*Creating request parameters*/
    this.getNewsletterParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "NewsServiceProvider";
            data.ServiceMethod = "GetNewsletters";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["1262282D-79EF-4D4A-AF75-C86C620AEEA0","247A39B5-3D5C-4833-9C6E-D057A1B3AD5E"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getNewsletterParameters" + err);
        }
    };
    /*bind newsletter body*/
    this.bindNewsletters = function (data) {
        try {
            $('#newsletterDesc').html(data.Description);
            var letter = data.Newsletters,
                $collapseIssue = $(".collapseissue"),
                collapIssueList = "",
                $collapseIssue1 = $(".collapseissue1"),
                collapIssue1List = "",
                i,
                j,
                issue,
                newsrc,
                str1date;
            for (i = 0; i < letter.length; i = i + 1) {
                issue = letter[i].Issues;
                $("#newsflash-accordcontent").append('<div class="panel"><div class="newsflash-accordion">' +
                                                     '<a data-toggle="collapse" accesskey="L1" role="button" href="#" data-target="#collapsenewsflash' + i + '"' +
                                                     'data-parent="#newsflash-accordcontent" aria-expanded="true" aria-controls="collapsenewsflash' + i + '"' +
                                                     'class="collapsed newsflash-accrdian-title">' + letter[i].NewsletterName + '<span class="pull-right news-flash-plus"></span>' +
                                                     '</a></div><div id="collapsenewsflash' + i + '" class="newsletter-collapse collapse" role="tabpanel" ' +
                                                     'aria-labelledby="headingOne"><div class="panel-body"><div id="newsletter-content' + i + '">' +
                                                     '</div></div></div></div>');
                for (j = 0; j < issue.length; j = j + 1) {
                    newsrc = letter[i].Issues[j].IssuePDF.Src;
                    if (letter[i].Issues[j].IssueDate !== null) {
                        str1date = moment(letter[i].Issues[j].IssueDate).format("MMMM DD, YYYY");
                    }
                    $("#newsletter-content" + i).append('<div class="newsflas-panelbody-content"><div class="newsletter-panelbody-content"><a data-url = "' + newsrc + '" onclick = "showPdf(this);" id="newsletter' + j + '">' + str1date + '</a></div></div>');
                }
            }

        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindNewsletters" + err);
        }
    };

    /* Open pdf */
    this.showPdf = function (event) {
        try {
            var url = $(event).attr("data-url");
            if (url && url !== "null" && url !== "undefined") {
               /* if (device) {
                    if (device.platform && device.platform.toLowerCase() === "android") {
                        url = "https://docs.google.com/viewer?url=" + encodeURIComponent(url);
                    }
                }*/
                openBrowser(url);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : showPdf " + err);
        }
    };
};
/**
 * Ready Function
 */
var newsLettersReady = function () {
    try {
        if(isApp){
            window.ga.trackView('News Letter');
        }
        var newsLetterClassObj = new NewsLetterClass();
        startLoading();
        headerMain();
        subHeaderCarousel();
        newsLetterClassObj.newsLetters();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : newsLettersReady " + err);
    }
};