/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed, 
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/**
 * Order of Play Class
 */
var OrderOfPlayClass = function () {
	var orderPlayTemplate = '<div class="orderofplay-table"><table id = "{2}" class="table table-bordered table-responsive borderless table-shadow-order">' +
            '<tr id= {1} class="row-class"><td colspan="2" class="table-heading"><span class="stadium-text">{0}</span></td></tr>' +
            '</table></div>';
	/**
	 * Get Order of Play data
	 */
	this.getOrderofPlayData = function (params) {
		try {
			var apiservicecallsObj = new Apiservicecalls(),
			    url =  constants.ajaxUrl,
			    sessionData = applicationDataObj.getSessionResponse(),
			    inputData = this.getOrderRequestParameters(sessionData, params);
			apiservicecallsObj.postData(url, inputData, this.onOrderSuccess,  this.onOrderError);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getOrderofPlayData : " +  err);
		}
	};
	/**
	 * Ajax Success
	 */
	this.onOrderSuccess = function (data) {
		try {
			var orderOfPlayObj = new OrderOfPlayDataClass();
			if (data) {
				orderOfPlayObj.bindOrderPlayBody(data);
				setTimeout(function () {
					endLoading();
				}, 1000);
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : onOrderSuccess "  +  err);
		}
	};
	/**
	 * Ajax Failure
	 */
	this.onOrderError = function (jqXHR, exception) {
		try {
			endLoading();
			var errMsg = "";
			if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
				errMsg = "Error : onOrderError "  +  jqXHR.statusText;
			} else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
				timoutErrorStatus = true;
				errMsg = "Error : onOrderError "  +  jqXHR.statusText;
			} else if (jqXHR.status === 0) {
				timoutErrorStatus = true;
				errMsg = "Error : onOrderError Unexpected Error with status Code 0";
			} else {
				timoutErrorStatus = true;
				errMsg = "Error : onOrderError Unexpected Error";
			}
			loggerObj.logToServer(constants.logSeverityError, errMsg);
			logout();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : onOrderError"  +  err);
		}
	};
	this.handleclickEvents = function () {
		try {
			$("#tournament-name").click(function () {
				var eventUrl = $(this).attr("data-url");
				if (eventUrl && eventUrl !== "null" && eventUrl !== "undefined") {
					constants.activeScheduleTab = "";
					var urlPath = eventUrl,
					    encodedString = btoa(urlPath);
					window.location.href  = "#/LoadWebsite/?urlToLoad=" +  encodedString;
				}
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : handleclickEventsOOP " +  err);
		}
	};
	
	/**
	 * Bind court details
	 */
	this.bindCourtDetails = function (scheduleCourts, tabId) {
		try {
			var orderOfPlayObj = new OrderOfPlayDataClass();
			$.each(scheduleCourts,  function (index,  value) {
				var id = "court_" +  index;
				var tableId ="table_" + index;
				if (value.CourtName) {
					var courtName = orderPlayTemplate.format(value.CourtName, id, tableId);
					$("#" +  tabId).append(courtName);
				}
				orderOfPlayObj.bindMatchDetails(value, id, tabId, tableId);
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindCourtDetails : "  +  err);
		}
	};
	
	/**
	 * Create request parameters
	 */
	this.getOrderRequestParameters = function (sessionData, params) {
		try {
			var data = {};
			data.Userid = sessionData.userId;
			data.ServiceProvider = "HomeServiceProvider";
			data.ServiceMethod = "GetLiveSchedules";
			data.Language = constants.englishLanguage;
			data.parametersArray =  ["D2239643-1127-4FC9-A766-EBA9F97DB81B"];
			var userSession = {};
			userSession.PlayerId = sessionData.playerId;
			userSession.Userid = sessionData.userId;
			userSession.FirstName = sessionData.firstName;
			userSession.LastName = sessionData.lastName;
			userSession.Roles = sessionData.roles;
			userSession.TOKEN  = applicationDataObj.getToken();
			if (params && params.eventId) {
				userSession.ORDEROFPLAY_EVENTID = params.eventId;
			}
			if (params && params.eventYear) {
				userSession.ORDEROFPLAY_EVENTYEAR = params.eventYear;
			}
			data.SessionData = userSession;
			var inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getOrderRequestParameters : " +  err);
		}
	};
		
};
/**
 * Ready functionality
 */
var orderOfPlayReady = function (params) {
	try {
        if(isApp){
            window.ga.trackView('OrderOfPlay');
        }
		var orderOfPlayObj = new OrderOfPlayClass();
		startLoading();
		if (deviceOS === 'ios' && isApp) {
			$('#iosscroll').addClass("scrollcontent");
		}
		//setTimeout(function () {
        orderOfPlayObj.getOrderofPlayData(params);
		//}, 500);
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : orderOfPlayReady : " +  err);
	}
};