/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/**
 * Order of Play Class
 */
var OrderOfPlayDataClass = function () {
	/**
	 * Initializing templates
	 */
	
	var timeSpan = '<tr id = {1} ><td colspan="2"><h4 class="bold font-size-14">{0}</h4></td></tr>';
	var matchDetailsTemplate = '<tr class="text-name"><td class="tab-wdt">{0}</td><td>{1}</td></tr>';
	/**
	 * Bind order of play body
	 */
	this.bindOrderPlayBody = function (data) {
		try {
			var orderOfPlayObj = new OrderOfPlayClass();
			if (data.TournamentBadgePath && data.TournamentBadgePath !== null && data.TournamentBadgePath !== "") {
				var imagePath = data.TournamentBadgePath;
				$(".buchest-logo").append('<img src="' +  imagePath +  '"class= "order-of-play-image" alt="image" />');
			}
            
            if(data.OrderOfPlayHeading) {
                $(".order").text(data.OrderOfPlayHeading);
            }
            
			if (data.TournamentName) {
				$(".buchest>a").text(data.TournamentName);
			}
			if (data.TournamentUrl) {
				$(".buchest>a").attr("data-url", data.TournamentUrl);
			} else {
				$(".buchest>a").attr("data-url", "");
			}
			if (data.YestDateFomat) {
				$("#li-yest>a").text(data.YestDateFomat);
			}
			if (data.TodayDateFomat) {
				$("#li-today>a").text(data.TodayDateFomat);
			}
			if (data.ScheduleDaysYest  && data.ScheduleDaysYest.length !== 0) {
				$.each(data.ScheduleDaysYest,  function (index,  value) {
					if (value.ScheduleCourts && value.ScheduleCourts.length !== 0) {
						orderOfPlayObj.bindCourtDetails(value.ScheduleCourts, "bindyest");
					}
				});
			}
			if (data.ScheduleDaysToday  && data.ScheduleDaysToday.length !== 0) {
				$.each(data.ScheduleDaysToday,  function (index,  value) {
					if (value.ScheduleCourts && value.ScheduleCourts.length !== 0) {
						orderOfPlayObj.bindCourtDetails(value.ScheduleCourts, "bindtoday");
					}
				});
			}
			if ((data.ScheduleDaysToday || data.ScheduleDaysYest)) {
				if (data.AtpSupervisor) {
					$("#atp_supervisor").text(data.AtpSupervisor);
				}
				if (data.TournamentDirector) {
					$("#tour-director").text(data.TournamentDirector);
				}
				if (data.AtpTourManager) {
					var atpTourManagerTemplate =  '<td><span class="large-text" id = "tour-manager">' +  data.AtpTourManager +  '</span><span class="tour-text">Tour Manager</span></td>';
					$("#manager-referee").append(atpTourManagerTemplate);
					if (!data.AtpReferee) {
						$("#manager-referee").append('<td></td>');
					}
				}
				if (data.AtpReferee) {
					var refereeTemplate =  '<td><span class="large-text" id = "referee">' +  data.AtpReferee +  '</span><span class="tour-text">Referee</span></td>';
					$("#manager-referee").append(refereeTemplate);
					if (!data.AtpTourManager) {
						$("#manager-referee").append('<td></td>');
					}
				}
				/*if (data.AtpReferee) {
					$("#referee").text(data.AtpReferee);
					$("#referee").parent().show();
				}      else{
					$("#referee").parent().empty();
				}
				if (data.AtpTourManager) {
					$("#tour-manager").text(data.AtpTourManager);
					$("#tour-manager").parent().show();
				}else{
					//$("#tour-manager").parent().hide();
				}*/
				if (data.SupervisorLabel) {
					$("#atp_supervisor").siblings().text(data.SupervisorLabel);
				}
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindOrderPlayBody " +  err);
		}
	};
	/**
	 * Bind Match Details
	 */
	this.bindMatchDetails = function (matchDetails, rowId, tabId, tableId) {
		try {
			var orderOfPlayObj = new OrderOfPlayClass();
			if (matchDetails.ScheduleMatches && matchDetails.ScheduleMatches.length !== 0) {
				$.each(matchDetails.ScheduleMatches,  function (index,  value) {
					var id = "time" +  index;
					if (value.DisplayTime) {
						var displayTime = timeSpan.format(value.DisplayTime, id);//matchDetails
						var matchType = value.Tour;
						var match = "";
						var player = value.SeedEntry1  +   value.PlayerDetails;
						var opponent = value.SeedEntry2  +   value.OpponentDetails;
						if (player) {
							match = player  +  " vs " +   opponent;
							if (player.indexOf("/") !== -1) {
								match = player  +  " vs <br/>" +   opponent;
							}
						}
						var matchDetail = matchDetailsTemplate.format(matchType, match);
						$("#" +  tabId).find("#" +  tableId).find('tbody:last-child').append(displayTime  +  matchDetail);
					}
				});
			}
			orderOfPlayObj.handleclickEvents();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : bindMatchDetails : " +  err);
		}
	};
};
