/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/**
 * OtherHomeClass
 */
var OtherHomeClass = function () {
	/**
	 * Function for loading other role home page
	 */
	this.loadOtherRolesHomePage = function(){
		endLoading();
		$(".player-home-div").addClass("hide");
		this.loadOtherRoleDetails();
		this.loadHeadlineDetails();
		this.loadBannerDetails();
	};
	/**
	 * loading the details of other roles in home
	 */
	this.loadOtherRoleDetails = function () {
		var inputData = this.createReqForOtherRoleHome();
		var apiservicecallsObj = new apiservicecalls();
		apiservicecallsObj.postData(constants.ajaxUrl, inputData,this.otherRoleHomeSuccess,this.otherRoleHomeError);
	};
	/**
	 * create request for getting the non players data
	 */
	this.createReqForOtherRoleHome = function () {
		try {
			var data = {},
			    sessionData = {},
			    inputData;
			data.Userid = applicationDataObj.UserId;
			data.ServiceProvider = "HomeServiceProvider";
			data.ServiceMethod = "GetCurrentPlayerRanks";
			data.Language = constants.englishLanguage;
			data.parametersArray = ["F266353E-186B-4FA3-88D9-CF904B64F94F"];
			var userSessionData  = applicationDataObj.getSessionResponse();
			if(userSessionData.playerId){
				sessionData.PlayerId = userSessionData.playerId;
			}else{
				sessionData.PlayerId ="";
			}
			sessionData.UserId = applicationDataObj.UserId;
			sessionData.FirstName = userSessionData.firstName;
			sessionData.LastName = userSessionData.lastName;
			sessionData.UserName = applicationDataObj.getUsername();
			sessionData.Roles = userSessionData.roles;
			sessionData.EmailId = userSessionData.emailId;
			sessionData.City = userSessionData.city;
			sessionData.Country = userSessionData.country;
			sessionData.Address1 = userSessionData.address1;
			sessionData.TOKEN = applicationDataObj.getToken(); 
			if(userSessionData.ManagementAgency){
				sessionData.ManagementAgency = userSessionData.ManagementAgency;
			}
			sessionData.JoinedDate = userSessionData.registeredDate;
			data.SessionData = sessionData;
			inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in createReqForOtherRoleHome : " + err);
		}
	};
	/**
	 * success call of getting non-players data
	 */
	this.otherRoleHomeSuccess = function (response) {
		try {
			var otherHomeObj = new OtherRoleHomeDataClass();
			otherHomeObj.bindOtherRolesPlayerDetails(response);
			endLoading();
			$(".other-roles-div").removeClass("hide");
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in otherRoleHomeSuccess : " + err);
		}
	};
	/**
	 * handle error of getting non-player's data
	 */
	this.otherRoleHomeError = function (jqXHR,error) {
		try {
			this.LoadError();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in otherRoleHomeError : " + err);
		}
	};
	/**
	 * loadHeadlineDetails for other roles
	 */
	this.loadHeadlineDetails = function () {
		try {
			var inputData = this.createReqForOtherRoleHeadlines();
			var apiservicecallsObj = new apiservicecalls();
			apiservicecallsObj.postData(constants.ajaxUrl, inputData,this.otherRoleHeadlineSuccess,this.otherRoleHeadlineError);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in loadHeadlineDetails : " + err);
		}

	};
	/**
	 * creating request for non players headlines
	 */
	this.createReqForOtherRoleHeadlines = function () {
		try {
			var data = {},
			    sessionData = {},
			    inputData;
			data.Userid = applicationDataObj.UserId;
			data.ServiceProvider = "HomeServiceProvider";
			data.ServiceMethod = "GetHeadlines";
			data.Language = constants.englishLanguage;
			data.parametersArray = ["28A85A5A-BDA6-4709-8F0B-6AB4C320699D"];
			var userSessionData  = applicationDataObj.getSessionResponse();
			if(userSessionData.playerId){
				sessionData.PlayerId = userSessionData.playerId;
			}else{
				sessionData.PlayerId ="";
			}
			sessionData.UserId = applicationDataObj.UserId;
			sessionData.FirstName = userSessionData.firstName;
			sessionData.LastName = userSessionData.lastName;
			sessionData.UserName = applicationDataObj.getUsername();
			sessionData.Roles = userSessionData.roles;
			sessionData.EmailId = userSessionData.emailId;
			sessionData.City = userSessionData.city;
			sessionData.Country = userSessionData.country;
			sessionData.Address1 = userSessionData.address1;
			sessionData.TOKEN = applicationDataObj.getToken(); 
			if(userSessionData.ManagementAgency){
				sessionData.ManagementAgency = userSessionData.ManagementAgency;
			}
			sessionData.JoinedDate = userSessionData.registeredDate;
			data.SessionData = sessionData;
			inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in createReqForOtherRoleHome : " + err);
		}
	};
	/**
	 * success call of non players headline
	 */
	this.otherRoleHeadlineSuccess = function (response) {
		try {
			var otherHomeObj = new OtherRoleHomeDataClass();
			otherHomeObj.bindOtherRolesPlayerHeadlines(response);
			//endLoading();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in otherRoleHeadlineSuccess : " + err);
		}
	};
	/**
	 * Error call of non players headline
	 */
	this.otherRoleHeadlineError = function (jqXHR,error) {
		try {
			this.LoadError();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in otherRoleHeadlineError : " + err);
		}
	};
	/**
	 * Banner details of other roles
	 */
	this.loadBannerDetails = function () {
		var inputData = this.createReqForOtherRoleBanner();
		var apiservicecallsObj = new apiservicecalls();
		apiservicecallsObj.postData(constants.ajaxUrl, inputData,this.otherRoleBannerSuccess,this.otherRoleBannerError);
	};
	/**
	 * creating request for other roles banner
	 */
	this.createReqForOtherRoleBanner = function () {
		try {
			var data = {},
			    sessionData = {},
			    inputData;
			data.Userid = applicationDataObj.UserId;
			data.ServiceProvider = "HomeServiceProvider";
			data.ServiceMethod = "GetBannerDetails";
			data.Language = constants.englishLanguage;
			data.parametersArray = ["9472C92C-2532-4A90-A0C5-2A0CE4E30577"];
			var userSessionData  = applicationDataObj.getSessionResponse();
			if(userSessionData.playerId){
				sessionData.PlayerId = userSessionData.playerId;
			}else{
				sessionData.PlayerId ="";
			}
			sessionData.UserId = applicationDataObj.UserId;
			sessionData.FirstName = userSessionData.firstName;
			sessionData.LastName = userSessionData.lastName;
			sessionData.UserName = applicationDataObj.getUsername();
			sessionData.Roles = userSessionData.roles;
			sessionData.EmailId = userSessionData.emailId;
			sessionData.City = userSessionData.city;
			sessionData.Country = userSessionData.country;
			sessionData.Address1 = userSessionData.address1;
			sessionData.TOKEN = applicationDataObj.getToken(); 
			if(userSessionData.ManagementAgency){
				sessionData.ManagementAgency = userSessionData.ManagementAgency;
			}
			sessionData.JoinedDate = userSessionData.registeredDate;
			data.SessionData = sessionData;
			inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in createReqForOtherRoleHome : " + err);
		}
	};
	/**
	 * success call of other roles banner
	 */
	this.otherRoleBannerSuccess = function (response) {
		try {
			var otherHomeObj = new OtherRoleHomeDataClass();
			otherHomeObj.bindOtherRolesBannerDetails(response);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in otherRoleHeadlineSuccess : " + err);
		}
	};
	/**
	 * error call of other roles banner
	 */
	this.otherRoleBannerError = function (jqXHR,error) {
		try {
			this.LoadError();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in otherRoleHeadlineError : " + err);
		}
	};
	/**
	 * common error for ajax errors
	 */
	this.LoadError = function () {
		try {
			endLoading();
			var errMsg = "";
			if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
				errMsg = "Error : LoadError " + jqXHR.statusText;
			} else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
				timoutErrorStatus = true;
				errMsg = "Error : LoadError " + jqXHR.statusText;
			} else if (jqXHR.status === 0) {
				timoutErrorStatus = true;
				errMsg = "Error : LoadError Unexpected Error with status Code 0";
			} else {
				timoutErrorStatus = true;
				errMsg = "Error : LoadError Unexpected Error";
			}
			loggerObj.logToServer(constants.logSeverityError, errMsg);
			logout();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : LoadError " +  err);
		}
	};
	/**
	 * bind TIU button click of other roles
	 */
	this.bindTIUbutton = function () {
		try {
			$(".find-out-more-btn").click(function(){
				var url = $(this).attr("data-url");
				window.open(url,"_system");
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in bindOtherRolesPlayerHeadlines : " + err);
		}
	};
	/**
	 * initiateSlickForPlayerNames
	 */
	this.initiateSlickForPlayerNames = function () {
		$('.playername-list-slick').slick({
			dots : false,
			arrows : true,
			swipe : false,
			infinite : false,
			slidesToShow : 1,
			slidesToScroll :1,
			arrows:true,
			autoplay:false

		});
	};
	/**
	 * initiate slick for alumni combined role
	 */
	this.initiateSlickFoAlumniCombinedRoles = function () {
		$('.hmrytcntnr-descrptn-carousel').slick({
			dots : false,
			arrows : true,
			swipe : false,
			infinite : false,
			slidesToShow : 1,
			slidesToScroll :1,
			arrows:true,
			autoplay:false,
			slide:".descptn-carousel-item"

		});
	};
};
/**
 * OtherRoleHomeDataClass
 */
var OtherRoleHomeDataClass = function () {
	/**
	 * bind non players details in home page
	 */
	this.bindOtherRolesPlayerDetails = function (response) {
		try {
			var playerName = "";
			var otherHomeObj = new OtherHomeClass();
			if (response.PlayerFirstName){
				playerName = response.PlayerFirstName;
			}
			if (response.PlayerLastName){
				playerName = playerName + " " + response.PlayerLastName;
				playerName = playerName.toUpperCase();
			}
			$(".atpmob-hp-plyrname").text(playerName);
			if (response.Flag){
				this.bindFlagDetails(response.Flag);
			}
			if (response.ProfilePicture && response.ProfilePicture.Src){
                if (response.ProfilePicture.Src.indexOf("Photo_Grey.png") >= 0){
                   $(".home-rytcntnr-plyrimg").attr("src","images/Photo_Grey.png");  
                }
                else{
				   $(".home-rytcntnr-plyrimg").attr("src",response.ProfilePicture.Src);
                }
			}
			if (response.DelegatedUsers && response.DelegatedUsers.length && response.DelegatedUsers.length !== 0){
				this.bindPlayerDetaills(response.DelegatedUsers);
			} 
			if (response.role) {
				$(".status div").text(applicationDataObj.getSessionResponse().roles[0]);
				this.hideShowMenus(response.role);
			}
			if (response.JoinedDate){
				var joinedDateVal = moment(response.JoinedDate).format('DD MMM YYYY');
				$(".joined-date div").text(joinedDateVal);
			} else {
				$(".joined-date").addClass("hide");
			}
			
			if (response.Location) {
				$(".location div").text(response.Location.toUpperCase());
			} else {
				$(".location").addClass("hide");
			}
			if (response.ManagementAgency){
				$(".agency div").text(response.ManagementAgency.toUpperCase());
			} else {
				$(".agency div").text("-");
			}
			if (response.Employer) {
				$(".employer div").text(response.Employer);
			} else {
				$(".employer div").text("-");
			}
			if (response.SglHiRank !== null || response.SglHiRank !== undefined) {
				var singlesRank = response.SglHiRank;
				var singlesDate = response.SglHiRankDate;
				if (singlesDate) {
					singlesDate = moment(singlesDate).format('YYYY.MM.DD');
				}
				var singlesData = singlesRank + " (" + singlesDate +" )";
				$(".al-sing  div").text(singlesData);
			}
			if (response.DblHiRank !== null || response.DblHiRank !== undefined) {
				var dblHiRank = response.DblHiRank;
				var dblHiRankDate = response.DblHiRankDate;
				if (dblHiRankDate) {
					dblHiRankDate = moment(dblHiRankDate).format('YYYY.MM.DD');
				}
				var doublesData = dblHiRank + " (" + dblHiRankDate +" )";
				$(".al-dbl  div").text(doublesData);
			}
			if (response.CareerPrize !== null || response.CareerPrize !== undefined) {
				var prizeMoney = response.CareerPrize;
				prizeMoney = "$" + ' ' + Number(response.CareerPrize).toString().replace(/.(?=(?:.{3})+$)/g, '$&,');
				$(".al-prize div").text(prizeMoney);
			}
			var userRole = applicationDataObj.getSessionResponse().roles[0];
			if (userRole === "Alumni"){
				$(".alumni-home-div").removeClass("hide");
			}
            if (userRole === "Alumni/ATP Coach"){
				$(".alumni-home-div").removeClass("hide");
			}
            if (userRole === "ATP Coach"){
				$(".coach-home-div").removeClass("hide");
			}
            if (userRole === "ATP Agent"){
				$(".agent-home-div").removeClass("hide");
			}
            if (userRole === "Alumni/ATP Agent"){
				$(".agent-alumni-coach-home-div").removeClass("hide");
			}
            if (userRole === "Alumni//ATP Coach/ATP Agent"){
				$(".agent-alumni-coach-home-div").removeClass("hide");
			}
            if (userRole === "ATP Coach/ATP Agent"){
				$(".coach-home-div").removeClass("hide");
			}
            if (userRole === "ATP Staff"){
				$(".myPlayersList").hide();
			}
            if (userRole === "Other"){
				$(".other-home-div").removeClass("hide");
			}
			/*if (userRole !== "Alumni" && userRole.indexOf("Alumni") === -1){
				$(".not-alumni-role-div").removeClass("hide");
			}*/
			if (userRole !== "Alumni" && userRole.indexOf("Alumni") !== -1){
				//$(".alumni-combined-role").removeClass("hide");
				//$(".al-combined").removeClass("hide");
				setTimeout(function(){
					otherHomeObj.initiateSlickFoAlumniCombinedRoles();
				},200);
			}
			$(".home-border").addClass("white-background");
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in bindOtherRolesPlayerDetails : " + err);
		}
	};
	/**
	 * bind non players flag image
	 */
	this.bindFlagDetails = function (flagResp) {
		try {
			if (flagResp && flagResp.Src) {
				var flagPath = flagResp.Src;	
				$(".atpmob-hp-rcflag img").attr("src",flagPath);
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in bindFlagDetails : " + err);
		}
	};
	/**
	 * bind player names in home page
	 */
	this.bindPlayerDetaills = function (playerDetails) {
		var otherHomeObj = new OtherHomeClass();
		try {
			var playerDiv = "";
			$(".hmrytcntnr-myplayers-heading").removeClass("hide");
			$(".hmrytcntnr-myplayers-list").removeClass("hide");
			$(".hmrytcntnr-myplayers-list").empty();
			var playerTemplate = "";
			var template = '<div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 paddinglftryt0 home-mngcntnr-plyrnames">';
			playerTemplate = template;
			$.each(playerDetails,  function (index,  value) {
				if (value && value.FullName){
					var name = value.FullName.toUpperCase();
					playerDiv = '<a href ="#/MyLanding">' + name + '</a><br>';
					if (index !== 0 && index%3 === 0){
						playerTemplate = playerTemplate+'</div>'+ template + playerDiv;
					} else {
						playerTemplate = playerTemplate + playerDiv;
					}
				}
			});
			playerTemplate = playerTemplate + "</div>";
			$(".hmrytcntnr-myplayers-list").append(playerTemplate);
			setTimeout(function(){
				otherHomeObj.initiateSlickForPlayerNames();
			},200);
			
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in bindPlayerDetaills : " + err);
		}
	};
	
	/**
	 * show hide different labels based on user role
	 */
	this.hideShowMenus = function (role) {
		try {
			role = role.toLowerCase();
			if (role.indexOf("alumni") !== -1) {
				$(".alumini-prize").removeClass("hide");
				$(".status").removeClass("hide");
				$(".employer").removeClass("hide");
			}
			if (role.indexOf("agent") !== -1) {
				$(".joined-date").removeClass("hide");
				$(".agency").removeClass("hide");
			}
			if (role.indexOf("coach") !== -1 || role.indexOf("other") !== -1 ||
					role.indexOf("staff") !== -1) {
				$(".joined-date").removeClass("hide");
				$(".location").removeClass("hide");
			}

		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in hideShowMenus : " + err);
		}
	};
	/**
	 * bind headlines of other profile role datas
	 */
	this.bindOtherRolesPlayerHeadlines = function (response) {
		try {
			var latestNewsLinks = "";
            var i = 0;
			if (response && response.childItems && response.childItems.length) {
				$(".home-news-headlines").empty();
				$.each(response.childItems,  function (index,  value) {
                    i++;
                    if(value.Title !== "" && i<=5) {
                       latestNewsLinks += '<li class="all-headlines"><a class="newsArticleanchor" data-Id = "' + value.Id + '" data-title = "' + value.Title + '">' + value.Title + '</a></li>';
                    }
				});
				$(".home-news-headlines").append(latestNewsLinks);
				$(".headlines-container").removeClass("hide");
				this.bindNewsClickHandler();
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in bindOtherRolesPlayerHeadlines : " + err);
		}
	};
	/**
	 * click handler for news links in headlines
	 */
	this.bindNewsClickHandler = function () {
		try {
			$(".all-headlines").click(function () {
				var newsId = $(this).find("a").attr("data-id"),
				newsText = $(this).find("a").attr("data-title");
				if(newsId){
					window.location.href = "#/NewsArticle/?newsId=" + newsId + "&newsText=" + newsText;
				}
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in bindOtherRolesPlayerHeadlines : " + err);
		}
	};
	/**
	 * bind banner of other profile roles
	 */
	this.bindOtherRolesBannerDetails = function (response) {
		try {
			var otherHomeClassObj = new OtherHomeClass();
			if (response) {
				if (response.BannerImage && response.BannerImage.Src){
					var bannerSrc  = response.BannerImage.Src;
					$(".TIU-image-container img").attr("src",bannerSrc);
				}
				if(response.TargetURL && response.TargetURL.Url){
					var url = response.TargetURL.Url;
					$(".find-out-more-btn").attr("data-url",url);
					otherHomeClassObj.bindTIUbutton();
				}
				if (response.BannerImage && response.TargetURL) {
					$(".TIU-container").removeClass("hide");
				}
			}
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error in bindOtherRolesPlayerHeadlines : " + err);
		}
	};
};