/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed, 
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/**
 * Other Profile Data Class
 */
var globalnotificationdata;
var otherProfileDataClass = function(){
	/**
	 * bindUserProfileDetails
	 */
	this.bindUserProfileDetails = function (data){
		try{
			$("#myProfileId").text("Profile");
			if(data.ProfileModel){
				var userData = data.ProfileModel;
				var playerName; 
				if(userData.PlayerFirstName || userData.PlayerLastName){
					playerName = userData.PlayerFirstName + " " + userData.PlayerLastName;
				}
				if(playerName){
					$(".myprofile-sub-text>label").text(playerName);
					$("#myprofile-sub-image");
				}
			}
			if(data.ProfileDetails && data.ProfileDetails.ProfilePictureSrc){
				$("#profile_image").attr("src",data.ProfileDetails.ProfilePictureSrc);
			}
			else{
				var imageSrc = "images/Photo_Grey.png";
				$("#profile_image").attr("src",imageSrc);
			}
			if(data.ProfileDetails && data.ProfileDetails.CountryFlag && data.ProfileDetails.CountryFlag.Src){
				var flagSrc = data.ProfileDetails.CountryFlag.Src;
				$('#flag_image').empty();
				$('#flag_image').append('<img class="landing-flag" src='+flagSrc+'/>');
			}
		}catch(err){
			loggerObj.logToServer(constants.logSeverityError, "bindUserProfileDetails" + err);
		}
	};
	/**
	 * bindCareerDetails
	 */
	this.bindCareerDetails = function (data){
		try{
			var singlesText ="";
			var doublesText = "";
			var prizeMoney = "";
			if(data.ProfileDetails){
				if(data.ProfileDetails.SinglesCareerHighText){
					singlesText +=  " " + data.ProfileDetails.SinglesCareerHighText;
				}
				if(data.ProfileDetails.DoublesCareerHighText){
					doublesText +=  " " + data.ProfileDetails.DoublesCareerHighText;
				}
				if(data.ProfileDetails.CareerPrizeMoneyText){
					prizeMoney +=  data.ProfileDetails.CareerPrizeMoneyText;
				}
			}
			if(data.ProfileModel){
				if(data.ProfileModel.SglHiRankDate){
					singlesText +=   " " + moment(data.ProfileModel.SglHiRankDate).format('YYYY.MM.DD');
				}
				if(data.ProfileModel.DblHiRankDate){
					doublesText +=  " " + moment(data.ProfileModel.DblHiRankDate).format('YYYY.MM.DD');
				}
			}
			$(".singles-other-label").text(singlesText);
			$(".doubles-other-label").text(doublesText);
			$(".career-other-label").text(prizeMoney);
			if(data.ProfileModel.CareerPrize !== undefined && data.ProfileModel.CareerPrize !== null && data.ProfileModel.CareerPrize !== ""){
			    $(".career-other-val").text("$" + ' ' + Number(data.ProfileModel.CareerPrize).toString().replace(/.(?=(?:.{3})+$)/g, '$&,'));
			}
			if(data.ProfileModel.SglHiRank !== null && data.ProfileModel.SglHiRank !== undefined && data.ProfileModel.SglHiRank !== "" ){
				$(".singles-other-val").text(data.ProfileModel.SglHiRank);
			}
			if(data.ProfileModel.DblHiRank !== null && data.ProfileModel.DblHiRank !== undefined && data.ProfileModel.DblHiRank !== "" ){
				$(".doubles-other-val").text(data.ProfileModel.DblHiRank);
			}
            
            if(data.ProfileModel.Employer !== null && data.ProfileModel.Employer !== undefined && data.ProfileModel.Employer !== "" ){
				$(".player-employer").text(data.ProfileModel.Employer);
			}
		}catch(err){
			loggerObj.logToServer(constants.logSeverityError, "bindCareerDetails" + err);
		}
	};
	/**
	 * bindJoinedStatusSection
	 */
	this.bindJoinedStatusSection = function (data){
		try{
			var role  = "";
			if(data.ProfileModel.JoinedDate){
				var joinedDate = data.ProfileModel.JoinedDate;
				var joinedDateVal = moment(joinedDate).format('DD MMM YYYY');
				$(".joined-date").text(joinedDateVal);
			}
			if(applicationDataObj.getSessionResponse()&& applicationDataObj.getSessionResponse().roles && 
					applicationDataObj.getSessionResponse().roles.length !== 0){
				role = applicationDataObj.getSessionResponse().roles[0];
				$(".player-status").text(role);
			}
			if(role){
				var lowerConvertedRole = role.toLowerCase(); 
				if (lowerConvertedRole.indexOf("agent") !== -1){
					$(".div-agency").removeClass("hide");
					if(data.ProfileModel && data.ProfileModel.ManagementAgency){
						$('.player-agency').text(data.ProfileModel.ManagementAgency);
					}
				}
				if (lowerConvertedRole.indexOf("coach") !== -1 || lowerConvertedRole.indexOf("other") !== -1 ||
						lowerConvertedRole.indexOf("staff") !== -1){
					$(".div-location").removeClass("hide");
					if(data.ProfileModel && data.ProfileModel.Location){
						$('.player-location').text(data.ProfileModel.Location);
					}
				}
				if (lowerConvertedRole.indexOf("alumni") !== -1 || lowerConvertedRole.indexOf("staff") !== -1){
					$('.prize-money-other').removeClass("hide");
                    $('.otherrolejointext').addClass("hide");
					$(".alumini-status").removeClass("hide");
                    $(".alumini-employer").removeClass("hide");
					$(".nonplayerclass").parent().hide();
					$(".alumini-prizemoney").parent().removeClass("hide");
					$("#rightarrow").hide();
				}else{
                    $('.otherrolejointext').removeClass("hide");
					$('.prize-money-other').addClass("hide");
					$(".alumini-status").addClass("hide");
                    $(".alumini-employer").addClass("hide");
					$(".nonplayerclass").parent().hide();
					$("#rightarrow").hide();
					$(".alumini-prizemoney").parent().addClass("hide");
				}
				if(lowerConvertedRole === "other" || lowerConvertedRole === "staff"){
					$(".nonplayerclass").parent().hide();
					$(".nonplayerclass-other").parent().hide();
					$("#rightarrow").hide();
				}

			}

			/*if(data.ProfileModel.Division){
				$(".player-status").text(data.ProfileModel.Division);
			}*/
		}catch(err){
			loggerObj.logToServer(constants.logSeverityError, "bindJoinedStatusSection" + err);
		}
	};
    
   
	/**
	 * bindOtherProfileDelegateSection
	 */
	this.bindOtherProfileDelegateSection = function(data) {
		try{
            globalnotificationdata = data;
            
			var otherProfileClassObj = new otherProfileClass();
			if(data.DelegatedUsers && data.DelegatedUsers.length !== 0){
				$(".other-prof-play").removeClass("hide");
				$.each(data.DelegatedUsers, function( index, value ) {
					var playerClass = "role-innercntnr3 commondivclass col-xs-12";
					var playerTextClass = "disabled-player-text hide";
					var playerPermissions = otherProfileClassObj.getPlayerPermissions(value.MyPermissions);
					var playerImageSrc = "images/Photo_Grey.png";
                    var optForEmailNotifications = value.OptForEmailNotifications;
                    var requestId = value.RequestId;
                    var userid = value.UserId;
					if(value.HeadshotImage){
						playerImageSrc = value.HeadshotImage;
					}
					var disabledUser = value.IsDisabled;
					if(disabledUser){
						playerClass = "role-innercntnr3 commondivclass col-xs-12 disabled-other-players";
						playerTextClass ="disabled-player-text show";
					}
					var playerName = value.FullName;
					var playerId = value.PlayerId;
					var players_template = '<div><div class="'+playerClass+'">'+
					'<div class="plyrimg_profile col-xs-3 statuspadd">'+
					'<figure>'+
					'<img class="img_team_player img-team-background-color" src="'+playerImageSrc+'" alt="playerimage">'+
					'</figure>'+
					'</div>'+
					'<div class="teamprofile_detail paddingleft2 col-xs-8 specifystyle">'+
					'<div class="role-playername">'+playerName+'</div>'+
					'<div class="player_profile2">'+playerPermissions+'</div>'+
					'</div>'+
					'<div class="plyer-modal-img_profile col-xs-1 imgspec">'+
					'<figure>'+
					'<img class="manage_1_img" src="images/Edit_icon.svg" onclick="onclickEdit(&quot;' + playerName + '&quot;,&quot;' + playerId + '&quot;,&quot;' + playerPermissions + '&quot;,&quot;' + playerImageSrc + '&quot;,&quot;' + optForEmailNotifications + '&quot;,&quot;' + requestId + '&quot;,&quot;' + userid + '&quot;)" alt="greyphoto">' +
					'</figure>'+
					'</div>'+
					'</div>'+
					'<div class="'+playerTextClass+'">Players account is currently disabled, therefore you cannot access his PlayerZone</div>'+
					'</div>';
					$(".add-players").append(players_template);
				});
			}
			endLoading();
		}catch(err){
			loggerObj.logToServer(constants.logSeverityError, "bindOtherProfileDelegateSection" + err);
		}
	};
	/**
	 * defaultButtonbehaviour
	 */
	this.defaultButtonbehaviour = function(){
		$("#bank-div button").addClass("button4-disabled");
		$("#bank-div button").addClass("disabled");
		$("#bank-div").addClass("pointer-class");
		$("#bank-div button").removeClass("button4");
		$("#bank-div img").show();
		$("#entry-div button").addClass("button4-disabled");
		$("#entry-div button").addClass("disabled");
		$("#entry-div button").removeClass("button4");
		$("#entry-div").addClass("pointer-class");
		$("#entry-div img").show();
		$("#profile-div button").addClass("button4-disabled");
		$("#profile-div button").addClass("disabled");
		$("#profile-div button").removeClass("button4");
		$("#profile-div").addClass("pointer-class");
		$("#profile-div img").show();
	};
	/***
	 * Extend Expiration Time
	 */
	this.extendExpirationTime = function (type, onBehalfPlayerId, playerName) {
		try {
			var apiservicecallsObj = new Apiservicecalls(),
			    inputData = this.extendExpirationTimeReqParams(type, onBehalfPlayerId, playerName);
			apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.extendExpirationTimeSuccess,  this.extendExpirationTimeError);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : extendExpirationTime " +  err);
		}
	};
	/***
	 * Extend Expiration Time - requestParams
	 */
	this.extendExpirationTimeReqParams = function (type, onBehalfPlayerId, playerName) {
		try {
			var sessionData = applicationDataObj.getSessionResponse(),
			    data = {},
			    parametersArray = [],
			    userSession = {},
			    itemId = "50903FD2-B119-4A36-9333-DACA9A70CBE1",
			    inputData;
			data.Userid = sessionData.userId;
			data.ServiceProvider = "MyProfileServiceProvider";
			data.ServiceMethod = "ExtendExpirationTime";
			data.Language = constants.englishLanguage;
			parametersArray.push(type);
			parametersArray.push(onBehalfPlayerId);
			parametersArray.push(sessionData.firstName + " " + sessionData.lastName);
			parametersArray.push("50903FD2-B119-4A36-9333-DACA9A70CBE1");
			//parametersArray.push(sessionData.firstName + " " + sessionData.lastName);
			data.parametersArray =  parametersArray;
			userSession.PlayerId = sessionData.playerId;
			userSession.UserId = sessionData.userId;
			userSession.FirstName = sessionData.firstName;
			userSession.LastName = sessionData.lastName;
			userSession.UserName = applicationDataObj.getUsername();
			userSession.Roles = sessionData.roles;
			userSession.TOKEN  = applicationDataObj.getToken();
			userSession.EmailId = sessionData.emailId;
			userSession.City = sessionData.city;
			userSession.Country = sessionData.country;
			userSession.Address1 = sessionData.address1;
			if(sessionData.ManagementAgency){
				userSession.ManagementAgency = sessionData.ManagementAgency;
			}
			userSession.JoinedDate = sessionData.registeredDate;
			data.SessionData = userSession;
			inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : extendExpirationTimeReqParams " +  err);
		}
	};
	/**
	 * extendExpirationTimeSuccess
	 */
	this.extendExpirationTimeSuccess = function (response) {
		constants.managingPlayers = true;
		$("body").removeClass("pointer-class");
		var otherProfileClassObj = new otherProfileClass();
		//otherProfileClassObj.manageExtendExpirationTime();
		var getOtherProfileDetails = applicationDataObj.getOtherProfileDetailObj();
		if(getOtherProfileDetails.type === "entries"){
			//var otherProfileClassObj = new otherProfileClass();
			otherProfileClassObj.createHybridAppLoginForManageEntries();
		}
		if(getOtherProfileDetails.type === "profile"){
			endLoading();
			$("#container-div2").modal("hide");
			window.location.href = "#/MyAccount/?onBehalfPlayerId=" + getOtherProfileDetails.onBehalfPlayerId + "&receiveEmailNotifications=" + getOtherProfileDetails.receiveEmailNotifications+ "&playerName="+getOtherProfileDetails.playerName;
		}
		if(getOtherProfileDetails.type === "bankdetails"){
			endLoading();
			$("#container-div2").modal("hide");
			window.location.href = "#/MyPrizeMoney/?onBehalfPlayerId=" + getOtherProfileDetails.onBehalfPlayerId + "&receiveEmailNotifications=" + getOtherProfileDetails.receiveEmailNotifications + "&playerName="+getOtherProfileDetails.playerName;

		}

	};
	/**
	 * extendExpirationTimeError
	 */
	this.extendExpirationTimeError = function (jqXHR, error) {
		console.log(jqXHR);
	};
	/**
	 * releaseLockedResources
	 */
	this.releaseLockedResources = function (type, onBehalfPlayerId, playerName) {
		try {
			var apiservicecallsObj = new Apiservicecalls();
			 var  inputData = this.releaseLockedResourcesReqParams(type, onBehalfPlayerId, playerName);
			apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.releaseLockedResourcesSuccess, this.releaseLockedResourcesError);
		
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "releaseLockedResources" + err);
		}
	};
	/**
	 * releaseLockedResourcesReqParams
	 */
	this.releaseLockedResourcesReqParams = function (type, onBehalfPlayerId, playerName) {
		try {
			var sessionData = applicationDataObj.getSessionResponse(),
			data = {},
			parametersArray = [],
			userSession = {},
			itemId = "50903FD2-B119-4A36-9333-DACA9A70CBE1",
			inputData;
			data.Userid = sessionData.userId;
			data.ServiceProvider = "MyProfileServiceProvider";
			data.ServiceMethod = "ReleaseResources";
			data.Language = constants.englishLanguage;
			parametersArray.push(type);
			parametersArray.push(onBehalfPlayerId);
			parametersArray.push(sessionData.firstName + " " + sessionData.lastName);
			parametersArray.push("50903FD2-B119-4A36-9333-DACA9A70CBE1");
			//parametersArray.push(sessionData.firstName + " " + sessionData.lastName);
			data.parametersArray =  parametersArray;
			userSession.PlayerId = sessionData.playerId;
			userSession.UserId = sessionData.userId;
			userSession.FirstName = sessionData.firstName;
			userSession.LastName = sessionData.lastName;
			userSession.UserName = applicationDataObj.getUsername();
			userSession.Roles = sessionData.roles;
			userSession.TOKEN  = applicationDataObj.getToken();
			userSession.EmailId = sessionData.emailId;
			userSession.City = sessionData.city;
			userSession.Country = sessionData.country;
			userSession.Address1 = sessionData.address1;
			if(sessionData.ManagementAgency){
				userSession.ManagementAgency = sessionData.ManagementAgency;
			}
			userSession.JoinedDate = sessionData.registeredDate;
			data.SessionData = userSession;
			inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : releaseLockedResourcesReqParams " +  err);
		}
	};
	/**
	 * releaseLockedResourcesSuccess
	 */
	this.releaseLockedResourcesSuccess = function (response) {
		constants.liveScoreLoading = false;
		constants.managingPlayers = false;
		$(".manageplyr-header").hide();
		window.location.href = "#/MyLanding";
	};
	/**
	 * releaseLockedResourcesError
	 */
	this.releaseLockedResourcesError = function (jqXHR,error) {
		console.log(jqXHR);
	};
	/**
	 * Request for onbehalf player id session
	 */
	this.createRequestForOnBehalfPlayerIdSession = function(){
		var receiveEmailNotifications = $("#entry-wdrwl1").prop("checked");
		var data = {};
		data.Userid = applicationDataObj.UserId;
		data.ServiceProvider = "MyProfileServiceProvider";
		data.ServiceMethod = "SetOnBehalfPlayerIdSessionValue";
		data.Language = constants.englishLanguage;
		data.parametersArray = [constants.onBehalfPlayerId,receiveEmailNotifications,"50903FD2-B119-4A36-9333-DACA9A70CBE1"];
		var sessionData = {};
		var userSessionData  = applicationDataObj.getSessionResponse();
		sessionData.PlayerId =userSessionData.playerId;
		sessionData.UserId = applicationDataObj.UserId;
		sessionData.FirstName = userSessionData.firstName;
		sessionData.LastName = userSessionData.lastName;
		sessionData.UserName = applicationDataObj.getUsername();
		sessionData.Roles = userSessionData.roles;
		sessionData.EmailId = userSessionData.emailId;
		sessionData.City = userSessionData.city;
		sessionData.Country = userSessionData.country;
		sessionData.Address1 = userSessionData.address1;
		sessionData.TOKEN = applicationDataObj.getToken(); 
		if(userSessionData.ManagementAgency){
			sessionData.ManagementAgency = userSessionData.ManagementAgency;
		}
		if (constants.onBehalfPlayerId) {
			sessionData.OnBehalfPlayerId = constants.onBehalfPlayerId;
        }
		sessionData.JoinedDate = userSessionData.registeredDate;
		data.SessionData = sessionData;
		var inputData = JSON.stringify(data);
		return inputData;
	}; 
	/**
	 * Manage player entries
	 */
	this.managePlayerEntries = function(){
		try{
			var userSessionData  = applicationDataObj.getSessionResponse();
			var receiveEmailNotifications = $("#entry-wdrwl1").prop("checked");
			/*var inputReq = this.createRequestForOnBehalfPlayerIdSession();
			var apiservicecallsObj = new apiservicecalls();
			var url = constants.ajaxUrl;
			apiservicecallsObj.postData(url, inputReq,this.onmanagePlayerEntrySuccess,this.onmanagePlayerEntryError);*/
			$.ajax({
				url: constants.hybridAppSessionValue,
				data: { "playerId": applicationDataObj.getOtherProfileDetailObj().onBehalfPlayerId,  "emailNotifications": receiveEmailNotifications },
				xhrFields: {
					withCredentials: true
				},
				crossDomain: true,
				type: "POST",
				async: true,
				timeout: 60000,
				success: function (respdata) {
					/*var otherProfileDataClassObj = new otherProfileDataClass();
					otherProfileDataClassObj.managePlayerEntries();*/
					var managePlayerEntryUrl = mwebUrls.manageEntryUrl;
					var encodedString = btoa(managePlayerEntryUrl);
					window.location.href  = "#/LoadManageEntryUrl/?urlToLoad="+encodedString;
				},
				error: function (jqXHR,  exception) {
					endLoading();
					if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
						errMsg = "Error : loadMwebUrl "  + jqXHR.statusText;
					} else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
						timoutErrorStatus = true;
						errMsg = "Error : loadMwebUrl "  + jqXHR.statusText;
					} else if (jqXHR.status === 0) {
						timoutErrorStatus = true;
						errMsg = "Error : loadMwebUrl Unexpected Error with status Code 0";
					} else {
						timoutErrorStatus = true;
						errMsg = "Error : loadMwebUrl Unexpected Error";
					}
					loggerObj.logToServer(constants.logSeverityError, errMsg);
					logout();
				}
			});
		}catch(err){
			loggerObj.logToServer(constants.logSeverityError, "managePlayerEntries" + err);
		}
	};
	/**
	 * manage entry success
	 */
	this.onmanagePlayerEntrySuccess = function(response){
		var managePlayerEntryUrl = mwebUrls.manageEntryUrl;
		var encodedString = btoa(managePlayerEntryUrl);
		//window.location.href  = "#/LoadWebsite/?urlToLoad="+encodedString;
		window.location.href  = "#/LoadManageEntryUrl/?urlToLoad="+encodedString;
	};
	/**
	 * Manage entry error
	 */
	this.onmanagePlayerEntryError = function(jqXHR,error){
		endLoading();
		if(jqXHR.status && jqXHR.status === 401 &&
				jqXHR.statusText === "Unauthorized" ){
			logout();
		}
	};
};
