/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed, 
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */
/**
 * Other Profile Class
 */
var playerUserId;
var otherProfileClass = function(){
	this.getOtherProfileDetails = function(){
		var inputReqParameters  = this.createOtherProfileGetReqParams();
		var apiservicecallsObj = new apiservicecalls();
		var url = constants.ajaxUrl;
		apiservicecallsObj.postData(url, inputReqParameters,this.onOtherProfSuccess,this.onOtherProfError);
	};
	/**
	 * Other Profile Success function
	 */
	this.onOtherProfSuccess = function(data){
        $("#notificationtoggleswitch1").removeAttr("checked");
        $("#notificationtoggleswitch2").removeAttr("checked");
        $('#notificationtoggleswitch3').removeAttr("checked");
		var otherProfileDataClassObj = new otherProfileDataClass();
		otherProfileDataClassObj.bindUserProfileDetails(data);
		otherProfileDataClassObj.bindCareerDetails(data);
		otherProfileDataClassObj.bindJoinedStatusSection(data);
		otherProfileDataClassObj.bindOtherProfileDelegateSection(data);
	};
	/***
	 * Other Profile error function
	 */
	this.onOtherProfError = function(jqXHR,error){
		endLoading();
		if(jqXHR.status && jqXHR.status === 401 &&
				jqXHR.statusText === "Unauthorized" ){
			logout();
		}
	};
	/**
	 * Get player permissions
	 */
	this. getPlayerPermissions = function(permissions){
		var grantedPermissions = "";
		if(permissions && permissions.length && permissions.length !== 0 ){
			$.each(permissions, function( index, value ) {
				if(value.PermissionName){
					grantedPermissions += value.PermissionName;
					grantedPermissions = grantedPermissions+",";
				}
			});
			grantedPermissions = grantedPermissions.replace(/,\s*$/, "");
		}
		return grantedPermissions;
	};
	/**
	 * Create request parameters 
	 */
	this.createOtherProfileGetReqParams = function(){
		var data = {};
		data.Userid = applicationDataObj.UserId;
		data.ServiceProvider = "MyProfileServiceProvider";
		data.ServiceMethod = "GetProfileDetails";
		data.Language = constants.englishLanguage;
		data.parametersArray = ["50903FD2-B119-4A36-9333-DACA9A70CBE1"];
		var sessionData = {};
		var userSessionData  = applicationDataObj.getSessionResponse();
		if(userSessionData.playerId){
			sessionData.PlayerId = userSessionData.playerId;
		}else{
			sessionData.PlayerId ="";
		}
		sessionData.UserId = applicationDataObj.UserId;
		sessionData.FirstName = userSessionData.firstName;
		sessionData.LastName = userSessionData.lastName;
		sessionData.UserName = applicationDataObj.getUsername();
		sessionData.Roles = userSessionData.roles;
		sessionData.EmailId = userSessionData.emailId;
		sessionData.City = userSessionData.city;
		sessionData.Country = userSessionData.country;
		sessionData.Address1 = userSessionData.address1;
		sessionData.TOKEN = applicationDataObj.getToken(); 
		if(userSessionData.ManagementAgency){
			sessionData.ManagementAgency = userSessionData.ManagementAgency;
		}
		sessionData.JoinedDate = userSessionData.registeredDate;
		data.SessionData = sessionData;
		var inputData = JSON.stringify(data);
		return inputData;
	};
	/**
	 * Get Lock Details
	 */
	this.getLockDetails = function (playerId, playerName, playerPermissions, playerImageSrc, requestId, optForEmailNotifications) {
		try{
			var otherProfileDataClassObj = new otherProfileDataClass();
			otherProfileDataClassObj.defaultButtonbehaviour();
			$(".player-name").text(playerName);
			if(playerName){
				$(".span-player-name").text(playerName.toUpperCase());
			}
			$(".player-name").attr("data-playerId", playerId);
			$(".player-name").attr("data-playerImg", playerImageSrc);
            $(".player-name").attr("data-requestId", requestId);
            $(".player-name").attr("data-recieveEmailNot", optForEmailNotifications);
			var inputReq = this.getReqForLocKDetails(playerId);
			var apiservicecallsObj = new apiservicecalls();
			var url = constants.ajaxUrl;
			apiservicecallsObj.postData(url, inputReq,this.onGetLockSuccess,this.onGetLockError);
		}catch(err){
			loggerObj.logToServer(constants.logSeverityError, "getLockDetails" + err);
		}
	};
	/**
	 * Get Lock Success
	 */
	this.onGetLockSuccess = function(data){
        $("#current-usediv").hide();
		$('#myModalEdit').show();
		$('#myModalEditConfirmation').hide();
		$("#container-div2").removeClass("divhided");
		if(!data.BankDetailsLock) {
			$("#bank-div button").removeClass("button4-disabled");
			$("#bank-div button").removeClass("disabled");
			$("#bank-div").removeClass("pointer-class");
			$("#bank-div button").addClass("button4");
			$("#bank-div img").hide();
		}else{
			$("#current-use").text("Currently in use by "+ data.BankDetailsLock);
            $("#current-usediv").show();
		}
		if(data.EntriesLock){
			$("#entry-div button").removeClass("button4-disabled");
			$("#entry-div button").removeClass("disabled");
			$("#entry-div").removeClass("pointer-class");
			$("#entry-div button").addClass("button4");
			$("#entry-div img").hide();
		}else{
			//$("#current-use").text("Currently in use by "+ data.EntriesLock);
            $("#entry-div button").removeClass("button4-disabled");
			$("#entry-div button").removeClass("disabled");
			$("#entry-div").removeClass("pointer-class");
			$("#entry-div button").addClass("button4");
			$("#entry-div img").hide();
		}
		if(!data.ProfileLock){
			$("#profile-div button").removeClass("button4-disabled");
			$("#profile-div button").removeClass("disabled");
			$("#profile-div").removeClass("pointer-class");
			$("#profile-div button").addClass("button4");
			$("#profile-div img").hide();
		}else{
			$("#current-use").text("Currently in use by "+ data.ProfileLock);
            $("#current-usediv").show();
		}
		/*if(!data.BankDetailsLock && !data.EntriesLock && !data.ProfileLock){
			$("#current-usediv").hide();
		}else{
			$("#current-usediv").show();
		}*/
		$("#container-div2").modal('show');
        $("#entry-wdrwl1").click(function() {
            console.log("Clicked");
            var apiservicecallsObj = new Apiservicecalls();
            var url = constants.ajaxUrl;
            var reqID = $(".player-name").attr("data-requestId");
            var checkBoxValue = $("#entry-wdrwl1").prop("checked");
            var inputData = getReqForrecieveEmailNotChange(reqID, checkBoxValue);
            apiservicecallsObj.postData(url, inputData, recieveEmailNotChangeSucesss , recieveEmailNotChangeFail);
        });
		endLoading();
	};
	/**
	 * Get Lock Error
	 */
	this.onGetLockError = function(jqXHR,error){
		endLoading();
		if(jqXHR.status && jqXHR.status === 401 &&
				jqXHR.statusText === "Unauthorized" ){
			logout();
		}
	};
	/**
	 * Request for lock details
	 */
	this.getReqForLocKDetails = function (playerID){
		var data = {};
		data.Userid = applicationDataObj.UserId;
		data.ServiceProvider = "MyProfileServiceProvider";
		data.ServiceMethod = "GetLockDetails";
		data.Language = constants.englishLanguage;
		data.parametersArray = [playerID,"50903FD2-B119-4A36-9333-DACA9A70CBE1"];
		var sessionData = {};
		var userSessionData  = applicationDataObj.getSessionResponse();
		sessionData.PlayerId ="";
		sessionData.UserId = applicationDataObj.UserId;
		sessionData.FirstName = userSessionData.firstName;
		sessionData.LastName = userSessionData.lastName;
		sessionData.UserName = applicationDataObj.getUsername();
		sessionData.Roles = userSessionData.roles;
		sessionData.EmailId = userSessionData.emailId;
		sessionData.City = userSessionData.city;
		sessionData.Country = userSessionData.country;
		sessionData.Address1 = userSessionData.address1;
		sessionData.TOKEN = applicationDataObj.getToken(); 
		if(userSessionData.ManagementAgency){
			sessionData.ManagementAgency = userSessionData.ManagementAgency;
		}
		sessionData.JoinedDate = userSessionData.registeredDate;
		data.SessionData = sessionData;
		var inputData = JSON.stringify(data);
		return inputData;

	};
	this.createHybridAppLoginForManageEntries = function () {
		try{
			var userId = applicationDataObj.getUserId(),
			token = applicationDataObj.getToken();
			$.ajax({
				url: constants.hybridAppLogin,
				data: { "userId": userId,  "token": token },
				xhrFields: {
					withCredentials: true
				},
				crossDomain: true,
				type: "POST",
				async: true,
				timeout: 60000,
				success: function (respdata) {
					var otherProfileDataClassObj = new otherProfileDataClass();
					otherProfileDataClassObj.managePlayerEntries();
				},
				error: function (jqXHR,  exception) {
					endLoading();
					if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
						errMsg = "Error : loadMwebUrl "  + jqXHR.statusText;
					} else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
						timoutErrorStatus = true;
						errMsg = "Error : loadMwebUrl "  + jqXHR.statusText;
					} else if (jqXHR.status === 0) {
						timoutErrorStatus = true;
						errMsg = "Error : loadMwebUrl Unexpected Error with status Code 0";
					} else {
						timoutErrorStatus = true;
						errMsg = "Error : loadMwebUrl Unexpected Error";
					}
					loggerObj.logToServer(constants.logSeverityError, errMsg);
					logout();
				}
			});
		}catch(err){
			loggerObj.logToServer(constants.logSeverityError, "createHybridAppLoginForManageEntries" + err);
		}
	}
	
	
	/**
	 * manageExtendExpirationTime
	 */
	this.manageExtendExpirationTime = function () {
		var otherProfileDataClassObj = new otherProfileDataClass();
		setTimeout(function(){
			if (constants.managingPlayers) {
				var otherProfileDetails = applicationDataObj.getOtherProfileDetailObj();
				var apiservicecallsObj = new Apiservicecalls(),
				inputData = otherProfileDataClassObj.extendExpirationTimeReqParams(otherProfileDetails.type, otherProfileDetails.onBehalfPlayerId, otherProfileDetails.playerName);
				constants.liveScoreLoading = true;
				apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.manageExtendExpirationTimeSuccess,  this.manageExtendExpirationTimeError);
			}
		}, 120000);
	};
	/**
	 * manageExtendExpirationTimeSuccess
	 */
	this.manageExtendExpirationTimeSuccess = function (response) {
		console.log(response);
	};
	/**
	 * manageExtendExpirationTimeSuccess
	 */
	this.manageExtendExpirationTimeSuccess = function (jqXHR,error) {
		console.log(jqXHR);
	};

};


/**
 * Other Profile Landing
 */
var otherProfileLanding = function(){
	var otherProfileClassObj = new otherProfileClass();
	otherProfileClassObj.getOtherProfileDetails();
};
/**
 * Click Edit of Modal
 */
var onclickEdit = function (playerName, playerId, playerPermissions, playerImageSrc, optForEmailNotifications, requestId,userid) {
    var notificationSettings = globalnotificationdata.NotificationSettings;
    playerUserId = userid;
    for (i = 0; i < notificationSettings.length ; i++) {
        if(notificationSettings[i].NotificationId === "d7fbb04b-5139-477b-b0dc-669e5d96645c" && notificationSettings[i].PlayerUserid === userid) {
            $('#notificationtoggleswitch1').prop("checked", "checked");
        }
        
        if(notificationSettings[i].NotificationId === "78dc208b-df51-4832-a5a1-a877ff391e83" && notificationSettings[i].PlayerUserid === userid) {
            $('#notificationtoggleswitch2').prop("checked", "checked");
        }
        
        if(notificationSettings[i].NotificationId === "1f7aae9a-3c55-4714-a3ca-e4cc7d0e2fbd" && notificationSettings[i].PlayerUserid === userid) {
            $('#notificationtoggleswitch3').prop("checked", "checked");
        }
    }
    
    
    $(".notificationsetting-toggle-function").change(function() {
        if ($('input', this).attr("checked") === "checked")
        {
            $('input', this).removeAttr("checked");
        }
        else {
            $('input', this).attr("checked", "checked");
            $('input', this).prop("checked", "checked");
        }
        if(this.id === "notificationSpanSwitch1") {
            var toggleId = globalnotificationdata.AllNotifications[0].NotificationId;
        }
        if(this.id === "notificationSpanSwitch2") {
            var toggleId = globalnotificationdata.AllNotifications[0].NotificationId;
        }
        if(this.id === "notificationSpanSwitch3") {
             var toggleId = globalnotificationdata.AllNotifications[0].NotificationId;
        }
        var toggleSwitchClassObj = new NotificationSettingsClass();
        toggleSwitchClassObj.toggleSwitchNonPlayer(toggleId,"50903FD2-B119-4A36-9333-DACA9A70CBE1",playerUserId,"xyz");
    });
    
	if(!$("#bank-div").hasClass('hide')){
		$("#bank-div").addClass("hide");
	}
	if(!$("#profile-div").hasClass('hide')){
		$("#profile-div").addClass("hide");
	}
	if(!$("#entry-div").hasClass('hide')){
		$("#entry-div").addClass("hide");
	}
	if(playerPermissions){
		var permissionValues = playerPermissions.split(',');
		if(permissionValues && permissionValues.length && permissionValues.length !== 0){
			 $.each(permissionValues, function( index, value ) {
				 if (value === "Bank Details"){
					 $("#bank-div").removeClass("hide");
				 }
				 if (value === "Profile"){
					 $("#profile-div").removeClass("hide");
				 }
				 if (value === "Entries"){
					 $("#entry-div").removeClass("hide");
				 }
			 });
		}
	}
    
    if (optForEmailNotifications === "true") {
        if($(".player-name").attr("data-recieveEmailNot") === "true") {
            $('#entry-wdrwl1').prop("checked", true);
        } else {
             $('#entry-wdrwl1').prop("checked", false);
        }
        
    } else {
        if($(".player-name").attr("data-recieveEmailNot") === "true") {
            $('#entry-wdrwl1').prop("checked", true);
        } else {
             $('#entry-wdrwl1').prop("checked", false);
        }
    }
    
	var otherProfileClassObj = new otherProfileClass();
	otherProfileClassObj.getLockDetails(playerId, playerName, playerPermissions, playerImageSrc, requestId, optForEmailNotifications);
    
};

/**
 * Navigate to Player Page
 */
var navigatePlayerPage = function(type,buttonclass){
    $("#MyApp").removeAttr("style");
	var receiveEmailNotifications = $("#entry-wdrwl1").prop("checked");
	var onBehalfPlayerId = $(".player-name").attr("data-playerId");
	var playerName = $(".player-name").text();
	constants.headShotImage = $(".player-name").attr("data-playerImg");
    /*
    if($("."+buttonclass).hasClass("button4")){
        $("."+buttonclass).removeClass("button4");
            $("."+buttonclass).addClass("button4active");
            setTimeout(function () {
                $("."+buttonclass).removeClass("button4active");
                $("."+buttonclass).addClass("button4");
        }, 1000);
    }*/
	var sessionData = applicationDataObj.getSessionResponse();
	var otherProfileDetails = {};
	otherProfileDetails.type = type;
	otherProfileDetails.onBehalfPlayerId=onBehalfPlayerId;
	otherProfileDetails.playerName=/*sessionData.firstName + " " + sessionData.lastName;*/playerName;
	otherProfileDetails.receiveEmailNotifications = receiveEmailNotifications;
	applicationDataObj.setOtherProfileDetailObj(otherProfileDetails);
	var otherProfileDataClassObj = new otherProfileDataClass();
	otherProfileDataClassObj.extendExpirationTime(type, onBehalfPlayerId, playerName);
};
/**
 * Load Player Relations
 */
var loadPlayerRelation = function(){
	window.location.href = '#/Contact-Player-Relations';
};

$("#entry-wdrwl1").click(function() {
    var apiservicecallsObj = new Apiservicecalls();
    var url = constants.ajaxUrl;
    var reqID = $(".player-name").attr("data-requestId");
    var checkBoxValue = $("#entry-wdrwl1").prop("checked");
    var inputData = getReqForrecieveEmailNotChange(reqID, checkBoxValue);
    apiservicecallsObj.postData(url, inputData, recieveEmailNotChangeSucesss , recieveEmailNotChangeFail);
});

var recieveEmailNotChangeSucesss = function (data) {
    endLoading();
    $(".player-name").attr("data-recieveEmailNot",  $('#entry-wdrwl1').prop("checked"));
    var checked,
        notificationId1 = globalnotificationdata.AllNotifications[0].NotificationId,
        notificationId2 = globalnotificationdata.AllNotifications[1].NotificationId,
        notificationId3 = globalnotificationdata.AllNotifications[2].NotificationId;
    if($('#notificationtoggleswitch1').prop('checked') == false) {
        $('#notificationtoggleswitch1').prop("checked", "checked");
        checked ="checked";
    } else {
        checked = "unchecked";
        $('#notificationtoggleswitch1').prop("checked", "");
    }
    if($('#notificationtoggleswitch2').prop('checked') == false) {
        $('#notificationtoggleswitch2').prop("checked", "checked");
        checked ="checked";
    } else {
        checked = "unchecked";
        $('#notificationtoggleswitch2').prop("checked", "");
    }
    if($('#notificationtoggleswitch3').prop('checked') == false) {
        $('#notificationtoggleswitch3').prop("checked", "checked");
        checked ="checked";
    } else {
        checked = "unchecked";
        $('#notificationtoggleswitch3').prop("checked", "");
    }
        
    var toggleSwitchClassObj = new NotificationSettingsClass();
    toggleSwitchClassObj.toggleSwitchNonPlayer(notificationId1,"50903FD2-B119-4A36-9333-DACA9A70CBE1",playerUserId,checked);
    toggleSwitchClassObj.toggleSwitchNonPlayer(notificationId2,"50903FD2-B119-4A36-9333-DACA9A70CBE1",playerUserId,checked);
    toggleSwitchClassObj.toggleSwitchNonPlayer(notificationId3,"50903FD2-B119-4A36-9333-DACA9A70CBE1",playerUserId,checked);
};

var recieveEmailNotChangeFail = function (jqXHR,error) {
    endLoading();
    if(jqXHR.status && jqXHR.status === 401 &&
            jqXHR.statusText === "Unauthorized" ){
        logout();
    }
};

var getReqForrecieveEmailNotChange = function (reqID,checkBoxVal){
		var data = {};
		data.Userid = applicationDataObj.UserId;
		data.ServiceProvider = "MyProfileServiceProvider";
		data.ServiceMethod = "ChangeStatusOfReceiveEmailNotifications";
		data.Language = constants.englishLanguage;
		data.parametersArray = [reqID,checkBoxVal,"50903FD2-B119-4A36-9333-DACA9A70CBE1"];
		var sessionData = {};
		var userSessionData  = applicationDataObj.getSessionResponse();
		sessionData.PlayerId ="";
		sessionData.UserId = applicationDataObj.UserId;
		sessionData.FirstName = userSessionData.firstName;
		sessionData.LastName = userSessionData.lastName;
		sessionData.UserName = applicationDataObj.getUsername();
		sessionData.Roles = userSessionData.roles;
		sessionData.EmailId = userSessionData.emailId;
		sessionData.City = userSessionData.city;
		sessionData.Country = userSessionData.country;
		sessionData.Address1 = userSessionData.address1;
		sessionData.TOKEN = applicationDataObj.getToken(); 
		if(userSessionData.ManagementAgency){
			sessionData.ManagementAgency = userSessionData.ManagementAgency;
		}
		sessionData.JoinedDate = userSessionData.registeredDate;
		data.SessionData = sessionData;
		var inputData = JSON.stringify(data);
		return inputData;

};