/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/* Other Taxes and Receipt class */

var TaxesReceiptClass = function () {

    var eventmanageidarray = [],
        eventmanageyeararray = [];
    /** get Manage player receipt data **/
    this.getManageAllReceiptsForBank = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getManageParametersAllReciepts();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnManageAllReceiptsSuccess, this.OnManageAllReceiptsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : TaxesReceiptClass " + err);
        }
    };

    /** Creating request Parameters **/
    this.getManageParametersAllReciepts = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MyProfileServiceProvider";
            data.ServiceMethod = "GetAllReceiptsForAPlayer";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["BEE85C7A-7EC4-4253-A936-287D02B01BDA"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId = sessionData.emailId;
            userSession.Address1 = sessionData.address1;
            userSession.City = sessionData.city;
            userSession.Country = sessionData.country;
            userSession.UserName = applicationDataObj.getUsername();
            if (sessionData.ManagementAgency) {
                userSession.ManagementAgency = sessionData.ManagementAgency;
            }
            userSession.JoinedDate = sessionData.registeredDate;
            userSession.OnBehalfPlayerId = constants.onBehalfPlayerId;
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getManageParametersAllReciepts " + err);
        }
    };

    /** binding manage receipt body data **/
    this.bindManageReceiptResponse = function (response) {
        try {
            output = response;
            if (response !== null && response !== undefined) {
                if (response.AllReceipts !== null) {
                    for (var index = 0; index < response.AllReceipts.length; index++) {
                        eventmanageidarray.push(response.AllReceipts[index].EventId);
                        eventmanageyeararray.push(response.AllReceipts[index].EventYear);
                        var eventDisplayname = response.AllReceipts[index].EventDisplayName;
                        var eventYear = response.AllReceipts[index].EventYear;
                        $("#selection").append('<option class="optionvalue" data-EventId=' + response.AllReceipts[index].EventId + ' data-year=' + response.AllReceipts[index].EventYear + ' value=' + index + '>' + eventYear + " " + eventDisplayname +
                        '</option>');
                    }
                }
            }
            //method for GetAReceipt to take the recipt of each player
            initiateManageDropDownControls();
            endLoading();

        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindManageReceiptResponse " + err);
        }
    };

    /*Ajax - Success Call back*/
    this.OnManageAllReceiptsSuccess = function (data) {
        try {
            var manageReceiptClassObj = new TaxesReceiptClass();
            manageReceiptClassObj.bindManageReceiptResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageAllReceiptsSuccess " + err);
        }
    };

    /*Ajax - Error Call back*/
    this.OnManageAllReceiptsError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageAllReceiptsError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageAllReceiptsError " + err);
        }
    };

    /** get Manage player receipt dropdown data **/
    this.receiptManageDropDownChange = function (e) {
        try {
            var eventSelectedValue = $('select[name=eventName]').val();
            var eventyear = $('select#selection option:selected').attr("data-year");
            var eventid = $('select#selection option:selected').attr("data-EventId");
            var apiservicecallsObj = new Apiservicecalls();
            var url = constants.ajaxUrl;
            var inputData = this.getManageParametersReciepts(eventyear, eventid);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnManageReceiptsSuccess, this.OnManageAllReceiptsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : TaxesReceiptClass " + err);
        }
    };

    /** Creating request Parameters **/
    this.getManageParametersReciepts = function (eventyear, eventid) {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MyProfileServiceProvider";
            data.ServiceMethod = "GetAReceipt";
            data.Language = constants.englishLanguage;
            data.parametersArray = [eventyear, eventid, "BEE85C7A-7EC4-4253-A936-287D02B01BDA"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId = sessionData.emailId;
            userSession.Address1 = sessionData.address1;
            userSession.City = sessionData.city;
            userSession.Country = sessionData.country;
            userSession.UserName = applicationDataObj.getUsername();
            if (sessionData.ManagementAgency) {
                userSession.ManagementAgency = sessionData.ManagementAgency;
            }
            userSession.JoinedDate = sessionData.registeredDate;
            userSession.OnBehalfPlayerId = constants.onBehalfPlayerId;
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getManageParametersReciepts " + err);
        }
    };

    /** binding manage receipt body data **/
    this.bindManageReceiptDropdownResponse = function (response) {
        try {
            $('#myallRecieptContent').html('<div class="westernpanel"><div class="westernpanel1">' +
                    '<span class="westpad" id="country"></span></div>' +
                    '<span class="mobpad" id="city"></span>' +
                    '<div class="borderplayer"></div><div class="playertop">' +
                    '<span class="plyernamehead">Player Name</span></div><div class="playertop1">' +
                    '<span class="plyername" id="name"></span></div></div><div class="outerpaneldiv">' +
                    '<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 roundpanel"><div>' +
                    '<div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 padding-div dotwrapdiv">' +
                    '<span class="singlernd">Singles: Round Achieved </span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 margntp taxreceipt-nopadding total-deduction-width">' +
                    '<span class="entrydottot margin-dollar">$</span><span class="cinnpad" id="singlesPrize"></span>' +
                    '</div><div><p class="tbdwinner" id="singlesResult"></p></div></div><div>' +
                    '<div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 padding-div dotwrapdiv margintp0">' +
                    '<span class="singlernd">Doubles: Round Achieved </span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 taxreceipt-nopadding total-deduction-width">' +
                    '<span class="entrydot margin-dollar">$</span><span class="cinnpad" id="doublesPrize"></span>' +
                    '</div><div><span class="tbdwinner" id="doublesResult"></span></div></div>' +
                    '<div class="clearfix"></div></div>' +
                    '<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 playertopbg">' +
                    '<div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 padding-div widthdiv">' +
                    '<span class="tbdwinner">Subtotal</span>' +
                    '</div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 taxreceipt-nopadding total-deduction-width">' +
                    '<span class="dollarcaps1 margin-dollar">$</span><span class="subtotpad" id="totalMoney"></span>' +
                    '</div></div><div class="clearfix"></div></div><div class="outerpaneldiv">' +
                    '<div><div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 roundpanel1 padding-div">' +
                    '<div><div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 dotwrapdiv margin-bottom-taxreceipt">' +
                    '<span class="tbdwinner">Entry or Service Fee </span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 margntp taxreceipt-nopadding padding-right-prize-money total-deduction-width">' +
                    '<span class="entrydot margin-dollar">$</span><span class="cinnpad" id="serviceTax"></span>' +
                    '</div></div><div>' +
                    '<div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 dotwrapdiv margin-bottom-taxreceipt">' +
                    '<span class="tbdwinner">Total Tax</span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 margntp taxreceipt-nopadding padding-right-prize-money total-deduction-width">' +
                    '<span class="entrydottot margin-dollar">$</span><span class="cinnpad" id="totalTax"></span></div>' +
                    '</div><div><div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 dotwrapdiv margin-bottom-taxreceipt">' +
                    '<span class="tbdwinner">Advance(s)</span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 margntp taxreceipt-nopadding padding-right-prize-money total-deduction-width">' +
                    '<span class="entrydot margin-dollar">$</span>' +
                    '<span class="cinnpad" id="totalAdvances"></span></div><div class="clearfix"></div>' +
                    '</div><div><div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 dotwrapdiv margin-bottom-taxreceipt">' +
                    '<span class="tbdwinner">Fines</span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 margntp taxreceipt-nopadding padding-right-prize-money total-deduction-width">' +
                    '<span class="entrydot margin-dollar">$</span><span class="cinnpad" id="totalfine"></span>' +
                    '</div><div class="clearfix"></div></div><div>' +
                    '<div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 dotwrapdiv margin-bottom-taxreceipt">' +
                    '<span class="tbdwinner">Stringing</span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 margntp taxreceipt-nopadding padding-right-prize-money total-deduction-width">' +
                    '<span class="entrydot margin-dollar">$</span><span class="cinnpad" id="totalStrings"></span>' +
                    '</div><div class="clearfix"></div></div><div>' +
                    '<div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 dotwrapdiv margin-bottom-taxreceipt">' +
                    '<span class="tbdwinner">Laundry</span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 margntp taxreceipt-nopadding padding-right-prize-money total-deduction-width">' +
                    '<span class="entrydot margin-dollar">$</span><span class="cinnpad" id="totalLaundry"></span></div>' +
                    '<div class="clearfix"></div></div><div><div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 dotwrapdiv ">' +
                    '<span class="tbdwinner">Miscellaneous</span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 margntp taxreceipt-nopadding padding-right-prize-money total-deduction-width">' +
                    '<span class="entrydot margin-dollar">$</span>' +
                    '<span class="cinnpad" id="totalMiscellaneous"></span>' +
                    '</div><div class="clearfix"></div></div></div>' +
                    '<div class="clearfix"></div></div>' +
                    '<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 playertopbg">' +
                    '<div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 padding-div widthdiv">' +
                    '<span class="tbdwinner">Total Deductions</span></div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 taxreceipt-nopadding totaldiv padding-right-prize-money-zero-padding total-deduction-width">' +
                    '<span class="dollarcaps1 left-margin" >$</span>' +
                    '<span class="subtotpad" id="totalDeductions"></span></div></div><div class="clearfix"></div>' +
                    '</div><div class="clearfix"></div><div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 totalamount">' +
                    '<div class="col-lg-8 col-md-8 col-sm-8 col-xs-8 padding-div widthdiv">' +
                    '<span class="tbdwinner">Total Amount Due Player</span>' +
                    '</div>' +
                    '<div class="col-lg-4 col-md-4 col-sm-4 col-xs-4 taxreceipt-nopadding totaldiv padding-right-prize-money-zero-padding total-deduction-width">' +
                    '<span class="dollarcaps1 left-margin">$</span>' +
                    '<span class="subtotpad" id="totalAmountDuePlayer"></span>' +
                    '</div></div><div class="clearfix"></div>' +
                    '<div class="contentbdy">' + "Appropriate current or outstanding fines will be deducted. Membership fees may be deducted if so requested by the Player or automatically deducted if overdue." +
                    '</div><div class="borderbmtplayer"></div>' +
                    '<div class="reciptwinner padL0"><span class="tbdwinner">Date:</span>' +
                    '<span class="datepad" id="dateOfReciept"></span></div>');

            if ($("#selection :selected").text() == "SELECT AN EVENT") {
                $('#myallRecieptContent').html("");
            }
            if (response !== null && response !== undefined) {
                $('#country').html(response.EventDisplayName);
                $('#city').html(response.EventCity + "," + " " + response.EventCountry);
                $('#name').html(response.PlayerLastName + "," + " " + response.PlayerFirstName);
                $('#singlesResult').html(response.SglRoundReached);
                $('#doublesResult').html(response.DblRoundReached);
                $('#singlesPrize').html(response.SglPrizeMoney);
                $('#doublesPrize').html(response.DblPrizeMoney);
                $('#totalMoney').html(response.TotalPrizeMoney);
                $('#serviceTax').html(response.EntryServiceFee);
                $('#totalTax').html(response.TotalTax);
                $('#totalAdvances').html(response.TotalAdvances);
                $('#totalfine').html(response.TotalFines);
                $('#totalStrings').html(response.TotalStringing);
                $('#totalLaundry').html(response.TotalLaundry);
                $('#totalMiscellaneous').html(response.TotalMiscellaneous);
                $('#totalDeductions').html(response.TotalDeductions);
                $('#totalAmountDuePlayer').html(response.TotalAmountDuePlayer);
                $('#dateOfReciept').html(moment(response.ReceiptDate.substring(0, 10)).format('DD MMM YYYY'));

            }
            endLoading();

        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindManageReceiptDropdownResponse " + err);
        }
    };

    /*Ajax - Success Call back*/
    this.OnManageReceiptsSuccess = function (data) {
        try {
            var manageReceiptDropdownClassObj = new TaxesReceiptClass();
            manageReceiptDropdownClassObj.bindManageReceiptDropdownResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageReceiptsSuccess " + err);
        }
    };

    /*Ajax - Error Call back*/
    this.OnManageReceiptsError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageReceiptsError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageReceiptsError " + err);
        }
    };

    /** get Other Taxes data **/
    this.getManageTaxDetailsFromService = function () {
        try {
            var eventmanageidarray = [];
            var eventmanageyeararray = [];
            var apiservicecallsObj = new apiservicecalls();
            var url = constants.ajaxUrl;
            var inputData = this.getManageTaxDetails();
            apiservicecallsObj.postData(url, inputData, this.OnManageTaxSuccess, this.OnManageTaxError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getManageTaxDetailsFromService " + err);
        }
    };

    /** Creating request Parameters **/
    this.getManageTaxDetails = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MyProfileServiceProvider";
            data.ServiceMethod = "GetTaxDetails";
            data.Language = constants.englishLanguage;
            data.parametersArray = [$("#taxYear option:selected").text(), "3B242127-653D-481B-AD51-0EEEA1A080D1"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId = sessionData.emailId;
            userSession.Address1 = sessionData.address1;
            userSession.City = sessionData.city;
            userSession.Country = sessionData.country;
            userSession.UserName = applicationDataObj.getUsername();
            if (sessionData.ManagementAgency) {
                userSession.ManagementAgency = sessionData.ManagementAgency;
            }
            userSession.JoinedDate = sessionData.registeredDate;
            userSession.OnBehalfPlayerId = constants.onBehalfPlayerId;
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getManageTaxDetails " + err);
        }
    };

    /** binding Taxes body data **/
    this.bindTaxesOtherResponse = function (response) {
        try {
            if (response.EventName === null) {
                $('#taxFormPdf').html("");
            }
            else {
                $('#taxFormPdf').html('<div class="taxcontent"><div class="contentfont" >' +
                        '<img class="pdfwidth" src="images/pdf.svg" />' +
                        '<a href="#" class="taxtext" id="taxFormContent"></a>' +
                '</div></div>');
                $("#taxFormContent").html(response.EventName);
            }
            endLoading();

        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindTaxesOtherResponse " + err);
        }
    };

    /*Ajax - Success Call back*/
    this.OnManageTaxSuccess = function (data) {
        try {
            var otherTaxClassObj = new TaxesReceiptClass();
            otherTaxClassObj.bindTaxesOtherResponse(data);
            endLoading();
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageTaxSuccess " + err);
        }
    };

    /*Ajax - Error Call back*/
    this.OnManageTaxError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageTaxError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        }
        catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnManageTaxError " + err);
        }
    };

};

//initializing dropdowns
var receiptDropdownObj = new TaxesReceiptClass();
var initiateManageDropDownControls = function () {
    try {
        $('#selection').on('change', function (e) {
            receiptDropdownObj.receiptManageDropDownChange(e);
        });
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : initiateManageDropDownControls " + err);
    }
};

/**
 * initiateManageTaxYear
 */
var initiateManageTaxYear = function () {
    try {
        $('#taxYear').on('change', function (e) {
            receiptDropdownObj.getManageTaxDetailsFromService();
        });
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : initiateManageTaxYear " + err);
    }
};
