/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/* Pension class */

var PensionClass = function () {

    /** get pension data **/
    this.getPensionData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getPensionRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.onPensionSuccess, this.onPensionError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getPensionData " + err);
        }
    };

    /** binding Pension body data **/
    this.bindPensionResponse = function (response) {
        try {
            $("#pensioninfolabel").append(response.PensionInformationLabel);
            $("#currentbalancelabel").append(response.CurrentBalanceLabel);
            $("#beneficiarieslabel").append(response.BeneficiariesLabel);
            $("#yearofcreditlabel").append(response.YearOfCreditLabel);
            $("#vestedstatuslabel").append(response.VestedStatusLabel);
            $("#annualstatementlabel").append(response.AnnualStatementLabel);
            $("#pensionbodylabel").append(response.PensionBodyLabel);
            $("#gotopensionwebsite").click(function () {
                //openBrowser(response.PensionAccountLink.Url);
            window.open(response.PensionAccountLink.Url,"_system");
            });
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindPensionResponse " + err);
        }
    };

    /** Creating request Parameters **/
    this.getPensionRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession;
            data.Userid = sessionData.userId;
            data.ServiceProvider = "BenefitsServiceProvider";
            data.ServiceMethod = "GetPension";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["C7774333-6731-44A4-9035-AEE6817ABEFF"];
            userSession = {};
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getPensionRequestParameters " + err);
        }
    };

    /*Ajax - Success Call back*/
    this.onPensionSuccess = function (data) {
        try {
            var pensionClassObj = new PensionClass();
            pensionClassObj.bindPensionResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onPensionSuccess " + err);
        }
    };

    /*Ajax - Error Call back*/
    this.onPensionError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : onPensionError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onPensionError " + err);
        }
    };


    this.subHeaderPensionHide = function () {
        try {
            var role = "",
                lowerConvertedRole;
            if (applicationDataObj.getSessionResponse() && applicationDataObj.getSessionResponse().roles &&
                    applicationDataObj.getSessionResponse().roles.length !== 0) {
                role = applicationDataObj.getSessionResponse().roles[0];
            }
            if (role) {
                lowerConvertedRole = role.toLowerCase();
                if (lowerConvertedRole.indexOf("registered player") !== -1 && applicationDataObj.getpensionTrue) {
                    $(".playerbenefits").addClass("hide");
                    $(".pensionSubheader").removeClass("hide");
                    $("#leftarrow").hide();
                    $("#rightarrow").hide();
                } else {
                    $(".playerbenefits").removeClass("hide");
                    $(".pensionSubheader").addClass("hide");
                    subHeaderCarousel();
                    navigationArrowMenu();
                }
            }

        } catch (err) {
            console.log(err);
        }
    };
};


/** pension **/

var pension = function () {
    try {
        if(isApp){
            window.ga.trackView('Benefits Pension');
        }
        var pensionObj = new PensionClass();
        startLoading();
        headerMain();
        pensionObj.subHeaderPensionHide();
        pensionObj.getPensionData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : pension " + err);
    }
};
