/**
Clas Name       : ReceiptDetailsClass and TaxDetailsClass
Description     : details about recipt and taxes
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/


var initiateDropDownControls = function() {
	try{
		$('#selection').on('change', function (e){
            var receiptClassObj = new ReceiptDetailsClass();
            receiptClassObj.receiptDropDownChange(e);
        });
	}catch(err){
		loggerObj.logToServer(constants.logSeverityError,"Error : initiateDropDownControls " +err);
	}
};

var ReceiptDetailsClass = function () {
    
    //receiptDropDownChange
    this.receiptDropDownChange = function(e) {
        try {
            startLoading();
            var eventSelectedValue=$('select[name=eventName]').val();
            var eventyear = $('select#selection option:selected').attr("data-year");
            var eventid =  $('select#selection option:selected').attr("data-EventId");
            var apiservicecallsObj = new apiservicecalls();
            var url = constants.ajaxUrl;
            var inputData = this.getRequestParametersReciepts(eventyear,eventid);
            apiservicecallsObj.postData(url, inputData, this.OnReceiptsSuccess, this.OnReceiptsError);

        } catch(err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : receiptDropDownChange " +err);
        }
    };
    
    // OnReceiptsSuccess
    this.OnReceiptsSuccess = function (response) {
        try{
            $('#myallRecieptContent').html('<div id="pdf" style="background-color:#e1e1e1;"><div style="margin-top:20px;background-color: #fff;box-shadow: 0px 4px 4px rgba(0,0,0,0.4);height:auto;padding-left:10px;padding-right:10px;margin-bottom:15px;"><div style="padding-top:10px;">'+'<span style= "font-size: 18px; font-family: Roboto Condensed;font-weight: bold; color: black;" id="country"></span></div>'+
                    '<span style="font-size: 16px; font-family: Roboto Condensed;font-weight: normal; color: black;" id="city"></span>'+
                    '<div style = "border-bottom:1px solid #bbbbbb;padding-top:10px;"></div><div style= "padding-top:10px;">'+
                    '<span style ="font-size: 16px; font-family: Roboto Condensed;font-weight: normal; color: black;padding-top:10px;">Player Name</span></div><div style ="padding-bottom:20px;">'+
                    '<span style="font-size: 16px; font-family: Roboto Condensed;font-weight: bold; color: black;padding-top:10px;" id="name"></span></div></div><div style="background-color:#fff;box-shadow: 0px 4px 4px rgba(0,0,0,0.4);margin-top:20px;border:1px solid #f3f3f3;">'+
                    '<div style="height:auto;padding:0 10px 10px 10px;width: 100%;float: left;position: relative;min-height: 1px;"><div>'+
                    '<div style="position: relative;min-height: 1px;float: left;width: 66%;text-overflow: clip;white-space: nowrap;overflow: hidden;margin-top: 10px;padding: 0px !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;">Singles: Round Achieved </span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;margin-top:10px;padding-left:0px;padding-right:0px;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span><span style="float:right;" id="singlesPrize"></span>'+
                    '</div><div><p style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;" id="singlesResult"></p></div></div><div>'+
                    '<div style="position: relative;min-height: 1px;float: left;padding:0px!important;width:66%;text-overflow:clip;white-space:nowrap;overflow: hidden;margin-top:10px;margin-top:0px!important;">'+
                    '<span styel="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;">Doubles: Round Achieved </span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;padding-left:0px;padding-right:0px; width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span><span style="float:right;" id="doublesPrize"></span>'+
                    '</div><div><span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;" id="doublesResult"></span></div></div>'+
                    '<div style="clear:both;box-sizing: border-box;"></div></div>'+
                    '<div style="width: 100%;position: relative;min-height: 1px;float: left;padding-top:10px;padding-bottom:10px;background-color: #eeeeee;padding-left:10px;padding-right:10px;    border-top: 1px solid #dcdcdc; ">'+
                    '<div style="position: relative;min-height: 1px;float: left;padding:0px!important;width:66%;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;">Subtotal</span>'+
                    '</div>'+
                    '<div style="position: relative;min-height: 1px;float: left;padding-left:0px;padding-right:0px;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;margin-left:-25px !important;">$</span><span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;float:right;" id="totalMoney"></span>'+
                    '</div></div><div style="clear:both;box-sizing: border-box;"></div></div><div style="background-color:#fff;box-shadow: 0px 4px 4px rgba(0,0,0,0.4);margin-top:20px;border:1px solid #f3f3f3;">'+
                    '<div><div style="width: 100%;position: relative;min-height: 1px;float: left;height:auto;margin-bottom:10px;padding:0px!important;">'+
                    '<div><div style="position: relative;min-height: 1px;float: left;width:66%;text-overflow:clip;white-space:nowrap;overflow: hidden;margin-top:10px;margin-bottom:5px;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;padding-left:10px">Entry or Service Fee </span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;margin-top:10px;padding-left:0px;padding-right:0px;padding-right:8px !important;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span><span style="float:right;" id="serviceTax"></span>'+
                    '</div></div><div>'+
                    '<div style="position: relative;min-height: 1px;float: left;width:66%;text-overflow:clip;white-space:nowrap;overflow: hidden;margin-top:10px;margin-bottom:5px;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;padding-left:10px">Total Tax</span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;margin-top:10px;padding-left:0px;padding-right:0px;padding-right:8px !important;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span><span style="float:right;" id="totalTax"></span></div>'+
                    '</div><div><div style="position: relative;min-height: 1px;float: left;width:66%;text-overflow:clip;white-space:nowrap;overflow: hidden;margin-top:10px;margin-bottom:5px;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;padding-left:10px">Advance(s)</span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;margin-top:10px;padding-left:0px;padding-right:0px;padding-right:8px !important;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span>'+
                    '<span style="float:right;" id="totalAdvances"></span></div><div style="clear:both;box-sizing: border-box;"></div>'+
                    '</div><div><div style="position: relative;min-height: 1px;float: left;width:66%;text-overflow:clip;white-space:nowrap;overflow: hidden;margin-top:10px;margin-bottom:5px;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;padding-left:10px">Fines</span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;margin-top:10px;padding-left:0px;padding-right:0px;padding-right: 8px !important;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span><span style="float:right;" id="totalfine"></span>'+
                    '</div><div style="clear:both;box-sizing: border-box;"></div></div><div>'+
                    '<div style="position: relative;min-height: 1px;float: left;width:66%;text-overflow:clip;white-space:nowrap;overflow: hidden;margin-top:10px;margin-bottom:5px;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;padding-left:10px">Stringing</span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;margin-top:10px;padding-left:0px;padding-right:0px;padding-right:8px !important;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span><span style="float:right;" id="totalStrings"></span>'+
                    '</div><div style="clear:both;box-sizing: border-box;"></div></div><div>'+
                    '<div style="position: relative;min-height: 1px;float: left;width:66%;text-overflow:clip;white-space:nowrap;overflow: hidden;margin-top:10px;margin-bottom:5px;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;padding-left:10px">Laundry</span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;margin-top:10px;padding-left:0px;padding-right:0px;padding-right:8px !important;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span><span style="float:right;" id="totalLaundry"></span></div>'+
                    '<div style="clear:both;box-sizing: border-box;"></div></div><div><div style="position: relative;min-height: 1px;float: left;width:66%;text-overflow:clip;white-space:nowrap;overflow: hidden;margin-top:10px;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;padding-left:10px">Miscellaneous</span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;margin-top:10px;padding-left:0px;padding-right:0px;padding-right:8px !important; width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;margin-left:-25px !important;">$</span>'+
                    '<span style="float:right;" id="totalMiscellaneous"></span>'+
                    '</div><div style="clear:both;box-sizing: border-box;"></div></div></div>'+
                    '<div style="clear:both;box-sizing: border-box;"></div></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;width:100%;padding-top:10px;padding-bottom:10px;background-color: #eeeeee;padding-left:10px;padding-right:10px;border-top: 1px solid #dcdcdc;">'+
                    '<div style="position: relative;min-height: 1px;float: left;padding:0px!important;width:66%;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;">Total Deductions</span></div>'+
                    '<div style="position: relative;min-height: 1px;float: left;padding-left:0px;padding-right:0px;float:right; padding-right:0px !important;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;margin-left:-24px !important;">$</span>'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;float:right;" id="totalDeductions"></span></div></div><div style="clear:both;box-sizing: border-box;"></div>'+
                    '</div><div style="clear:both;box-sizing: border-box;"></div><div style="position: relative;min-height: 1px;float: left;width:100%;margin-top:20px;height:40px;padding-top:9px;background-color: #effaff;padding-left:10px;padding-right:10px; box-shadow: 0px 4px 4px rgba(0,0,0,0.4);">'+
                    '<div style="padding:0px!important;width:66%;position: relative;min-height: 1px;float: left;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;">Total Amount Due Player</span>'+
                    '</div>'+
                    '<div style="position: relative;min-height: 1px;float: left;padding-left:0px;padding-right:0px;float:right;padding-right:0px !important;width:34% !important;">'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;margin-left:-24px !important;">$</span>'+
                    '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;float:right;" id="totalAmountDuePlayer"></span>'+
                    '</div></div><div style="clear:both;box-sizing: border-box;"></div>'+
                    '<div style="font-size: 14px; font-family: Helvetica;font-weight: normal; color:#777777;margin-top:20px;padding-left:0px!important;padding-right:0px!important;">'+"Appropriate current or outstanding fines will be deducted. Membership fees may be deducted if so requested by the Player or automatically deducted if overdue."+
                    '</div><div style="border-bottom:2px solid #b2b2b2;padding-top:15px;"></div>'+
                    '<div style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;padding:10px 0px;padding-left: 0px !important;"><span style="font-size: 14px; font-family: Roboto Condensed;font-weight: bold; color: black;">Date:</span>'+
            '<span style="font-size: 14px; font-family: Roboto Condensed;font-weight: normal; color: black;padding-left:5px;" id="dateOfReciept"></span></div></div>');

            if($("#selection :selected").text()=="SELECT AN EVENT"){
                $('#myallRecieptContent').html("");
            }
            if(response !== null && response !== undefined ){
            	$('#country').html(response.EventDisplayName);    
            	$('#city').html(response.EventCity +"," + " " + response.EventCountry);
            	$('#name').html(response.PlayerLastName+ "," + " " + response.PlayerFirstName);
            	if(response.SglRoundReached){
            		$('#singlesResult').html(response.SglRoundReached);
            	}
            	if(response.DblRoundReached){
            		$('#doublesResult').html(response.DblRoundReached);
            	}
            	if(response.SglPrizeMoney !== ""){
            		$('#singlesPrize').html((response.SglPrizeMoney.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.DblPrizeMoney !== ""){
            		$('#doublesPrize').html((response.DblPrizeMoney.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalPrizeMoney !== ""){
            		$('#totalMoney').html((response.TotalPrizeMoney.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.EntryServiceFee !== ""){
            		$('#serviceTax').html((response.EntryServiceFee.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalTax !== ""){
            		$('#totalTax').html((response.TotalTax.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalAdvances !== ""){
            		$('#totalAdvances').html((response.TotalAdvances.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalFines !== ""){
            		$('#totalfine').html((response.TotalFines.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalStringing !== ""){
            		$('#totalStrings').html((response.TotalStringing.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalLaundry !== ""){
            		$('#totalLaundry').html((response.TotalLaundry.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalMiscellaneous !== ""){
            		$('#totalMiscellaneous').html((response.TotalMiscellaneous.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalDeductions !== ""){
            		$('#totalDeductions').html((response.TotalDeductions.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	if(response.TotalAmountDuePlayer !== ""){
            		$('#totalAmountDuePlayer').html((response.TotalAmountDuePlayer.toFixed(2) + "").replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,"));
            	}
            	$('#dateOfReciept').html(moment(response.ReceiptDate.substring(0,10)).format('DD MMM YYYY'));   

            }
            endLoading();
        }catch(err){
            loggerObj.logToServer(constants.logSeverityError,"Error : OnReceiptsSuccesr " +err);
        }
    };
    
    //OnReceipt Error
    this.OnReceiptsError = function (jqXHR,error) {
        try{
            endLoading();
            var errMsg = "";
            if(jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized" ){
                errMsg = "Error : OnReceiptsError " +jqXHR.statusText;
            }
            else if (jqXHR.statusText === "timeout" && jqXHR.status === 0){
                timoutErrorStatus = true;
                errMsg = "Error : OnReceiptsError " +jqXHR.statusText;
            } 
            else if (jqXHR.status === 0){
                timoutErrorStatus = true;
                errMsg = "Error : OnReceiptsError Unexpected Error with status Code 0";
            } 
            else {
                timoutErrorStatus = true;
                errMsg = "Error : OnReceiptsError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError,errMsg);
            logout();
        } 
        catch(err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : OnReceiptsError " +err);
        }
    };
    
    //getRequestParametersReciepts
    this.getRequestParametersReciepts = function (eventyear,eventid) {
        try{
            var sessionData = applicationDataObj.getSessionResponse();
            var data = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MyProfileServiceProvider";
            data.ServiceMethod = "GetAReceipt";
            data.Language = constants.englishLanguage;
            data.parametersArray = [eventyear, eventid, "BEE85C7A-7EC4-4253-A936-287D02B01BDA"];
            var userSession = {};
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId=sessionData.emailId;
            userSession.Address1=sessionData.address1;
            userSession.City=sessionData.city;
            userSession.Country=sessionData.country;
            userSession.UserName=applicationDataObj.getUsername();
            data.SessionData = userSession;
            var inputData = JSON.stringify(data);
            return inputData;
        }catch(err){
            loggerObj.logToServer(constants.logSeverityError,"Error : getRequestParametersReciepts " +err);
        }
    };
};

//initiateTaxYear
var initiateTaxYear = function () {
    try{
       /* $('#taxYear').on('change', function (e){
            var taxdetailsObj = new TaxDetailsClass();
            taxdetailsObj.getTaxDetailsFromService();
        });*/
    }catch(err) {
        loggerObj.logToServer(constants.logSeverityError,"Error : initiateTaxYear " +err);
    }
};

//Tax Details class
var TaxDetailsClass = function () {
    
    //get Tax Details from service
    this.getTaxDetailsFromService = function () {
        try{
            var apiservicecallsObj = new apiservicecalls();
            var url = constants.ajaxUrl;
            var sessionData = applicationDataObj.getSessionResponse();
            var inputData = this.getTaxDetails(sessionData);
            apiservicecallsObj.postData(url, inputData, this.OnTaxSuccess, this.OnTaxError);
        }catch(err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : getTaxDetailsFromService " +err);
        }
    };
    
    //Ajax success taxes
    this.OnTaxSuccess = function (response) {
        try{
            
            if(response.Details.length === 0){
                $('#taxFormPdf').html("");
            }
            else{
                for(i =0 ; i < response.Details.length ; i++) {
                    $('#taxFormPdf').html('<tr><th><a id="Tax' + i + '" onclick = "showTaxPdf(' + response.Details[i].EventId + ');"><span><img class="pdfwidth" src="images/pdf.svg" /></span><span class="plyrwkly-pdflinktext">' + response.Details[i].EventName + '</span></a></th></tr>');
                    
                   /* $("#Tax" +i ).on('click', function() {
                        var apiservicecallsObj = new apiservicecalls();
                        var url = constants.ajaxUrl;
                        var sessionData = applicationDataObj.getSessionResponse();
                        var inputData = getTaxPdfDetails(sessionData,response.Details[0].EventId);
                        apiservicecallsObj.postData(url, inputData, OnTaxPdfSuccess, OnTaxPdfError);
                    });*/
                    
                 }
                
                 
                  /*$('#taxFormPdf').html('<div class="taxcontent"><div class="contentfont" >'+
                        '<img class="pdfwidth" src="images/pdf.svg" />'+
                        '<a href="#" class="taxtext" id="taxFormContent"></a>'+
                    '</div></div>');*/
                
                /*for(i =0 ; i < response.Details.length ; i++) {
                  
                    $("#taxFormContent").html(response.Details[i].EventName);
                }*/
                
            }
                
            endLoading();
        }catch(err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : OnTaxSuccess " +err);
        }
    };
    
    $('#taxFormContent').on('click',function() {
        
    });
    //Ajax error taxes
    this.OnTaxError = function (jqXHR,error) {
        try{
            endLoading();
            var errMsg = "";
            if(jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized" ){
                errMsg = "Error : OnTaxError " +jqXHR.statusText;
            }
            else if (jqXHR.statusText === "timeout" && jqXHR.status === 0){
                timoutErrorStatus = true;
                errMsg = "Error : OnTaxError " +jqXHR.statusText;
            } 
            else if (jqXHR.status === 0){
                timoutErrorStatus = true;
                errMsg = "Error : OnTaxError Unexpected Error with status Code 0";
            } 
            else {
                timoutErrorStatus = true;
                errMsg = "Error : OnTaxError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError,errMsg);
            logout();
        } 
        catch(err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : OnTaxError " +err);
        }
    };
    
    //getTaxDetails
    this.getTaxDetails = function (sessionData) {
        try{
            var data = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MyProfileServiceProvider";
            data.ServiceMethod = "GetTaxDetails";
            data.Language = constants.englishLanguage;
            data.parametersArray = [$("#taxYear option:selected").text(), "3B242127-653D-481B-AD51-0EEEA1A080D1"];
            var userSession = {};
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId=sessionData.emailId;
            userSession.Address1=sessionData.address1;
            userSession.City=sessionData.city;
            userSession.Country=sessionData.country;
            userSession.UserName=applicationDataObj.getUsername();
            data.SessionData = userSession;
            var inputData = JSON.stringify(data);
            return inputData;
        }catch(err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : getTaxDetails " +err);
        }
    };
};

  //getTaxDetails
    getTaxPdfDetails = function (sessionData,eventId) {
        try{
            var data = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MyProfileServiceProvider";
            data.ServiceMethod = "GetTaxPDFContent";
            data.Language = constants.englishLanguage;
            data.parametersArray = [$("#taxYear option:selected").text(),eventId, "3B242127-653D-481B-AD51-0EEEA1A080D1"];
            var userSession = {};
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId=sessionData.emailId;
            userSession.Address1=sessionData.address1;
            userSession.City=sessionData.city;
            userSession.Country=sessionData.country;
            userSession.UserName=applicationDataObj.getUsername();
            data.SessionData = userSession;
            var inputData = JSON.stringify(data);
            return inputData;
        }catch(err) {
            loggerObj.logToServer(constants.logSeverityError,"Error : getTaxDetails " +err);
        }
    };

OnTaxPdfSuccess = function (response) {
    var pdfAsDataUri = "data:application/pdf;base64,"+response;
    window.open(pdfAsDataUri,"_system");
    endLoading();
};

OnTaxPdfError = function (jqXHR,error) {
    console.log(jqXHR);
};

showTaxPdf = function (event) {
    var apiservicecallsObj = new apiservicecalls();
    var url = constants.ajaxUrl;
    var sessionData = applicationDataObj.getSessionResponse();
    var inputData = getTaxPdfDetails(sessionData,event);
    apiservicecallsObj.postData(url, inputData, OnTaxPdfSuccess, OnTaxPdfError);
}

var openWebsite = function () {
    window.open(envUrl,"_system");
};

// Remember to execute this after the onDeviceReady event

// To define the type of the Blob
var contentType = "application/pdf";
// if cordova.file is not available use instead :
var folderpath = "file:///storage/emulated/0/";
var filename = "MyPrizeMoney.pdf";
     
var generatePdf = function () {
    var htmlapplied = $('#pdf').html();
/*     var doc = new jsPDF('p','pt','a4');
         margins = {
        top: 40,
        bottom: 40,
        left: 40,
        right: 40,
        width: 522
    };
    
     doc.addHTML($('#pdf').get(0),{pagesplit:true},function() {
	     doc.save('MyPrizeMoney.pdf');
              });*/
        pdf.htmlToPDF({
            data:htmlapplied,
            documentSize: "A4",
            landscape: "portrait",
            type: "base64"
        }, this.success, this.failure);
     };
     
     this.success = function (data) {
         savebase64AsPDF(folderpath,filename,data,contentType);
     };
     
     this.error = function (error) {
         console.log(error);
     }
 



/**
 * Convert a base64 string in a Blob according to the data and contentType.
 * 
 * @param b64Data {String} Pure base64 string without contentType
 * @param contentType {String} the content type of the file i.e (application/pdf - text/plain)
 * @param sliceSize {Int} SliceSize to process the byteCharacters
 * @see http://stackoverflow.com/questions/16245767/creating-a-blob-from-a-base64-string-in-javascript
 * @return Blob
 */
function b64toBlob(b64Data, contentType, sliceSize) {
        contentType = contentType || '';
        sliceSize = sliceSize || 512;

        var byteCharacters = window.atob(b64Data);
        var byteArrays = [];

        for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
            var slice = byteCharacters.slice(offset, offset + sliceSize);

            var byteNumbers = new Array(slice.length);
            for (var i = 0; i < slice.length; i++) {
                byteNumbers[i] = slice.charCodeAt(i);
            }

            var byteArray = new Uint8Array(byteNumbers);

            byteArrays.push(byteArray);
        }

      var blob = new Blob(byteArrays, {type: contentType});
      return blob;
}

/**
 * Create a PDF file according to its database64 content only.
 * 
 * @param folderpath {String} The folder where the file will be created
 * @param filename {String} The name of the file that will be created
 * @param content {Base64 String} Important : The content can't contain the following string (data:application/pdf;base64). Only the base64 string is expected.
 */
function savebase64AsPDF(folderpath,filename,content,contentType) {
    // Convert the base64 string in a Blob
    var DataBlob = b64toBlob(content,contentType);
    
    console.log("Starting to write the file :3");
    if (deviceOS === "android") {
        window.resolveLocalFileSystemURL(folderpath, function(dir) {
            console.log("Access to the directory granted succesfully");
            dir.getFile(filename, {create:true}, function(file) {
                $.confirm({
                    title: 'Alert !',
                    content: 'File Created Successfully',
                    buttons: {
                        Ok: function () {
                            //Logout
                        }
                    }
                });
                file.createWriter(function(fileWriter) {
                    console.log("Writing content to file");
                    fileWriter.write(DataBlob);
                }, function(){
                    alert('Unable to save file in path '+ folderpath);
                });
            });
        });
    }
    
    if (deviceOS === "ios") {
        window.resolveLocalFileSystemURL(cordova.file.documentsDirectory, function(dir) {
            console.log("Access to the directory granted succesfully");
            dir.getFile(filename, {create:true}, function(file) {
                $.confirm({
                    title: 'Alert !',
                    content: 'File Created Successfully',
                    buttons: {
                        Ok: function () {
                            //Logout
                        }
                    }
                });
                file.createWriter(function(fileWriter) {
                    console.log("Writing content to file");
                    fileWriter.write(DataBlob);
                }, function(){
                    alert('Unable to save file in path '+ cordova.file.dataDirectory);
                });
            });
        });
    }

}