/**
Clas Name       : PushNotificationClass
Description     : Push Notification for iOS and Android
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/

//push notification 
var PushNotificationClass = function () {
    var apiservicecallsObj = new Apiservicecalls();
    this.registerNotification = function () {
        // save this server-side and use it to push notifications to this device
        try {
            if (pushToken !== null) {
            //Register Token for Push notification
                var data = {},
                    parametersArray = [],
                    sessionObj = {},
                    userSession = applicationDataObj.getSessionResponse();
                data.UserId = applicationDataObj.getUserId();
                data.ServiceProvider = "RegistrationServiceProvider";
                data.ServiceMethod = "RegisterDeviceForPushNotifications";
                data.Language = constants.englishLanguage;
                parametersArray.push(applicationDataObj.getUserId());
                parametersArray.push(pushToken);
                parametersArray.push(device.uuid);
                parametersArray.push(cordova.platformId);
                parametersArray.push("120E7750-E5FF-4519-8AAA-17FEA73FF18E");
                data.parametersArray = parametersArray;
                sessionObj.PlayerId = userSession.playerId;
                sessionObj.UserId = userSession.userId;
                sessionObj.FirstName = userSession.firstName;
                sessionObj.LastName = userSession.lastName;
                sessionObj.Roles = userSession.roles;
                sessionObj.TOKEN = applicationDataObj.getToken();
                sessionObj.UserName = applicationDataObj.getUsername();
                sessionObj.EmailId = userSession.emailId;
                sessionObj.Address1 = userSession.address1;
                sessionObj.City = userSession.city;
                sessionObj.Country = userSession.country;
                data.SessionData = sessionObj;
                data = JSON.stringify(data);
                apiservicecallsObj.postData(constants.ajaxUrl, data, onSuccessRegPushNot, onErrorRegPushNot);
                
                /*$.ajax({
                    type: "POST",
                    url: constants.ajaxUrl,
                    data: data,
                    contentType: "application/json",
                    processData: false,
                    headers: {
                        "Content-Type": "application/json",
                        "Authorization" : "Bearer " + applicationDataObj.getToken()
                    },
                    timeout: 60000,
                    success: this.onSuccessRegPushNot,
                    error: this.onErrorRegPushNot,
                    async: true
                });*/
            } else {
                loggerObj.logToServer(constants.logSeverityError, "Error : Invalid Push Notification Token");
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : RegisterDeviceForPushNotifications" + err);
        }
    };
};

var onSuccessRegPushNot = function (response) {
    if (response) {
        if (window.localStorage.getItem("PushNotification") === null) {
            //No device is registered till now
            window.localStorage.setItem("PushNotification", "true");
            window.localStorage.setItem("UserId", applicationDataObj.getUserId());
            window.localStorage.setItem("PushToken", pushToken);
        } else {
            window.localStorage.setItem("UserId", applicationDataObj.getUserId());
            window.localStorage.setItem("PushToken", pushToken);
        }
    }
};

var onErrorRegPushNot = function (jqXHR) {
    console.log("onErrorRegPushNot : " + jqXHR);
};