/**
Clas Name           : TripwareClass
Description         : Calling this function for tripware validation from login
Ownership Info      : This software is the confidential and proprietary information of ATP and may not be used, reproduced,                         modified, distributed, publicly displayed or otherwise disclosed without the express written consent of                         ATP. 
*/
var diffDays;
var TripwareClass = function () {
    //calling tripwire validation function
    
    this.tripwareValidation = function () {
        try {
            var sessionResponse = applicationDataObj.getSessionResponse();
                user_roles = sessionResponse.roles[0];
            var ExpiredDueSubstring,ExpiredDueGracePeriod,PhysicalExaminationExpirySubstring;
            var user_rolesSubstring = user_roles.substring(0,10),
                token_Response = applicationDataObj.getTokenResponse(),
                ExpiredDue = token_Response.tipp_expiration_message_for_membership_fees_due,
                ExpiredDueGracePeriod = token_Response.tipp_membership_fees_due_message;
                if(token_Response.tipp_expiration_message_for_membership_fees_due) {
                    ExpiredDueSubstring = ExpiredDue.replace('{0}',user_rolesSubstring);
                }
                if(token_Response.tipp_membership_fees_due_message) {
                    ExpiredDueGracePeriod = ExpiredDueGracePeriod.replace('{0}',user_rolesSubstring);
                }
            var PhysicalExaminationExpiry = token_Response.tipp_remaining_days_for_physical_examination_message;
                if(token_Response.tipp_remaining_days_for_physical_examination_message) {
                    PhysicalExaminationExpirySubstring = PhysicalExaminationExpiry.replace('{0}',sessionResponse.daysRemaining);
                }
                
                if(sessionResponse.isTermsandConditions_Accepted !== null) {
                    var date1 = new Date(sessionResponse.isTermsandConditions_Accepted),
                        d = new Date(date1),
                        date2 = new Date(),
                        timeDiff = Math.abs(date2.getTime() - date1.getTime());
                    diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));
                }
                if (sessionResponse.roles[0] === "ATP Staff" || sessionResponse.roles[0] === "Other") {
                    StaffandOthers(); 
                } else {
                    if (sessionResponse.isRegistrationFeePaid === true) {
                        if (sessionResponse.roles[0] === "Division I Player" || sessionResponse.roles[0] === "Division II Player" || sessionResponse.roles[0] === "Registered Player") {
                            if (sessionResponse.isTIUCompleted === true) {
                                if (sessionResponse.roles[0] === "Division I Player" || sessionResponse.roles[0] === "Division II Player") {
                                    if (sessionResponse.isPhysicalExaminationExpired === null) {
                                        DivisonAndRegistration();
                                    } else if(sessionResponse.isPhysicalExaminationExpired === true) {
                                        endLoading();
                                        clearTimeout(popupTimer);
                                        clearTimeout(tokenTimer);
                                        $.confirm({
                                            title: token_Response.tipp_mandatory_physical_title,
                                            content: token_Response.tipp_expiration_message_for_physical_examination,
                                            buttons: {
                                                Ok : function () {
                                                    $("#login-username-field").val("");
                                                    $("#login-password").val("");
                                                    logout();
                                                }
                                            }
                                        });
                                    } else if(sessionResponse.isPhysicalExaminationExpired === false) {
                                        endLoading();
                                        clearTimeout(popupTimer);
                                        clearTimeout(tokenTimer);
                                        $.confirm({
                                            title: token_Response.tipp_mandatory_physical_title,
                                            content: PhysicalExaminationExpirySubstring,
                                            buttons: {
                                                Ok : function () {
                                                    //open the tipp url
                                                   logintohomepage();
                                                }
                                            }
                                        });
                                    }
                                } else {
                                    DivisonAndRegistration();
                                }
                            } else {
                                endLoading();
                                clearTimeout(popupTimer);
                                clearTimeout(tokenTimer);
                                $.confirm({
                                    title: token_Response.tipp_tipprequirement_title,
                                    content: token_Response.tipp_incomplete_tipp_message,
                                    buttons: {
                                        success : {
                                            text: token_Response.tipp_goto_website_button_text,
                                            action: function(){
                                                myPlayerZoneFunc();
                                                logout();
                                            }
                                        },
                                        error : {
                                            text: token_Response.tipp_cancel_button_text,
                                            action: function(){
                                                console.log("Clicked Cancel");
                                                logout();
                                            }
                                        }
                                    }
                                });
                            }
                        } else {
                            StaffandOthers();
                        }
                    } else {
                        if(sessionResponse.CanSkipPayment === true) {
                            endLoading();
                            $.confirm({
                                title: token_Response.dues_payment_title,
                                content: ExpiredDueGracePeriod,
                                buttons: {
                                    success : {
                                        text: token_Response.tipp_goto_website_button_text,
                                        action: function(){
                                            myPlayerZoneFunc();
                                            logout();
                                        }
                                    },
                                    error : {
                                        text: token_Response.tipp_cancel_button_text,
                                        action: function() {
                                            if (sessionResponse.isTIUCompleted === true) {
                                                if (sessionResponse.roles[0] === "Division I Player" || sessionResponse.roles[0] === "Division II Player" || 
                                                    sessionResponse.roles[0] === "Registered Player") {
                                                    if (sessionResponse.roles[0] === "Division I Player" || 
                                                        sessionResponse.roles[0] === "Division II Player") {
                                                        if (sessionResponse.isPhysicalExaminationExpired === null) {
                                                            DivisonAndRegistration();
                                                        } else if(sessionResponse.isPhysicalExaminationExpired === true) {
                                                            endLoading();
                                                            clearTimeout(popupTimer);
                                                            clearTimeout(tokenTimer);
                                                            $.confirm({
                                                                title: token_Response.tipp_mandatory_physical_title,
                                                                content: token_Response.tipp_expiration_message_for_physical_examination,
                                                                buttons: {
                                                                    Ok : function () {
                                                                        $("#login-username-field").val("");
                                                                        $("#login-password").val("");
                                                                        logout();
                                                                    }
                                                                }
                                                            });
                                                        } else if(sessionResponse.isPhysicalExaminationExpired === false) {
                                                            endLoading();
                                                            clearTimeout(popupTimer);
                                                            clearTimeout(tokenTimer);
                                                            $.confirm({
                                                                title: token_Response.tipp_mandatory_physical_title,
                                                                content: PhysicalExaminationExpirySubstring,
                                                                buttons: {
                                                                    Ok : function () {
                                                                        //open the tipp url
                                                                       logintohomepage();
                                                                    }
                                                                }
                                                            });
                                                        }
                                                    } else {
                                                        DivisonAndRegistration();
                                                    }
                                                } else {
                                                    StaffandOthers();
                                                }
                                            } else {
                                                endLoading();
                                                clearTimeout(popupTimer);
                                                clearTimeout(tokenTimer);
                                                $.confirm({
                                                    title: token_Response.tipp_tipprequirement_title,
                                                    content: token_Response.tipp_incomplete_tipp_message,
                                                    buttons: {
                                                        success : {
                                                            text: token_Response.tipp_goto_website_button_text,
                                                            action: function(){
                                                                myPlayerZoneFunc();
                                                                logout();
                                                            }
                                                        },
                                                        error : {
                                                            text: token_Response.tipp_cancel_button_text,
                                                            action: function(){
                                                                console.log("Clicked Cancel");
                                                                logout();
                                                            }
                                                        }
                                                    }
                                                });
                                            }
                                        }
                                    }
                                }
                            });
                        } else {
                            endLoading();
                            clearTimeout(popupTimer);
                            clearTimeout(tokenTimer);
                            $.confirm({
                                title: token_Response.dues_payment_title,
                                content: ExpiredDueSubstring,
                                buttons: {
                                    success : {
                                        text: token_Response.tipp_goto_website_button_text,
                                        action: function(){
                                            myPlayerZoneFunc();
                                            logout();
                                        }
                                    },
                                    error : {
                                        text: token_Response.tipp_cancel_button_text,
                                        action: function(){
                                            console.log("Clicked Cancel");
                                            logout();
                                        }
                                    }
                                }
                            });
                        }
                    }
                }
            } catch (err) {
                loggerObj.logToServer(constants.logSeverityError, "tripwarevalidation" + err);
            }
        };
    
    //getStep2Registration Ajax call
    this.getStep2RegistrationAjax = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = this.getStep2RegSessionData(sessionData);
            startLoading();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.getStep2RegistrationOnSuccess, this.getStep2RegistrationOnError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getStep2RegistrationAjax " + err);
        }
        
    };
    
    //calling getstep2Registration parameters
    this.getStep2RegSessionData = function (sessionData) {
        try {
            var data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "RegistrationServiceProvider";
            data.ServiceMethod = "GetStep2Registration";
            data.Language = constants.englishLanguage;
            data.parametersArray = [sessionData.playerId, "D86E5E83-2ADE-4AE4-ADA0-25B47A10580C"];
            
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId = sessionData.emailId;
            userSession.Address1 = sessionData.address1;
            userSession.City = sessionData.city;
            userSession.Country = sessionData.country;
            userSession.UserName = applicationDataObj.getUsername();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getStep2RegSessionData " + err);
        }
        
    };
    
    //Ajax getStep2Registration success call
    this.getStep2RegistrationOnSuccess = function (response) {
        try {
            $('.registration-stage2').html(response.Title);
            $('#registertaionAlert').html(response.LabelText);
            $('#registrationBody').html(response.Summary);
            $('.reg-steps-text1').html(response.BioStageText);
            $('.reg-steps-text2').html(response.FinancialStageText);
            $('.please-note-text').html(response.Notetext);
            $('#homepagebutton').html(response.HomeButtonText);
            $('#continueregistration').html(response.ContinueButtonText);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getStep2RegistrationOnSuccess " + err);
        }
    };

    //Ajax getStep2Registration error call 
    this.getStep2RegistrationOnError = function (jqXHR, error) {
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : getStep2RegistrationOnError" + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                errMsg = "Error : getStep2RegistrationOnError" + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                errMsg = "Error : getStep2RegistrationOnError Unexpected Error";
            } else {
                errMsg = "Error : getStep2RegistrationOnError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            logout();
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getStep2RegistrationOnError" + err);
        }
    };
    
    // Ajax call for getting terms and condition text values
    this.getTermsandConditionsAjaxCall = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = this.getTermsandCondSessData(sessionData);
            startLoading();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.getTermsandConditionsSuccess, this.getTermsandConditionsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getTermsandConditionsAjaxCall " + err);
        }
    };
    
    //Terms and Condition Success
    this.getTermsandConditionsSuccess = function (response) {
        $(".terms-conditions-heading").append(response.Title);
        $(".registration-para-div2").append(response.Description);
        $(".resgistration-para").append(response.AlertText);
        endLoading();
    };
    
    //Terms and Condition Failure
    this.getTermsandConditionsError = function (jqXHR, error) {
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : getTermsandConditionsError" + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                errMsg = "Error : getTermsandConditionsError" + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                errMsg = "Error : getTermsandConditionsError Unexpected Error";
            } else {
                errMsg = "Error : getTermsandConditionsError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            logout();
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getTermsandConditionsError" + err);
        }
    };
    
    //Create request parameters for get terms and condition
    this.getTermsandCondSessData = function (sessionData) {
        try {
            var data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "RegistrationServiceProvider";
            data.ServiceMethod = "GetTermsandConditions";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["32EB125C-E14A-48FA-AE69-288CDA7ECD6F"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId = sessionData.emailId;
            userSession.Address1 = sessionData.address1;
            userSession.City = sessionData.city;
            userSession.Country = sessionData.country;
            userSession.UserName = applicationDataObj.getUsername();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getTermsandCondSessData " + err);
        }
    };
    
    //Ajax call for accept terms and condition text values
    this.acceptTermsandConditionsAjaxCall = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = this.acceptTermsandConditions(sessionData);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.acceptTermsandConditionsSuccess, this.acceptTermsandConditionsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "acceptTermsandConditionsAjaxCall " + err);
        }
    };

    //Ajax call for Terms and Conditons Success
    this.acceptTermsandConditionsSuccess = function (response) {
        try {
            var sessionResponse = applicationDataObj.getSessionResponse();
            if (response.isSuccess === true) {
                if (sessionResponse.roles[0] === "ATP Staff" || sessionResponse.roles[0] === "Other") {
                   afterTermsStaffandOthers();
                } else {
                    if (sessionResponse.roles[0] === "Division I Player" || sessionResponse.roles[0] === "Division II Player"   || sessionResponse.roles[0] === "Registered Player") {
                        if(sessionResponse.isPasswordReset === true) {
                            if (sessionResponse.isPasswordChangedBasedOnDays === false) {
                                if (sessionResponse.isstage2RegistrationCompleted === true) {
                                    if(sessionResponse.isHeadshotPhotoUploaded === true) {
                                        logintohomepage();
                                    } else {
                                        window.location.href = "#/photoUpload";
                                        endLoading();
                                    }
                                } else {
                                     window.location.href = "#/stageTwoRegistration";
                                }
                            } else {
                                window.location.href = "#/savePasswordPage";
                            }
                        } else {
                            window.location.href = "#/savePasswordPage";
                        }
                     } else {
                        afterTermsStaffandOthers();
                    }
                }
            } else {
                console.log("terms and condition not accepted");
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "acceptTermsandConditionsSuccess " + err);
        }
        endLoading();
    };

    //Ajax call for Terms and Conditons Error
    this.acceptTermsandConditionsError = function (jqXHR, error) {
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : acceptTermsandConditionsError" + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                errMsg = "Error : acceptTermsandConditionsError" + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                errMsg = "Error : acceptTermsandConditionsError Unexpected Error";
            } else {
                errMsg = "Error : acceptTermsandConditionsError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            endLoading();
            logout();
           
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "acceptTermsandConditionsError" + err);
        }
    };

    //Create request parameters for accept terms & condition
    this.acceptTermsandConditions = function (sessionData) {
        try {
            var data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "RegistrationServiceProvider";
            data.ServiceMethod = "AcceptTermsandConditions";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["118A0C9D-C0F0-4707-8C9E-7DE155467E6B"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN  = applicationDataObj.getToken();
            userSession.Roles = sessionData.roles;
            userSession.EmailId = sessionData.emailId;
            userSession.Address1 = sessionData.address1;
            userSession.City = sessionData.city;
            userSession.Country = sessionData.country;
            userSession.UserName = applicationDataObj.getUsername();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "acceptTermsandConditions " + err);
        }
    };
    
    //Calling forgot password page class
    this.forgetPasswordPage = function () {
        try {
            $(".currentpass").html("");
            $("#current").removeClass("pro-error-border");
            $("#newpassword").removeClass("pro-error-border");
            $("#confirm-pass").removeClass("pro-error-border");
            $(".reloadpass").val("");
            $(".reloadpass1").val("");
            $(".reloadpass2").val("");
            this.passwordError();
            this.resetPasswordAjaxCall();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "forgetPasswordPage" + err);
        }
    };
    
    //calling photo upload page class
    this.photoUploadPage = function () {
        startLoading();
        getPhotoUpload();
        
    };

    //Password error
    this.passwordError = function () {
        try {
            $('.validationclass').hide();
            $('.replacevalidation').hide();
            $('.reg13-div').hide();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "passwordError" + err);
        }
    };
    //reset Password Ajax Call
    this.resetPasswordAjaxCall = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = this.getResetParameters(sessionData);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnResetSuccess, this.OnResetError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "resetPasswordAjaxCall" + err);
        }
    };

    //Ajax OnReset Success
    this.OnResetSuccess = function (data) {
        endLoading();
        if (data) {
            $(".password-para").text(data.PasswordDetails.Description);
            $(".currentpass").append(data.PasswordDetails.CurrentPassword);
            $(".newpass").text(data.PasswordDetails.NewPassword);
            $(".confirmpas").text(data.PasswordDetails.ConfirmNewPassword);
            $(".cancelbt").text(data.PasswordDetails.Cancel);
            $(".savebt").text(data.PasswordDetails.Save);
            $(".contact-btn").text(data.PasswordDetails.ContactATP);
            $(".conpass").text(data.PasswordDetails.PasswordValidation);
            $(".cnfnew").text(data.PasswordDetails.ConfirmPasswordValidation);
        }
    };

    //Ajax OnReset Failure
    this.OnResetError = function (jqXHR, error) {
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : OnResetError" + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                errMsg = "Error : OnResetError" + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                errMsg = "Error : OnResetError Unexpected Error";
            } else {
                errMsg = "Error : OnResetError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            endLoading();
            logout();
           
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "OnResetError" + err);
        }
    };

    //Function for creating request for restpassword  data
    this.getResetParameters = function (sessionData) {
        try {
            var data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "MyProfileServiceProvider";
            data.ServiceMethod = "ResetPassword";
            data.Language = constants.englishLanguage;
            data.parametersArray =  ["79639071-359E-4D23-AEEB-8B5F98B7AD0C"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.UserName = applicationDataObj.getUsername();
            userSession.Roles = sessionData.roles;
            userSession.Address1 = sessionData.address1;
            userSession.City = sessionData.city;
            userSession.EmailId = sessionData.emailId;
            userSession.Country = sessionData.country;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "getResetParameters" + err);
        }
    };
    
    //save password Ajax call
    this.savePasswordAjaxCall = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                sessionData = applicationDataObj.getSessionResponse(),
                inputData = getSavePassword(sessionData);
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.onSaveSuccess, this.onSaveError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : savePasswordAjaxCall : " + err);
        }
    };
    
     //Ajax onSave success
    this.onSaveSuccess = function (data) {
        try {
            var sessionResponse = applicationDataObj.getSessionResponse();
            if (data === false) {
                endLoading();
            } else {
                $(".invalidpass").hide();
                $('.currentpasswordvalidation').hide();
                $("#current").removeClass("pro-error-border");
                if (sessionResponse.roles[0] === "Division I Player" || sessionResponse.roles[0] === "Division II Player" || sessionResponse.roles[0] === "Registered Player") {
                    if (sessionResponse.isstage2RegistrationCompleted === true) {
                        if(sessionResponse.isHeadshotPhotoUploaded === true) {
                            logintohomepage();
                        } else {
                            window.location.href = "#/photoUpload";
                            endLoading();
                        }
                    } else {
                         window.location.href = "#/stageTwoRegistration";
                    }
                    
                } else {
                    if(sessionResponse.isHeadshotPhotoUploaded === true) {
                        logintohomepage();
                    } else {
                        window.location.href = "#/photoUpload";
                        endLoading();
                    }
                }
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onSaveSuccess : " + err);
        }
    };

    //Ajax onSave failure
    this.onSaveError = function (jqXHR, error) {
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : onSaveError" + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                errMsg = "Error : onSaveError" + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                errMsg = "Error : onSaveError Unexpected Error";
            } else {
                errMsg = "Error : onSaveError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            endLoading();
            logout();
           
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "onSaveError" + err);
        }
    };
};

//Ready functionality for stagetwo registration
var registrationReady = function () {
    try {
        if(isApp){
            window.ga.trackView('Registration');
        }
        endLoading();
        if(deviceOS == 'ios' && isApp) {
            $('#iosscroll').addClass('scrollcontent');
        }
        if(deviceOS == 'android') {
            $('#androidscroll').addClass('scrollcontentandroid');
        }
        
        var tripwareClassObj = new TripwareClass(),
            sessionResponse = applicationDataObj.getSessionResponse(),
            date1 = new Date(sessionResponse.registeredDate),
            d = new Date(date1),
            date2 = new Date(),
            timeDiff = Math.abs(date2.getTime() - date1.getTime()),
            diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));
        if (diffDays > 10) {
            $("#homepagebutton").hide();
        }
        $('#homepagebutton').click(function (){
            logintohomepage();
        });
        if(sessionResponse.IsBioInfoSaved === true) {
            $('.circle1').css("background", "#18b9fa");
        } 
        if(sessionResponse.IsFinancialInfoSaved === true) {
            $('.circle2').css("background", "#18b9fa");
        } 
        $("#continueregistration").click(function () {
            if(applicationDataObj.getSessionResponse().IsBioInfoSaved === true && applicationDataObj.getSessionResponse().IsFinancialInfoSaved === false) {
                window.location.href = "#/registration_BankPage";
                
            } else if(applicationDataObj.getSessionResponse().IsBioInfoSaved === false && applicationDataObj.getSessionResponse().IsFinancialInfoSaved === true) {
                 window.location.href = "#/registration_BioPage";
                
            } else {
                window.location.href = "#/registration_account";
            }
        });
        tripwareClassObj.getStep2RegistrationAjax();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : registrationReady : " + err);
    }
};

//Ready functionality for terms and condition page
var termsandCondReady = function () {
    if(isApp){
        window.ga.trackView('Terms & Conditions');
    }
    var tripwareClassObj = new TripwareClass();
	try {
        tripwareClassObj.getTermsandConditionsAjaxCall();
        $('#acceptTerms').click(function () {
            tripwareClassObj.acceptTermsandConditionsAjaxCall();
        });
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : termsandconditionReady :" + err);
	}
};

//Forget password Ready function
var savePasswordReady = function () {
	try {
        if(isApp){
            window.ga.trackView('SavePassword');
        }
        var tripwareClassObj = new TripwareClass();
        tripwareClassObj.forgetPasswordPage();

	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : savePasswordReady : " + err);
	}
};

//Ready functionlaity for photoUpload
var PhotoUploadReady = function () {
    try {
        if(isApp){
            window.ga.trackView('Photo Upload');
        }
        var sessionResponse = applicationDataObj.getSessionResponse();
        var tripwareClassObj = new TripwareClass();
        tripwareClassObj.photoUploadPage();
        $('#successMessage').hide();
        $("#photoSkip").text('Skip..');
        $("#photoSkip").click(function () {
            logintohomepage();
        });
    } catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : PhotoUploadReady : " + err);
	}
};

//function to go to homepage
var gotohome = function () {
    var tripwareClassObj = new TripwareClass();
    tripwareClassObj.logintohomepage();
};

//function to show tabs
var profileTabSlicker = function () {
	$('.myprfile-subheaderslicker').slick({
		slide: 'li',
		dots : false,
		arrows : true,
		swipe : false,
		infinite : false,
		slidesToShow : 3,
		slidesToScroll : 1,
		autoplay: false
	});
};

//function to go to homepage
var registrationAccount = function () {
    try {
        if(isApp){
            window.ga.trackView('Registration Account');
        }
        if(deviceOS == 'ios' && isApp) {
            $('#iosscroll').addClass('scrollcontent');
        }
        if(deviceOS == 'android') {
            $('#androidscroll').addClass('scrollcontentaccount');
        }
        profileTabSlicker();
        $("div.slick-track").removeAttr("style");
        $("div.slick-track li.myacc-class").removeAttr("style");
        $("a[data-tab-destination]").on('click', function () {
            var tab = $(this).attr('data-tab-destination');
            $("#" + tab).click();
        });
        $(".data").siblings().addClass("notactiveData");
        $('.myaccount-nav-cntnr li').click(function () {
            $("#bio-save-msg").removeClass("show");
            $("#bio-save-msg").addClass("hide");
            $(this).siblings().removeClass('myaccnt-navactive');
            $(this).siblings().addClass('myacc-navdeactive');
            $(this).addClass('myaccnt-navactive');
            $(this).removeClass('myacc-navdeactive');
            var x = $(this).children().attr("href"),
                clickedField = $(this).find('a').text();
            
            $(".data").siblings().removeClass("activeData");
            $(".data").siblings().removeClass("active");
            $(".data").siblings().addClass("notactiveData");
            $(x).addClass("activeData");
            $(x).removeClass("notactiveData");
            $(".trnmnthome-nav-cntnr").addClass("activeData");
            $('.reg13-div').hide();
            startLoading();
            if (clickedField === "Bio") {
                startLoading();
                var bioClassObj = new BioClass();
                var otherBioClassObj = new OtherBioClass();
                if(constants.onBehalfPlayerId){
                    otherBioClassObj.managebio(playerName);
                }
                else {
                    if (applicationDataObj.getSessionResponse() && applicationDataObj.getSessionResponse().roles && applicationDataObj.getSessionResponse().roles.length !== 0) {
                        role = applicationDataObj.getSessionResponse().roles[0];
                    }
                    if ((role == "Other" || role == "ATP Staff"))
                    {
                        $("#bioplayer").hide();
                        $("#bioagent").hide();
                        $("#biocoach").hide();
                        $("#bioalumni").hide();
                        endLoading();
                    }
                    else
                    {
                        bioClassObj.checkBio();
                        bio();
                    }	
                }
            }
            
            if (clickedField === "Bank Details") {
                startLoading();
                bankDetails("");
            }
        });
        $("#bankregli").click();
        var sessionResponse = applicationDataObj.getSessionResponse(),
            date1 = new Date(sessionResponse.registeredDate),
            d = new Date(date1),
            date2 = new Date(),
            timeDiff = Math.abs(date2.getTime() - date1.getTime()),
            diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));
        if (diffDays > 10) {
            $("#bankDetailSkip").hide();
            $("#bioSkip").hide();
        }
        $('#bankDetailSkip').click(function () {
            $("#bioli").click();
        });
        $('#bioSkip').click(function () {
            window.location.href = "#/photoUpload";
        });
        
    } catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : registrationAccount : " + err);
	}
};

//function to go to homepage
var registrationBankPage = function () {
    try {
        if(isApp){
            window.ga.trackView('Registration BankPage');
        }
        if(deviceOS == 'ios' && isApp) {
            $('#iosscroll').addClass('scrollcontent');
        }
        if(deviceOS == 'android') {
            $('#androidscroll').addClass('scrollcontentaccount');
        }
 
        startLoading();
        bankDetails("");
        var sessionResponse = applicationDataObj.getSessionResponse(),
            date1 = new Date(sessionResponse.registeredDate),
            d = new Date(date1),
            date2 = new Date(),
            timeDiff = Math.abs(date2.getTime() - date1.getTime()),
            diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));
        if (diffDays > 10) {
            $("#bankDetailPageSkip").hide();
        }
        $('#bankDetailPageSkip').click(function () {
            if(applicationDataObj.getSessionResponse().isHeadshotPhotoUploaded === true) {
                logintohomepage();
            } else {
                window.location.href = "#/photoUpload";
                endLoading();
            }
        });
        
    } catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : registrationAccount : " + err);
	}
};

//function to go to homepage
var registrationBioPage = function () {
    try {
        if(isApp){
            window.ga.trackView('Registration Bio');
        }
        if(deviceOS == 'ios' && isApp) {
            $('#iosscroll').addClass('scrollcontent');
        }
        if(deviceOS == 'android') {
            $('#androidscroll').addClass('scrollcontentaccount');
        }
 
        startLoading();
        var bioClassObj = new BioClass();
        var otherBioClassObj = new OtherBioClass();
        if(constants.onBehalfPlayerId){
            otherBioClassObj.managebio(playerName);
        }
        else {
            if (applicationDataObj.getSessionResponse() && applicationDataObj.getSessionResponse().roles && applicationDataObj.getSessionResponse().roles.length !== 0) {
                role = applicationDataObj.getSessionResponse().roles[0];
            }
            if ((role == "Other" || role == "ATP Staff"))
            {
                $("#bioplayer").hide();
                $("#bioagent").hide();
                $("#biocoach").hide();
                $("#bioalumni").hide();
                endLoading();
            }
            else
            {
                bioClassObj.checkBio();
                bio();
            }	
        }
        var sessionResponse = applicationDataObj.getSessionResponse(),
            date1 = new Date(sessionResponse.registeredDate),
            d = new Date(date1),
            date2 = new Date(),
            timeDiff = Math.abs(date2.getTime() - date1.getTime()),
            diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));
        if (diffDays > 10) {
            $("#bioSkip").hide();
        }
        $('#bioSkip').click(function () {
            if(applicationDataObj.getSessionResponse().isHeadshotPhotoUploaded === true) {
                logintohomepage();
            } else {
                window.location.href = "#/photoUpload";
                endLoading();
            }
        });
        
    } catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : registrationAccount : " + err);
	}
};


//Clicking on save this method will be called
var savevalidation = function () {
    try {
        $('.currentpasswordvalidation').hide();
        $(".invalidpass").hide();
        $('.newpassvalidation').hide();
        $('.profileconfirmvalidation').hide();
        $("#current").removeClass("pro-error-border");
        $("#newpassword").removeClass("pro-error-border");
        $("#confirm-pass").removeClass("pro-error-border");
        var passexpr = /^(?=.*[a-zA-Z])(?=.*\d)(?=.*[!@#$%^&*()_+]?)[A-Za-z\d][A-Za-z\d!@#$%^&*()_+]{7,20}$/,
            isError = false,
            newpass = $('#newpassword').val(),
            tripwareClassObj = new TripwareClass();
        if ($('#current').val() === "") {
            $('.currentpasswordvalidation').show();
            $("#current").addClass("pro-error-border");
            isError = true;
        }
        if (!passexpr.test(newpass)) {
            $('.newpassvalidation').show();
            $("#newpassword").addClass("pro-error-border");
            isError = true;
        }
        if ($('#confirm-pass').val() !== $('#newpassword').val()) {
            $('.profileconfirmvalidation').show();
            $("#confirm-pass").addClass("pro-error-border");
            isError = true;
            return false;
        } else {
            $('.newpassvalidation').hide();
            $("#newpassword").removeClass("pro-error-border");
            $('.profileconfirmvalidation').hide();
            $("#confirm-pass").removeClass("pro-error-border");
            tripwareClassObj.savePasswordAjaxCall();
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : savevalidation : " + err);
    }
};

//clicking on cancel this method will be called
var cancelPassvalidation = function () {
    try {
        $("#current").val('');
        $("#newpassword").val('');
        $("#confirm-pass").val('');
        $('.currentpasswordvalidation').hide();
        $(".invalidpass").hide();
        $('.newpassvalidation').hide();
        $('.samepassvalidation').hide();
        $('.profileconfirmvalidation').hide();
        $("#current").removeClass("pro-error-border");
        $("#newpassword").removeClass("pro-error-border");
        $("#confirm-pass").removeClass("pro-error-border");
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : cancelvalidation : " + err);
    }
};

//Redirect to home page by calling API GetLoginDetails
var logintohomepage = function () {
    try {
        var loginAlertObj = new LoginAlertClass();
        //applicationDataObj.setLoginResponse(loginResponse);
        window.location.href = "#/Home";
        loginAlertObj.getLoginAlerts();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "logintohomepage" + err);
    }
};

//On success of API GetLoginDetails
var logintohomepageSuccess = function (loginResponse) {
    try {
        var loginAlertObj = new LoginAlertClass();
        applicationDataObj.setLoginResponse(loginResponse);
        window.location.href = "#/Home";
        loginAlertObj.getLoginAlerts();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "logintohomepageSuccess" + err);
    }

};

// On failure of API GetLoginDetails
var logintohomepageError = function (jqXHR) {
    try {
        if (jqXHR.statusText === constants.timeout && jqXHR.status === 0) {
            $("#invalid_user").html(constants.UnexpectedError);
        } else {
            $("#invalid_user").html(textStatus.statusText);
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "logintohomepageError" + err);
    }

    logout();
    endLoading();
};

//clicking on PlayerZone link in login page
var myPlayerZoneFunc = function () {
    $(".usernamevalidation-finger").hide();
    $(".passwordvalidation-finger").hide();
    $(".usernamevalidation").hide();
    $(".passwordvalidation").hide();
    $(".usernamevalidation-finger-invalid").hide();
    $("#login-username-field").val("");
    $("#login-password").val("");
    $("#invalid_user").text("");
    $('#invalid_user_fingerprint').text("");
    $("#invalid_user_faceId").html("");
    $('#finger-username').val("");
    $('#finger-password').val("");
    var url=mwebUrls.playerzoneUrl;
    window.open(url, '_system');
};

//common validation function for staff and others
var StaffandOthers = function () {
    var sessionResponse = applicationDataObj.getSessionResponse();
    if (sessionResponse.isTermsandConditions_Accepted !== null) {
        if (diffDays <= 365) {
            if(sessionResponse.isPasswordReset === true) {
                if (sessionResponse.isPasswordChangedBasedOnDays === false) {
                    if (sessionResponse.isstage2RegistrationCompleted === true) {
                        if(sessionResponse.isHeadshotPhotoUploaded === true) {
                            logintohomepage();
                        } else {
                            window.location.href = "#/photoUpload";
                            endLoading();
                        }
                    } else {
                         window.location.href = "#/stageTwoRegistration";
                    }
                } else {
                    window.location.href = "#/savePasswordPage";
                }
            } else {
                window.location.href = "#/savePasswordPage";
            }
        } else {
             window.location.href = "#/regTermsAndCond";
        }
    } else {
        window.location.href = "#/regTermsAndCond";
    }
};

//common validation function for divison and registration
var DivisonAndRegistration = function () {
    var sessionResponse = applicationDataObj.getSessionResponse();
    if (sessionResponse.isTermsandConditions_Accepted !== null) {
        if (diffDays <= 365) {
            if(sessionResponse.isPasswordReset === true) {
                if (sessionResponse.isPasswordChangedBasedOnDays === false) {
                    if (sessionResponse.isstage2RegistrationCompleted === true) {
                        if(sessionResponse.isHeadshotPhotoUploaded === true) {
                            logintohomepage();
                        } else {
                            window.location.href = "#/photoUpload";
                            endLoading();
                        }
                    } else {
                         window.location.href = "#/stageTwoRegistration";
                    }
                } else {
                    window.location.href = "#/savePasswordPage";
                }
            } else {
                window.location.href = "#/savePasswordPage";
            }
        } else {
            window.location.href = "#/regTermsAndCond";
        }
    } else {
        window.location.href = "#/regTermsAndCond";
    }
};

//common function for staff and others after accepting terms and conditions
var afterTermsStaffandOthers = function () {
    var sessionResponse = applicationDataObj.getSessionResponse();
    if(sessionResponse.isPasswordReset === true) {
        if (sessionResponse.isPasswordChangedBasedOnDays === false) {
            if (sessionResponse.isstage2RegistrationCompleted === true) {
                if(sessionResponse.isHeadshotPhotoUploaded === true) {
                    logintohomepage();
                } else {
                    window.location.href = "#/photoUpload";
                    endLoading();
                }
            } else {
                 window.location.href = "#/stageTwoRegistration";
            }
        } else {
             window.location.href = "#/savePasswordPage";
        }
    } else {
        window.location.href = "#/savePasswordPage";
    }
};

//Function for creating request for getting password  data
var getSavePassword = function (sessionData) {
    try {
        var data = {},
            userSession = {},
            parametersArray = [],
            saveObject = {};
        data.UserId = sessionData.userId;
        data.ServiceProvider = "MyProfileServiceProvider";
        data.ServiceMethod = "SaveResetPassword";
        data.Language = constants.englishLanguage;
        userSession.PlayerId = sessionData.playerId;
        userSession.UserId = sessionData.userId;
        userSession.FirstName = sessionData.firstName;
        userSession.LastName = sessionData.lastName;
        userSession.Roles = sessionData.roles;
        userSession.UserName = applicationDataObj.getUsername();
        userSession.EmailId = sessionData.emailId;
        userSession.Address1 = sessionData.address1;
        userSession.City = sessionData.city;
        userSession.Country = sessionData.country;
        userSession.TOKEN  = applicationDataObj.getToken();
        data.SessionData = userSession;
        saveObject.OldPassword = $("#current").val();
        saveObject.NewPassword = $("#newpassword").val();
        saveObject.ConfirmNewPassword = $("#confirm-pass").val();
        parametersArray.push(saveObject);
        parametersArray.push("79639071-359E-4D23-AEEB-8B5F98B7AD0C");
        data.parametersArray = parametersArray;
        data = JSON.stringify(data);
        return data;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : getSavePassword : " + err);
    }
};
