/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/* Result class */
var countChallengerlength = 0;
var ResultClass = function () {
    
    /** get Result data **/
    this.getResultData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getRequestParametersResults();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.onResultsRespSuccess, this.onResultsRespError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getResultData " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getRequestParametersResults = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "ResultsServiceProvider";
            data.ServiceMethod = "GetCompletedResults";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["A6696EE3-8D21-45A0-AA17-B97091CF61AE"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.Roles = sessionData.roles;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getRequestParametersResults " + err);
        }
    };
    
    /** binding Results body data **/
    this.bindResultsResponse = function (response) {
        countChallengerlength = 0;
        try {
            tourData = response.Tour;
			tourlen = tourData.length;
            //var width = $(document).width();
            var counttourlength = 0;
			for (i = 0; i < tourlen; i++) {
				eventsData = tourData[i].Events;
				eventslen = eventsData.length;
				tourid = tourData[i].TabDate.split(" ").join("");
				if (eventslen !== 0) {
                    counttourlength++;
					$("#tour-second-div").append('<div class="draw-color  draw-color-1  new-li " id="tour-list-date' + (i + 1) + '"><a data-toggle="tab" id="tour-date' + (i + 1) + '" class="date-pagination  new-a tour-new-a" href="#livetab' + i + '">' + tourData[i].TabDate + '</a></div>');
					if (i === 0) {
						$(".tourresults").append('<div class="tab-pane fade in active" id="livetab' + i + '"><div class="row" id="tabevent' + (i + 1) + '"></div></div>');
					} else {
						$(".tourresults").append('<div class="tab-pane fade" id="livetab' + i + '"><div class="row" id="tabevent' + (i + 1) + '"></div></div>');
					}
                }
				if (eventslen === 0) {
					$("#tour-list-date" + (i + 1)).remove();
				}
				for (j = 0; j < eventslen; j++) {
					matchResultData = eventsData[j].MatchResults;
					resultlen = matchResultData.length;
					$("#tabevent" + (i + 1)).append('<div class="col-xs-12 col-sm-6 col-md-4 mrgbtm"><div class="thumbnail tumb">' +
							'<table class="table new-table-sec" id="' + tourid + 'tourtable' + (j + 1) + '">' +
							'<tr class="bgcolor-white height55">' +
							'<td colspan="2" class="tab-wdt top-row2 result-tableheading-padding bordertopnone">' +
							'<img src="' + eventsData[j].BadgePath + '" alt="image" class="valign result-tableheader-imgsize">' +
							'<span class="text-color-live paddingleft10 fontsize19 top-row1">' +
							'<a data-url = "' + eventsData[j].EventUrl + '"onclick = "navigateEntryUrl(this);">' + eventsData[j].EventName + '</a>' +
							'</span></span>' +
							'</td>' +
                            '</tr></table></div></div>');
					for (k = 0; k < resultlen; k++) {
						$('#' + tourid + 'tourtable' + (j + 1)).append('<tr>' +
								'<td class="tab-wdt">' + matchResultData[k].Round.ShortName + '</td>' +
								'<td>' +
								'<span class="text-info">' + matchResultData[k].MatchResultDisplay + '</span>' +
								'<span class="num-class">' + matchResultData[k].Result + '</span>' +
								'<sup class="toursup">' + matchResultData[k].Set2Tie + '</sup>' +
								'</td>' +
                                                                       '</tr>');
						if (matchResultData[k].Set2Tie !== 0) {
							$(".toursup").show();
						} else {
							$(".toursup").hide();
						}
					}
				}
			}
			tourFirst = $("#tour-second-div div a").last().attr('id');
			if ($("#" + tourFirst).length) {
				if ($("#" + tourFirst).hasClass("tour-challenger-first-data")) {
					$("#" + tourFirst).removeClass("tour-challenger-first-data");
					$("#" + tourFirst).addClass("tour-challenger-first-data");
				} else {
					$("#" + tourFirst).addClass("tour-challenger-first-data");
				}
				$("#" + tourFirst).click();
			}
			challengeData = response.Challenger;
			challengelen = challengeData.length;
			for (i = 0; i < challengelen; i++) {
				cheventsData = challengeData[i].Events;
				cheventslen = cheventsData.length;
				challengeid = challengeData[i].TabDate.split(" ").join("");
				if (cheventslen !== 0) {
                    countChallengerlength++;
					$("#challenge-second-div").append('<div class="draw-colors  draw-color-1  new-li " id="challenge-list-date' + (i + 1) + '"><a data-toggle="tab" id="challenge-date' + (i + 1) + '" class="date-pagination  new-a challenge-new-a" href="#chlivetab' + i + '">' + challengeData[i].TabDate + '</a></div>');
					if (i === 0) {
						$(".challengerresult").append('<div class="tab-pane fade in active" id="chlivetab' + i + '"><div class="row" id="chtabevent' + (i + 1) + '"></div></div>');
					} else {
						$(".challengerresult").append('<div class="tab-pane fade" id="chlivetab' + i + '"><div class="row" id="chtabevent' + (i + 1) + '"></div></div>');
					}
				}
				if ($(".challengerresult div").eq(0).not("in active")) {
					$(".challengerresult div").eq(0).addClass("in active");
                }
				if (cheventslen === 0) {
					$("#challenge-list-date" + (i + 1)).remove();
				}
				for (j = 0; j < cheventslen; j++) {
					challengeResultData = cheventsData[j].MatchResults;
					chresultlen = challengeResultData.length;
					$("#chtabevent" + (i + 1)).append('<div class="col-xs-12 col-sm-6 col-md-4 mrgbtm"><div class="thumbnail tumb">' +
							'<table class="table new-table-sec" id="' + challengeid + 'challengetable' + (j + 1) + '">' +
							'<tr class="bgcolor-white height55">' +
							'<td colspan="2" class="tab-wdt top-row2 result-tableheading-padding bordertopnone">' +
							'<img src="' + cheventsData[j].BadgePath + '" alt="image" class="valign result-tableheader-imgsize">' +
							'<span class="text-color-live paddingleft10 fontsize19 top-row1">' +
							'<a data-url = "' + cheventsData[j].EventUrl + '"onclick = "navigateEntryUrl(this);">' + cheventsData[j].EventName + '</a>' +
							'</span></span>' +
							'</td>' +
                                                      '</tr></table></div></div>');
					for (k = 0; k < chresultlen; k++) {
						$('#' + challengeid + 'challengetable' + (j + 1)).append('<tr>' +
								'<td class="tab-wdt">' + challengeResultData[k].Round.ShortName + '</td>' +
								'<td>' +
								'<span class="text-info">' + challengeResultData[k].MatchResultDisplay + '</span>' +
								'<span class="num-class">' + challengeResultData[k].Result + '</span>' +
								'<sup class="challengesup">' + challengeResultData[k].Set2Tie + '</sup>' +
								'</td>' +
                                                                                 '</tr>');
						if (challengeResultData[k].Set2Tie !== 0) {
							$(".challengesup").show();
						} else {
							$(".challengesup").hide();
						}
					}
				}
			}
			challengeFirst = $("#challenge-second-div div a").last().attr('id');
			if ($("#" + challengeFirst).length) {
				if ($("#" + challengeFirst).hasClass("tour-challenger-first-data")) {
					$("#" + challengeFirst).removeClass("tour-challenger-first-data");
					$("#" + challengeFirst).addClass("tour-challenger-first-data");
				} else {
					$("#" + challengeFirst).addClass("tour-challenger-first-data");
				}
				
			}

			//setTimeout(function(){
			//endLoading();
			//},500);
			endLoading();
            setTimeout(function(){

                if ($(document).width() > 1229) {
                    width = $(document).width() - ($(document).width() * 0.1);
                    width = width + 'px';
                } else {
                    width = $(document).width();
                    width = width + 'px';
                }
                $('.item1').css('width', width);

                $("div.item1.tour-second-div").slick({
                    dots: false,
                    arrows: true,
                    swipe: false,
                    slidesToShow: 3,
                    slidesToScroll: 1,
                    autoplay: false,
                    infinite: false,
                    initialSlide: counttourlength - 3
                });
                if ($(".draw-color").hasClass("slick-active")) {
                    $(".slick-active").eq(0).addClass("new-border");
                    $(".slick-active").eq(1).addClass("new-border");
                }
                
                if($('.slick-active').length < 3){
                    $('.slick-active').last().removeClass("new-border");  
                }
                enableTourSlickButtons();
             
            
            },50);
			

        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindResultsResponse " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.onResultsRespSuccess = function (data) {
        try {
            var resultClassObj = new ResultClass();
            resultClassObj.bindResultsResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onResultsRespSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.onResultsRespError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : onResultsRespError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : onResultsRespError " + err);
        }
    };
};

/* Result */

var resultsReady = function () {
    try {
        if(isApp){
            window.ga.trackView('ResultsPage');
        }
        var resultObj = new ResultClass();
        var width = $(document).width();
        startLoading();
        setTimeout(function () {
            headerMain();
		    subHeaderCarousel();
            resultObj.getResultData();
            if (deviceOS === 'ios' && isApp) {
               $('#iosscroll').addClass("scrollcontent");
            }
        }, 500);
        $('.item1').carousel();
		$('.item2').carousel();
        
        $("#rightarrow").click(function () {
			firstres = $("#rightarrow").parent().children().children(".item").first().hasClass("active");
			lastres = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
			if (firstres === true || lastres === true) {
				$("#leftarrow").show();
                $("#rightarrow").hide();
			}
		});

		$("#leftarrow").click(function () {
			firstact = $("#leftarrow").parent().children().children(".item").first().hasClass("active");
			lastact = $("#leftarrow").parent().children().children(".item").last().hasClass("active");
			if (firstact === true || lastact === true) {
				$("#rightarrow").show();
                $("#leftarrow").hide();
			}
		});
        
        $("#Challenger").click(function () {
            if ($(document).width() > 1229) {
                width = $(document).width() - ($(document).width() * 0.1);
                width = width + 'px';
            } else {
                width = $(document).width();
                width = width + 'px';
            }
            $('.item2').css('width', width);

            setTimeout(function () {
                $(".item2.challenge-second-div").slick({
                    dots: false,
                    arrows: true,
                    swipe: false,
                    slidesToShow: 3,
                    slidesToScroll: 1,
                    autoplay: false,
                    infinite: false,
                    initialSlide: countChallengerlength -3
                });
                enableSlickButtons();
            }, 200);
            if ($("div.challenge-second-div div div.draw-colors").not(".slick-active")) {
                $(".challenge-second-div div").eq(0).addClass("new-border");
                $(".challenge-second-div div").eq(1).addClass("new-border");
                $("div.challenge-second-div div.slick-track").removeClass("new-border");
                if($(".challenge-second-div div.slick-list").hasClass("new-border")){
                    $(".challenge-second-div div.slick-list").removeClass("new-border");
                }
            }
            if($('.slick-active').length < 3){
                    $('.slick-active').last().removeClass("new-border");
            }
            
        });
        
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : resultsReady " + err);
    }
};





// ************ slick for Tour tab starts ***********************************************
var enableTourSlickButtons = function () {
    $("div.tour-second-div .slick-prev").css("background", " url(images/tertiary_arrow_black_left.png) no-repeat center");
    $("div.tour-second-div .slick-next").css("background", " url(images/arrow_right_grey.svg) no-repeat center");
    if ($(".draw-color").hasClass("slick-active")) {
        $(".slick-active").eq(0).addClass("new-border");
        $(".slick-active").eq(1).addClass("new-border");
        $(".slick-active").eq(2).addClass("new-margin");
    }
    $(".draw-color").not(".slick-active").removeClass("new-border");
    $("div.tour-second-div .slick-next").click(function () {
        $('#tour-date1').removeClass("tour-challenger-first-data");
        $("div.tour-second-div .slick-prev").css("background", " url(images/tertiary_arrow_black_left.png) no-repeat center");
        lstChild = $("div.tour-second-div .slick-list div");
        lchild = lstChild.last().attr('class');
        lChildCls = lchild.slice(-12);
        if (lChildCls === "slick-active") {
            $("div.tour-second-div .slick-next").css("background", " url(images/arrow_right_grey.svg) no-repeat center");
        }
        if ($(".draw-color").hasClass("slick-active")) {
            $(".slick-active").eq(0).addClass("new-border");
            $(".slick-active").eq(1).addClass("new-border");
            $(".slick-active").eq(2).addClass("new-margin");
        }
        $(".draw-color").not(".slick-active").removeClass("new-border");
    });

    $("div.tour-second-div .slick-prev").click(function () {
        $("div.tour-second-div .slick-next").css("background", " url(images/tertiary_arrow_black.png) no-repeat center");
        frtChild = $("div.tour-second-div .slick-list .slick-track div");
        fchild = frtChild.first().attr('class');
        fChildCls = fchild.slice(-12);
        if (fChildCls === "slick-active") {
            $("div.tour-second-div .slick-prev").css("background", " url(images/arrow_left_grey.svg) no-repeat center");
        }
        if ($(".draw-color").hasClass("slick-active")) {
            $(".slick-active").eq(0).addClass("new-border");
            $(".slick-active").eq(1).addClass("new-border");
            $(".slick-active").eq(2).removeClass("new-border");
        }
    });
    $('.tour-new-a').click(function () {
        $('.tour-new-a').css('font-weight', 'normal');
        $(this).css('font-size', '15px !important');
        $(this).css('font-weight', 'bold');
        $("#" + tourFirst).removeClass("tour-challenger-first-data");

    });
};

//*************************Slick Challenger Tab starts here*****************************************
var enableSlickButtons = function () {
    $("div.challenge-second-div .slick-prev").css("background", " url(images/tertiary_arrow_black_left.png) no-repeat center");
    $("div.challenge-second-div .slick-next").css("background", " url(images/arrow_right_grey.svg) no-repeat center");
    if ($(".draw-colors").hasClass("slick-active")) {
        $("div.challenge-second-div div div.slick-active").eq(0).addClass("new-border");
        $("div.challenge-second-div div div.slick-active").eq(1).addClass("new-border");
        $("div.challenge-second-div div div.slick-active").eq(2).addClass("new-margin");	
    }
    $("div.challenge-second-div div div").not(".slick-active").removeClass("new-border");
    $("div.challenge-second-div .slick-next").click(function () {
        $('#challenge-date1').removeClass("tour-challenger-first-data");
        $("div.challenge-second-div .slick-prev").css("background", " url(images/tertiary_arrow_black_left.png) no-repeat center");
        var lstChild = $("div.challenge-second-div .slick-list div");
        var lchild = lstChild.last().attr('class');
        var lChildCls = lchild.slice(-12);
        if (lChildCls === "slick-active") {
            $("div.challenge-second-div .slick-next").css("background", " url(images/arrow_right_grey.svg) no-repeat center");
        }
        if ($(".draw-colors").hasClass("slick-active")) {
            $("div.challenge-second-div div div.slick-active").eq(0).addClass("new-border");
            $("div.challenge-second-div div div.slick-active").eq(1).addClass("new-border");
            $("div.challenge-second-div div div.slick-active").eq(2).addClass("new-margin");	
        }
        $("div.challenge-second-div div div").not(".slick-active").removeClass("new-border");
    });
    $("div.challenge-second-div .slick-prev").click(function () {
        $("div.challenge-second-div .slick-next").css("background", " url(images/tertiary_arrow_black.png) no-repeat center");
        var frtChild = $("div.challenge-second-div .slick-list .slick-track div");
        var fchild = frtChild.first().attr('class');
        var fChildCls = fchild.slice(-12);
        if (fChildCls === "slick-active") {
            $("div.challenge-second-div .slick-prev").css("background", " url(images/arrow_left_grey.svg) no-repeat center");
        }
        if ($(".draw-colors").hasClass("slick-active")) {
            $("div.challenge-second-div div div.slick-active").eq(0).addClass("new-border");
            $("div.challenge-second-div div div.slick-active").eq(1).addClass("new-border");
            $("div.challenge-second-div div div.slick-active").eq(2).removeClass("new-border");
            $("div.challenge-second-div div div.slick-active").eq(2).addClass("new-margin");    	
        }
    });  
    $('.challenge-new-a').click(function () {
        $('.challenge-new-a').css('font-weight', 'normal');
        $(this).css('font-size', '15px !important');
        $(this).css('font-weight', 'bold');
        $("#" + challengeFirst).removeClass("tour-challenger-first-data");
    }); 	
};
//*******************************Results End******************************************
