/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/* Rulebook class */

var inAppBrowserRef;

var RulebookClass = function () {
    
    /** get Rulebook data **/
    this.getRuleBookData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getRulebookRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnRulebookSuccess, this.OnRulebookError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getRuleBookData " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getRulebookRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "RulesServiceProvider";
            data.ServiceMethod = "GetRuleBookImage";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["2F947054-0C24-434F-82BE-C6FEC0D6F1D0"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.Country = sessionData.country;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getRulebookRequestParameters " + err);
        }
    };
    
    /** binding Rulebook image body data **/
    this.bindRulebookResponse = function (data) {
        startLoading();
        try {
            ruleBookText = data.Text;
            $('#ruleDesc').html(data.Description);
            $(".rulebkimgcls").attr('src', data.RuleBookImage.Src);
            $(".rulebkmrglftfullmob").append('<p class="rulebkfullmobcontent" id="fulllabel">' + data.Full2015 + '</p><p class="rulebkfullmobcontent" id="rulemenu">' + data.ATPRulebook + '</p><button type="button" class="col-xs-10 rulebkdwnbtnmob" data-url ="' + data.PDF.Src + '"  onclick="showDownloadPdf(this);">OPEN</button>');
            $("#tablecontent").append(data.TableOfContentLabel);
            $("#tablecontent").attr('data-url', data.TableOfContentPdf.Src);
            $("#indexcontent").append(data.IndexLabel);
            $("#indexcontent").attr('data-url', data.IndexPdf.Src);
            $("#Rulebookchangescontent").append(data.RulebookChangesLabel);
            $("#Rulebookchangescontent").attr('data-url', data.RulebookChangesPdf.Src);

        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindRulebookResponse " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnRulebookSuccess = function (data) {
        try {
            var rulebookClassObj = new RulebookClass();
            rulebookClassObj.bindRulebookResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnRulebookSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnRulebookError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnRulebookError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnRulebookError " + err);
        }
    };
    
    /** get Table Information data **/
    this.tablepdfInformation = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getTablePDFRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnTablePDFSuccess, this.OnTablePDFError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : tablepdfInformation " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getTablePDFRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "RulesServiceProvider";
            data.ServiceMethod = "GetPDFInformation";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["D15669D1-3D49-4D6D-9E9D-5633308F635C"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.Country = sessionData.country;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getTablePDFRequestParameters " + err);
        }
    };
    
    /** binding Index body data **/
    this.bindTableInformation = function (data) {
        startLoading();
        try {
            childrenContent = data.Childen;
            tableLen = childrenContent.length;
            for (i = 0; i < tableLen; i++) {
                $(".tacol").append('<tr><td>'+ (i + 1) + "." +' </td><td class="paddinglft0"><a class="spl-hotel-container-tablerowfont" data-url="' + childrenContent[i].PDF.Src + '" onclick="showRulesPdf(this);">' + childrenContent[i].Text + ' </a></td></tr>');
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindTableInformation " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnTablePDFSuccess = function (data) {
        try {
            var TableClassObj = new RulebookClass();
            TableClassObj.bindTableInformation(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnTablePDFSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnTablePDFError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnTablePDFError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnTablePDFError " + err);
        }
    };
};


/* Rulebook */

var ruleBook = function () {
    try {
        if(isApp){
            window.ga.trackView('Rules RuleBook');
        }
        var ruleBookObj = new RulebookClass();
        startLoading();
        headerMain();
        subHeaderHide();
        ruleBookObj.getRuleBookData();
        ruleBookObj.tablepdfInformation();
        $(".tacol1").hide();
        $("#tablecontent").click(function () {
            $(".tacol").show();
            $(".tacol1").hide();
        });
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : ruleBook " + err);
    }
};

/*Opening Table pdf*/
var showRulesPdf = function (event) {
	try {
		var url = $(event).attr("data-url");
	    if (url && url !== "null" && url !== "undefined") {
            /*if (device) {
                if (device.platform && device.platform.toLowerCase() === "android") {
                    url = "https://docs.google.com/viewer?url=" + encodeURIComponent(url);
                }
            }*/
            window.open(url,"_system");
	    }
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, " Error : showRulesPdf " + err);
	}
};

var showDownloadPdf = function (event) {

    try {
        var url = $(event).attr("data-url");
        if (url && url !== "null" && url !== "undefined") {
             window.open(url,"_system");
        }
           
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, " Error : showPdf " + err);
	}
};

function openRulesPdfBrowser(url) {
	try {
		if (url && url !== "null" && url !== "undefined") {
			window.open(url,"_system");
		}
		/*var target = '_blank',
            options = 'location=no,closebuttoncaption=back,toolbar=yes,hardwareback=yes,toolbarposition=top',
            ref = cordova.InAppBrowser.open(url, target, options);
		ref.addEventListener('loadstart', loadstartCallback);
		ref.addEventListener('loadstop', loadstopCallback);
		ref.addEventListener('loadloaderror', loaderrorCallback);
		ref.addEventListener('exit', exitCallback);*/
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, " Error : openRulesPdfBrowser " + err);
	}
}

function loadstartCallback(event) {
    console.log('Loading started: '  + event.url);
}
function loadstopCallback(event) {
    console.log('Loading finished: ' + event.url);
}
function loaderrorCallback(error) {
    console.log('Loading error: ' + error.message);
}

function exitCallback() {
    if (device.platform.toLowerCase() === "ios") {
        document.body.style.webkitTransform = 'translate3d(0, 20px, 0)';
    }
}







