/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/* Rules Form class */

var RulesFormClass = function () {
    
    /** get Rules Form data **/
    this.getRulesFormData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getRulesformRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.OnFormsSuccess, this.OnFormsError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : rulesFormClass " + err);
        }
    };
    
    /** Creating request Parameters **/
    this.getRulesformRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(),
                data = {},
                userSession = {};
            data.Userid = sessionData.userId;
            data.ServiceProvider = "RulesServiceProvider";
            data.ServiceMethod = "Forms";
            data.Language = constants.englishLanguage;
            data.parametersArray = ["02647EED-207A-4FA0-B0F9-A34517F837F1"];
            userSession.PlayerId = sessionData.playerId;
            userSession.UserId = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.Country = sessionData.country;
            userSession.TOKEN  = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getRulesformRequestParameters " + err);
        }
    };
    
    /** binding Forms body data **/
    this.bindFormsResponse = function (data) {
        $('#RulesDesc').html(data.Description);
        try {
            $(".contactapp-btn").append(data.ContactATP);
            if(data.Query !== null) {
                var scriptQuery = '<script language="JavaScript">';
                scriptQuery = scriptQuery + data.Query;
                scriptQuery = scriptQuery + '</script>';
                $("#rules-rules-forms").append(scriptQuery);
            }
            for (i = 0; i < data.Forms.length; i++) {
                $("#formtable").append('<tr>' +
                '<td><span><a class="spl-hotel-container-tablerowfont" data-url="' + data.Forms[i].Link.Url + '" onclick="showFormsLink(this);">' + data.Forms[i].Title + '</a></span></td>' +
                 '</tr>');
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindFormsResponse " + err);
        }
    };
    
     /*Ajax - Success Call back*/
    this.OnFormsSuccess = function (data) {
        try {
            var formsClassObj = new RulesFormClass();
            formsClassObj.bindFormsResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFormsSuccess " + err);
        }
    };
    
    /*Ajax - Error Call back*/
    this.OnFormsError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFormsError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnFormsError " + err);
        }
    };
    
};

/* Rules Forms */

var rulesForm = function () {
    try {
        if(isApp){
            window.ga.trackView('Rules RuleForm');
        }
        var rulesFormObj = new RulesFormClass();
        startLoading();
        headerMain();
        subHeaderHide();
        rulesFormObj.getRulesFormData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : rulesForm " + err);
    }
};

var showFormsLink = function (event) {
	try {
		var url = $(event).attr("data-url");
	    if (url && url !== "null" && url !== "undefined") {
            window.open(url,"_system");
	    }
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : showFormsLink " + err);
	}
};

function openFormsLinkBrowser(url) {
	try {
		var target = '_blank',
            options = 'location=no,closebuttoncaption=back,toolbar=yes,hardwareback=yes,toolbarposition=top',
            ref = cordova.InAppBrowser.open(url, target, options);
		ref.addEventListener('loadstart', loadstartCallback);
		ref.addEventListener('loadstop', loadstopCallback);
		ref.addEventListener('loadloaderror', loaderrorCallback);
		ref.addEventListener('exit', exitCallback);
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : openFormsLinkBrowser " + err);
	}
}

function loadstartCallback(event) {
    console.log('Loading started: '  + event.url);
}
function loadstopCallback(event) {
    console.log('Loading finished: ' + event.url);
}
function loaderrorCallback(error) {
    console.log('Loading error: ' + error.message);
}

function exitCallback() {
    console.log('Browser is closed...');
}







