/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used,  reproduced,  modified,  distributed, 
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/**
 * Schedule Class
 */
var scheduleClass = function () {
	/**
	 * get schedule data function
	 */
	this.getScheduleData = function () {
		try {
			var apiservicecallsObj = new Apiservicecalls(),
			    url =  constants.ajaxUrl,
			    inputData = this.getScheduleRequestParameters();
			apiservicecallsObj.postData(url, inputData, this.onScheduleSuccess,  this.onScheduleError);
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getScheduleData " + err);
		}
	};
	/**
	 * Creating request parameters
	 */
	this.getScheduleRequestParameters = function () {
		try {
			var sessionData = applicationDataObj.getSessionResponse(),
			    data = {},
                userSession = {};
			data.Userid = sessionData.userId;
			data.ServiceProvider = "HomeServiceProvider";
			data.ServiceMethod = "GetSchedule";
			data.Language = constants.englishLanguage;
			data.parametersArray =  ["F748B42E-95D3-43E5-88ED-AF22EB86C3BC"];
			userSession.playerid = sessionData.playerId;
			userSession.userid = sessionData.userId;
			userSession.firstname = sessionData.firstName;
			userSession.lastname = sessionData.lastName;
			userSession.TOKEN  = applicationDataObj.getToken();
			data.SessionData = userSession;
			var inputData = JSON.stringify(data);
			return inputData;
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : getScheduleRequestParameters " + err);
		}
	};
	/**
	 * Ajax success call
	 */
	this.onScheduleSuccess = function (response) {
		try {
			var scheduleClassObj = new ScheduleDataClass();
			if (response && response.EventList) {
				$.each(response.EventList,  function (index,  value) {
					if (value) {
						var tableRowFormat = '<tr>' +
                        '<td  class="col-xs-6 paddinglftryt0 schedule-td1"><a  data-EventPath = {1} accesskey="W">{0}</a></td>' +
                        '<td class="col-xs-5 paddinglftryt0 alignright"><button data-EventYear ={2} data-EventId = {3} class="button1">VIEW SCHEDULE</button></td>' +
                        '</tr>',
                        tableFormat = '<table class="schedule-table">{0}</table>';
                        var tableData = "";
			               tableData  += tableRowFormat.format(value.EventDisplayName, value.EventPath, value.EventYear, value.EventId);
                        if (tableData) {
                            var scheduleTable = tableFormat.format(tableData);
                            $("#scheduledata").append(scheduleTable);
                        }
					}
				});
				scheduleClassObj.handleclickEvents();
			}
			endLoading();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : onScheduleSuccess " + err);
		}
	};
	/**
	 * Ajax failure call
	 */
	this.onScheduleError = function (jqXHR,  exception) {
		try {
			endLoading();
			var errMsg = "";
			if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
				errMsg = "Error : onScheduleError " + jqXHR.statusText;
			} else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
				timoutErrorStatus = true;
				errMsg = "Error : onScheduleError " + jqXHR.statusText;
			} else if (jqXHR.status === 0) {
				timoutErrorStatus = true;
				errMsg = "Error : onScheduleError Unexpected Error with status Code 0";
			} else {
				timoutErrorStatus = true;
				errMsg = "Error : onScheduleError Unexpected Error";
			}
			loggerObj.logToServer(constants.logSeverityError, errMsg);
			logout();
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : onScheduleError " + err);
		}
	};
	

	/**
	 * Initializing Controls
	 */
	this.initializeControls = function () {
		try {
			$("#rightarrow").click(function () {
				var firstlive = $("#rightarrow").parent().children().children(".item").first().hasClass("active");
				var lastlive = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
				if (firstlive === true || lastlive === true) {
					$("#leftarrow").show();
				}
			});

			$("#leftarrow").click(function () {
				var firstliveact = $("#leftarrow").parent().children().children(".item").first().hasClass("active"),
				    lastliveact = $("#leftarrow").parent().children().children(".item").last().hasClass("active");
				if (firstliveact === true || lastliveact === true) {
					$("#rightarrow").show();
				}
			});
		} catch (err) {
			loggerObj.logToServer(constants.logSeverityError, "Error : initializeControls " + err); 
		}
	};
};
/**
 * Ready Function
 */
var sheduleReady = function () {
	try {
        if(isApp){
            window.ga.trackView('Schedule');
        }
		var scheduleClassObj = new scheduleClass();
		startLoading();
		setTimeout(function () {
			if (deviceOS === 'ios' && isApp) {
				$('#iosscroll').addClass("scrollcontent");
			}
			headerMain();
			subHeaderCarousel();
			scheduleClassObj.getScheduleData();
			scheduleClassObj.initializeControls();
			var firstSchedule = $("#rightarrow").parent().children().children(".item").first().hasClass("active"),
			    lastSchedule = $("#rightarrow").parent().children().children(".item").last().hasClass("active");
			if (!firstSchedule || !lastSchedule) {
				$("#leftarrow").show();
				$("#rightarrow").hide();
			}
		}, 500);
	} catch (err) {
		loggerObj.logToServer(constants.logSeverityError, "Error : sheduleReady " + err);
	}
};