/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

var SocialMediaClass = function () {
    /** get health data **/
    this.getHealthData = function () {
        try {
            var apiservicecallsObj = new Apiservicecalls(),
                inputData = this.getHealthRequestParameters();
            apiservicecallsObj.postData(constants.ajaxUrl, inputData, this.onHealthSuccess, this.onHealthError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getHealthData " + err);
        }
    };

    /** Binding Health body data**/
   
    this.bindBenefitsHealthResponse = function (response) {
        try {
            
            $("#benefits-social-content").append(response.Content);
            if(response.Query !== null) {
                var scriptQuery = '<script language="JavaScript">';
                scriptQuery = scriptQuery + response.Query;
                scriptQuery = scriptQuery + '</script>';
                $("#benefits-social-content").append(scriptQuery);
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : bindBenefitsHealthResponse " + err);
        }
    };

    /** Creating request parameters**/
    this.getHealthRequestParameters = function () {
        try {
            var sessionData = applicationDataObj.getSessionResponse(), data = {}, userSession = {};
            data.userId = sessionData.userId;
            data.ServiceProvider = "BenefitsServiceProvider";
            data.ServiceMethod = "GetHealth";
            data.Language = constants.Language;
            data.ParametersArray = ["B3219EE4-3A5C-4254-B91E-3078DF92313F"];
            userSession.PlayerId = sessionData.playerId;
            userSession.Userid = sessionData.userId;
            userSession.FirstName = sessionData.firstName;
            userSession.LastName = sessionData.lastName;
            userSession.TOKEN = applicationDataObj.getToken();
            data.SessionData = userSession;
            data = JSON.stringify(data);
            return data;
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : getHealthRequestParameters " + err);
        }
    };
    /*Ajax - Success Call back*/
    this.onHealthSuccess = function (data) {
        try {
            var socialClassObj = new SocialMediaClass();
            socialClassObj.bindBenefitsHealthResponse(data);
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnHealthSuccess " + err);
        }
    };
    this.onHealthError = function (jqXHR, error) {
        try {
            endLoading();
            var errorMessage = jqXHR.statusText;
            if (jqXHR.responseJSON && jqXHR.responseJSON.Message) {
                errorMessage = errorMessage + " : " + jqXHR.responseJSON.Message;
            }
            loggerObj.logToServer(constants.logSeverityError, "Error : OnHealthError " + errorMessage);
            if (jqXHR.status && jqXHR.status === constants.errorCode401 &&
                    jqXHR.statusText === constants.unauthorizedError) {
                logout();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "Error : OnHealthError " + err);
        }
    };
};

var socialMedia = function () {
    try {
        if(isApp){
            window.ga.trackView('Benefits socialMedia');
        }
        var socialClassObj = new SocialMediaClass();
        startLoading();
        headerMain();
        subHeaderBenefitsHide();
        navigationArrowMenu();
        socialClassObj.getHealthData();
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : health " + err);
    }
};
