/**
Clas Name       : TouchIdAndroidClass
Description     : Handles Touch ID related to Android
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/

var TouchIdAndroidClass = function () {
  
    var loginServiceClass = new LoginServiceClass();
    var isAvailableSuccessObj = new isAvailableSuccessClass();
    //if touch id is there 
    this.isAvailableSuccess = function (result) {
        try {
            $('.settingText').html('Settings > Lock screen and<div> security > Fingerprints</div>');
            if (result.hasEnrolledFingerprints) {
                $('#sign-in-modalsettings').modal('hide');
                $('#sign-in-modal').modal('hide');
                var encryptConfig = {};
                encryptConfig.clientId = applicationDataObj.getUserId();
                encryptConfig.username = applicationDataObj.getUsername();
                encryptConfig.dialogTitle = 'Touch ID for "PlayerZone"';
                encryptConfig.dialogMessage = 'Touch to Sign In with' + " " + applicationDataObj.getUsername().toLowerCase().trim();
                FingerprintAuth.encrypt(encryptConfig, isAvailableSuccessObj.isAvailableSuccessCallback, isAvailableSuccessObj.isAvailableErrorCallback);
            } else {
                $('#sign-in-modal').modal('hide');
                $('#fingerPrintSettingModal').modal('show');
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableSuccess android method" + err);
        }
    };
    
    //if touch id is not there
    this.isAvailableError = function (message) {
        console.log("isAvailableError(): " + message);
        logout();
    }; 
    
    //success calback method when touch id is available in android
    this.androidTouchIDAvailableSuccess = function (result) {
        try {
            $('.settingText').html('Settings > Lock screen and<div> security > Fingerprints</div>');
            $('.invalid_username').hide();
            $(".usernamevalidation-finger").hide();
            $(".passwordvalidation-finger").hide();
            $(".usernamevalidation").hide();
            $(".passwordvalidation").hide();
            $(".usernamevalidation-finger-invalid").hide();
            $("#login-username-field").val("");
            $("#login-password").val("");
            $("#invalid_user").text("");
            $('#invalid_user_fingerprint').text("");
            $('#finger-username').val("");
            $('#finger-password').val("");
            $('#finger-username').attr('disabled', false);
            $('#finger-password').attr('disabled', false);
            if (result.hasEnrolledFingerprints) {
                if (window.localStorage.getItem("GUID") !== null && window.localStorage.getItem("GUID") !== "" && window.localStorage.getItem("GUID") !== "undefined") {
                    var decryptConfig = {};
                    decryptConfig.token = window.localStorage.getItem("TOKEN");
                    decryptConfig.clientId = window.localStorage.getItem("clientId");
                    decryptConfig.username = window.localStorage.getItem("Username");
                    decryptConfig.dialogTitle = 'Touch ID for "PlayerZone"';
                    decryptConfig.dialogMessage = 'Touch to Sign In with' + " " + window.localStorage.getItem("Username").toLowerCase().trim();
                    FingerprintAuth.decrypt(decryptConfig, isAvailableSuccessObj.androidPluginSuccessIfGUID, isAvailableSuccessObj.androidPluginErrorIfGUID);
                } else {
                    $("#fingerPrintModal").modal('show');
                }
            } else {
                $('#fingerPrintSettingModal').modal('show');
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "androidTouchIDAvailableSuccess android method" + err);
        }
    };
    
    //error calback method when touch id is available in android
    this.androidisTouchIDAvailableError = function (message) {
        try {
            console.log("isAvailableError(): " + message);
            logout();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "androidisTouchIDAvailableError android method" + err);
        }
    };
    
    //android callback success 
    this.firstTimeAndroidSucess = function (result) {
        $('.settingText').html('Settings > Lock screen and<div> security > Fingerprints</div>');
         if (result.hasEnrolledFingerprints) {
             console.log('plugin callback success');
         } else {
            window.localStorage.setItem("flagResult" , 0);
            $('#fingerPrintSettingModal').modal('show');
         }
    };
    
    //android callback error 
    this.firstTimeAndroidError = function (message) {
        try {
            console.log("isAvailableError(): " + message);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "androidisTouchIDAvailableError android method" + err);
        }
    };
    
    //if guid is there success callback method when fingerprint is configured android
    this.isAvailableGUIDSuccess = function (result) {
        try {
            if (result.isAvailable) {
                var decryptConfig = {};
                decryptConfig.token = window.localStorage.getItem("TOKEN");
                decryptConfig.clientId = window.localStorage.getItem("clientId");
                decryptConfig.username = window.localStorage.getItem("Username");
                decryptConfig.dialogTitle = 'Touch ID for "PlayerZone"';
                decryptConfig.dialogMessage = 'Touch to Sign In with' + " " + window.localStorage.getItem("Username").toLowerCase().trim();
                FingerprintAuth.decrypt(decryptConfig, isAvailableSuccessObj.androidPluginSuccessIfGUID, isAvailableSuccessObj.androidPluginErrorIfGUID);
            }
           
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableGUIDSuccess android method" + err);
        }
    };
    
    //if guid is there error callback method when fingerprint is configured android
    this.isAvailabGUIDError = function(message) {
        try {
            console.log("isAvailableError(): " + message);
            logout();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailabGUIDError android method" + err);
        }
    };
    
    //if touch id is there (authentication from setting menu tab)
    this.isAvailableSuccessSettings = function (result) {
        $('.settingText').html('Settings > Lock screen and<div> security > Fingerprints</div>');
        try {
            if(result.hasEnrolledFingerprints){
                $('#sign-in-modalsettings').modal('hide');
                $('#sign-in-modal').modal('hide');
                var encryptConfig={};
                encryptConfig.clientId=applicationDataObj.getUserId();
                encryptConfig.username=applicationDataObj.getUsername();
                encryptConfig.dialogTitle='Touch ID for "PlayerZone"';
                encryptConfig.dialogMessage='Touch to Sign In with' +" " + applicationDataObj.getUsername().toLowerCase().trim();
                FingerprintAuth.encrypt(encryptConfig, isAvailableSuccessObj.successCallbackSettings, isAvailableSuccessObj.errorCallbackSettings);
            }
            else{
                $('#sign-in-modal').modal('hide');
                $('#fingerPrintSettingModal').modal('show'); 
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableSuccessSettings android method" + err);
        }
      
    };
    
    //if touch id is not there (authentication from setting menu tab)
    this.isAvailableErrorSettings = function (message) {
        console.log("isAvailableError(): " + message);
        logout();
    };
};

//if fingerprint successfully authenticated
var isAvailableSuccessClass = function () {
    var AjaxfingerResponseObj = new AjaxfingerResponseClass();
    //touchid available success
    this.isAvailableSuccessCallback = function (resultToken) {
        startLoading();
        try {
            if (resultToken.withFingerprint) {
                window.localStorage.setItem("TOKEN", resultToken.token);
                var loginData =  {};
                loginData.Userid = applicationDataObj.getUserId();
                loginData.deviceid = deviceuuid;
                loginData = JSON.stringify(loginData);
                var apiservicecallsObj = new apiservicecalls();
                var url = constants.saveBiometricUrl;
                apiservicecallsObj.postData(url, loginData, AjaxfingerResponseObj.OnfingerSuccess, AjaxfingerResponseObj.OnfingerError);
            } else {
                loginServiceClass.getLoginDetails();
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableSuccessCallback android method" + err);
        }
    };
    
    //touchid available error
    this.isAvailableErrorCallback = function (error) {
        endLoading();
        try {
            if (error === "Cancelled") {
                console.log("FingerprintAuth Dialog Cancelled!");
            } else {
                console.log("FingerprintAuth Error: " + error);
                
            }
            logout();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"isAvailableErrorCallback android method" + err);
        }
    };
    
    //success callback when the android plugin popup comes
    this.androidPluginSuccessIfGUID = function (result) {
        startLoading();
        passwordFlag = false;
        if (!getOnlineStatus()) {
            endLoading();
            window.location.href = "#/";
            $("#invalid_user").html(appMsgs.noNetworkError);
        } else {
            try {
                var authenticateData =  {},
                    apiservicecallsObj = new apiservicecalls(),
                    url =  constants.ajaxUrl,
                    tokenUrl = constants.ajaxTokenUrl,
                    loginData =  {};
                authenticateData.username = "biometric_oauth:" + deviceuuid;
                authenticateData.password = window.localStorage.getItem("GUID");
                authenticateData = JSON.stringify(authenticateData);
                apiservicecallsObj.postData(tokenUrl, authenticateData, fingerprintPluginSuccess, fingerprintPluginError);

            } catch (err) {
                loggerObj.logToServer(constants.logSeverityError, "androidPluginSuccessIfGUID android method" + err);
            }
        }
    };
    
    //error callback when the android plugin popup comes
    this.androidPluginErrorIfGUID = function (error) {
        endLoading();
        try {
            if (error === "Cancelled") {
                console.log("FingerprintAuth Dialog Cancelled!");
            } else {
                console.log("FingerprintAuth Error: " + error);
                
            }
            window.location.href = "#/";
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "androidPluginErrorIfGUID android method" + err);
        }
    };
    
    //if fingerprint successfully authenticated (authentication from setting menu tab)
    this.successCallbackSettings = function (resultToken) {
        try {
            window.localStorage.setItem("Username",applicationDataObj.getUsername());
            window.localStorage.setItem("clientId",applicationDataObj.getUserId());
            if (resultToken.withFingerprint) {
                window.localStorage.setItem("TOKEN", resultToken.token);
                var loginData =  {};
                loginData.Userid =applicationDataObj.getUserId();
                loginData.deviceid=deviceuuid;
                loginData = JSON.stringify(loginData);
                var apiservicecallsObj = new apiservicecalls();
                var url = constants.saveBiometricUrl;     
                apiservicecallsObj.postData(url,loginData, AjaxfingerResponseObj.OnfingerSuccessSettings, AjaxfingerResponseObj.OnfingerErrorSettings);
            } else {
                clickCloseNavBar();
                endLoading();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "successCallbackSettings android method" + err);
        }
    };
    
    //if fingerprint authentication error (authentication from setting menu tab)
    this.errorCallbackSettings = function (error) {
        try{
            endLoading();
            if (error === "Cancelled") {
                console.log("FingerprintAuth Dialog Cancelled!");
            } else {
                console.log("FingerprintAuth Error: " + error);
            }
            window.location.href = "#/";
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "errorCallbackSettings android method" + err);
        }
    };
};

var AjaxfingerResponseClass = function () {
    var loginServiceClass = new LoginServiceClass();
    
    //Ajax finger success
    this.OnfingerSuccess = function (fingerprintguid) {
        window.localStorage.setItem("GUID", fingerprintguid);
        loginServiceClass.getLoginDetails();
        endLoading();
    };

    //Ajax finger error
    this.OnfingerError = function (jqXHR, error) {
        endLoading();
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : OnfingerError " + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnfingerError " + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnfingerError Unexpected Error";
            } else {
                errMsg = "Error : OnfingerError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            logout();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError,"OnfingerError" + err);
        }
    };
    
    //Ajax finger success from setting tab
    this.OnfingerSuccessSettings = function (fingerprintguid) {
        try {
            window.localStorage.setItem("GUID", fingerprintguid);
            clickCloseNavBar();
            endLoading();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "OnfingerSuccessSettings android method" + err);
        }
    };

    //Ajax finger error from setting tab
    this.OnfingerErrorSettings = function (jqXHR,error) {
        endLoading();
        try{
            var errMsg = "";
            if(jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized" ){
                errMsg = "Error : OnfingerErrorSettings " +jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0){
                timoutErrorStatus = true;
                errMsg = "Error : OnfingerErrorSettings " +jqXHR.statusText;
            } else if (jqXHR.status === 0){
                timoutErrorStatus = true;
                errMsg = "Error : OnfingerErrorSettings Unexpected Error";
            } else {
                errMsg = "Error : OnfingerErrorSettings Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError,errMsg);
            logout();
        }
        catch(err){
            loggerObj.logToServer(constants.logSeverityError,"OnfingerErrorSettings android method" + err);
        }
    };
};