/**
Clas Name       : TouchIdiOSClass
Description     : Handles Touch ID related to iOS
Ownership Info  : This software is the confidential and proprietary information of ATP and may not be used, reproduced, modified, distributed,
                    publicly displayed or otherwise disclosed without the express written consent of ATP. 
*/

var TouchIdiOSClass = function () {
    
    var loginServiceClass = new LoginServiceClass();
    var isAvailableSuccessIOSObj = new isAvailableSuccessIOSClass();
    //if touch id is there 
    this.isAvailableSuccess = function () {
        try {
            $('#sign-in-modal').modal('hide');
            $('#sign-in-modal-Face').modal('hide');
            window.plugins.touchid.verifyFingerprint('Touch to Sign In with' + " " + applicationDataObj.getUsername().toLowerCase().trim(), isAvailableSuccessIOSObj.isAvailableSuccessCallback, isAvailableSuccessIOSObj.isAvailableErrorCallback);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableSuccess ios method" + err);
        }
    };
    
    //if touch id is not there
    this.isAvailableError = function () {
        try {
            console.log("touch id is not available");
            window.location.href = "#/";
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableError ios method" + err);
        }
    };
    
   
    
    //if touch id is there (authentication from setting menu tab)
    this.isAvailableSuccessSettings = function () {
        try {
            $('#sign-in-modal').modal('hide');
            $('#sign-in-modal-Face').modal('hide');
            window.plugins.touchid.verifyFingerprint('Touch to Sign In with' + " " + applicationDataObj.getUsername().toLowerCase().trim(),isAvailableSuccessIOSObj.successCallbackSettings, isAvailableSuccessIOSObj.errorCallbackSettings); 
        } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "isAvailableSuccessSettings ios method" + err);
        }
        
    };
    
    //if touch id is not there (authentication from setting menu tab)
    this.isAvailableErrorSettings = function () {
        try {
            $('.settingText').html('Settings > Touch ID & Passcode</div>');
            $('#sign-in-modal').modal('hide');
            $('#sign-in-modal-Face').modal('hide');
            
            if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
                $('#FaceIDSettingModal').modal('show');
            } else {
                $('#fingerPrintSettingModal').modal('show');
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableErrorSettings ios method" + err);
        }
    };
    
    //ios callback success
    this.firstTimeIOSSucess = function () {
        console.log('plugin callback success');
    };
    
    //ios callback error
    this.firstTimeIOSError = function () {
        $('.settingText').html('Settings > Touch ID & Passcode</div>');
        window.localStorage.setItem("flagResult" , 0);
        if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
            $('#FaceIDSettingModal').modal('show');
        } else {
            $('#fingerPrintSettingModal').modal('show');
        } 
    };
    
      
    //if guid is there success callback method when fingerprint is configured ios
    this.isAvailableGUIDSuccess = function () {
        startLoading();
        try {
            window.plugins.touchid.verifyFingerprint('Touch to Sign In with' + " " + window.localStorage.getItem("Username").toLowerCase().trim(), isAvailableSuccessIOSObj.iosPluginSuccessIfGUID, isAvailableSuccessIOSObj.iosPluginErrorIfGUID);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableGUIDSuccess ios method" + err);
        }
    };
    
    this.isAvailabGUIDError = function (error) {
        try {
            console.log(error);
            window.location.href = "#/";
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailabGUIDError ios method" + err);
        }
    };
    
    //if touch id is configured in the ios device
    this.iOSTouchIDAvailableSuccess = function () {
        endLoading();
         try {
            $('.invalid_username').hide();
            $(".usernamevalidation-finger").hide();
            $(".passwordvalidation-finger").hide();
            $(".usernamevalidation-face").hide();
            $(".passwordvalidation-face").hide();
            $(".usernamevalidation").hide();
            $(".passwordvalidation").hide();
            $(".usernamevalidation-finger-invalid").hide();
            $(".usernamevalidation-face-invalid").hide();
            $("#login-username-field").val("");
            $("#login-password").val("");
            $("#invalid_user").text("");
            $('#invalid_user_fingerprint').text("");
            $("#invalid_user_faceId").html("");
            $('#finger-username').val("");
            $('#finger-password').val("");
            $('#finger-username-face').val("");
            $('#finger-password-face').val("");
            $('#finger-username').attr('disabled', false);
            $('#finger-password').attr('disabled', false);
            $('#finger-username-face').attr('disabled', false);
            $('#finger-password-face').attr('disabled', false);
            if (window.localStorage.getItem("GUID") !== null && window.localStorage.getItem("GUID") !== "" && window.localStorage.getItem("GUID") !== "undefined") {
                window.plugins.touchid.verifyFingerprint('Touch to Sign In with' + " " + window.localStorage.getItem("Username").toLowerCase().trim(), isAvailableSuccessIOSObj.iosPluginSuccessIfGUID, isAvailableSuccessIOSObj.iosPluginErrorIfGUID);
            } else {
                if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
                    $("#FaceIDModel").modal('show');
                } else {
                    $("#fingerPrintModal").modal('show');
                }
               
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "iOSTouchIDAvailableSuccess ios method" + err);
        }
    };

    //if touch id is not configured in the ios device
    this.iOSTouchIDAvailableError = function (msg) {
        $('.settingText').html('Settings > Touch ID & Passcode</div>');
        endLoading();
        try {
            touchiderrormsg = msg;
            if (touchiderrormsg.code === -7) {
                if(device.model === "iPhone10,3" || device.model === "iPhone10,6") {
                    $('#FaceIDSettingModal').modal('show');
                } else {
                    $('#fingerPrintSettingModal').modal('show');
                }
            } else if (touchiderrormsg.code === -6) {
                $('.setting-modal').hide();
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "iOSTouchIDAvailableError ios method" + err);
        }
    };
};

//if fingerprint successfully authenticated
var isAvailableSuccessIOSClass = function () {
    var AjaxfingerResponseIOSObj = new AjaxfingerResponseIOSClass();
    var loginServiceClass = new LoginServiceClass();
    //touchid available success
    this.isAvailableSuccessCallback = function () {
        var loginServiceClass = new LoginServiceClass();
        try {
            startLoading();
            var loginData =  {},
                apiservicecallsObj = new apiservicecalls(),
                url = constants.saveBiometricUrl;
            loginData.Userid = applicationDataObj.getUserId();
            loginData.deviceid = deviceuuid;
            loginData = JSON.stringify(loginData);
            apiservicecallsObj.postData(url, loginData, AjaxfingerResponseIOSObj.OnfingerSuccess, AjaxfingerResponseIOSObj.OnfingerError);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "isAvailableSuccessCallback ios method" + err);
        }
    };
    
    //touchid available error
    this.isAvailableErrorCallback = function (msg) {
       try {
            if (msg.code === -3) {
                endLoading();
                loginServiceClass.getLoginDetails();
            } else if (msg.code === -8) {
                endLoading();
                window.location.href = "#/";
                $("#invalid_user").html(msg.localizedDescription + "Please Try after 30 mins");
            } else if (msg.code === -1) {
                endLoading();
                window.location.href = "#/";
                $("#invalid_user").html("Fingerprint temporarily disabled due to 3 incorrect attempts. Please login with username and password");   
            } else {
                endLoading();
                window.location.href = "#/";
            }
        } catch (err) {
             loggerObj.logToServer(constants.logSeverityError, "isAvailableErrorCallback ios method" + err);
        }
    };
    
    //if guid is stored success callback method for ios
    this.iosPluginSuccessIfGUID = function () {
        startLoading();
        passwordFlag = false;
        if (!getOnlineStatus()) {
            endLoading();
            window.location.href = "#/";
            $("#invalid_user").html(appMsgs.noNetworkError);
        } else {
            try {
                var authenticateData =  {},
                    apiservicecallsObj = new apiservicecalls(),
                    tokenUrl =  constants.ajaxTokenUrl,
                    loginData =  {};
                authenticateData.username = "biometric_oauth:" + deviceuuid;
                authenticateData.password = window.localStorage.getItem("GUID");
                authenticateData = JSON.stringify(authenticateData);
                apiservicecallsObj.postData(tokenUrl, authenticateData, fingerprintPluginSuccess, fingerprintPluginError);

         
            } catch (err) {
                loggerObj.logToServer(constants.logSeverityError, "iosPluginSuccessIfGUID ios method" + err);
            }
        }
    };

    //if guid is stored error callback method for ios
    this.iosPluginErrorIfGUID = function (msg) {
        if (!getOnlineStatus()) {
            endLoading();
            window.location.href = "#/";
            $("#invalid_user").html(appMsgs.noNetworkError);
        } else {
            try {
                if (msg.code === -3) {
                    window.location.href = "#/Home";
                    endLoading();
                } else {
                    endLoading();
                    logout();
                }
            } catch (err) {
                loggerObj.logToServer(constants.logSeverityError, "iosPluginErrorIfGUID ios method" + err);
            }
        }
    };
    
    
    //if fingerprint successfully authenticated (authentication from setting menu tab)
    this.successCallbackSettings = function () {
        try {
            window.localStorage.setItem("Username", applicationDataObj.getUsername());
            window.localStorage.setItem("clientId", applicationDataObj.getUserId());
            var loginData =  {};
            loginData.Userid = applicationDataObj.getUserId();
            loginData.deviceid = deviceuuid;
            loginData = JSON.stringify(loginData);
            var apiservicecallsObj = new apiservicecalls(),
                url = constants.saveBiometricUrl;
            apiservicecallsObj.postData(url, loginData, AjaxfingerResponseIOSObj.OnfingerSuccessSettings, AjaxfingerResponseIOSObj.OnfingerErrorSettings);
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "successCallbackSettings ios method" + err);
        }
    };
  
    //if fingerprint authentication error (authentication from setting menu tab)
    this.errorCallbackSettings = function (msg) {
        try {
            if (msg.code === -3) {
                endLoading();
                window.location.href = "#/Home";
            } else if (msg.code === -8) {
                endLoading();
                $('#errorfingerprintmodal').modal('show');
                $("#wrongfingerprint").html(msg.localizedDescription + "Please Try after 30 mins");
                
            } else if (msg.code === -1) {
                endLoading();
                $('#errorfingerprintmodal').modal('show');
                $("#wrongfingerprint").html("Fingerprint temporarily disabled due to 3 incorrect attempts. Please login with username and password");

            } else {
                endLoading();
                window.location.href = "#/";
            }
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "errorCallbackSettings ios method" + err);
        }
    };
};

var AjaxfingerResponseIOSClass = function () {
     var loginServiceClass = new LoginServiceClass();
    
    //Ajax finger success
    this.OnfingerSuccess = function (fingerprintguid) {
        window.localStorage.setItem("GUID", fingerprintguid);
        loginServiceClass.getLoginDetails();
        endLoading();
    };

    //Ajax finger error
    this.OnfingerError = function (jqXHR, error) {
        endLoading();
        try {
            var errMsg = "";
            if (jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized") {
                errMsg = "Error : OnfingerError " + jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnfingerError " + jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnfingerError Unexpected Error";
            } else {
                errMsg = "Error : OnfingerError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError, errMsg);
            logout();
        } catch (err) {
            loggerObj.logToServer(constants.logSeverityError, "OnfingerError" + err);
        }
    };
    
    //Ajax finger success from setting tab
    this.OnfingerSuccessSettings = function (fingerprintguid) {
        window.localStorage.setItem("GUID", fingerprintguid);
        clickCloseNavBar();
        endLoading();
    };

    //Ajax finger error from setting tab
    this.OnfingerErrorSettings = function (jqXHR,error) {
        endLoading();
        try{
            var errMsg = "";
            if(jqXHR.status && jqXHR.status === 401 && jqXHR.statusText === "Unauthorized" ){
                errMsg = "Error : OnfingerError " +jqXHR.statusText;
            } else if (jqXHR.statusText === "timeout" && jqXHR.status === 0){
                timoutErrorStatus = true;
                errMsg = "Error : OnfingerError " +jqXHR.statusText;
            } else if (jqXHR.status === 0) {
                timoutErrorStatus = true;
                errMsg = "Error : OnfingerError Unexpected Error";
            } else {
                errMsg = "Error : OnloginError Unexpected Error";
            }
            loggerObj.logToServer(constants.logSeverityError,errMsg);
            logout();
        }
        catch(err){
            loggerObj.logToServer(constants.logSeverityError,"OnfingerError" + err);
        }
    };
};