﻿/**
 * This software is the confidential and proprietary information of
 * ATP and may not be used, reproduced, modified, distributed,
 * publicly displayed or otherwise disclosed without the express written
 * consent of ATP. 
 */

/* Validate email */

var validateEmailAddress = function (elementId) {
    try {
        var toCheckValue = $(elementId).val();
        if (toCheckValue) {
            var regexEmailCheck = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
            if (regexEmailCheck.test(toCheckValue)) {
               return true;
            } else {
               return false;
            }
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : validateEmailAddress " + err);
    }
};


/**
 * Validate Phone number
 */
var validatePhoneNum = function (elementId) {
    try {
        var isValidPhoneNumber = true;
        var toCheckValue = $(elementId).val();
        if (toCheckValue) {
            var regexPhoneCheck = /\(?([0-9]{3})\)?([ .-]?)([0-9]{3})\2([0-9]{4})/;
            if (regexPhoneCheck.test(toCheckValue)) {
               isValidPhoneNumber = true;
            } else {
                isValidPhoneNumber = false;
            }
            if (isValidPhoneNumber) {
                if (isNaN(toCheckValue)) {
                    isValidPhoneNumber = false;
                }
            }
            return isValidPhoneNumber;
        }
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : validatePhoneNum " + err);
    }
};


/**
 * validatePassportNumber
 */
var validatePassportNum = function (elementId) {
    try {
        var error = false,
		    pasportnum = $(elementId).val(),
            regx;
        if (pasportnum && pasportnum.length <= 20) {
            regx = /^[A-Za-z0-9]+$/;
            if (!regx.test(pasportnum)) {
                error = true;
            }
        }
        if (pasportnum && pasportnum.length > 20) {
            error = true;
        }
        return error;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : validatePassportNum " + err);
    }
};

/** 
 * Check Mandatory Fields
 */

var validateMandatoryField = function (elementId) {
    try {
        var error = false;
        if ($(elementId).val() === "") {
            error = true;
        } else {
            error = false;
        }
        return error;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : validateMandatoryField " + err);
    }
};


/* Number Validation */

var validateNumber = function (elementId) {
    try {
        var error = false,
            w = $(elementId).val();
        if (!w.match(/^[0-9\.]+$/)) {
            error = true;
        } else {
            error = false;
        }
        return error;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : validateNumber " + err);
    }
};

/**
 * Date validation
 */
var validateDateFormat = function (datePickerId) {
    try {
        var isError = false,
            dateFormat;
        if ($(datePickerId).val()) {
            dateFormat = "MM/DD/YYYY";
            if (moment($(datePickerId).val(), dateFormat, true).isValid() === true) {
                isError = false;
            } else {
                isError = true;
            }
        }
        return isError;
    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : validateDateFormat " + err);
    }
};

/** 
 * Validating mobile Number Format
 */

var validateMobileNumFormat = function (elementId) {
    try {
        var isValidPhoneNumber = true;
        var toCheckValue = $(elementId).val();
        if (toCheckValue) {
            var regexPhoneCheck = /\(?([0-9]{3})\)?([ .-]?)([0-9]{3})\2([0-9]{4})/;
            if (regexPhoneCheck.test(toCheckValue)) {
                isValidPhoneNumber = true;
            } else {
                isValidPhoneNumber = false;
            }
            if (isValidPhoneNumber) {
                if (isNaN(toCheckValue)) {
                    isValidPhoneNumber = false;
                }
            }
            return isValidPhoneNumber;
        }

    } catch (err) {
        loggerObj.logToServer(constants.logSeverityError, "Error : validateMobileNumFormat " + err);
    }
};